<?php
if (!defined('BASEPATH'))
    exit('No direct script access allowed');

/*
 *  @author : Wallace Pacheco
 *  date    : 01 junho, 2015
 *  ContSimples Tecnologia
 *  http://contsimples.com.br
 */

/*
|---------------------------------------------------------------
| TimeZone
|---------------------------------------------------------------
*/
date_default_timezone_set('America/Sao_Paulo');

class Client extends CI_Controller
{


    function __construct()
    {
        parent::__construct();
        $this->load->database();
        $this->load->library('calendar');
        //$this->load->library('pdf');
        $this->load->helper('date');
        //$this->load->dbutil();
        //$this->load->library('phplot.php');
        /*cache control*/
        $this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
        $this->output->set_header('Pragma: no-cache');
    }

/***default functin, redirects to login page if no client logged in yet***/
    public function index()
    {

        if ($this->session->userdata('client_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');
        if ($this->session->userdata('client_login') == 1)
            redirect(base_url() . 'index.php?client/dashboard', 'refresh');
    }

/***CLIENTE DASHBOARD***/
    function dashboard()
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['page_name']  = 'dashboard';
        $page_data['page_icon'] = 'dashboard';
        $page_data['page_title'] = 'Painel';
        $this->load->view('index', $page_data);
    }


/****MANAGE Avisos*****/
    function avisos($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        //$this->session->set_flashdata('flash_message', 'Passou en!!');

        if ($param1 == 'create') {
            $data['sender']        = $this->input->post('sender');
            $data['sender_type']   = $this->input->post('sender_type');
            $data['receiver']      = $this->input->post('receiver');
            $data['receiver_type'] = $this->input->post('receiver_type');
            $data['subject']       = $this->input->post('subject');
            $data['body']          = $this->input->post('body');
            $data['time']          = $this->input->post('time');
            $data['date']          = $this->input->post('date');
            $data['status']        = $this->input->post('status');
            $this->db->insert('files', $data);

            // Envio Email
            //$Xsender        = $this->db->get_where('client', array('client_id' => $this->input->post('sender')))->row()->name;
            //$Xsend_email    = $this->db->get_where('client', array('client_id' => $this->input->post('sender')))->row()->email;


            //$this->email_model->envia_email_mensagem_cliente($Xsender,$Xsend_email,$this->input->post('subject'),$this->input->post('body'));


            redirect(base_url() . 'index.php?client/avisos/', 'refresh');
        }
        if ($param1 == 'update_status') {

            $data['status']         = 'baixado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect(base_url() . 'index.php?client/avisos/', 'refresh');

        }
        if ($param1 == 'delete') {
            $this->db->where('file_id', $param2);
            $this->db->delete('files');
            redirect(base_url() . 'index.php?client/avisos/', 'refresh');
        }

        $page_data['avisos']    = $this->db->get_where('files', array('client' => $this->session->userdata('client_id')))->result_array();
        //$page_data['message']    =  $this->db->get_where('message', array('sender' => $this->session->userdata('client_id')))->result_array();
        $page_data['page_name']  = 'avisos';
        $page_data['page_icon']  = 'envelope';
        $page_data['page_title'] = 'Avisos Importantes!';
        $this->load->view('index', $page_data);
    }

    /***EMPRESA ABERTURA***/
    function empresa_abrir ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url() . 'index.php?client/empresa_abrir/', 'refresh');

        if ($param1 == 'do_update') {
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['status']           = $this->input->post('status');
            $data['obs']           = $this->input->post('obs');
            $data['fc_03_numero_cpf']           = $this->input->post('fc_03_numero_cpf');
            $data['fc_04_radio_documentos']           = $this->input->post('fc_04_radio_documentos');
            $data['fc_05_rg_digital']           = $this->input->post('fc_05_rg_digital');
            $data['fc_06_cpf_digital']           = $this->input->post('fc_06_cpf_digital');
            $data['fc_07_cnh_digital']           = $this->input->post('fc_07_cnh_digital');
            $data['fc_08_nome_mae']           = $this->input->post('fc_08_nome_mae');
            $data['fc_09_estado_civil']           = $this->input->post('fc_09_estado_civil');
            $data['fc_10_regime_casamento']           = $this->input->post('fc_10_regime_casamento');
            $data['fc_11_opcao_irpf']           = $this->input->post('fc_11_opcao_irpf');
            $data['fc_12_irpf']           = $this->input->post('fc_12_irpf');
            $data['fc_13_titulo_eleitor']           = $this->input->post('fc_13_titulo_eleitor');
            $data['fc_14_nome_rua']           = $this->input->post('fc_14_nome_rua');
            $data['fc_15_numero_rua']           = $this->input->post('fc_15_numero_rua');
            $data['fc_16_complemento']           = $this->input->post('fc_16_complemento');
            $data['fc_17_bairro']           = $this->input->post('fc_17_bairro');
            $data['fc_18_cidade']           = $this->input->post('fc_18_cidade');
            $data['fc_19_uf']           = $this->input->post('fc_19_uf');
            $data['fc_20_cep']           = $this->input->post('fc_20_cep');
            $data['fc_21_nome_empresa01']           = $this->input->post('fc_21_nome_empresa01');
            $data['fc_22_nome_empresa02']           = $this->input->post('fc_22_nome_empresa02');
            $data['fc_23_nome_empresa03']           = $this->input->post('fc_23_nome_empresa03');
            $data['fc_24_nome_fantasia']           = $this->input->post('fc_24_nome_fantasia');
            $data['fc_25_data_inicio']           = $this->input->post('fc_25_data_inicio');
            $data['fc_134_numero_funcionarios']           = $this->input->post('fc_134_numero_funcionarios');
            $data['fc_26_endereco_referencia']           = $this->input->post('fc_26_endereco_referencia');
            $data['fc_27_nome_rua']           = $this->input->post('fc_27_nome_rua');
            $data['fc_28_numero_rua']           = $this->input->post('fc_28_numero_rua');
            $data['fc_30_bairro']           = $this->input->post('fc_30_bairro');
            $data['fc_31_cidade']           = $this->input->post('fc_31_cidade');
            $data['fc_32_uf']           = $this->input->post('fc_32_uf');
            $data['fc_33_cep']           = $this->input->post('fc_33_cep');
            $data['fc_34_iptu_empresa']           = $this->input->post('fc_34_iptu_empresa');
            $data['fc_35_atividades']           = $this->input->post('fc_35_atividades');
            $data['fc_36_capital_social']           = $this->input->post('fc_36_capital_social');
            $data['fc_37_socio_administrador']           = $this->input->post('fc_37_socio_administrador');
            $data['fc_38_pro_labore']           = $this->input->post('fc_38_pro_labore');
            $data['fc_39_qtd_socios']           = $this->input->post('fc_39_qtd_socios');
            $data['fc_40_socio_01_nome']           = $this->input->post('fc_40_socio_01_nome');
            $data['fc_41_socio_01_rg']           = $this->input->post('fc_41_socio_01_rg');
            $data['fc_42_socio_01_cpf']           = $this->input->post('fc_42_socio_01_cpf');
            $data['fc_43_socio_01_documento']           = $this->input->post('fc_43_socio_01_documento');
            $data['fc_44_socio_01_rgdigital']           = $this->input->post('fc_44_socio_01_rgdigital');
            $data['fc_45_socio_01_cpfdigital']           = $this->input->post('fc_45_socio_01_cpfdigital');
            $data['fc_46_socio_01_cnhdigital']           = $this->input->post('fc_46_socio_01_cnhdigital');
            $data['fc_47_socio_01_mae']           = $this->input->post('fc_47_socio_01_mae');
            $data['fc_48_socio_01_estadocivil']           = $this->input->post('fc_48_socio_01_estadocivil');
            $data['fc_49_socio_01_regimecasamento']           = $this->input->post('fc_49_socio_01_regimecasamento');
            $data['fc_50_socio_01_profissao']           = $this->input->post('fc_50_socio_01_profissao');
            $data['fc_51_socio_01_declara_irpf']           = $this->input->post('fc_51_socio_01_declara_irpf');
            $data['fc_52_socio_01_irpf']           = $this->input->post('fc_52_socio_01_irpf');
            $data['fc_53_socio_01_eleitor']           = $this->input->post('fc_53_socio_01_eleitor');
            $data['fc_54_socio_01_capital']           = $this->input->post('fc_54_socio_01_capital');
            $data['fc_55_socio_01_pisinss']           = $this->input->post('fc_55_socio_01_pisinss');
            $data['fc_56_socio_01_rua']           = $this->input->post('fc_56_socio_01_rua');
            $data['fc_57_socio_01_numero']           = $this->input->post('fc_57_socio_01_numero');
            $data['fc_58_socio_01_complemento']           = $this->input->post('fc_58_socio_01_complemento');
            $data['fc_59_socio_01_bairro']           = $this->input->post('fc_59_socio_01_bairro');
            $data['fc_60_socio_01_cidade']           = $this->input->post('fc_60_socio_01_cidade');
            $data['fc_61_socio_01_uf']           = $this->input->post('fc_61_socio_01_uf');
            $data['fc_62_socio_01_cep']           = $this->input->post('fc_62_socio_01_cep');
            $data['fc_63_socio_02_nome']           = $this->input->post('fc_63_socio_02_nome');
            $data['fc_64_socio_02_rg']           = $this->input->post('fc_64_socio_02_rg');
            $data['fc_65_socio_02_cpf']           = $this->input->post('fc_65_socio_02_cpf');
            $data['fc_66_socio_02_documento']           = $this->input->post('fc_66_socio_02_documento');
            $data['fc_67_socio_02_rgdigital']           = $this->input->post('fc_67_socio_02_rgdigital');
            $data['fc_68_socio_02_cpfdigital']           = $this->input->post('fc_68_socio_02_cpfdigital');
            $data['fc_69_socio_02_cnhdigital']           = $this->input->post('fc_69_socio_02_cnhdigital');
            $data['fc_70_socio_02_mae']           = $this->input->post('fc_70_socio_02_mae');
            $data['fc_71_socio_02_estadocivil']           = $this->input->post('fc_71_socio_02_estadocivil');
            $data['fc_72_socio_02_regimecasamento']           = $this->input->post('fc_72_socio_02_regimecasamento');
            $data['fc_73_socio_02_profissao']           = $this->input->post('fc_73_socio_02_profissao');
            $data['fc_74_socio_02_declaraimposto']           = $this->input->post('fc_74_socio_02_declaraimposto');
            $data['fc_75_socio_02_irpf']           = $this->input->post('fc_75_socio_02_irpf');
            $data['fc_76_socio_02_eleitor']           = $this->input->post('fc_76_socio_02_eleitor');
            $data['fc_77_socio_02_capital']           = $this->input->post('fc_77_socio_02_capital');
            $data['fc_78_socio_02_pisinss']           = $this->input->post('fc_78_socio_02_pisinss');
            $data['fc_79_socio_02_rua']           = $this->input->post('fc_79_socio_02_rua');
            $data['fc_80_socio_02_numero']           = $this->input->post('fc_80_socio_02_numero');
            $data['fc_81_socio_02_complemento']           = $this->input->post('fc_81_socio_02_complemento');
            $data['fc_82_socio_02_bairro']           = $this->input->post('fc_82_socio_02_bairro');
            $data['fc_83_socio_02_cidade']           = $this->input->post('fc_83_socio_02_cidade');
            $data['fc_84_socio_02_uf']           = $this->input->post('fc_84_socio_02_uf');
            $data['fc_85_socio_02_cep']           = $this->input->post('fc_85_socio_02_cep');
            $data['fc_86_socio_03_nome']           = $this->input->post('fc_86_socio_03_nome');
            $data['fc_87_socio_03_rg']           = $this->input->post('fc_87_socio_03_rg');
            $data['fc_88_socio_03_cpf']           = $this->input->post('fc_88_socio_03_cpf');
            $data['fc_89_socio_03_documento']           = $this->input->post('fc_89_socio_03_documento');
            $data['fc_90_socio_03_rgdigital']           = $this->input->post('fc_90_socio_03_rgdigital');
            $data['fc_91_socio_03_cpfdigital']           = $this->input->post('fc_91_socio_03_cpfdigital');
            $data['fc_92_socio_03_cnhdigital']           = $this->input->post('fc_92_socio_03_cnhdigital');
            $data['fc_93_socio_03_mae']           = $this->input->post('fc_93_socio_03_mae');
            $data['fc_94_socio_03_estadocilvil']           = $this->input->post('fc_94_socio_03_estadocilvil');
            $data['fc_95_socio_03_regimecasamento']           = $this->input->post('fc_95_socio_03_regimecasamento');
            $data['fc_96_socio_03_profissao']           = $this->input->post('fc_96_socio_03_profissao');
            $data['fc_97_socio_03_declaraimposto']           = $this->input->post('fc_97_socio_03_declaraimposto');
            $data['fc_98_socio_03_irpf']           = $this->input->post('fc_98_socio_03_irpf');
            $data['fc_99_socio_03_eleitor']           = $this->input->post('fc_99_socio_03_eleitor');
            $data['fc_100_socio_03_capital']           = $this->input->post('fc_100_socio_03_capital');
            $data['fc_101_socio_03_pisinss']           = $this->input->post('fc_101_socio_03_pisinss');
            $data['fc_102_socio_03_rua']           = $this->input->post('fc_102_socio_03_rua');
            $data['fc_103_socio_03_numero']           = $this->input->post('fc_103_socio_03_numero');
            $data['fc_104_socio_03_complemento']           = $this->input->post('fc_104_socio_03_complemento');
            $data['fc_105_socio_03_bairro']           = $this->input->post('fc_105_socio_03_bairro');
            $data['fc_106_socio_106_socio_03_cidade']           = $this->input->post('fc_106_socio_106_socio_03_cidade');
            $data['fc_107_socio_03_uf']           = $this->input->post('fc_107_socio_03_uf');
            $data['fc_108_socio_03_cep']           = $this->input->post('fc_108_socio_03_cep');
            $data['fc_109_socio_04_nome']           = $this->input->post('fc_109_socio_04_nome');
            $data['fc_110_socio_04_rg']           = $this->input->post('fc_110_socio_04_rg');
            $data['fc_111_socio_04_cpf']           = $this->input->post('fc_111_socio_04_cpf');
            $data['fc_112_socio_04_documento']           = $this->input->post('fc_112_socio_04_documento');
            $data['fc_113_socio_04_rgdigital']           = $this->input->post('fc_113_socio_04_rgdigital');
            $data['fc_114_socio_04_cpfdigital']           = $this->input->post('fc_114_socio_04_cpfdigital');
            $data['fc_115_socio_04_cnhdigital']           = $this->input->post('fc_115_socio_04_cnhdigital');
            $data['fc_116_socio_04_mae']           = $this->input->post('fc_116_socio_04_mae');
            $data['fc_117_socio_04_estadocivil']           = $this->input->post('fc_117_socio_04_estadocivil');
            $data['fc_118_socio_04_regimecasamento']           = $this->input->post('fc_118_socio_04_regimecasamento');
            $data['fc_119_socio_04_profissao']           = $this->input->post('fc_119_socio_04_profissao');
            $data['fc_120_socio_04_declaraimposto']           = $this->input->post('fc_120_socio_04_declaraimposto');
            $data['fc_121_socio_04_irpf']           = $this->input->post('fc_121_socio_04_irpf');
            $data['fc_122_socio_04_eleitor']           = $this->input->post('fc_122_socio_04_eleitor');
            $data['fc_123_socio_04_capital']           = $this->input->post('fc_123_socio_04_capital');
            $data['fc_124_socio_04_pisinss']           = $this->input->post('fc_124_socio_04_pisinss');
            $data['fc_125_socio_04_rua']           = $this->input->post('fc_125_socio_04_rua');
            $data['fc_126_socio_04_numero']           = $this->input->post('fc_126_socio_04_numero');
            $data['fc_127_socio_04_complemento']           = $this->input->post('fc_127_socio_04_complemento');
            $data['fc_128_socio_04_bairro']           = $this->input->post('fc_128_socio_04_bairro');
            $data['fc_129_socio_04_cidade']           = $this->input->post('fc_129_socio_04_cidade');
            $data['fc_107_socio_04_uf']           = $this->input->post('fc_107_socio_04_uf');
            $data['fc_131_socio_04_cep']           = $this->input->post('fc_131_socio_04_cep');

            $this->db->where('clientes_fc_id', $param2);
            $this->db->update('clientes_fc', $data);

            $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso!!!');

            redirect(base_url() . 'index.php?client/empresa_abrir/', 'refresh');

        }


        if ($param1 == 'delete') {

            $data['status']         = 'excluido';
            $this->db->where('clientes_fc_id', $param2);
            $this->db->update('clientes_fc', $data);
            redirect(base_url() . 'index.php?client/empresa_abrir/', 'refresh');

        }
        $page_data['empresa_abrir']     = $this->db->get('clientes_fc')->result_array();
        $page_data['page_name']         = 'empresa_abrir';
        $page_data['page_icon']         = 'user';
        $page_data['page_title']        = 'Abertura Empresa';
        $this->load->view('index', $page_data);
    }

    /***EMPRESA TRAZER***/
    function empresa_trazer ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'do_update') {
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['status']           = $this->input->post('status');
            $data['obs']           = $this->input->post('obs');
            $data['te_02_numero_rg']           = $this->input->post('te_02_numero_rg');
            $data['te_03_numero_cpf']           = $this->input->post('te_03_numero_cpf');
            $data['te_04_radio_documentos']           = $this->input->post('te_04_radio_documentos');
            $data['te_05_rg_digital']           = $this->input->post('te_05_rg_digital');
            $data['te_06_cpf_digital']           = $this->input->post('te_06_cpf_digital');
            $data['te_07_cnh_digital']           = $this->input->post('te_07_cnh_digital');
            $data['te_08_nome_mae']           = $this->input->post('te_08_nome_mae');
            $data['te_09_estado_civil']           = $this->input->post('te_09_estado_civil');
            $data['te_10_regime_casamento']           = $this->input->post('te_10_regime_casamento');
            $data['te_11_opcao_irpf']           = $this->input->post('te_11_opcao_irpf');
            $data['te_12_irpf']           = $this->input->post('te_12_irpf');
            $data['te_13_titulo_eleitor']           = $this->input->post('te_13_titulo_eleitor');
            $data['te_14_nome_empresarial']           = $this->input->post('te_14_nome_empresarial');
            $data['te_15_cnpj']           = $this->input->post('te_15_cnpj');
            $data['te_16_codigo_acesso']           = $this->input->post('te_16_codigo_acesso');
            $data['te_30_numero_funcionarios']           = $this->input->post('te_30_numero_funcionarios');
            $data['te_17_paginas_contrato']           = $this->input->post('te_17_paginas_contrato');
            $data['te_18_contrato_pagina1']           = $this->input->post('te_18_contrato_pagina1');
            $data['te_19_contrato_pagina2']           = $this->input->post('te_19_contrato_pagina2');
            $data['te_20_contrato_pagina3']           = $this->input->post('te_20_contrato_pagina3');
            $data['te_21_contrato_pagina4']           = $this->input->post('te_21_contrato_pagina4');
            $data['te_40_contrato_pagina5']           = $this->input->post('te_40_contrato_pagina5');
            $data['te_41_contrato_pagina6']           = $this->input->post('te_41_contrato_pagina6');
            $data['te_42_contrato_pagina7']           = $this->input->post('te_42_contrato_pagina7');
            $data['te_43_contrato_pagina8']           = $this->input->post('te_43_contrato_pagina8');
            $data['te_21_alvara']           = $this->input->post('te_21_alvara');
            $data['te_22_tem_certificado']           = $this->input->post('te_22_tem_certificado');
            $data['te_23_certificado_digital']           = $this->input->post('te_23_certificado_digital');
            $data['te_24_certificado_senha']           = $this->input->post('te_24_certificado_senha');
            $data['te_25_numero_socios']           = $this->input->post('te_25_numero_socios');
            $data['te_26_doc_socio01']           = $this->input->post('te_26_doc_socio01');
            $data['te_27_doc_socio02']           = $this->input->post('te_27_doc_socio02');
            $data['te_28_doc_socio03']           = $this->input->post('te_28_doc_socio03');
            $data['te_29_doc_socio04']           = $this->input->post('te_29_doc_socio04');

            $this->db->where('clientes_te_id', $param2);
            $this->db->update('clientes_te', $data);

            $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso!!!');

            redirect(base_url() . 'index.php?client/empresa_trazer/', 'refresh');

        }


        if ($param1 == 'delete') {

            $data['status']         = 'excluido';
            $this->db->where('clientes_te_id', $param2);
            $this->db->update('clientes_te', $data);
            redirect(base_url() . 'index.php?client/empresa_trazer/', 'refresh');

        }
        $page_data['empresa_trazer']     = $this->db->get('clientes_te')->result_array();
        $page_data['page_name']         = 'empresa_trazer';
        $page_data['page_icon']         = 'user';
        $page_data['page_title']        = 'Trazer Empresa';
        $this->load->view('index', $page_data);
    }

    /***MEI ABERTURA***/
    function mei_abrir ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'do_update') {
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['status']           = $this->input->post('status');
            $data['obs']           = $this->input->post('obs');
            $data['ma_02_numero_rg']           = $this->input->post('ma_02_numero_rg');
            $data['ma_03_numero_cpf']           = $this->input->post('ma_03_numero_cpf');
            $data['ma_04_radio_documentos']           = $this->input->post('ma_04_radio_documentos');
            $data['ma_05_rg_digital']           = $this->input->post('ma_05_rg_digital');
            $data['ma_06_cpf_digital']           = $this->input->post('ma_06_cpf_digital');
            $data['ma_07_cnh_digital']           = $this->input->post('ma_07_cnh_digital');
            $data['ma_08_nome_mae']           = $this->input->post('ma_08_nome_mae');
            $data['ma_11_opcao_irpf']           = $this->input->post('ma_11_opcao_irpf');
            $data['ma_12_irpf']           = $this->input->post('ma_12_irpf');
            $data['ma_13_titulo_eleitor']           = $this->input->post('ma_13_titulo_eleitor');
            $data['ma_14_nome_rua']           = $this->input->post('ma_14_nome_rua');
            $data['ma_15_numero_rua']           = $this->input->post('ma_15_numero_rua');
            $data['ma_16_complemento']           = $this->input->post('ma_16_complemento');
            $data['ma_17_bairro']           = $this->input->post('ma_17_bairro');
            $data['ma_18_cidade']           = $this->input->post('ma_18_cidade');
            $data['ma_19_uf']           = $this->input->post('ma_19_uf');
            $data['ma_20_cep']           = $this->input->post('ma_20_cep');
            $data['ma_24_nome_fantasia']           = $this->input->post('ma_24_nome_fantasia');
            $data['ma_40_numero_funcionarios']           = $this->input->post('ma_40_numero_funcionarios');
            $data['ma_26_endereco_referencia']           = $this->input->post('ma_26_endereco_referencia');
            $data['ma_27_nome_rua']           = $this->input->post('ma_27_nome_rua');
            $data['ma_28_numero_rua']           = $this->input->post('ma_28_numero_rua');
            $data['ma_29_complemento']           = $this->input->post('ma_29_complemento');
            $data['ma_30_bairro']           = $this->input->post('ma_30_bairro');
            $data['ma_31_cidade']           = $this->input->post('ma_31_cidade');
            $data['ma_32_uf']           = $this->input->post('ma_32_uf');
            $data['ma_33_cep']           = $this->input->post('ma_33_cep');
            $data['ma_34_iptu_empresa']           = $this->input->post('ma_34_iptu_empresa');
            $data['ma_35_atividades']           = $this->input->post('ma_35_atividades');
            $data['ma_36_capital_social']           = $this->input->post('ma_36_capital_social');

            $this->db->where('clientes_ma_id', $param2);
            $this->db->update('clientes_ma', $data);

            $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso!!!');

            redirect(base_url() . 'index.php?client/mei_abrir/', 'refresh');

        }

        if ($param1 == 'delete') {

            $data['status']         = 'excluido';
            $this->db->where('clientes_ma_id', $param2);
            $this->db->update('clientes_ma', $data);
            redirect(base_url() . 'index.php?client/mei_abrir/', 'refresh');

        }
        $page_data['mei_abrir']     = $this->db->get('clientes_ma')->result_array();
        $page_data['page_name']         = 'mei_abrir';
        $page_data['page_icon']         = 'user';
        $page_data['page_title']        = 'Abertura MEI';
        $this->load->view('index', $page_data);
    }

    /***MEI TRAZER***/
    function mei_trazer ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'do_update') {
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['status']           = $this->input->post('status');
            $data['obs']           = $this->input->post('obs');
            $data['mt_02_numero_rg']           = $this->input->post('mt_02_numero_rg');
            $data['mt_03_numero_cpf']           = $this->input->post('mt_03_numero_cpf');
            $data['mt_04_radio_documentos']           = $this->input->post('mt_04_radio_documentos');
            $data['mt_05_rg_digital']           = $this->input->post('mt_05_rg_digital');
            $data['mt_06_cpf_digital']           = $this->input->post('mt_06_cpf_digital');
            $data['mt_07_cnh_digital']           = $this->input->post('mt_07_cnh_digital');
            $data['mt_14_nome_empresarial']           = $this->input->post('mt_14_nome_empresarial');
            $data['mt_15_cnpj']           = $this->input->post('mt_15_cnpj');
            $data['mt_16_codigo_acesso']           = $this->input->post('mt_16_codigo_acesso');
            $data['mt_25_numero_funcionarios']           = $this->input->post('mt_25_numero_funcionarios');
            $data['mt_17_paginas_contrato']           = $this->input->post('mt_17_paginas_contrato');
            $data['mt_18_contrato_pagina1']           = $this->input->post('mt_18_contrato_pagina1');
            $data['mt_19_contrato_pagina2']           = $this->input->post('mt_19_contrato_pagina2');
            $data['mt_21_alvara']           = $this->input->post('mt_21_alvara');
            $data['mt_22_tem_certificado']           = $this->input->post('mt_22_tem_certificado');
            $data['mt_23_certificado_digital']           = $this->input->post('mt_23_certificado_digital');
            $data['mt_24_certificado_senha']           = $this->input->post('mt_24_certificado_senha');

            $this->db->where('clientes_mt_id', $param2);
            $this->db->update('clientes_mt', $data);

            $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso!!!');

            redirect(base_url() . 'index.php?client/mei_trazer/', 'refresh');

        }


        if ($param1 == 'delete') {

            $data['status']         = 'excluido';
            $this->db->where('clientes_mt_id', $param2);
            $this->db->update('clientes_mt', $data);
            redirect(base_url() . 'index.php?client/mei_trazer/', 'refresh');

        }
        $page_data['mei_trazer']     = $this->db->get('clientes_mt')->result_array();
        $page_data['page_name']         = 'mei_trazer';
        $page_data['page_icon']         = 'user';
        $page_data['page_title']        = 'Trazer MEI';
        $this->load->view('index', $page_data);
    }

    /***Prof Liberal ABERTURA***/
    function pl_abrir ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'do_update') {
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['status']           = $this->input->post('status');
            $data['obs']           = $this->input->post('obs');
            $data['pl_03_habilitacao']           = $this->input->post('pl_03_habilitacao');
            $data['pl_04_habilitacao_digital']           = $this->input->post('pl_04_habilitacao_digital');
            $data['pl_05_habilitacao_digital']           = $this->input->post('pl_05_habilitacao_digital');
            $data['pl_13_atividade']           = $this->input->post('pl_13_atividade');
            $data['pl_06_rua']           = $this->input->post('pl_06_rua');
            $data['pl_07_numero']           = $this->input->post('pl_07_numero');
            $data['pl_08_complemento']           = $this->input->post('pl_08_complemento');
            $data['pl_09_bairro']           = $this->input->post('pl_09_bairro');
            $data['pl_10_cidade']           = $this->input->post('pl_10_cidade');
            $data['pl_11_uf']           = $this->input->post('pl_11_uf');
            $data['pl_12_cep']           = $this->input->post('pl_12_cep');
            $data['pl_14_legalizado']           = $this->input->post('pl_14_legalizado');
            $data['pl_15_alvara']           = $this->input->post('pl_15_alvara');
            $data['pl_16_endereco_conferencia']           = $this->input->post('pl_16_endereco_conferencia');
            $data['pl_17_rua']           = $this->input->post('pl_17_rua');
            $data['pl_18_numero']           = $this->input->post('pl_18_numero');
            $data['pl_19_complemento']           = $this->input->post('pl_19_complemento');
            $data['pl_20_bairro']           = $this->input->post('pl_20_bairro');
            $data['pl_21_cidade']           = $this->input->post('pl_21_cidade');
            $data['pl_21_uf']           = $this->input->post('pl_21_uf');
            $data['pl_22_cep']           = $this->input->post('pl_22_cep');
            $data['pl_23_iptu']           = $this->input->post('pl_23_iptu');
            $data['pl_26_iptu']           = $this->input->post('pl_26_iptu');
            $data['pl_24_cadastro_cei']           = $this->input->post('pl_24_cadastro_cei');
            $data['pl_25_numero_cei']           = $this->input->post('pl_25_numero_cei');

            $this->db->where('clientes_pl_id', $param2);
            $this->db->update('clientes_pl', $data);

            $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso!!!');

            redirect(base_url() . 'index.php?client/pl_abrir/', 'refresh');

        }

        if ($param1 == 'delete') {

            $data['status']         = 'excluido';
            $this->db->where('clientes_pl_id', $param2);
            $this->db->update('clientes_pl', $data);
            redirect(base_url() . 'index.php?client/pl_abrir/', 'refresh');

        }
        $page_data['pl_abrir']     = $this->db->get('clientes_pl')->result_array();
        $page_data['page_name']         = 'pl_abrir';
        $page_data['page_icon']         = 'user';
        $page_data['page_title']        = 'Abertura Prof.Liberal';
        $this->load->view('index', $page_data);
    }

    /***Prof Liberal TRAZER***/
    function pl_trazer ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        //$this->session->set_flashdata('flash_message', 'Passou aqui !!!');
        $page_data['pl_trazer']     = $this->db->get('clientes_pl')->result_array();
        $page_data['page_name']         = 'pl_trazer';
        $page_data['page_icon']         = 'user';
        $page_data['page_title']        = 'Trazer Prof.Liberal';
        $this->load->view('index', $page_data);
    }

/****MANAGE Status Cliente Acompanhamento*****/
    function status_cliente($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['status'] = $this->input->post('status');
            $this->db->insert('status_cliente', $data);
            redirect(base_url() . 'index.php?client/status_cliente/', 'refresh');
        }
        if ($param1 == 'do_update') {

            $data['status']    = $this->input->post('status');
            $this->db->where('status_cliente_id', $param2);
            $this->db->update('status_cliente', $data);
            redirect(base_url() . 'index.php?client/status_cliente/', 'refresh');
        }

        if ($param1 == 'delete') {
            $this->db->where('status_cliente_id', $param2);
            $this->db->delete('status_cliente');
            redirect(base_url() . 'index.php?client/status_cliente/', 'refresh');
        }
        $page_data['status_cliente']       = $this->db->get('status_cliente')->result_array();
        $page_data['page_name']  = 'status_cliente';
        $page_data['page_icon']  = 'cog';
        $page_data['page_title'] = 'Status Cliente';
        $this->load->view('index', $page_data);
    }



/**** Página Serviços Avulsos*****/
    function serv_avulso($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        else if ($param1 == 'personal_profile') {
            $page_data['personal_profile']   = true;
            $page_data['current_product_id'] = $param2;
        }
        $page_data['page_name']  = 'serv_avulso';
        $page_data['page_icon']  = 'tasks';
        $page_data['page_title'] = 'Serviços Avulsos';
        $this->load->view('index', $page_data);
    }

/*****SITE/SYSTEM SETTINGS********
    function system_settings($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');

        if ($param2 == 'do_update') {
            $this->db->where('type', $param1);
            $this->db->update('settings', array(
                'description' => $this->input->post('description')
            ));
            $this->session->set_flashdata('flash_message', 'settings_updated');
            redirect(base_url() . 'index.php?client/system_settings/', 'refresh');
        }
        if ($param1 == 'upload_logo') {
            move_uploaded_file($_FILES['userfile']['tmp_name'], 'uploads/logo.png');
            $this->session->set_flashdata('flash_message', 'settings_updated');
            redirect(base_url() . 'index.php?client/system_settings/', 'refresh');
   }
        $page_data['page_name']  = 'system_settings';
        $page_data['page_title'] = 'ConfiguraÃ§Ãµes do Sistema';
        $page_data['settings']   = $this->db->get('settings')->result_array();
        $this->load->view('index', $page_data);
    }
  */
/****** GESTÃO DO USUÁRIO E TROCA DE SENHA ***/
    function manage_profile($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');
        if ($param1 == 'update_profile_info') {
            $data['name']    = $this->input->post('name');
            $data['address'] = $this->input->post('address');
            $data['phone']   = $this->input->post('phone');
            $data['email']   = $this->input->post('email');

            $this->db->where('client_id', $this->session->userdata('client_id'));
            $this->db->update('client', $data);
            $this->session->set_flashdata('flash_message', 'account_updated');
            redirect(base_url() . 'index.php?client/manage_profile/', 'refresh');
        }
        if ($param1 == 'change_password') {
            $data['password']             = $this->input->post('password');
            $data['new_password']         = $this->input->post('new_password');
            $data['confirm_new_password'] = $this->input->post('confirm_new_password');

            $current_password = $this->db->get_where('client', array(
                'client_id' => $this->session->userdata('client_id')
            ))->row()->password;
            if ($current_password == $data['password'] && $data['new_password'] == $data['confirm_new_password']) {
                $this->db->where('client_id', $this->session->userdata('client_id'));
                $this->db->update('client', array(
                    'password' => $data['new_password']
                ));
                $this->session->set_flashdata('flash_message', 'password_updated');
            } else {
                $this->session->set_flashdata('flash_message', 'password_mismatch');
            }
            redirect(base_url() . 'index.php?client/manage_profile/', 'refresh');
        }
        $page_data['page_name']  = 'manage_profile';
        $page_data['page_title'] = 'Gestão Usuário';
        $page_data['page_icon'] = 'user';
        $page_data['edit_data']  = $this->db->get_where('client', array(
            'client_id' => $this->session->userdata('client_id')
        ))->result_array();
        $this->load->view('index', $page_data);
    }

}
/****** GESTÃO DO USUÁRIO E TROCA DE SENHA ***/