$(function() {

    // Atribui evento e função para limpeza dos campos
    $('#busca').on('input', limpaCampos);

    // Dispara o Autocomplete a partir do segundo caracter
    $( "#busca" ).autocomplete({
	    minLength: 2,
	    source: function( request, response ) {
	        $.ajax({
	            url: "consulta.php",      //aqui é o arquivo onde foi gerado o Json
	            dataType: "json",
	            data: {
	            	acao: 'autocomplete',
	                parametro: $('#busca').val()
	            },
	            success: function(data) {
	               response(data);
	            }
	        });
	    },
	    focus: function( event, ui ) {
	        $("#busca").val( ui.item.dest_cliente );
	        carregarDados();
	        return false;
	    },
	    select: function( event, ui ) {
	        $("#busca").val( ui.item.dest_cliente );
	        return false;
	    }
    })  // aqui é onde abre a tela da seleção do cliente
    .autocomplete( "instance" )._renderItem = function( ul, item ) { 
      return $( "<li>" )
        .append( "<a><b>CPF/CNPJ: </b>" + item.dest_cnpj_cpf + "<br><b>Nome: </b>" + item.dest_cliente + "</a><br>" )
        .appendTo( ul );
    };

    // Função para carregar os dados da consulta nos respectivos campos
    function carregarDados(){
    	var busca = $('#busca').val();

    	if(busca != "" && busca.length >= 2){
    		$.ajax({
	            url: "consulta.php",
	            dataType: "json",	
	            data: {
	            	acao: 'consulta',
	                parametro: $('#busca').val()
	            },
	            success: function( data ) {
	               $('#cpf').val(data[0].dest_cnpj_cpf);
	               $('#email').val(data[0].dest_email);
	               $('#cep').val(data[0].dest_cep);
	               $('#tel').val(data[0].dest_tel);
	               $('#endereco').val(data[0].dest_end);
	               $('#num').val(data[0].dest_n);
	               $('#complemento').val(data[0].dest_comp);
	               $('#bairro').val(data[0].dest_bairro);
	            }
	        });
    	}
    }

    // Função para limpar os campos caso a busca esteja vazia
    function limpaCampos(){
       var busca = $('#busca').val();

       if(busca == ""){
	   $('#cpf').val('');
           $('#email').val('')
           $('#cep').val('')
           $('#tel').val('')
           $('#endereco').val('')
           $('#num').val('')
           $('#complemento').val('')
           $('#bairro').val('')
       }
    }
});