<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Crud_model extends CI_Model
{

    function __construct()
    {
        parent::__construct();
    }

    function clear_cache()
    {
        $this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
        $this->output->set_header('Pragma: no-cache');
    }

    function get_type_name_by_id($type, $type_id = '', $field = 'name')
    {
        return $this->db->get_where($type, array($type . '_id' => $type_id))->row()->$field;
    }


    /////////ADMIN/////////////
    function get_admin()
    {
        $query = $this->db->get('admin');
        return $query->result_array();
    }

    function get_admin_info($admin_id)
    {
        $query = $this->db->get_where('admin', array('admin_id' => $admin_id));
        return $query->result_array();
    }

    function get_name_by_admin($admin_id, $field = 'name')
    {
        return $this->db->get_where('admin', array('admin_id' => $admin_id))->row()->$field;
    }

    function get_email_by_admin($admin_id, $field = 'email')
    {
        return $this->db->get_where('admin', array('admin_id' => $admin_id))->row()->$field;
    }

    ///////// DASHBOARD /////////////
    function get_count_message($client_id)
    {
        $this->db->count_all_results('message');  // Produces an integer, like 25
        $this->db->where('sender', $client_id);
        $this->db->from('message');

        return $this->db->count_all_results();
    }


    /////////BULK_MAIL/////////////
    function get_bulk_mail()
    {
        $query = $this->db->get('bulk_mail');
        return $query->result_array();
    }

    function get_bulk_mail_info($bulk_mail_id)
    {
        $query = $this->db->get_where('bulk_mail', array('bulk_mail_id' => $bulk_mail_id));
        return $query->result_array();
    }

    /////////CLIENT/////////////
    function get_client()
    {
        $query = $this->db->get('client');
        return $query->result_array();
    }

    function get_client_info($client_id)
    {
        $query = $this->db->get_where('client', array('client_id' => $client_id));
        return $query->result_array();
    }
    
    function get_client_form_id($client_id, $field = 'form_id')
    {
        return $this->db->get_where('w_client_form_id', array('client_id' => $client_id))->row()->$field;
    }

    
    function get_clientes_info_novo_fluxo($client_id)
    {
        $query = $this->db->get_where('clientes_novo_fluxo', array('id_novo_fluxo' => $client_id));
        return $query->result_array();
    }    
    
    function get_clientes_fc_info($client_id)
    {
        $query = $this->db->get_where('clientes_fc', array('clientes_fc_id' => $client_id));
        return $query->result_array();
    }

    function get_clientes_ma_info($client_id)
    {
        $query = $this->db->get_where('clientes_ma', array('clientes_ma_id' => $client_id));
        return $query->result_array();
    }

    function get_clientes_mt_info($client_id)
    {
        $query = $this->db->get_where('clientes_mt', array('clientes_mt_id' => $client_id));
        return $query->result_array();
    }

    function get_clientes_pl_info($client_id)
    {
        $query = $this->db->get_where('clientes_pl', array('clientes_pl_id' => $client_id));
        return $query->result_array();
    }

    function get_clientes_te_info($client_id)
    {
        $query = $this->db->get_where('clientes_te', array('clientes_te_id' => $client_id));
        return $query->result_array();
    }
    
    function get_clientes_tc_info($client_id)
    {
        $query = $this->db->get_where('clientes_tc', array('clientes_tc_id' => $client_id));
        return $query->result_array();
    }
    
    function get_clientes_ac_info($client_id)
    {
        $query = $this->db->get_where('clientes_ac', array('clientes_ac_id' => $client_id));
        return $query->result_array();
    }
    
    function get_clientes_cidade_UF($client_id,$tipo_form)
    {
          switch ($tipo_form) {
                case 'ac':
                  $cidade = @$this->db->get_where('clientes_ac', array('clientes_ac_id' => $client_id))->row('ac_residencial_cidade');
                  $uf = @$this->db->get_where('clientes_ac', array('clientes_ac_id' => $client_id))->row('ac_residencial_uf');
                  break;
                case 'fc':
                  $cidade = @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $client_id))->row('fc_18_cidade');
                  $uf = @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $client_id))->row('fc_19_uf');
                  break;
                case 'ma':
                  $cidade = @$this->db->get_where('clientes_ma', array('clientes_ma_id' => $client_id))->row('ma_18_cidade');
                  $uf = @$this->db->get_where('clientes_ma', array('clientes_ma_id' => $client_id))->row('ma_19_uf');                  
                  break;
                case 'mt':
                  $cidade = '';//@$this->db->get_where('clientes_mt', array('clientes_mt_id' => $client_id))->row('mt_residencial_cidade');
                  $uf = '';//@$this->db->get_where('clientes_mt', array('clientes_mt_id' => $client_id))->row('mt_residencial_uf');                  
                  break;
                case 'pl':
                  $cidade = @$this->db->get_where('clientes_pl', array('clientes_pl_id' => $client_id))->row('pl_10_cidade');
                  $uf = @$this->db->get_where('clientes_pl', array('clientes_pl_id' => $client_id))->row('pl_11_uf');                  
                  break;
                case 'tc':
                  $cidade = '';//@$this->db->get_where('clientes_tc', array('clientes_tc_id' => $client_id))->row('tc_residencial_cidade');
                  $uf = '';//@$this->db->get_where('clientes_tc', array('clientes_tc_id' => $client_id))->row('tc_residencial_uf');                  
                  break;
                case 'te':
                  $cidade = '';//@$this->db->get_where('clientes_te', array('clientes_te_id' => $client_id))->row('te_residencial_cidade');
                  $uf = '';//@$this->db->get_where('clientes_te', array('clientes_te_id' => $client_id))->row('te_residencial_uf');                  
                  break;                                                      
                default:
                  $cidade = '';
                  $uf = '';
              }
        
        $cidadeUF  = $cidade.'-'.$uf ;
        
        return $cidadeUF;
    }
    
    function get_clientes_ultimo_contato($client_id,$tipo_form,$field = 'data')
    {
        return $this->db->get_where('w_clientes_obs_max_data', array('form_client_id' => $client_id, 'form_tipo'=>$tipo_form))->row()->$field;
    }
    
    function get_status_by_id($status_id, $field = 'status')
    {
        return $this->db->get_where('status_cliente', array('status_cliente_id' => $status_id))->row()->$field;
    }
    
    function get_client_tipo_form($client_id, $field = 'tipo_form')
    {
        return $this->db->get_where('client', array('client_id' => $client_id))->row()->$field;
    }
    
    function get_enviado_cs($client_form_id, $tipo_form ,$field = 'enviado_cs')
    {
        $client_id = $this->db->get_where('w_client', array('form_client_id' => $client_form_id, 'tipo_form' => $tipo_form ))->row()->client_id;
        return $this->db->get_where('client', array('client_id' => $client_id))->row()->$field;
    }
        
    function get_boleto_status($client_form_id, $tipo_form)
    {
        $status = @$this->db->get_where('financeiro', array('form_client_id' => $client_form_id, 'form_tipo' => $tipo_form ))->row('status');
        
            switch ($status) {
                case 'enviado':
                     $status = '<font color="#FFBB1F"><i class="icon-envelope"></i></font>';
                  break;
                case 'pago':
                    $status = '<font color="#5DB3DF"><i class="icon-ok-sign"></i></font>';
                  break;
                case 'cancelado':
                    $status = '<i class="icon-remove-sign"></i>';
                  break;                                                      
                default:
                   $status = '<i class="icon-minus-sign vermelho"></i>';
              } 
                
        return $status;
    }
    
    function get_log_acesso($client_id)
    {
        //$this->db->count_all_results('log_acesso');
        $this->db->where('user', $client_id);
        $this->db->where('tipo =', 'accesso');
        $this->db->from('log_acesso');

        return $this->db->count_all_results();
    }

    /////////FILES/////////////
    function get_file()
    {
        $query = $this->db->get('files');
        return $query->result_array();
    }

    function get_file_info($file_id)
    {
        $query = $this->db->get_where('files', array('file_id' => $file_id));
        return $query->result_array();
    }

    function get_status_inicial($status_id)
    {
        switch ($status_id) {
                case '1':
                     $status = 'Novo';
                  break;
                case '2':
                    $status = 'Contato Feito';
                  break;
                case '3':
                    $status = 'Desistência Cliente';
                  break;
                case '4':
                    $status = 'Perfil Não Atendido';
                  break;                                                                         
                default:
                   $status = '';
        } 
        
        return $status;
    }

    function get_status_inicial_cor($status_id)
    {
        switch ($status_id) {
                case '1':
                     $cor = 'vermelho';
                  break;
                case '2':
                    $cor = 'verde';
                  break;
                case '3':
                    $cor = 'amarelo';
                  break;
                case '4':
                    $cor = 'cinza';
                  break;                                                                         
                default:
                   $cor = 'preto';
        } 
        
        return $cor;
    }
    
    function get_status_client_cor($status_id)
    {
        switch ($status_id) {
                case '1':
                     $cor = 'vermelho';
                  break;
                case '2':
                    $cor = 'verde';
                  break;
                case '3':
                    $cor = 'preto';
                  break;
                case '4':
                    $cor = 'preto';
                  break;
                case '5':
                    $cor = 'amarelo';
                  break; 
                case '6':
                    $cor = 'azul';
                  break; 
                case '7':
                    $cor = 'cinza';
                  break;                                                                                                                                 
                default:
                   $cor = 'preto';
        } 
        
        return $cor;
    } 
    
    function get_op_achou_contsimples($id)
    {
        return $this->db->get_where('op_achou_contsimples', array('id' => $id))->row()->opcao;
    }
    function get_op_contabilidade_anterior($id)
    {
        return $this->db->get_where('op_contabilidade_anterior', array('id' => $id))->row()->opcao;
    }    
    function get_op_ramo_atuacao($id)
    {
        return $this->db->get_where('op_ramo_atuacao', array('id' => $id))->row()->opcao;
    }                    

    function get_nome_tipo_form($id)
    {
          switch ($id) {
                case 'ac':
                    $nome_form = 'abrir comercio';           
                  break;
                case 'fc':
                    $nome_form = 'abrir empresa';
                  break;
                case 'ma':
                    $nome_form = 'abrir mei';             
                  break;
                case 'mt':
                    $nome_form = 'tazer mei';           
                  break;
                case 'pl':
                    $nome_form = 'trazer pl';            
                  break;
                case 'tc':
                    $nome_form = 'trazer comercio';             
                  break;
                case 'te':
                    $nome_form = 'trazer empresa';              
                  break;                                                      
                default:
                  $nome_form = '';
              }
        
        return $nome_form;
    } 
    
    function get_cod_alterdata($id,$tipo_form)
    {
          switch ($tipo_form) {
                case 'ac':
                  $alterdata = @$this->db->get_where('clientes_ac', array('clientes_ac_id' => $id))->row('alterdata');
                  break;
                case 'fc':
                  $alterdata = @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $id))->row('alterdata');
                  break;
                case 'ma':
                  $alterdata = @$this->db->get_where('clientes_ma', array('clientes_ma_id' => $id))->row('alterdata');                 
                  break;
                case 'mt':
                  $alterdata = @$this->db->get_where('clientes_mt', array('clientes_mt_id' => $id))->row('alterdata');                  
                  break;
                case 'pl':
                  $alterdata = @$this->db->get_where('clientes_pl', array('clientes_pl_id' => $id))->row('alterdata');                 
                  break;
                case 'tc':
                  $alterdata = @$this->db->get_where('clientes_tc', array('clientes_tc_id' => $id))->row('alterdata');                  
                  break;
                case 'te':
                  $alterdata = @$this->db->get_where('clientes_te', array('clientes_te_id' => $id))->row('alterdata');                  
                  break;                                                      
                default:
                  $alterdata = '';
              }
        
        return $alterdata;
    }    

}
