<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Crud_model extends CI_Model {

    function __construct()
    {
        parent::__construct();
    }

    function clear_cache()
    {
        $this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
        $this->output->set_header('Pragma: no-cache');
    }
    function get_type_name_by_id($type,$type_id='',$field='name')
    {
        return	$this->db->get_where($type,array($type.'_id'=>$type_id))->row()->$field;
    }


    /////////ADMIN/////////////
    function get_admin()
    {
        $query	=	$this->db->get('admin' );
        return $query->result_array();
    }
    function get_admin_info($admin_id)
    {
        $query	=	$this->db->get_where('admin' , array('admin_id' => $admin_id));
        return $query->result_array();
    }
    function get_name_by_admin($admin_id,$field='name')
    {
        return	$this->db->get_where('admin',array('admin_id'=>$admin_id))->row()->$field;
    }
    function get_email_by_admin($admin_id,$field='email')
    {
        return	$this->db->get_where('admin',array('admin_id'=>$admin_id))->row()->$field;
    }

    ///////// DASHBOARD /////////////
    function get_count_message($client_id)
    {
        $this->db->count_all_results('message');  // Produces an integer, like 25
        $this->db->where('sender', $client_id);
        $this->db->from('message');

        return	$this->db->count_all_results();
    }
    function get_count_cobranca($client_id)
    {
        $this->db->count_all_results('files');  // Produces an integer, like 25
        $this->db->where('client', $client_id);
        $this->db->where('product', '60');
        $this->db->where('status !=', 'pago');
        $this->db->from('files');

        return	$this->db->count_all_results();
    }

    /////////BULK_MAIL/////////////
    function get_bulk_mail()
    {
        $query	=	$this->db->get('bulk_mail' );
        return $query->result_array();
    }
    function get_bulk_mail_info($bulk_mail_id)
    {
        $query	=	$this->db->get_where('bulk_mail' , array('bulk_mail_id' => $bulk_mail_id));
        return $query->result_array();
    }

    /////////CATEGORY/////////////
    function get_category()
    {
        $query	=	$this->db->get('category' );
        return $query->result_array();
    }
    function get_category_info($category_id)
    {
        $query	=	$this->db->get_where('category' , array('category_id' => $category_id));
        return $query->result_array();
    }
    function get_category_name_by_id($category_id)
    {
        $query	=	$this->db->get_where('category' , array('category_id' => $category_id));
        return $query->result_array();
    }
    function get_category_ordenada($ind_client)
    {
        $this->db->order_by('ordem', 'ASC');
        $this->db->order_by('name', 'ASC');
        $query	=	$this->db->get_where('category',array('ind_client' => $ind_client));

        return $query->result_array();
    }

    /////////CLIENT/////////////
    function get_client()
    {
        $query	=	$this->db->get('client');
        return $query->result_array();
    }
    function get_client_info($client_id)
    {
        $query	=	$this->db->get_where('client' , array('client_id' => $client_id));
        return $query->result_array();
    }
    function get_name_by_client($client_id,$field='name')
    {
        return	$this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }
    function get_client_pj_pf($client_id,$field='pj_pf')
    {
        return	$this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }
    function get_cnpj_cpf_by_client($client_id,$field='cnpj_cpf')
    {
        return	$this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }
    function get_client_usa_dp($client_id,$field='usa_dp')
    {
        return	$this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }
    function get_client_usa_nota_fiscal($client_id,$field='usa_nota_fiscal')
    {
        return	$this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }
    function get_alterdata_by_client($client_id,$field='alterdata')
    {
        return	$this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }
    function get_email_by_client($client_id,$field='email')
    {
        return	$this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }
    function get_client_aliquota_iss($client_id,$field='aliquota_iss')
    {
        return $this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }
    function get_log_acesso($client_id)
    {
        //$this->db->count_all_results('log_acesso');
        $this->db->where('user', $client_id);
        $this->db->where('tipo =', 'accesso');
        $this->db->from('log_acesso');

        return	$this->db->count_all_results();
    }
    ///////// Client Sócio /////////////
    function get_count_socio($client_id)
    {
        //$this->db->count_all_results('client_socio');  // Produces an integer, like 25
        $this->db->where('client', $client_id);
        $this->db->from('client_socio');

        return	$this->db->count_all_results();
    }
    function get_client_socio_info($client_socio_id)
    {

        $query	=	$this->db->get_where('client_socio' , array('client_socio_id' => $client_socio_id));

        return $query->result_array();
    }
    function get_all_client_socio_info($client_id)
    {
        $query	=	$this->db->get_where('client_socio' , array('client' => $client_id));

        return $query->result_array();
    }
    function get_nome_by_client_socio($client_id,$field='name')
    {
        return	$this->db->get_where('w_client_socio_resp_cnpj',array('client'=>$client_id))->row()->$field;
    }
    function get_cnpj_cpf_by_client_socio($client_id,$field='cnpj_cpf')
    {
        return	$this->db->get_where('w_client_socio_resp_cnpj',array('client'=>$client_id))->row()->$field;
    }
    function get_id_by_client_socio($client_id,$field='cliente_socio')
    {
        return	$this->db->get_where('w_client_socio_resp_cnpj',array('client'=>$client_id))->row()->$field;
    }
    //////// IBGE ///////////////////////////

    function get_ibge_uf($uf,$field='cod_uf')
    {
        return $this->db->get_where('tb_ex_ibge',array('uf'=>$uf))->row()->$field;
    }
    function get_ibge_cidade($cidade,$field)
    {
        return $this->db->get_where('tb_ex_ibge',array('nome'=>$cidade))->row()->$field;
    }
    //////// Cliente Atividade /////////////
    function get_client_atividade_desc($cae,$field='descricao')
    {
        return $this->db->get_where('tb_ex_cae',array('cae'=>$cae))->row()->$field;
    }
    //////// Cliente Cnae /////////////
    function get_client_cnae_desc($cnae,$field='descricao')
    {
        return $this->db->get_where('tb_ex_cnae',array('cnae'=>$cnae))->row()->$field;
    }
    ///////// Dest Cliente - Meus Clientes /////////////
    function get_client_dest_cliente_all_info($client_id)
    {

        $query	=	$this->db->get_where('dest_cliente' , array('cliente' => $client_id));

        return $query->result_array();
    }
    function get_client_dest_cliente_info($dest_client_id)
    {

        $query	=	$this->db->get_where('dest_cliente' , array('dest_cliente_id' => $dest_client_id));

        return $query->result_array();
    }
    function get_name_by_dest_client($dest_cliente_id,$field='dest_cliente')
    {
        return	$this->db->get_where('dest_cliente',array('dest_cliente_id'=>$dest_cliente_id))->row()->$field;
    }

    ///////// Funcionário /////////////
    function get_funcionario_info($dp_funcionario_id)
    {

        $query	=	$this->db->get_where('dp_funcionario' , array('dp_funcionario_id' => $dp_funcionario_id));

        return $query->result_array();
    }

    ///////// Dependente /////////////
    function get_dependente_info($dp_dependente_id)
    {

        $query	=	$this->db->get_where('dp_dependente' , array('dp_dependente_id' => $dp_dependente_id));

        return $query->result_array();
    }

    /////////GROUP/////////////
    function get_group()
    {
        $query	=	$this->db->get('group' );
        return $query->result_array();
    }
    function get_group_info($group_id)
    {
        $query	=	$this->db->get_where('group' , array('group_id' => $group_id));
        return $query->result_array();
    }

    /////////INVOICE/////////////
    function get_invoice()
    {
        $query	=	$this->db->get('invoice' );
        return $query->result_array();
    }
    function get_invoice_info($invoice_id)
    {
        $query	=	$this->db->get_where('invoice' , array('invoice_id' => $invoice_id));
        return $query->result_array();
    }
    function get_orders_by_client($client_id)
    {
        $query	=	$this->db->get_where('order' , array('client' => $client_id));
        return $query->result_array();
    }
    function get_product_detail_by_order($order_id, $field = 'name', $product = 'product')
    {
        $product = $this->db->get_where('order',array('order_id'=>$order_id))->row()->$product;
        return	$this->db->get_where('product',array('product_id'=>$product))->row()->$field;
    }

    function get_order_amount($order_id, $field = 'total_price')
    {
        return	$this->db->get_where('order',array('order_id'=>$order_id))->row()->$field;
    }

    /////////MESSAGE/////////////
    function get_message()
    {
        $query	=	$this->db->get('message' );
        return $query->result_array();
    }
    function get_message_info($message_id)
    {
        $query	=	$this->db->get_where('message' , array('message_id' => $message_id));
        return $query->result_array();
    }

    /////////NOTE/////////////
    function get_note()
    {
        $query	=	$this->db->get('note' );
        return $query->result_array();
    }
    function get_note_info($note_id)
    {
        $query	=	$this->db->get_where('note' , array('note_id' => $note_id));
        return $query->result_array();
    }
    function get_note_name($sender,$field='name')
    {
        return	$this->db->get_where('admin',array('admin_id'=>$sender))->row()->$field;
    }
    function get_count_anotacao($admin_id)
    {
        $this->db->count_all_results('note');  // Produces an integer, like 25
        $this->db->where('note', $admin_id);
        $this->db->where('status !=', 'finalizado');
        $this->db->from('note');

        return	$this->db->count_all_results();
    }

    /////////ORDER/////////////
    function get_order()
    {
        $query	=	$this->db->get('order' );
        return $query->result_array();
    }
    function get_order_info($order_id)
    {
        $query	=	$this->db->get_where('order' , array('order_id' => $order_id));
        return $query->result_array();
    }

    function get_products_by_type($type_id)
    {
        $query	=	$this->db->get_where('product' , array('type' => $type_id));
        return $query->result_array();
    }

    function get_ref_by_product($ref)
    {
        $query	=	$this->db->get_where('product' , array('w_product_ref' => $ref));
        return $query->result_array();
    }
    function get_cnpj_by_client($client)
    {
        $query	=	$this->db->get_where('client' , array('client_id' => $client));
        return $query->result_array();
    }
    /////////FILES/////////////
    function get_file()
    {
        $query	=	$this->db->get('files' );
        return $query->result_array();
    }
    function get_file_info($file_id)
    {
        $query	=	$this->db->get_where('files' , array('file_id' => $file_id));
        return $query->result_array();
    }


    /////////NOTAS FISCAIS/////////////
    function get_xml_info($xml_id)
    {
        $query	=	$this->db->get_where('xmls' , array('xml_id' => $xml_id));
        return $query->result_array();
    }

    function get_nome_municipio($codigo_munic,$field='nome')
    {
        return	$this->db->get_where('tb_ex_ibge',array('codigo'=>$codigo_munic))->row()->$field;
    }

    function get_nome_cnae($n_cnae,$field='descricao')
    {
        return	$this->db->get_where('tb_ex_cnae',array('cnae'=>$n_cnae))->row()->$field;
    }

    function get_nome_cae($n_cae,$field='descricao')
    {
        return	$this->db->get_where('tb_ex_cae',array('cae'=>$n_cae))->row()->$field;
    }
    function get_nfs_info($nfs_id)
    {
        $query	=	$this->db->get_where('nfs' , array('nfs_id' => $nfs_id));
        return $query->result_array();
    }
    function get_nota_num_by_client($client,$field='nfs_num')
    {
        return	$this->db->get_where('nfs_n',array('cliente'=>$client))->row()->$field;
    }
    /////////RECIBOS/////////////
    function get_recibo_info($recibo_id)
    {
        $query	=	$this->db->get_where('recibo' , array('recibo_id' => $recibo_id));
        return $query->result_array();
    }

    /////////RECIBOS NUMERO/////////////

    function get_recibo_num_by_client($client,$field='recibo_num')
    {

        return	$this->db->get_where('recibo_n',array('client'=>$client))->row()->$field;
    }

    /////////PRODUCT/////////////
    function get_product()
    {
        $query	=	$this->db->get('product' );
        return $query->result_array();
    }
    function get_product_info($product_id)
    {
        $query	=	$this->db->get_where('product' , array('product_id' => $product_id));
        return $query->result_array();
    }

    /////////TRANSACTION/////////////
    function get_transaction()
    {
        $query	=	$this->db->get('transaction' );
        return $query->result_array();
    }
    function get_transaction_info($transaction_id)
    {
        $query	=	$this->db->get_where('transaction' , array('transaction_id' => $transaction_id));
        return $query->result_array();
    }

    /////////TYPE/////////////
    function get_type()
    {
        $query	=	$this->db->get('type' );
        return $query->result_array();
    }
    function get_type_info($type_id)
    {
        $query	=	$this->db->get_where('type' , array('type_id' => $type_id));
        return $query->result_array();
    }
    function get_types_by_category($category_id)
    {
        $query	=	$this->db->get_where('type' , array('category' => $category_id));
        return $query->result_array();
    }



/////////EXTRAS/////////////

    function get_desc_pasta_num_by_product($product,$field='description')
    {
        return	$this->db->get_where('product',array('product_id'=>$product))->row()->$field;
    }

/////////FILES EXTRAS/////////////
    function get_pasta_by_files_extra_id($files_extra_id,$field='path')
    {
        return	$this->db->get_where('files_extra',array('files_extra_id'=>$files_extra_id))->row()->$field;
    }

/////////Cliente dos Clientes /////////////

    function get_dest_cliente_info($dest_cliente_id)
    {
        $query	=	$this->db->get_where('dest_cliente' , array('dest_cliente_id' => $dest_cliente_id));
        return $query->result_array();
    }

}
//////// CONTRATO /////////////
function get_log_contrato($client_id)
    {
        $query	=	$this->db->get_where('client_contrato' , array('cliente' => $client_id));
        return $query->result_array();
    }
