<?php
if (!defined('BASEPATH'))
    exit('No direct script access allowed');

/*  
 *  @author : Wallace Pacheco
 *  date    : 01 junho, 2015
 *  ContSimples Tecnologia
 *  http://contsimples.com.br
 */
 
/*
|---------------------------------------------------------------
| TimeZone 
|---------------------------------------------------------------
*/
date_default_timezone_set('America/Sao_Paulo');

class Client extends CI_Controller
{
    
    
    function __construct()
    {
        parent::__construct();
        $this->load->database();
        $this->load->library('calendar');
        $this->load->helper('date');
        //$this->load->library('phplot.php');
        /*cache control*/
        $this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
        $this->output->set_header('Pragma: no-cache');
    }
    
/***default functin, redirects to login page if no client logged in yet***/
    public function index()
    {

        if ($this->session->userdata('client_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');
        if ($this->session->userdata('client_login') == 1)
            redirect(base_url() . 'index.php?client/dashboard', 'refresh');
    }
    
/***CLIENTE DASHBOARD***/
    function dashboard()
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        $page_data['page_name']  = 'dashboard';
        $page_data['page_icon'] = 'dashboard';
        $page_data['page_title'] = 'Painel';
        $this->load->view('index', $page_data);
    }
    

/****MANAGE message*****/
    function message($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['sender']        = $this->input->post('sender');
            $data['sender_type']   = $this->input->post('sender_type');
            $data['receiver']      = $this->input->post('receiver');
            $data['receiver_type'] = $this->input->post('receiver_type');
            $data['subject']       = $this->input->post('subject');
            $data['body']          = $this->input->post('body');
            $data['time']          = $this->input->post('time');
            $data['date']          = $this->input->post('date');
            $this->db->insert('message', $data);
            redirect(base_url() . 'index.php?client/message/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['sender']        = $this->input->post('sender');
            $data['sender_type']   = $this->input->post('sender_type');
            $data['receiver']      = $this->input->post('receiver');
            $data['receiver_type'] = $this->input->post('receiver_type');
            $data['subject']       = $this->input->post('subject');
            $data['body']          = $this->input->post('body');
            $data['time']          = $this->input->post('time');
            $data['date']          = $this->input->post('date');
            $this->db->insert('message', $data);
            redirect(base_url() . 'index.php?client/message/', 'refresh');
        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile']   = true;
            $page_data['current_message_id'] = $param2;
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('message', array(
                'message_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $this->db->where('message_id', $param2);
            $this->db->delete('message');
            redirect(base_url() . 'index.php?client/message/', 'refresh');
        }
        $page_data['message']    = $this->db->get('message')->result_array();
        $page_data['page_name']  = 'message';
        $page_data['page_icon']  = 'envelope';
        $page_data['page_title'] = 'Fale Conosco';
        $this->load->view('index', $page_data);
    }
     
/****MANAGE files*****
    function files($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['file']      = $this->input->post('file');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            $data['status']      = $this->input->post('status');
            $this->db->insert('files', $data);
            redirect(base_url() . 'index.php?client/files/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['file']        = $this->input->post('file');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            $data['status']      = $this->input->post('status');
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect(base_url() . 'index.php?client/files/', 'refresh');
        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile'] = true;
            $page_data['current_file_id'] = $param2;
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('files', array(
                'file_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $this->db->where('file_id', $param2);
            $this->db->delete('files');
            redirect(base_url() . 'index.php?client/files/', 'refresh');
        }
        if ($param1 == 'upload_info') {


            $data['file']        = $_FILES['file']['name'];
            $data['path']        = $this->input->post('path').$_FILES['file']['name'];
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['desc_file']     = $this->input->post('desc_file');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            $data['status']      = $this->input->post('status');
            $this->db->insert('files', $data);

            move_uploaded_file($_FILES['file']['tmp_name'], $this->input->post('path').$_FILES['file']['name']);
            $this->session->set_flashdata('flash_message', get_phrase('Arquivo Enviado'));

            redirect(base_url() . 'index.php?client/files/', 'refresh');
        }
        $page_data['files']      = $this->db->get('files')->result_array();
        $page_data['page_name']  = 'files';
        $page_data['page_icon'] = 'file';
        $page_data['page_title'] = 'manage_files';
        $this->load->view('index', $page_data);
    }
/****GESTÃO - files_extra*****/
    function files_extra($param1 = '', $param2 = '', $param3 = '')
    {
        /**** Definição de variáveis *****/
        $Xrand = '';
        $origem = '';
        $destino = ''; 
        $XnovoNome = '';
        
        
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['file']         = $this->input->post('file');
            $data['path']         = $this->input->post('path');
            $data['client']       = $this->input->post('client');
            $data['product']      = $this->input->post('product');
            $data['quantity']     = $this->input->post('quantity');
            $data['valor']        = $this->input->post('valor');
            $data['date']         = $this->input->post('date');
            $data['ind_up']       = $this->input->post('ind_up');
            $data['status']       = $this->input->post('status');
            $this->db->insert('files_extra', $data);
            redirect(base_url() . 'index.php?client/files_extra/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['file']        = $this->input->post('file');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            $data['status']      = $this->input->post('status');
            $this->db->where('file_extra_id', $param2);
            $this->db->update('files_extra', $data);
            redirect(base_url() . 'index.php?client/files_extra/', 'refresh');
        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile'] = true;
            $page_data['current_file_id'] = $param2;
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('files_extra', array(
                'file_extra_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
        
            $Xdados = $this->db->get_where('files_extra', array('file_extra_id' => $param2))->result_array(); 
             //print_r($Xdados);
             
            foreach($Xdados as $row):
            $origem = $row['path'];
            $destino = $origem;
            endforeach;
            //print_r($origem);
                          
            $destino =  str_replace('/doc_extra/','/_lixo/', $destino);
            //print_r($destino);
            
            copy($origem, $destino);
            unlink($origem);
            
            // Geração do Log   ------------------------------------------------
            $log['admin']        = '';
            $log['client']       = $this->session->userdata('client_id');  
            $log['path']         = $destino;
            $format = 'DATE_W3C';
            $time = time();
            $log['date']         = standard_date($format, $time) ;
            $log['tipo']         = 'deleted';
            $this->db->insert('log', $log);
            // FIM - Geração do Log   ------------------------------------------
                 
            $this->db->where('file_extra_id', $param2);
            $this->db->delete('files_extra');
            $this->session->set_flashdata('flash_message', get_phrase('Arquivo Deletado!'));
            redirect(base_url() . 'index.php?client/files_extra/', 'refresh');
        }
        if ($param1 == 'upload_info') {
        
            $Xrand =  mt_rand();

            if ( !empty($_FILES['file']['name'])){
            
            $XnovoNome = strtolower($this->caracter_model->t5f_translit($_FILES['file']['name']));
             
            $data['file']         = $_FILES['file']['name'];
            $data['path']         = $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome;
            //$data['path']         = $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$_FILES['file']['name'];
            $data['client']       = $this->input->post('client');
            $data['product']      = $this->input->post('product');
            //$data['desc_file']    = $_FILES['file']['name']; 
            $data['desc_file']    = $this->input->post('desc_file');
            $data['quantity']     = $this->input->post('quantity');
            $data['valor']        = $this->input->post('valor');
            $data['date']         = $this->input->post('date');
            $data['data_venc']    = $this->input->post('date');
            $data['ind_up']       = $this->input->post('ind_up');
            $data['status']       = $this->input->post('status');
            $this->db->insert('files_extra', $data);

            move_uploaded_file($_FILES['file']['tmp_name'], $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome);
            //move_uploaded_file($_FILES['file']['tmp_name'], $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$_FILES['file']['name']);
            $this->session->set_flashdata('flash_message', get_phrase('Arquivo Enviado'));
            
            $Xcontato       = $this->db->get_where('client', array('client_id' => $this->input->post('client')))->row()->contact;
            $Xemail         = $this->db->get_where('client', array('client_id' => $this->input->post('client')))->row()->email;
            $Xnome_empresa  = $this->db->get_where('client', array('client_id' => $this->input->post('client')))->row()->name;
            $Xtel           = $this->db->get_where('client', array('client_id' => $this->input->post('client')))->row()->ddd_phone.' '.$this->db->get_where('client', array('client_id' => $this->input->post('client')))->row()->phone;
            $Xdocumento     = $this->db->get_where('client', array('client_id' => $this->input->post('client')))->row()->cnpj_cpf;
            $Xalterdata     = $this->db->get_where('client', array('client_id' => $this->input->post('client')))->row()->alterdata;
            $Xdesc_arquivo  = $this->input->post('desc_file'); 
            $Xarquivo       = ($this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome);

            $this->email_model->envia_email_postagem_cliente($Xcontato,$Xemail,$Xnome_empresa,$Xarquivo,$Xdesc_arquivo,$Xtel,$Xdocumento,$Xalterdata);

            redirect(base_url() . 'index.php?client/files_extra/', 'refresh');    
              }  else 
                  {
                 $this->session->set_flashdata('flash_message', get_phrase('Arquivo Não Enviado, favor adicionar um arquivo!'));
                 redirect(base_url() . 'index.php?client/files_extra/', 'refresh'); 
                 }

        }
        $page_data['files']       = $this->db->get_where('files_extra', array('client' => $this->session->userdata('client_id')))->result_array();
        $page_data['page_name']   = 'files_extra';
        $page_data['page_icon']   = 'file';
        $page_data['page_title']  = 'Enviar Documentos Extras';
        $this->load->view('index', $page_data);
    }
    
/**** BLOCO  - NOTAS FISCAIS |-> nf
    
    Importar || importar
    consultar || consultar

*****/
    /**** NOTAS FISCAIS |-> nf  -  importar ****/
    function nf_importar($param1 = '', $param2 = '', $param3 = '')
    {
        
        /**** Definição de variáveis *****/
        $Xrand = '';
        $origem = '';
        $destino = ''; 
        $XnovoNome = '';
        
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['xml']      = $this->input->post('xml');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->insert('xmls', $data);
            redirect(base_url() . 'index.php?client/nf_importar/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['xml']        = $this->input->post('xml');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->where('xml_id', $param2);
            $this->db->update('xmls', $data);
            redirect(base_url() . 'index.php?client/nf_importar/', 'refresh');
        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile'] = true;
            $page_data['current_xml_id'] = $param2;
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('xmls', array(
                'xml_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
        
            $Xdados = $this->db->get_where('xmls', array('xml_id' => $param2))->result_array();
             //print_r($Xdados);
             
            foreach($Xdados as $row):
            $origem = $row['path'];
            $destino = $origem;
            endforeach;
            //print_r($origem);
                          
            $destino =  str_replace('/xml/','/_lixo/', $destino);
            //print_r($destino);
            
            copy($origem, $destino);
            unlink($origem);
                 
            $this->db->where('xml_id', $param2);
            $this->db->delete('xmls');
            $this->session->set_flashdata('flash_message', get_phrase('Arquivo Deletado!'));
            redirect(base_url() . 'index.php?client/nf_consultar/', 'refresh');
      
        }
        if ($param1 == 'upload_info') {
        
            $Xrand =  mt_rand();
            
            if ( !empty($_FILES['file']['name'])){
            
            $XnovoNome = strtolower($this->caracter_model->t5f_translit($_FILES['file']['name']));
            
            $data['xml']         = $_FILES['file']['name'];
            $data['path']        = $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome;
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['desc_xml']    = $_FILES['file']['name'];
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            $data['status']      = $this->input->post('status');
            $this->db->insert('xmls', $data);

            move_uploaded_file($_FILES['file']['tmp_name'], $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome);
            $this->session->set_flashdata('flash_message', get_phrase('Arquivo Enviado'));
            
            redirect(base_url() . 'index.php?client/nf_importar/', 'refresh');    
              }  else 
                  {
                 $this->session->set_flashdata('flash_message', get_phrase('Arquivo Não Importado, favor adicionar o arquivo'));
                 redirect(base_url() . 'index.php?client/nf_importar/', 'refresh'); 
                 }
        }
        $page_data['xmls']      = $this->db->get('xmls')->result_array();
        $page_data['page_name']  = 'nf_importar';
        $page_data['page_icon'] = 'download-alt';
        $page_data['page_title'] = 'Nota Fiscal - Importar';
        $this->load->view('index', $page_data);
    }

    /**** NOTAS FISCAIS |-> nf  -  consultar ****/
    function nf_consultar($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['files']      = $this->db->get('xmls')->result_array();
        $page_data['page_name']  = 'nf_consultar';
        $page_data['page_icon']  = 'search';
        $page_data['page_title'] = 'Nota Fiscal - Consultar';
        $this->load->view('index', $page_data);
    }
/**** FIM - BLOCO  -    NOTAS FISCAIS |-> nf    *****/


 /**** BLOCO  -   MOV |-> Movimentações

    Consultar - consultar 
    Importar - importar
    lançar - lancar
    Recibos    

*****/
    /**** MOV |-> Movimentações  -  consultar ****/
    function mov_consultar($param1 = '', $param2 = '', $param3 = '')
    {
        
                /**** Definição de variáveis *****/
        $Xrand = '';
        $origem = '';
        $destino = ''; 
        $XnovoNome = '';
        
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['file']        = $this->input->post('file');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->insert('files', $data);
            redirect(base_url() . 'index.php?client/mov_consultar/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['file']        = $this->input->post('file');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect(base_url() . 'index.php?client/mov_consultar/', 'refresh');
        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile'] = true;
            $page_data['current_file_id'] = $param2;
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('files', array(
                'file_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $this->db->where('file_id', $param2);
            $this->db->delete('files');
            redirect(base_url() . 'index.php?client/mov_consultar/', 'refresh');
        }
        if ($param1 == 'upload_info') {

            $Xrand =  mt_rand();
            
            $XnovoNome = strtolower($this->caracter_model->t5f_translit($_FILES['file']['name']));
            
            $data['file']        = $_FILES['file']['name'];
            $data['path']        = $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome;
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['desc_file']   = $this->input->post('desc_file');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            $data['status']      = $this->input->post('status');
            $this->db->insert('files', $data);

            move_uploaded_file($_FILES['file']['tmp_name'], $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome);
            $this->session->set_flashdata('flash_message', get_phrase('Arquivo Enviado'));

            redirect(base_url() . 'index.php?client/mov_consultar/', 'refresh');
        }
        $page_data['files']      =  $this->db->get_where('files', array('product' => ''))->result_array();
        $page_data['page_name']  = 'mov_consultar';
        $page_data['page_icon'] = 'search';
        $page_data['page_title'] = 'Consultar Movimentos';
        $this->load->view('index', $page_data);
    }

    /**** MOV |-> Movimentações  -  importar ****/
    function mov_importar($param1 = '', $param2 = '', $param3 = '')
    {
                /**** Definição de variáveis *****/
        $Xrand = '';
        $origem = '';
        $destino = ''; 
        $XnovoNome = '';
        
        
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['file']        = $this->input->post('file');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->insert('files', $data);
            redirect(base_url() . 'index.php?client/mov_importar/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['file']        = $this->input->post('file');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect(base_url() . 'index.php?client/mov_importar/', 'refresh');
        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile'] = true;
            $page_data['current_file_id'] = $param2;
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('files', array(
                'file_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
        
            $Xdados = $this->db->get_where('files', array('file_id' => $param2))->result_array();
            //print_r($Xdados);
             
            foreach($Xdados as $row):
            $origem = $row['path'];
            $destino = $origem;
            endforeach;
            //print_r($origem);
                          
            $destino =  str_replace('/mov/','/_lixo/', $destino);
            //print_r($destino);
            
            copy($origem, $destino);
            unlink($origem);
                 
            $this->db->where('file_id', $param2);
            $this->db->delete('files');
            $this->session->set_flashdata('flash_message', get_phrase('Arquivo Deletado!'));
            redirect(base_url() . 'index.php?client/mov_importar/', 'refresh');

            
        }
        if ($param1 == 'upload_info') {

            $Xrand =  mt_rand();
            
            $XnovoNome = strtolower($this->caracter_model->t5f_translit($_FILES['file']['name']));
            
            $data['file']        = $_FILES['file']['name'];
            $data['path']        = $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome;
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['desc_file']   = $this->input->post('desc_file');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            $data['status']      = $this->input->post('status');
            $this->db->insert('files', $data);

            move_uploaded_file($_FILES['file']['tmp_name'], $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome);
            $this->session->set_flashdata('flash_message', get_phrase('Arquivo Enviado'));

            redirect(base_url() . 'index.php?client/mov_importar/', 'refresh');
        }
        $page_data['files']      =  $this->db->get_where('files', array('product' => ''))->result_array();
        $page_data['page_name']  = 'mov_importar';
        $page_data['page_icon']  = 'download-alt';
        $page_data['page_title'] = 'Movimentações - Importar Extrato Bancário';
        $this->load->view('index', $page_data);
    }

    /**** MOV |-> Movimentações  -  lancar ****/
    function mov_lancar($param1 = '', $param2 = '', $param3 = '')
    {
                /**** Definição de variáveis *****/
        $Xrand = '';
        $origem = '';
        $destino = ''; 
        $XnovoNome = '';
        
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['mov']          = $_FILES['mov']['name'];
            $data['tipo_mov']     = $this->input->post('tipo_mov');
            if ( empty($_FILES['mov']['name'])){
                $data['path']         = 'Sem Arquivo';
              }  else 
            $Xrand =  mt_rand();
            
            $XnovoNome = strtolower($this->caracter_model->t5f_translit($_FILES['mov']['name']));
              
            $data['path']         = $this->input->post('path').$this->input->post('alterdata').'_E_'.$Xrand.'_'.$XnovoNome;
            $data['client']       = $this->input->post('client');
            $data['category']     = $this->input->post('category');
            $data['desc_mov']     = $this->input->post('desc_mov');
            $data['quantity']     = $this->input->post('quantity');
            $data['valor']        = $this->input->post('valor');
            $data['date']         = $this->input->post('date');
            $data['alt_date']     = $this->input->post('alt_date');
            $data['status']       = $this->input->post('status');
            $this->db->insert('mov', $data);
            
            move_uploaded_file($_FILES['mov']['tmp_name'], $this->input->post('path').$this->input->post('alterdata').'_E_'.$Xrand.'_'.$XnovoNome);
            $this->session->set_flashdata('flash_message', get_phrase('Movimento Salvo!'));
            
                         
            redirect(base_url() . 'index.php?client/mov_lancar/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['mov']          = $this->input->post('mov');
            $data['tipo_mov']     = $this->input->post('tipo_mov');
            $data['path']         = $this->input->post('path');
            $data['client']       = $this->input->post('client');
            $data['category']     = $this->input->post('category');
            $data['desc_mov']     = $this->input->post('mov');
            $data['quantity']     = $this->input->post('quantity');
            $data['valor']        = $this->input->post('valor');
            $data['date']         = $this->input->post('date');
            $data['alt_date']     = $this->input->post('alt_date');
            $data['status']       = $this->input->post('status');
            $this->db->where('mov_id', $param2);
            $this->db->update('mov', $data);
            redirect(base_url() . 'index.php?client/mov_lancar/', 'refresh');
        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile'] = true;
            $page_data['current_file_id'] = $param2;
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('mov', array(
                'mov_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
        
            $Xdados = $this->db->get_where('mov', array('mov_id' => $param2))->result_array();
            //print_r($Xdados);
             
            foreach($Xdados as $row):
            $origem = $row['path'];
            $destino = $origem;
            endforeach;
            //print_r($origem);
                          
            $destino =  str_replace('/mov/','/_lixo/', $destino);
            //print_r($destino);
            
            copy($origem, $destino);
            unlink($origem);
                 
            $this->db->where('mov_id', $param2);
            $this->db->delete('mov');
            $this->session->set_flashdata('flash_message', get_phrase('Arquivo Deletado!'));
            redirect(base_url() . 'index.php?client/mov_lancar/', 'refresh');

        }
        if ($param1 == 'visualizar') {
        
            //$caminho =  $this->db->get_where('mov', array('mov_id' => $param2))->result_array();
             echo   'id cliente:'.$this->input->post('client') ;
             echo   ' - ' ;
             echo   'id movimento:'.$this->input->post('mov_id') ;
            redirect(base_url() . 'index.php?client/mov_recibos/', 'refresh');
        }
        if ($param1 == 'create_saida') {
            $data['mov']          = $_FILES['mov']['name'];
            $data['tipo_mov']     = $this->input->post('tipo_mov');
            if ( empty($_FILES['mov']['name'])){
                $data['path']         = 'Sem Arquivo';
              }  else
              
              $Xrand =  mt_rand();
              
              
              $XnovoNome = strtolower($this->caracter_model->t5f_translit($_FILES['mov']['name']));
               
              $data['path']         = $this->input->post('path').$this->input->post('alterdata').'_S_'.$Xrand.'_'.$XnovoNome;
            $data['client']       = $this->input->post('client');
            $data['category']     = $this->input->post('category');
            $data['desc_mov']     = $this->input->post('desc_mov');
            $data['quantity']     = $this->input->post('quantity');
            $data['valor']        = $this->input->post('valor')*(-1);
            $data['date']         = $this->input->post('date');
            $data['alt_date']     = $this->input->post('alt_date');
            $data['status']       = $this->input->post('status');
            $this->db->insert('mov', $data);
            
            move_uploaded_file($_FILES['mov']['tmp_name'], $this->input->post('path').$this->input->post('alterdata').'_S_'.$Xrand.'_'.$XnovoNome);
            $this->session->set_flashdata('flash_message', get_phrase('Movimento Salvo!'));
            
                         
            redirect(base_url() . 'index.php?client/mov_lancar/', 'refresh');
        }
        $page_data['mov']      =  $this->db->get_where('mov', array('client' => ''))->result_array();
        $page_data['page_name']  = 'mov_lancar';
        $page_data['page_icon'] = 'inbox';
        $page_data['page_title'] = 'Movimentações - Lançamento de caixa';
        $this->load->view('index', $page_data);
    }
        
    /**** MOV |-> Movimentações  -  Recibos ****/
    function mov_recibos($param1 = '', $param2 = '', $param3 = '')
    {
                /**** Definição de variáveis *****/
        $Xrand = '';
        $origem = '';
        $destino = ''; 
        $XnovoNome = '';       
        
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            //$data['recibo']       = $_FILES['recibo']['name'];
            $data['recibo']       = $this->input->post('recibo');
            $data['recibo_num']   = $this->input->post('xrecibo_n');
            $data['tipo_recibo']  = $this->input->post('tipo_recibo');
            //$data['path']         = $this->input->post('path').$this->input->post('alterdata').'_R_'.$_FILES['recibo']['name'];
            $data['path']         = 'Sem Arquivo';
            $data['client']       = $this->input->post('client');
            $data['category']     = $this->input->post('category');
            $data['desc_recibo']  = $this->input->post('desc_recibo');
            $data['quantity']     = $this->input->post('quantity');
            $data['valor']        = $this->input->post('valor');
            $data['date']         = $this->input->post('date');
            $data['alt_date']     = $this->input->post('alt_date');
            $data['status']       = $this->input->post('status'); 
            $data['rec_cliente']  = $this->input->post('rec_cliente');
            $data['rec_doc']      = $this->input->post('rec_doc');
            $data['rec_end']      = $this->input->post('rec_end');
            $data['rec_n']        = $this->input->post('rec_n');
            $data['rec_comp']     = $this->input->post('rec_comp');
            $data['rec_bairro']   = $this->input->post('rec_bairro');
            $data['rec_cidade']   = $this->input->post('rec_cidade');
            $data['rec_uf']       = $this->input->post('rec_uf');
            $data['rec_cep']      = $this->input->post('rec_cep');
            $data['rec_ddd']      = $this->input->post('rec_ddd');
            $data['rec_tel']      = $this->input->post('rec_tel');  
            $data['rec_email']    = $this->input->post('rec_email');
            $data['rec_desc']     = $this->input->post('rec_desc');
            
            $this->db->insert('recibo', $data);
            
            // incrementa nº recibo

            $data2['recibo_num']     =  $this->input->post('xrecibo_n')+1;
            $this->db->where('client', $this->input->post('client'));
            $this->db->update('recibo_n', $data2);
            
            $this->session->set_flashdata('flash_message', 'Recibo Criado com Sucesso!!!');
            
            //move_uploaded_file($_FILES['recibo']['tmp_name'], $this->input->post('path').$this->input->post('alterdata').'_R_'.$_FILES['recibo']['name']);
            //$this->session->set_flashdata('flash_message', get_phrase('Recibo Salvo!'));
            
                         
            redirect(base_url() . 'index.php?client/mov_recibos_consultar/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['recibo']       = $this->input->post('recibo');
            $data['tipo_recibo']  = $this->input->post('tipo_recibo');
            $data['path']         = $this->input->post('path');
            $data['client']       = $this->input->post('client');
            $data['category']     = $this->input->post('category');
            $data['desc_recibo']  = $this->input->post('recibo');
            $data['quantity']     = $this->input->post('quantity');
            $data['valor']        = $this->input->post('valor');
            $data['date']         = $this->input->post('date');
            $data['alt_date']     = $this->input->post('alt_date');
            $data['status']       = $this->input->post('status');
            $this->db->where('recibo_id', $param2);
            $this->db->update('recibo', $data);
            redirect(base_url() . 'index.php?client/mov_recibos/', 'refresh');
        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile'] = true;
            $page_data['current_file_id'] = $param2;
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('recibo', array(
                'recibo_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
        
            $caminho =  $this->db->get_where('recibo', array('recibo_id' => $param2))->result_array();
            //delte_file($caminho['path'])
            
            $this->db->where('recibo_id', $param2);
            $this->db->delete('recibo');
            $this->session->set_flashdata('flash_message', get_phrase('Arquivo Deletado!'));
            
            redirect(base_url() . 'index.php?client/mov_recibos_consultar/', 'refresh');
        }
        if ($param1 == 'cancelar') {
        
            $data['quantity']     = '0';
            $data['alt_date']     = (date('Y-m-d'));
            $data['status']       = 'cancelado';
            $this->db->where('recibo_id', $param2);
            $this->db->update('recibo', $data);
            
            $this->session->set_flashdata('flash_message', get_phrase('Recibo Cancelado!'));
            
            redirect(base_url() . 'index.php?client/mov_recibos_consultar/', 'refresh');
        }
 
        $page_data['rec']        =  $this->db->get_where('recibo', array('client' => ''))->result_array();
        $page_data['page_name']  = 'mov_recibos';
        $page_data['page_icon']  = 'list-alt';
        $page_data['page_title'] = 'Recibo - Emitir Recibo';
        $this->load->view('index', $page_data);
    }
    
    /**** MOV |-> Movimentações  -  Recibos Consultar****/
    function mov_recibos_consultar($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
 
        $page_data['rec']        =  $this->db->get_where('recibo', array('client' => ''))->result_array();
        $page_data['page_name']  = 'mov_recibos_consultar';
        $page_data['page_icon']  = 'search';
        $page_data['page_title'] = 'Recibo - Consultar Recibos';
        $this->load->view('index', $page_data);
    }
/**** FIM - BLOCO  -   MOV |-> Movimentação    *****/


/**** BLOCO  -   GUIAS |-> guias

    DAS  Simples Nacional || das
    GPS  INSS || gps
    GPS  INSS || darf

*****/
     /**** GUIAS |-> guias  -  DAS ****/
    function guias_das($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['files']      =  $this->db->get_where('files', array('product' => '10'))->result_array();
        $page_data['page_name']  = 'guias_das';
        $page_data['page_icon']  = 'check';
        $page_data['page_title'] = 'Guias/Impostos - Simples Nacional';
        $this->load->view('index', $page_data);
    }

    /**** GUIAS |-> guias  -  GPS ****/
    function guias_gps($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['files']      =  $this->db->get_where('files', array('product' => '11'))->result_array();
        $page_data['page_name']  = 'guias_gps';
        $page_data['page_icon'] = 'check';
        $page_data['page_title'] = 'Guias/Impostos - GPS';
        $this->load->view('index', $page_data);
    }
    /**** GUIAS |-> guias  -  DARF ****/
    function guias_darf($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['files']      =  $this->db->get_where('files', array('product' => '14'))->result_array();
        $page_data['page_name']  = 'guias_darf';
        $page_data['page_icon'] = 'check';
        $page_data['page_title'] = 'Guias/DARF - Imposto de Renda';
        $this->load->view('index', $page_data);
    }
/**** FIM - BLOCO  -   GUIAS |-> guias    *****/


/**** BLOCO  - RELATORIOS |-> relatorios
    
    BALANÇO PATRIMONIAL || balanco_patri
    DEMONSTRATIVO DO RESULTADO ECONÔMICO|| drecom
    BALANCETE Periodico || balancete_peri
    DIARIO || diario
    RAZÃO || razao
    Livro Caixa

*****/
    /**** RELATORIOS |-> relatorios  -  importar ****/
    function rel_balanco_patri($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['files']      =  $this->db->get_where('files', array('product' => '20'))->result_array();
        $page_data['page_name']  = 'rel_balanco_patri';
        $page_data['page_icon']  = 'print';
        $page_data['page_title'] = 'Relatórios - Balanço Patrimonial';
        $this->load->view('index', $page_data);
    }
    /**** RELATORIOS |-> relatorios  -  consultar ****/
    function rel_drecom($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['files']      =  $this->db->get_where('files', array('product' => '21'))->result_array();
        $page_data['page_name']  = 'rel_drecom';
        $page_data['page_icon']  = 'print';
        $page_data['page_title'] = 'Relatórios - DRE';
        $this->load->view('index', $page_data);
    }
    /**** RELATORIOS |-> relatorios  -  rel_balancete_peri ****/
    function rel_balancete_peri($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['files']      =  $this->db->get_where('files', array('product' => '22'))->result_array();
        $page_data['page_name']  = 'rel_balancete_peri';
        $page_data['page_icon']  = 'print';
        $page_data['page_title'] = 'Relatórios - Balancete Período';
        $this->load->view('index', $page_data);
    }
    /**** RELATORIOS |-> relatorios  -  rel_diario ****/
    function rel_diario($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['files']      =  $this->db->get_where('files', array('product' => '23'))->result_array();
        $page_data['page_name']  = 'rel_diario';
        $page_data['page_icon']  = 'print';
        $page_data['page_title'] = 'Relatórios - Diário';
        $this->load->view('index', $page_data);
    }
    /**** RELATORIOS |-> relatorios  -  DAS ****/
    function rel_razao($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['files']      =  $this->db->get_where('files', array('product' => '24'))->result_array();
        $page_data['page_name']  = 'rel_razao';
        $page_data['page_icon']  = 'print';
        $page_data['page_title'] = 'Relatórios - Razão';
        $this->load->view('index', $page_data);
    }
    /**** RELATORIOS |-> relatorios  -  rel_la_iss ****/
    function rel_la_iss($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['files']      =  $this->db->get_where('files', array('product' => '25'))->result_array();
        $page_data['page_name']  = 'rel_la_iss';
        $page_data['page_icon']  = 'print';
        $page_data['page_title'] = 'Relatórios - Apuração ISS';
        $this->load->view('index', $page_data);
    }
    /**** RELATORIOS |-> relatorios  -  rel_lc ****/
    function rel_lc($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
 
        $page_data['rec']        =  $this->db->get_where('mov', array('client' => ''))->result_array();
        $page_data['page_name']  = 'rel_lc';
        $page_data['page_icon']  = 'search';
        $page_data['page_title'] = 'Livro Caixa';
        $this->load->view('index', $page_data);
    }
/**** FIM - BLOCO  -   RELATORIOS |-> relatorios    *****/


/**** BLOCO  - DOCUMENTOS DE CADASTRO |-> doc_cad
    
        Contrato Social / AlteraÃƒÂ§ÃƒÂµes || contrato_social
        Enquadramento (ME/EPP) || enquadramento
        Alvará (Prefeitura) || alvara
        Cartão de Inscrição Estadual || cartao_ie -- nÃƒÂ£o precisa
        Sócios (CPF, RG, ResidÃƒÂªncia) || doc_soc
        Certificado do MEI  || cert_mei
        Cadastro do CEI / INSS  || cei_inss
        

*****/
   /**** DOCUMENTOS DE CADASTRO |-> doc_cad  -  Contrato Social / Alteração || contrato_social ****/
    function doc_cad_contrato_social($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['files']      = $this->db->get_where('files', array('product' => '1'))->result_array();
        $page_data['page_name']  = 'doc_cad_contrato_social';
        $page_data['page_icon']  = 'folder-open';
        $page_data['page_title'] = 'Arquivo - Contrato Social';
        $this->load->view('index', $page_data);
    }
    /**** DOCUMENTOS DE CADASTRO |-> doc_cad  -  Enquadramento (ME/EPP) || enquadramento ****/
    function doc_cad_enquadramento($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['files']      = $this->db->get_where('files', array('product' => '3'))->result_array();
        $page_data['page_name']  = 'doc_cad_enquadramento';
        $page_data['page_icon']  = 'folder-open';
        $page_data['page_title'] = 'Arquivo - Enquadramento';
        $this->load->view('index', $page_data);
    }
    /**** DOCUMENTOS DE CADASTRO |-> doc_cad   -  CNPJ ****/
    function doc_cad_cnpj($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['files']      =  $this->db->get_where('files', array('product' => '2'))->result_array();
        $page_data['page_name']  = 'doc_cad_cnpj';
        $page_data['page_icon']  = 'folder-open';
        $page_data['page_title'] = 'Arquivo - Cartão CNPJ';
        $this->load->view('index', $page_data);
    }
    /**** DOCUMENTOS DE CADASTRO |-> doc_cad  -  Alvará (Prefeitura) || alvara ****/
    function doc_cad_alvara($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['files']      =  $this->db->get_where('files', array('product' => '4'))->result_array();
        $page_data['page_name']  = 'doc_cad_alvara';
        $page_data['page_icon']  = 'folder-open';
        $page_data['page_title'] = 'Arquivo - Alvará';
        $this->load->view('index', $page_data);
    }
    /**** DOCUMENTOS DE CADASTRO |-> doc_cad   -  CA do Corpo de Bomdeiro ****/
    function doc_cad_ca_cb($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        
        $page_data['files']      =  $this->db->get_where('files', array('product' => '5'))->result_array();
        $page_data['page_name']  = 'doc_cad_ca_cb';
        $page_data['page_icon']  = 'folder-open';
        $page_data['page_title'] = 'Arquivo - CA Corpo de Bombeiros';
        $this->load->view('index', $page_data);
    }
    /**** DOCUMENTOS DE CADASTRO |-> doc_cad   -  Sócios (CPF, RG, Residência) || doc_soc ****/
    function doc_cad_doc_soc($param1 = '', $param2 = '', $param3 = '')
    {
                /**** Definição de variáveis *****/
        $Xrand = '';
        $origem = '';
        $destino = ''; 
        $XnovoNome = '';       
        
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['file']      = $this->input->post('file');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->insert('files', $data);
            redirect(base_url() . 'index.php?client/doc_cad_doc_soc/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['file']        = $this->input->post('file');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect(base_url() . 'index.php?client/doc_cad_doc_soc/', 'refresh');
        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile'] = true;
            $page_data['current_file_id'] = $param2;
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('files', array(
                'file_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $this->db->where('file_id', $param2);
            $this->db->delete('files');
            redirect(base_url() . 'index.php?client/doc_cad_doc_soc/', 'refresh');
        }
        if ($param1 == 'upload_info') {

            $Xrand =  mt_rand();
            
            $XnovoNome = strtolower($this->caracter_model->t5f_translit($_FILES['file']['name']));
            
            $data['file']        = $_FILES['file']['name'];
            $data['path']        = $this->input->post('path').'_'.$Xrand.'_'.$XnovoNome;
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['desc_file']     = $this->input->post('desc_file');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            $data['status']      = $this->input->post('status');
            $this->db->insert('files', $data);

            move_uploaded_file($_FILES['file']['tmp_name'], $this->input->post('path').'_'.$Xrand.'_'.$XnovoNome);
            $this->session->set_flashdata('flash_message', get_phrase('Arquivo Enviado'));

            redirect(base_url() . 'index.php?client/doc_cad_doc_soc/', 'refresh');
        }
        $page_data['files']      =  $this->db->get_where('files', array('product' => '6'))->result_array();
        $page_data['page_name']  = 'doc_cad_doc_soc';
        $page_data['page_icon']  = 'folder-open';
        $page_data['page_title'] = 'Arquivo - Documentos dos Sócios';
        $this->load->view('index', $page_data);
    }
    /**** DOCUMENTOS DE CADASTRO |-> doc_cad   -  Cadastro do MEI || cert_mei ****/
    function doc_cad_cert_mei($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['files']      =  $this->db->get_where('files', array('product' => '7'))->result_array();
        $page_data['page_name']  = 'doc_cad_cert_mei';
        $page_data['page_icon']  = 'folder-open';
        $page_data['page_title'] = 'Certificado do MEI';
        $this->load->view('index', $page_data);
    }
    /**** DOCUMENTOS DE CADASTRO |-> doc_cad   -  Cadastro do CEI / INSS || cei_inss ****/
    function doc_cad_cei_inss($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['files']      =  $this->db->get_where('files', array('product' => '8'))->result_array();
        $page_data['page_name']  = 'doc_cad_cei_inss';
        $page_data['page_icon']  = 'folder-open';
        $page_data['page_title'] = 'Cadastro do CEI / INSS';
        $this->load->view('index', $page_data);
    }

/**** FIM - BLOCO  -   DOCUMENTOS DE CADASTRO |-> doc_cad     *****/

/**** BLOCO  - DOCUMENTOS FISCAIS |-> doc_fis
    
            DEFIS Declaração Anual || defis
            Extrato do Simples Nacional Ã¢â‚¬â€œ Mensal || extrato_simples_nacional
            SEFIP - Mensal || sefip
            RAIS Anual ||rais
            DIRF  Anual || dirf
            Certidão Negativa || cert_neg
            DASN - SIMEI || dasn_simei

*****/

    /**** DOCUMENTOS FISCAIS |-> doc_fis  -  DEFIS Declaração Anual || defis ****/
    function doc_fis_defis($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        
        $page_data['files']      =  $this->db->get_where('files', array('product' => '40'))->result_array();
        $page_data['page_name']  = 'doc_fis_defis';
        $page_data['page_icon']  = 'file';
        $page_data['page_title'] = 'Documentos Fiscais - Defis - Declaração Anual';
        $this->load->view('index', $page_data);
    }
    /**** DOCUMENTOS FISCAIS |-> doc_fis  -  Extrato do Simples Nacional Mensal || extrato_simples_nacional ****/
    function doc_fis_extrato_simples_nacional($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
       
        $page_data['files']      =  $this->db->get_where('files', array('product' => '41'))->result_array();
        $page_data['page_name']  = 'doc_fis_extrato_simples_nacional';
        $page_data['page_icon']  = 'file';
        $page_data['page_title'] = 'Documentos Fiscais - Extrato Simples Nacional';
        $this->load->view('index', $page_data);
    }
    /**** DOCUMENTOS FISCAIS |-> doc_fis  -  SEFIP - Mensal || sefip ****/
    function doc_fis_sefip($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        
        $page_data['files']      =  $this->db->get_where('files', array('product' => '42'))->result_array();
        $page_data['page_name']  = 'doc_fis_sefip';
        $page_data['page_icon']  = 'file';
        $page_data['page_title'] = 'Documentos Fiscais - SEFIP';
        $this->load->view('index', $page_data);
    }
    /**** DOCUMENTOS FISCAIS |-> doc_fis  -  RAIS Anual ||rais ****/
    function doc_fis_rais($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
 
        $page_data['files']      =  $this->db->get_where('files', array('product' => '43'))->result_array();
        $page_data['page_name']  = 'doc_fis_rais';
        $page_data['page_icon']  = 'file';
        $page_data['page_title'] = 'Documentos Fiscais - RAIS';
        $this->load->view('index', $page_data);
    }
/**** DOCUMENTOS FISCAIS |-> doc_fis  -  DIRF Anual || dirf ****/
    function doc_fis_dirf($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        
        $page_data['files']      =  $this->db->get_where('files', array('product' => '44'))->result_array();
        $page_data['page_name']  = 'doc_fis_dirf';
        $page_data['page_icon']  = 'file';
        $page_data['page_title'] = 'Documentos Fiscais - DIRF';
        $this->load->view('index', $page_data);
    }
    /**** DOCUMENTOS FISCAIS |-> doc_fis  -  Certidão Negativa || cert_neg ****/
    function doc_fis_cert_neg($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        
        $page_data['files']      =  $this->db->get_where('files', array('product' => '45'))->result_array();
        $page_data['page_name']  = 'doc_fis_cert_neg';
        $page_data['page_icon']  = 'file';
        $page_data['page_title'] = 'Documentos Fiscais - Certidão Negativa';
        $this->load->view('index', $page_data);
    }
    /**** DOCUMENTOS FISCAIS |-> doc_fis  -  Certidão Negativa || cert_neg ****/
    function doc_fis_dasn_simei($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        
        $page_data['files']      =  $this->db->get_where('files', array('product' => '46'))->result_array();
        $page_data['page_name']  = 'doc_fis_dasn_simei';
        $page_data['page_icon']  = 'file';
        $page_data['page_title'] = 'Documentos DASN - SIMEI';
        $this->load->view('index', $page_data);
    }
/**** FIM - BLOCO  -   DOCUMENTOS FISCAIS |-> doc_fis    *****/


/**** BLOCO  -  Cobrança |-> cobranca 

        Mensalidade (boleto) || mensalidade
        Histórico || historico

*****/

    /**** COBRANÇA |-> cobranca - Histórico  *****/
    function cobranca_historico($param1 = '', $param2 = '', $param3 = '')
    {
                /**** Definição de variáveis *****/
        $Xrand = '';
        $origem = '';
        $destino = ''; 
        $XnovoNome = '';
    
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['file']      = $this->input->post('file');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->insert('files', $data);
            redirect(base_url() . 'index.php?client/cobranca_historico/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['file']        = $this->input->post('file');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect(base_url() . 'index.php?client/cobranca_historico/', 'refresh');
        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile'] = true;
            $page_data['current_file_id'] = $param2;
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('files', array(
                'file_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $this->db->where('file_id', $param2);
            $this->db->delete('files');
            redirect(base_url() . 'index.php?client/cobranca_historico/', 'refresh');
        }
        if ($param1 == 'upload_info') {

            $Xrand =  mt_rand();
            
            $XnovoNome = strtolower($this->caracter_model->t5f_translit($_FILES['file']['name']));
            
            $data['file']        = $_FILES['file']['name'];
            $data['path']        = $this->input->post('path').'_'.$Xrand.'_'.$XnovoNome;
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['desc_file']     = $this->input->post('desc_file');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            $data['status']      = $this->input->post('status');
            $this->db->insert('files', $data);

            move_uploaded_file($_FILES['file']['tmp_name'], $this->input->post('path').'_'.$Xrand.'_'.$XnovoNome);
            $this->session->set_flashdata('flash_message', get_phrase('Arquivo Enviado'));

            redirect(base_url() . 'index.php?client/cobranca_historico/', 'refresh');
        }
        $page_data['files']      =  $this->db->get_where('files', array('product' => ''))->result_array();
        $page_data['page_name']  = 'cobranca_historico';
        $page_data['page_icon']  = 'time';
        $page_data['page_title'] = 'Cobrança - Histórico';
        $this->load->view('index', $page_data);
    }

    /**** COBRANÇA |-> cobranca - mensalidade  *****/
    function cobranca_mensalidade($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['file']      = $this->input->post('file');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->insert('files', $data);
            redirect(base_url() . 'index.php?client/cobranca_mensalidade/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['file']        = $this->input->post('file');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect(base_url() . 'index.php?client/cobranca_mensalidade/', 'refresh');
        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile'] = true;
            $page_data['current_file_id'] = $param2;
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('files', array(
                'file_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $this->db->where('file_id', $param2);
            $this->db->delete('files');
            redirect(base_url() . 'index.php?client/cobranca_mensalidade/', 'refresh');
        }
        if ($param1 == 'upload_info') {

            $Xrand =  mt_rand();
            
            $XnovoNome = strtolower($this->caracter_model->t5f_translit($_FILES['file']['name']));
            
            $data['file']        = $_FILES['file']['name'];
            $data['path']        = $this->input->post('path').'_'.$Xrand.'_'.$XnovoNome;
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['desc_file']     = $this->input->post('desc_file');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            $data['status']      = $this->input->post('status');
            $this->db->insert('files', $data);

            move_uploaded_file($_FILES['file']['tmp_name'], $this->input->post('path').'_'.$Xrand.'_'.$XnovoNome);
            $this->session->set_flashdata('flash_message', get_phrase('Arquivo Enviado'));

            redirect(base_url() . 'index.php?client/cobranca_mensalidade/', 'refresh');
        }
        $page_data['files']      =  $this->db->get_where('files', array('product' => ''))->result_array();
        $page_data['page_name']  = 'cobranca_mensalidade';
        $page_data['page_icon']  = 'calendar';
        $page_data['page_title'] = 'Cobrança - Mensalidade(s)';
        $this->load->view('index', $page_data);
    }

/**** FIM - BLOCO  -   COBRANÇA |-> cobranca     *****/

/**** GESTÃO product*****/
    function product($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        else if ($param1 == 'personal_profile') {
            $page_data['personal_profile']   = true;
            $page_data['current_product_id'] = $param2;
        }
        $page_data['product']    = $this->db->get('product')->result_array();
        $page_data['page_name']  = 'product';
        $page_data['page_title'] = get_phrase('manage_product');
        $this->load->view('index', $page_data);
    }
    
/**** Página Serviços Avulsos*****/
    function serv_avulso($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        else if ($param1 == 'personal_profile') {
            $page_data['personal_profile']   = true;
            $page_data['current_product_id'] = $param2;
        }
        $page_data['page_name']  = 'serv_avulso';
        $page_data['page_icon']  = 'tasks';
        $page_data['page_title'] = 'Serviços Avulsos';
        $this->load->view('index', $page_data);
    }
    
/*****SITE/SYSTEM SETTINGS********
    function system_settings($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');
        
        if ($param2 == 'do_update') {
            $this->db->where('type', $param1);
            $this->db->update('settings', array(
                'description' => $this->input->post('description')
            ));
            $this->session->set_flashdata('flash_message', get_phrase('settings_updated'));
            redirect(base_url() . 'index.php?client/system_settings/', 'refresh');
        }
        if ($param1 == 'upload_logo') {
            move_uploaded_file($_FILES['userfile']['tmp_name'], 'uploads/logo.png');
            $this->session->set_flashdata('flash_message', get_phrase('settings_updated'));
            redirect(base_url() . 'index.php?client/system_settings/', 'refresh');
   }
        $page_data['page_name']  = 'system_settings';
        $page_data['page_title'] = 'ConfiguraÃ§Ãµes do Sistema';
        $page_data['settings']   = $this->db->get('settings')->result_array();
        $this->load->view('index', $page_data);
    }
  */  
/****** GESTÃO DO USUÁRIO E TROCA DE SENHA ***/
    function manage_profile($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');
        if ($param1 == 'update_profile_info') {
            $data['name']    = $this->input->post('name');
            $data['address'] = $this->input->post('address');
            $data['phone']   = $this->input->post('phone');
            $data['email']   = $this->input->post('email');
            
            $this->db->where('client_id', $this->session->userdata('client_id'));
            $this->db->update('client', $data);
            $this->session->set_flashdata('flash_message', get_phrase('account_updated'));
            redirect(base_url() . 'index.php?client/manage_profile/', 'refresh');
        }
        if ($param1 == 'change_password') {
            $data['password']             = $this->input->post('password');
            $data['new_password']         = $this->input->post('new_password');
            $data['confirm_new_password'] = $this->input->post('confirm_new_password');
            
            $current_password = $this->db->get_where('client', array(
                'client_id' => $this->session->userdata('client_id')
            ))->row()->password;
            if ($current_password == $data['password'] && $data['new_password'] == $data['confirm_new_password']) {
                $this->db->where('client_id', $this->session->userdata('client_id'));
                $this->db->update('client', array(
                    'password' => $data['new_password']
                ));
                $this->session->set_flashdata('flash_message', get_phrase('password_updated'));
            } else {
                $this->session->set_flashdata('flash_message', get_phrase('password_mismatch'));
            }
            redirect(base_url() . 'index.php?client/manage_profile/', 'refresh');
        }
        $page_data['page_name']  = 'manage_profile';
        $page_data['page_title'] = 'Gestão Usuário';
        $page_data['page_icon'] = 'user';
        $page_data['edit_data']  = $this->db->get_where('client', array(
            'client_id' => $this->session->userdata('client_id')
        ))->result_array();
        $this->load->view('index', $page_data);
    }
    
}
/****** GESTÃO DO USUÁRIO E TROCA DE SENHA ***/