<?php
if (!defined('BASEPATH'))
    exit('No direct script access allowed');

/*  
 *  @author : Wallace Pacheco
 *  date    : 01 junho, 2015
 *  ContSimples Tecnologia
 *  http://contsimples.com.br
 */

/*
|---------------------------------------------------------------
| TimeZone 
|---------------------------------------------------------------
*/
date_default_timezone_set('America/Sao_Paulo');



class Admin extends CI_Controller
{


    function __construct()
    {
        parent::__construct();
        $this->load->database();
        $this->load->helper('date');
        //$this->load->library('session');
        /*cache control*/
        $this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
        $this->output->set_header('Pragma: no-cache');
    }


/***default functin, redirects to login page if no admin logged in yet***/
    public function index()
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');
        if ($this->session->userdata('admin_login') == 1)
            redirect(base_url() . 'index.php?admin/dashboard', 'refresh');
    }


/***ADMIN DASHBOARD***/
    function dashboard()
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        $page_data['page_name']  = 'dashboard';
        $page_data['page_icon'] = 'dashboard';
        $page_data['page_title'] = 'Painel Administrativo';
        $this->load->view('index', $page_data);
    }
    
    
/**** Atualização de Status Etapa |->  ****/
    function atualiza_status($param1 = '', $param2 = '', $param3 = '')
    {

        if ($param1 == 'etapa1') {

            $data['status']      = '2';
            $this->db->where('id_novo_fluxo', $param2);
            $this->db->update('clientes_novo_fluxo', $data);
            
            switch ($param3){
                case 'abrir%20empresa':
                    $formulario = 'admin/empresa_abrir/';
                  break;
                case 'abrir%20mei':
                    $formulario = 'admin/mei_abrir/';
                  break;
                case 'abrir%20comercio':
                    $formulario = 'admin/comercio_abrir/';
                  break;
                case 'trazer%20empresa':
                    $formulario = 'admin/empresa_trazer/';
                  break;                                
                case 'trazer%20mei':
                    $formulario = 'admin/mei_trazer/';
                  break;
                case 'trazer%20comercio':
                    $formulario = 'admin/comercio_trazer/';
                  break;
                case 'trazer%20pl':
                    $formulario = 'admin/trazer_pl/';
                  break;                  
                default:
                    //echo 'Formulário não encontrado';
                    $formulario = 'admin/';                                         
            }                   
             
            redirect(base_url() . 'index.php?'.$formulario, 'refresh');
        }
        
        if ($param1 == 'etapa2') {

            $data['status']      = '2';
            $this->db->where('id_novo_fluxo', $param2);
            $this->db->update('clientes_novo_fluxo', $data);
            
            switch ($param3){
                case 'abrir%20empresa':
                    $formulario = 'admin/empresa_abrir2/';
                  break;
                case 'abrir%20mei':
                    $formulario = 'admin/mei_abrir2/';
                  break;
                case 'abrir%20comercio':
                    $formulario = 'admin/comercio_abrir2/';
                  break;
                case 'trazer%20empresa':
                    $formulario = 'admin/empresa_trazer2/';
                  break;                                
                case 'trazer%20mei':
                    $formulario = 'admin/mei_trazer2/';
                  break;
                case 'trazer%20comercio':
                    $formulario = 'admin/comercio_trazer2/';
                  break;
                case 'trazer%20pl':
                    $formulario = 'admin/trazer_pl2/';
                  break;                  
                default:
                    //echo 'Formulário não encontrado';
                    $formulario = 'admin/';                                         
            }         

            redirect(base_url() . 'index.php?'.$formulario, 'refresh');
        }
    }
    

/**** Gestão CLIENTE*****/
    function client($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['name']            = strtoupper($this->input->post('name'));
            $data['cpf']             = str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('cpf'))));
            $data['email']           = $this->input->post('email');
            $data['password']        = $this->input->post('password');
            $data['creation_date']   = $this->input->post('creation_date');
            $this->db->insert('client', $data);

            // cria estrutura de pasta
            mkdir("./uploads/".str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('cpf'))))."/", 0755);
            mkdir("./uploads/".str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('cpf'))))."/mov/", 0755);
            mkdir("./uploads/".str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('cpf'))))."/rel/", 0755);
            mkdir("./uploads/".str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('cpf'))))."/doc_extra/", 0755);
            mkdir("./uploads/".str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('cpf'))))."/_lixo/", 0755);

            // cria estrutura de recibo para os clientes do profissional 

            $query = $this->db->query('SELECT LAST_INSERT_ID()');
            $row = $query->row_array();
            $LastIdInserted = $row['LAST_INSERT_ID()'];

            //$data2['recibo_num']  =  '1';
            //$data2['client']      =   $LastIdInserted ;
            //$this->db->insert('recibo_n', $data2);

            // cria estrutura de notas para as empresas

            //$data3['nfs_num']  =  '1';
            //$data3['cliente']      =   $LastIdInserted ;
            //$this->db->insert('nfs_n', $data3);


            $this->session->set_flashdata('flash_message', 'Cliente adicionado com sucesso!!!');


            //envia email
            //$this->email_model->abertura_de_conta('client', $data['email']);
            //$this->email_model->abertura_de_conta_confirma_cadastro('client',$data['name'],$data['cnpj_cpf'], $data['email']);

            redirect(base_url() . 'index.php?client/client/', 'refresh');
        }
        if ($param1 == 'insert') {
            $data['cpf']                = str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('cpf'))));
            $data['p_conjuge']          = $this->input->post('p_conjuge');
            $data['port_def_fis_ment']  = $this->input->post('port_def_fis_ment');
            $data['email']              = $this->input->post('email');
            $data['password']           = $this->input->post('password');
            $data['name']               = $this->input->post('name');
            $data['creation_date']      = $this->input->post('creation_date');
            $data['alt_date']           = $this->input->post('alt_date');
            $data['data_nasc']          = $this->input->post('data_nasc');
            $data['titulo_eleitor']     = $this->input->post('titulo_eleitor');
            $data['mudou_end']          = $this->input->post('mudou_end');
            $data['address']            = $this->input->post('address');
            $data['addr_n']             = $this->input->post('addr_n');
            $data['addr_comp']          = $this->input->post('addr_comp');
            $data['addr_bairro']        = $this->input->post('addr_bairro');
            $data['addr_cidade']        = $this->input->post('addr_cidade');
            $data['addr_estado']        = $this->input->post('addr_estado');
            $data['addr_cep']           = $this->input->post('addr_cep');
            $data['addr_pais']          = $this->input->post('addr_pais');
            $data['ddd_phone']          = $this->input->post('ddd_phone');
            $data['phone']              = $this->input->post('phone');
            $data['nat_ocup']           = $this->input->post('nat_ocup');
            $data['ocup_principal']     = $this->input->post('ocup_principal');
            $data['tipo_decla']         = $this->input->post('tipo_decla');
            $data['n_ult_declaracao']   = $this->input->post('n_ult_declaracao');
            $data['status']             = 'NOVO';
            $data['fim_cliente']        = 'N';
            $data['dt_fin_preench']     = '';
            $this->db->insert('client', $data);
            
            // cria estrutura de pasta
            mkdir("./uploads/".str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('cpf'))))."/", 0755);
            mkdir("./uploads/".str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('cpf'))))."/mov/", 0755);
            mkdir("./uploads/".str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('cpf'))))."/rel/", 0755);
            mkdir("./uploads/".str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('cpf'))))."/doc_extra/", 0755);
            mkdir("./uploads/".str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('cpf'))))."/_lixo/", 0755);

            
            $this->session->set_flashdata('flash_message', 'Registro Gravado com Sucesso!');
            redirect(base_url() . 'index.php?client/client/', 'refresh');
            
        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile']  = true;
            $page_data['current_client_id'] = $param2;
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('client', array(
                'client_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'do_update') {
            $data['cpf']                = str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('cpf'))));
            $data['p_conjuge']          = $this->input->post('p_conjuge');
            $data['port_def_fis_ment']  = $this->input->post('port_def_fis_ment');
            $data['email']              = $this->input->post('email');
            $data['password']           = $this->input->post('password');
            $data['name']               = $this->input->post('name');
            //$data['creation_date']      = $this->input->post('creation_date');
            $data['alt_date']           = $this->input->post('alt_date');
            $data['data_nasc']          = $this->input->post('data_nasc');
            $data['titulo_eleitor']     = $this->input->post('titulo_eleitor');
            $data['mudou_end']          = $this->input->post('mudou_end');
            $data['address']            = $this->input->post('address');
            $data['addr_n']             = $this->input->post('addr_n');
            $data['addr_comp']          = $this->input->post('addr_comp');
            $data['addr_bairro']        = $this->input->post('addr_bairro');
            $data['addr_cidade']        = $this->input->post('addr_cidade');
            $data['addr_estado']        = $this->input->post('addr_estado');
            $data['addr_cep']           = $this->input->post('addr_cep');
            $data['addr_pais']          = $this->input->post('addr_pais');
            $data['ddd_phone']          = $this->input->post('ddd_phone');
            $data['phone']              = $this->input->post('phone');
            $data['nat_ocup']           = $this->input->post('nat_ocup');
            $data['ocup_principal']     = $this->input->post('ocup_principal');
            $data['tipo_decla']         = $this->input->post('tipo_decla');
            $data['n_ult_declaracao']   = $this->input->post('n_ult_declaracao');
            $this->db->where('client_id', $param2);
            $this->db->update('client', $data);
            
            $this->session->set_flashdata('flash_message', 'Registro Atualizado com Sucesso!');
            redirect(base_url() . 'index.php?client/client/', 'refresh');
            
        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile']  = true;
            $page_data['current_client_id'] = $param2;
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('client', array(
                'client_id' => $param2
            ))->result_array();
        }

        if ($param1 == 'update_finalizar') {
            
            $data['status']         = 'Enviado Cliente';
            $data['fim_cliente']    = 'S';
            $data['dt_fin_preench'] = date("Y-m-d H:i:s", time());
            $this->db->where('client_id', $param2);
            $this->db->update('client', $data);

            // Envio Email
            $Xsender        = $this->db->get_where('client', array('client_id' => $param2))->row()->name;
            $Xsend_email    = $this->db->get_where('client', array('client_id' => $param2))->row()->email;
            
            $this->email_model->envia_email_aviso_preenchido_irpf($Xsender,$Xsend_email,$this->input->post('subject'),$this->input->post('body'));

            $this->session->set_flashdata('flash_message', 'Declaração Enviada para Contabilidade!');

            redirect(base_url() . 'index.php?client/dashboard/', 'refresh');
        }
        if ($param1 == 'delete') {

            $destino = $this->db->get_where('client' , array('client_id' => $param2))->row()->alterdata ;

            rename('./uploads/'.$destino,'./uploads/_lixo/'.$destino);

            $this->db->where('client_id', $param2);
            $this->db->delete('client');
            redirect(base_url() . 'index.php?client/client/', 'refresh');
        }

        $page_data['client']     = $this->db->query("SELECT * from w_client where status_nome<>'Finalizado'")->result_array();
        $page_data['page_name']  = 'client';
        $page_data['page_icon'] = 'user';
        $page_data['page_title'] = 'Clientes';
        $this->load->view('index', $page_data);
    }
/**** FIM - Gestão CLIENTE*****/    

/**** Gestão CLIENTE |-> Finalizados ****/
    function client_finalizados($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['client']      = @$this->db->query("SELECT * from w_client where status_nome='Finalizado'")->result_array();
        $page_data['page_name']  = 'client_finalizados';
        $page_data['page_icon']  = 'icon-briefcase';
        $page_data['page_title'] = 'Clientes Finalizados';
        $this->load->view('index', $page_data);
    }


/**** Gestão CLIENTE |-> Etapa 1 ****/
    function client_etapa_inicial1($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        
        if ($param1 == 'delete') {

            $data['status']         = '5';
            $this->db->where('id_novo_fluxo', $param2);
            $this->db->update('clientes_novo_fluxo', $data);
            redirect(base_url() . 'index.php?admin/client_etapa_inicial1/', 'refresh');

        }
        $page_data['client']      = @$this->db->query("SELECT * FROM clientes_novo_fluxo where etapa='1' and status in ('1','2')")->result_array();
        $page_data['page_name']  = 'client_etapa_inicial1';
        $page_data['page_icon']  = 'icon-briefcase';
        $page_data['page_title'] = 'Clientes Etapa 1';
        $this->load->view('index', $page_data);
    }
    
/**** Gestão CLIENTE |-> Etapa 2 ****/
    function client_etapa_inicial2($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['client']      = @$this->db->query("SELECT * FROM clientes_novo_fluxo where etapa='2' and status in ('1','2')")->result_array();
        $page_data['page_name']  = 'client_etapa_inicial2';
        $page_data['page_icon']  = 'icon-briefcase';
        $page_data['page_title'] = 'Clientes Etapas 2';
        $this->load->view('index', $page_data);
    }    
    
/**** Gestão CLIENTE |-> Desistência Cliente ****/
    function client_desistencia($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['client']      = @$this->db->query("SELECT * FROM clientes_novo_fluxo where status in ('3')")->result_array();
        $page_data['page_name']  = 'client_desistencia';
        $page_data['page_icon']  = 'icon-briefcase';
        $page_data['page_title'] = 'Clientes - Desistência';
        $this->load->view('index', $page_data);
    }
    
/**** Gestão CLIENTE |-> Perfil não Atendido ****/
    function client_perfil_nao_atendido($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['client']      = @$this->db->query("SELECT * FROM clientes_novo_fluxo where status in ('4')")->result_array();
        $page_data['page_name']  = 'client_perfil_nao_atendido';
        $page_data['page_icon']  = 'icon-briefcase';
        $page_data['page_title'] = 'Perfil Não Atendido';
        $this->load->view('index', $page_data);
    }        

/*** Grava etapas ***/
    function atualiza_etapas ($param1 = '', $param2 = '', $param3 = '')
    {

        if ($param1 == 'grava_etapa1') {

            $data['tipo_form']           = $this->input->post('tipo_form');
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['cidade']           = $this->input->post('cidade');
            $data['uf']           = $this->input->post('uf');
            $data['segmento']           = $this->input->post('segmento');
            $data['cnpj_cpf']           = $this->input->post('cnpj_cpf');
            if ($this->input->post('status') == '2') {
              $data['status']           = '1';
            } else {
              $data['status']           = $this->input->post('status');
            }
            $data['etapa']           = $this->input->post('etapa');
            $data['ramo_atuacao']           = $this->input->post('ramo_atuacao');
            $data['saber_cs']           = $this->input->post('saber_cs');
            $data['periodo_atend_contab']           = $this->input->post('periodo_atend_contab');
            $data['ja_teve_contador']           = $this->input->post('ja_teve_contador');
            $data['vai_ter_funcionario']           = $this->input->post('vai_ter_funcionario');
            $data['migrar_mei_me']           = $this->input->post('migrar_mei_me');
            $data['obs']           = $this->input->post('obs');             
            $data['id_formulario']           = $this->input->post('id_formulario');
            
            $this->db->where('id_novo_fluxo', $param2);
            $this->db->update('clientes_novo_fluxo', $data);

            $this->session->set_flashdata('flash_message', 'Cadastro Atualizado com Sucesso!!!');
            
            redirect(base_url() . 'index.php?admin/'.$param3.'/', 'refresh');

        }


        if ($param1 == 'editar_etapa1') {

            $data['tipo_form']           = $this->input->post('tipo_form');
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['cidade']           = $this->input->post('cidade');
            $data['uf']           = $this->input->post('uf');
            $data['segmento']           = $this->input->post('segmento');
            $data['cnpj_cpf']           = $this->input->post('cnpj_cpf');
            $data['status']           = $this->input->post('status');
            $data['etapa']           = $this->input->post('etapa');
            $data['ramo_atuacao']           = $this->input->post('ramo_atuacao');
            $data['saber_cs']           = $this->input->post('saber_cs');
            $data['periodo_atend_contab']           = $this->input->post('periodo_atend_contab');
            $data['ja_teve_contador']           = $this->input->post('ja_teve_contador');
            $data['vai_ter_funcionario']           = $this->input->post('vai_ter_funcionario');
            $data['migrar_mei_me']           = $this->input->post('migrar_mei_me');
            $data['obs']           = $this->input->post('obs');             
            $data['id_formulario']           = $this->input->post('id_formulario');
            
            $this->db->where('id_novo_fluxo', $param2);
            $this->db->update('clientes_novo_fluxo', $data);

            $this->session->set_flashdata('flash_message', 'Cadastro Atualizado com Sucesso!!!');
            
            redirect(base_url() . 'index.php?admin/client_etapa_inicial1/', 'refresh');

        }

        if ($param1 == 'delete') {

            $data['status']         = 'excluido';
            $this->db->where('clientes_fc_id', $param2);
            $this->db->update('clientes_fc', $data);
            redirect(base_url() . 'index.php?admin/empresa_abrir/', 'refresh');

        }
        if ($param1 == 'cancelar') {

            $data['status']         = '14';
            $this->db->where('id_novo_fluxo', $param2);
            $this->db->update('clientes_novo_fluxo', $data);
            redirect(base_url() . 'index.php?admin/empresa_abrir/', 'refresh');

        }
        
        if ($param1 == 'finalizar_cadastro') {

            $form = $param3; 
            switch ($form) {
                case 'ac':
                    $data['alterdata']      = $this->input->post('alterdata');
                    //$data['status']         = '6';
                    $this->db->where('clientes_ac_id', $param2);
                    $this->db->update('clientes_ac', $data);
                    redirect(base_url() . 'index.php?admin/comercio_abrir3/', 'refresh');                
                  break;
                case 'fc':
                    $data['alterdata']      = $this->input->post('alterdata');
                    //$data['status']         = '6';
                    $this->db->where('clientes_fc_id', $param2);
                    $this->db->update('clientes_fc', $data);
                    redirect(base_url() . 'index.php?admin/empresa_abrir3/', 'refresh');                    
                  break;
                case 'ma':
                    $data['alterdata']      = $this->input->post('alterdata');
                    //$data['status']         = '6';
                    $this->db->where('clientes_ma_id', $param2);
                    $this->db->update('clientes_ma', $data);
                    redirect(base_url() . 'index.php?admin/mei_abrir3/', 'refresh');                  
                  break;
                case 'mt':
                    $data['alterdata']      = $this->input->post('alterdata');
                    //$data['status']         = '6';
                    $this->db->where('clientes_mt_id', $param2);
                    $this->db->update('clientes_mt', $data);
                    redirect(base_url() . 'index.php?admin/mei_trazer3/', 'refresh');                  
                  break;
                case 'pl':
                    $data['alterdata']      = $this->input->post('alterdata');
                    //$data['status']         = '6';
                    $this->db->where('clientes_pl_id', $param2);
                    $this->db->update('clientes_pl', $data);
                    redirect(base_url() . 'index.php?admin/comercio_abrir3/', 'refresh');                   
                  break;
                case 'tc':
                    $data['alterdata']      = $this->input->post('alterdata');
                    //$data['status']         = '6';
                    $this->db->where('clientes_tc_id', $param2);
                    $this->db->update('clientes_tc', $data);
                    redirect(base_url() . 'index.php?admin/empresa_abrir3/', 'refresh');                   
                  break;
                case 'te':
                    $data['alterdata']      = $this->input->post('alterdata');
                    //$data['status']         = '6';
                    $this->db->where('clientes_te_id', $param2);
                    $this->db->update('clientes_te', $data);
                    redirect(base_url() . 'index.php?admin/empresa_trazer3/', 'refresh');                   
                  break;                                                      
                default:
                    redirect(base_url() . 'index.php?admin/dashboard/', 'refresh'); 
                  
              }


        } 
                 
        if ($param1 == 'obs') {
        
        
            $data['status']   = $this->input->post('status');
            $data['obs']      = $this->input->post('obs');

            $this->db->where('clientes_fc_id', $param2);
            $this->db->update('clientes_fc', $data);
           
            
            $Xemail    = @$this->db->get_where('w_client_form_id', array('form_id' => $param2,'tipo_form' => 'fc' ))->row('email');

            if (empty($Xemail)){
            
                        $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso, mas email não foi enviado para o Cliente!!!');
            
            } else {
            
                        $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso!!!');
            
                        
            // Conversão no RD
              $data_rd['email']   = $Xemail;
              $data_rd['status']  = $this->input->post('status');
              $data_rd['obs']     = $this->input->post('obs');
              
              $fields = http_build_query($data_rd);
              $ch = curl_init();
              curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/validacao-documentos.php");
              curl_setopt($ch, CURLOPT_POST, 1);
              curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
              curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
              $server_output = curl_exec($ch);
              curl_close($ch);
            // Conversão no RD - FIM  
           
                        }
            $data2['form_client_id']     = $param2;
            $data2['form_tipo']          = 'fc';
            $data2['usuario']            = $this->session->userdata('admin_id');
            $data2['data']               = date("Y-m-d H:i:s", time()); 
            $data2['status']             = $this->input->post('status');
            $data2['obs']                = $this->input->post('obs');
            $this->db->insert('clientes_obs', $data2);
            
        
            // Envio Email            
            if ($this->input->post('status')==9)
            {
            
            $Xnome         = @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('nome');
            $Xdocumento    = @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('fc_03_numero_cpf');
            $Xendereco     = @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('fc_14_nome_rua').', '.
                              @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('fc_15_numero_rua').' '.
                              @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('fc_16_complemento').' - '.
                              @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('fc_17_bairro').' - '.
                              @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('fc_18_cidade').' - '.
                              @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('fc_19_uf').'';
            $Xcep          = @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('fc_20_cep');
            $Xemail        = @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('email');
            $Xnome_socio   = @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('nome');
            
            $this->email_model->envia_notificacao_enviar_boleto_abrir('Abrir Empresa',$Xnome,$Xdocumento,$Xendereco,$Xcep,$Xemail,$Xnome_socio);

            }
            
            
            redirect(base_url() . 'index.php?admin/empresa_abrir/', 'refresh');

        }
        
        //$page_data['empresa_abrir']     = $this->db->get('clientes_fc')->result_array();
        //$page_data['empresa_abrir2']     = $this->db->query("SELECT * from clientes_fc where fluxo=2 and status not in ('6','7','8')")->result_array();
        $page_data['empresa_abrir']     = $this->db->query("SELECT * from clientes_novo_fluxo where tipo_form='abrir empresa' and etapa='1' and status in ('1','2')")->result_array();
        $page_data['page_name']         = 'empresa_abrir';
        $page_data['page_icon']         = 'globe';
        $page_data['page_title']        = 'Abertura Empresa - Etapa 1';
        $this->load->view('index', $page_data);
    }


/***EMPRESA ABERTURA - Etapa 1***/
    function empresa_abrir ($param1 = '', $param2 = '', $param3 = '')
    {

        if ($param1 == 'do_update') {

            $data['tipo_form']           = $this->input->post('tipo_form');
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['cidade']           = $this->input->post('cidade');
            $data['uf']           = $this->input->post('uf');
            $data['segmento']           = $this->input->post('segmento');
            $data['cnpj_cpf']           = $this->input->post('cnpj_cpf');
            $data['status']           = $this->input->post('status');
            $data['etapa']           = $this->input->post('etapa');
            $data['ramo_atuacao']           = $this->input->post('ramo_atuacao');
            $data['saber_cs']           = $this->input->post('saber_cs');
            $data['periodo_atend_contab']           = $this->input->post('periodo_atend_contab');
            $data['ja_teve_contador']           = $this->input->post('ja_teve_contador');
            $data['vai_ter_funcionario']           = $this->input->post('vai_ter_funcionario');
            $data['migrar_mei_me']           = $this->input->post('migrar_mei_me');
            $data['obs']           = $this->input->post('obs');             
            $data['id_formulario']           = $this->input->post('id_formulario');
            
            $this->db->where('id_novo_fluxo', $param2);
            $this->db->update('clientes_novo_fluxo', $data);

            $this->session->set_flashdata('flash_message', 'Cadastro enviado para etapa 2!!!');
            
            redirect(base_url() . 'index.php?admin/empresa_abrir/', 'refresh');

        }
        
        $page_data['empresa_abrir']     = $this->db->query("SELECT * from clientes_novo_fluxo where tipo_form='abrir empresa' and etapa='1' and status in ('1','2')")->result_array();
        $page_data['page_name']         = 'empresa_abrir';
        $page_data['page_icon']         = 'globe';
        $page_data['page_title']        = 'Abertura Empresa - Etapa 1';
        $this->load->view('index', $page_data);
    }

/***EMPRESA TRAZER - Etapa 1***/
    function empresa_trazer ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($param1 == 'do_update') {

            $data['tipo_form']           = $this->input->post('tipo_form');
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['cidade']           = $this->input->post('cidade');
            $data['uf']           = $this->input->post('uf');
            $data['segmento']           = $this->input->post('segmento');
            $data['cnpj_cpf']           = $this->input->post('cnpj_cpf');
            $data['status']           = $this->input->post('status');
            $data['etapa']           = $this->input->post('etapa');
            $data['ramo_atuacao']           = $this->input->post('ramo_atuacao');
            $data['saber_cs']           = $this->input->post('saber_cs');
            $data['periodo_atend_contab']           = $this->input->post('periodo_atend_contab');
            $data['ja_teve_contador']           = $this->input->post('ja_teve_contador');
            $data['vai_ter_funcionario']           = $this->input->post('vai_ter_funcionario');
            $data['migrar_mei_me']           = $this->input->post('migrar_mei_me');
            $data['obs']           = $this->input->post('obs');             
            $data['id_formulario']           = $this->input->post('id_formulario');
            
            $this->db->where('id_novo_fluxo', $param2);
            $this->db->update('clientes_novo_fluxo', $data);

            $this->session->set_flashdata('flash_message', 'Cadastro enviado para etapa 3!!!');
            
            redirect(base_url() . 'index.php?admin/empresa_trazer/', 'refresh');

        }

        $page_data['empresa_trazer']     = $this->db->query("SELECT * from clientes_novo_fluxo where tipo_form='trazer empresa' and etapa='1' and status in ('1','2')")->result_array();
        $page_data['page_name']         = 'empresa_trazer';
        $page_data['page_icon']         = 'globe';
        $page_data['page_title']        = 'Trazer Empresa - Etapa 1';
        $this->load->view('index', $page_data);
    }

/***MEI ABERTURA  - Etapa 1 ***/
    function mei_abrir ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($param1 == 'do_update') {

            $data['tipo_form']           = $this->input->post('tipo_form');
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['cidade']           = $this->input->post('cidade');
            $data['uf']           = $this->input->post('uf');
            $data['segmento']           = $this->input->post('segmento');
            $data['cnpj_cpf']           = $this->input->post('cnpj_cpf');
            $data['status']           = $this->input->post('status');
            $data['etapa']           = $this->input->post('etapa');
            $data['ramo_atuacao']           = $this->input->post('ramo_atuacao');
            $data['saber_cs']           = $this->input->post('saber_cs');
            $data['periodo_atend_contab']           = $this->input->post('periodo_atend_contab');
            $data['ja_teve_contador']           = $this->input->post('ja_teve_contador');
            $data['vai_ter_funcionario']           = $this->input->post('vai_ter_funcionario');
            $data['migrar_mei_me']           = $this->input->post('migrar_mei_me'); 
            $data['obs']           = $this->input->post('obs');            
            $data['id_formulario']           = $this->input->post('id_formulario');
            
            $this->db->where('id_novo_fluxo', $param2);
            $this->db->update('clientes_novo_fluxo', $data);

            $this->session->set_flashdata('flash_message', 'Cadastro enviado para etapa 3!!!');
            
            redirect(base_url() . 'index.php?admin/mei_abrir/', 'refresh');

        }
        //$page_data['mei_abrir']     = $this->db->get('clientes_ma')->result_array();
        $page_data['mei_abrir']     = $this->db->query("SELECT * from clientes_novo_fluxo where tipo_form='abrir mei' and etapa='1' and status in ('1','2')")->result_array();
        $page_data['page_name']         = 'mei_abrir';
        $page_data['page_icon']         = 'tag';
        $page_data['page_title']        = 'Abertura MEI - Etapa 1';
        $this->load->view('index', $page_data);
    }

/***MEI TRAZER  - Etapa 1 ***/
    function mei_trazer ($param1 = '', $param2 = '', $param3 = '')
    {
        
        if ($param1 == 'do_update') {

            $data['tipo_form']           = $this->input->post('tipo_form');
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['cidade']           = $this->input->post('cidade');
            $data['uf']           = $this->input->post('uf');
            $data['segmento']           = $this->input->post('segmento');
            $data['cnpj_cpf']           = $this->input->post('cnpj_cpf');
            $data['status']           = $this->input->post('status');
            $data['etapa']           = $this->input->post('etapa');
            $data['ramo_atuacao']           = $this->input->post('ramo_atuacao');
            $data['saber_cs']           = $this->input->post('saber_cs');
            $data['periodo_atend_contab']           = $this->input->post('periodo_atend_contab');
            $data['ja_teve_contador']           = $this->input->post('ja_teve_contador');
            $data['vai_ter_funcionario']           = $this->input->post('vai_ter_funcionario');
            $data['migrar_mei_me']           = $this->input->post('migrar_mei_me');
            $data['obs']           = $this->input->post('obs');             
            $data['id_formulario']           = $this->input->post('id_formulario');
            
            $this->db->where('id_novo_fluxo', $param2);
            $this->db->update('clientes_novo_fluxo', $data);

            $this->session->set_flashdata('flash_message', 'Cadastro enviado para etapa 3!!!');
            
            redirect(base_url() . 'index.php?admin/mei_trazer/', 'refresh');

        }     
        
        $page_data['mei_trazer']     = $this->db->query("SELECT * from clientes_novo_fluxo where tipo_form='trazer mei' and etapa='1' and status in ('1','2')")->result_array();
        $page_data['page_name']         = 'mei_trazer';
        $page_data['page_icon']         = 'tag';
        $page_data['page_title']        = 'Trazer MEI - Etapa 1';
        $this->load->view('index', $page_data);
    }
    
/***COMERCIO ABERTURA  - Etapa 1***/
    function comercio_abrir ($param1 = '', $param2 = '', $param3 = '')
    {
        
        if ($param1 == 'do_update') {

            $data['tipo_form']           = $this->input->post('tipo_form');
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['cidade']           = $this->input->post('cidade');
            $data['uf']           = $this->input->post('uf');
            $data['segmento']           = $this->input->post('segmento');
            $data['cnpj_cpf']           = $this->input->post('cnpj_cpf');
            $data['status']           = $this->input->post('status');
            $data['etapa']           = $this->input->post('etapa');
            $data['ramo_atuacao']           = $this->input->post('ramo_atuacao');
            $data['saber_cs']           = $this->input->post('saber_cs');
            $data['periodo_atend_contab']           = $this->input->post('periodo_atend_contab');
            $data['ja_teve_contador']           = $this->input->post('ja_teve_contador');
            $data['vai_ter_funcionario']           = $this->input->post('vai_ter_funcionario');
            $data['migrar_mei_me']           = $this->input->post('migrar_mei_me');
            $data['obs']           = $this->input->post('obs');             
            $data['id_formulario']           = $this->input->post('id_formulario');
            
            $this->db->where('id_novo_fluxo', $param2);
            $this->db->update('clientes_novo_fluxo', $data);

            $this->session->set_flashdata('flash_message', 'Cadastro enviado para etapa 3!!!');
            
            redirect(base_url() . 'index.php?admin/comercio_abrir/', 'refresh');

        }
               
        //$page_data['comercio_abrir']     = $this->db->get('clientes_ac')->result_array();
        $page_data['comercio_abrir']     = $this->db->query("SELECT * from clientes_novo_fluxo where tipo_form='abrir comercio' and etapa='1' and status in ('1','2')")->result_array();
        $page_data['page_name']         = 'comercio_abrir';
        $page_data['page_icon']         = 'shopping-cart';
        $page_data['page_title']        = 'Comercio Empresa - Etapa 1';
        $this->load->view('index', $page_data);
    }

/***COMERCIO TRAZER - Etapa 1***/
    function comercio_trazer ($param1 = '', $param2 = '', $param3 = '')
    {
        
        if ($param1 == 'do_update') {

            $data['tipo_form']           = $this->input->post('tipo_form');
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['cidade']           = $this->input->post('cidade');
            $data['uf']           = $this->input->post('uf');
            $data['segmento']           = $this->input->post('segmento');
            $data['cnpj_cpf']           = $this->input->post('cnpj_cpf');
            $data['status']           = $this->input->post('status');
            $data['etapa']           = $this->input->post('etapa');
            $data['ramo_atuacao']           = $this->input->post('ramo_atuacao');
            $data['saber_cs']           = $this->input->post('saber_cs');
            $data['periodo_atend_contab']           = $this->input->post('periodo_atend_contab');
            $data['ja_teve_contador']           = $this->input->post('ja_teve_contador');
            $data['vai_ter_funcionario']           = $this->input->post('vai_ter_funcionario');
            $data['migrar_mei_me']           = $this->input->post('migrar_mei_me');
            $data['obs']           = $this->input->post('obs');             
            $data['id_formulario']           = $this->input->post('id_formulario');
            
            $this->db->where('id_novo_fluxo', $param2);
            $this->db->update('clientes_novo_fluxo', $data);

            $this->session->set_flashdata('flash_message', 'Cadastro enviado para etapa 3!!!');
            
            redirect(base_url() . 'index.php?admin/comercio_trazer/', 'refresh');

        }        
        //$page_data['comercio_trazer']     = $this->db->get('clientes_tc')->result_array();
        $page_data['comercio_trazer']     = $this->db->query("SELECT * from clientes_novo_fluxo where tipo_form='trazer comercio' and etapa='1' and status in ('1','2')")->result_array();
        $page_data['page_name']         = 'comercio_trazer';
        $page_data['page_icon']         = 'shopping-cart';
        $page_data['page_title']        = 'Trazer Comercio';
        $this->load->view('index', $page_data);
    }

/***** FIM - DO NOVO FLUXO - Etapa 1 *********/    


/***EMPRESA ABERTURA - Etapa 2***/
    function empresa_abrir2 ($param1 = '', $param2 = '', $param3 = '')
    {

        if ($param1 == 'do_update') {

            $data['tipo_form']           = $this->input->post('tipo_form');
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['cidade']           = $this->input->post('cidade');
            $data['uf']           = $this->input->post('uf');
            $data['segmento']           = $this->input->post('segmento');
            $data['cnpj_cpf']           = $this->input->post('cnpj_cpf');
            $data['status']           = $this->input->post('status');
            $data['etapa']           = $this->input->post('etapa');
            $data['ramo_atuacao']           = $this->input->post('ramo_atuacao');
            $data['saber_cs']           = $this->input->post('saber_cs');
            $data['periodo_atend_contab']           = $this->input->post('periodo_atend_contab');
            $data['ja_teve_contador']           = $this->input->post('ja_teve_contador');
            $data['vai_ter_funcionario']           = $this->input->post('vai_ter_funcionario');
            $data['migrar_mei_me']           = $this->input->post('migrar_mei_me');
            $data['obs']           = $this->input->post('obs');             
            $data['id_formulario']           = $this->input->post('id_formulario');
            
            $this->db->where('id_novo_fluxo', $param2);
            $this->db->update('clientes_novo_fluxo', $data);

            $this->session->set_flashdata('flash_message', 'Cadastro enviado para etapa 3!!!');
            
            redirect(base_url() . 'index.php?admin/empresa_abrir2/', 'refresh');

        }

        $page_data['empresa_abrir2']     = $this->db->query("SELECT * from clientes_novo_fluxo where tipo_form='abrir empresa' and etapa='2' and status in ('1','2')")->result_array();
        $page_data['page_name']         = 'empresa_abrir2';
        $page_data['page_icon']         = 'globe';
        $page_data['page_title']        = 'Abertura Empresa - Etapa 2';
        $this->load->view('index', $page_data);
    }

/***EMPRESA TRAZER - Etapa 2***/
    function empresa_trazer2 ($param1 = '', $param2 = '', $param3 = '')
    {

        if ($param1 == 'do_update') {

            $data['tipo_form']           = $this->input->post('tipo_form');
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['cidade']           = $this->input->post('cidade');
            $data['uf']           = $this->input->post('uf');
            $data['segmento']           = $this->input->post('segmento');
            $data['cnpj_cpf']           = $this->input->post('cnpj_cpf');
            $data['status']           = $this->input->post('status');
            $data['etapa']           = $this->input->post('etapa');
            $data['ramo_atuacao']           = $this->input->post('ramo_atuacao');
            $data['saber_cs']           = $this->input->post('saber_cs');
            $data['periodo_atend_contab']           = $this->input->post('periodo_atend_contab');
            $data['ja_teve_contador']           = $this->input->post('ja_teve_contador');
            $data['vai_ter_funcionario']           = $this->input->post('vai_ter_funcionario');
            $data['migrar_mei_me']           = $this->input->post('migrar_mei_me');
            $data['obs']           = $this->input->post('obs');             
            $data['id_formulario']           = $this->input->post('id_formulario');
            
            $this->db->where('id_novo_fluxo', $param2);
            $this->db->update('clientes_novo_fluxo', $data);

            $this->session->set_flashdata('flash_message', 'Cadastro enviado para etapa 3!!!');
            
            redirect(base_url() . 'index.php?admin/empresa_abrir2/', 'refresh');

        }


        $page_data['empresa_trazer2']     = $this->db->query("SELECT * from clientes_novo_fluxo where tipo_form='trazer empresa' and etapa='2' and status in ('1','2')")->result_array();
        $page_data['page_name']         = 'empresa_trazer2';
        $page_data['page_icon']         = 'globe';
        $page_data['page_title']        = 'Trazer Empresa- Etapa 2';
        $this->load->view('index', $page_data);
    }

/***MEI ABERTURA  - Etapa 2 ***/
    function mei_abrir2 ($param1 = '', $param2 = '', $param3 = '')
    {

        if ($param1 == 'do_update') {

            $data['tipo_form']           = $this->input->post('tipo_form');
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['cidade']           = $this->input->post('cidade');
            $data['uf']           = $this->input->post('uf');
            $data['segmento']           = $this->input->post('segmento');
            $data['cnpj_cpf']           = $this->input->post('cnpj_cpf');
            $data['status']           = $this->input->post('status');
            $data['etapa']           = $this->input->post('etapa');
            $data['ramo_atuacao']           = $this->input->post('ramo_atuacao');
            $data['saber_cs']           = $this->input->post('saber_cs');
            $data['periodo_atend_contab']           = $this->input->post('periodo_atend_contab');
            $data['ja_teve_contador']           = $this->input->post('ja_teve_contador');
            $data['vai_ter_funcionario']           = $this->input->post('vai_ter_funcionario');
            $data['migrar_mei_me']           = $this->input->post('migrar_mei_me');
            $data['obs']           = $this->input->post('obs');             
            $data['id_formulario']           = $this->input->post('id_formulario');
            
            $this->db->where('id_novo_fluxo', $param2);
            $this->db->update('clientes_novo_fluxo', $data);

            $this->session->set_flashdata('flash_message', 'Cadastro enviado para etapa 3!!!');
            
            redirect(base_url() . 'index.php?admin/mei_abrir2/', 'refresh');

        }
        
        $page_data['mei_abrir2']     = $this->db->query("SELECT * from clientes_novo_fluxo where tipo_form='abrir mei' and etapa='2' and status in ('1','2')")->result_array();
        $page_data['page_name']         = 'mei_abrir2';
        $page_data['page_icon']         = 'tag';
        $page_data['page_title']        = 'Abertura MEI - Etapa 2';
        $this->load->view('index', $page_data);
    }

/***MEI TRAZER  - Etapa 2 ***/
    function mei_trazer2 ($param1 = '', $param2 = '', $param3 = '')
    {

        if ($param1 == 'do_update') {

            $data['tipo_form']           = $this->input->post('tipo_form');
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['cidade']           = $this->input->post('cidade');
            $data['uf']           = $this->input->post('uf');
            $data['segmento']           = $this->input->post('segmento');
            $data['cnpj_cpf']           = $this->input->post('cnpj_cpf');
            $data['status']           = $this->input->post('status');
            $data['etapa']           = $this->input->post('etapa');
            $data['ramo_atuacao']           = $this->input->post('ramo_atuacao');
            $data['saber_cs']           = $this->input->post('saber_cs');
            $data['periodo_atend_contab']           = $this->input->post('periodo_atend_contab');
            $data['ja_teve_contador']           = $this->input->post('ja_teve_contador');
            $data['vai_ter_funcionario']           = $this->input->post('vai_ter_funcionario');
            $data['migrar_mei_me']           = $this->input->post('migrar_mei_me');
            $data['obs']           = $this->input->post('obs');             
            $data['id_formulario']           = $this->input->post('id_formulario');
            
            $this->db->where('id_novo_fluxo', $param2);
            $this->db->update('clientes_novo_fluxo', $data);

            $this->session->set_flashdata('flash_message', 'Cadastro enviado para etapa 3!!!');
            
            redirect(base_url() . 'index.php?admin/mei_trazer2/', 'refresh');

        }
        
        $page_data['mei_trazer2']     = $this->db->query("SELECT * from clientes_novo_fluxo where tipo_form='trazer mei' and etapa='2' and status in ('1','2')")->result_array();
        $page_data['page_name']         = 'mei_trazer2';
        $page_data['page_icon']         = 'tag';
        $page_data['page_title']        = 'Trazer MEI - Etapa 2';
        $this->load->view('index', $page_data);
    }
    
    
/***** FIM - DO NOVO FLUXO 2 *********/    

/***EMPRESA ABERTURA - Etapa 3***/
    function empresa_abrir3 ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url() . 'index.php?admin/empresa_abrir3/', 'refresh');

        if ($param1 == 'do_update') {
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
//            $data['status']           = $this->input->post('status');
//
            $data['fc_03_numero_cpf']           = $this->input->post('fc_03_numero_cpf');
            $data['fc_04_radio_documentos']           = $this->input->post('fc_04_radio_documentos');
            $data['fc_05_rg_digital']           = $this->input->post('fc_05_rg_digital');
            $data['fc_06_cpf_digital']           = $this->input->post('fc_06_cpf_digital');
            $data['fc_07_cnh_digital']           = $this->input->post('fc_07_cnh_digital');
            $data['fc_08_nome_mae']           = $this->input->post('fc_08_nome_mae');
            $data['fc_09_estado_civil']           = $this->input->post('fc_09_estado_civil');
            $data['fc_10_regime_casamento']           = $this->input->post('fc_10_regime_casamento');
            $data['fc_11_opcao_irpf']           = $this->input->post('fc_11_opcao_irpf');
            $data['fc_12_irpf']           = $this->input->post('fc_12_irpf');
            $data['fc_13_titulo_eleitor']           = $this->input->post('fc_13_titulo_eleitor');
            $data['fc_14_nome_rua']           = $this->input->post('fc_14_nome_rua');
            $data['fc_15_numero_rua']           = $this->input->post('fc_15_numero_rua');
            $data['fc_16_complemento']           = $this->input->post('fc_16_complemento');
            $data['fc_17_bairro']           = $this->input->post('fc_17_bairro');
            $data['fc_18_cidade']           = $this->input->post('fc_18_cidade');
            $data['fc_19_uf']           = $this->input->post('fc_19_uf');
            $data['fc_20_cep']           = $this->input->post('fc_20_cep');
            $data['fc_21_nome_empresa01']           = $this->input->post('fc_21_nome_empresa01');
            $data['fc_22_nome_empresa02']           = $this->input->post('fc_22_nome_empresa02');
            $data['fc_23_nome_empresa03']           = $this->input->post('fc_23_nome_empresa03');
            $data['fc_24_nome_fantasia']           = $this->input->post('fc_24_nome_fantasia');
            $data['fc_25_data_inicio']           = $this->input->post('fc_25_data_inicio');
            $data['fc_134_numero_funcionarios']           = $this->input->post('fc_134_numero_funcionarios');
            $data['fc_26_endereco_referencia']           = $this->input->post('fc_26_endereco_referencia');
            $data['fc_27_nome_rua']           = $this->input->post('fc_27_nome_rua');
            $data['fc_28_numero_rua']           = $this->input->post('fc_28_numero_rua');
            $data['fc_29_complemento']           = $this->input->post('fc_29_complemento');
            $data['fc_30_bairro']           = $this->input->post('fc_30_bairro');
            $data['fc_31_cidade']           = $this->input->post('fc_31_cidade');
            $data['fc_32_uf']           = $this->input->post('fc_32_uf');
            $data['fc_33_cep']           = $this->input->post('fc_33_cep');
            $data['fc_34_iptu_empresa']           = $this->input->post('fc_34_iptu_empresa');
            $data['fc_35_atividades']           = $this->input->post('fc_35_atividades');
            $data['fc_36_capital_social']           = $this->input->post('fc_36_capital_social');
            $data['fc_37_socio_administrador']           = $this->input->post('fc_37_socio_administrador');
            $data['fc_38_pro_labore']           = $this->input->post('fc_38_pro_labore');
            $data['fc_39_qtd_socios']           = $this->input->post('fc_39_qtd_socios');
            $data['fc_40_socio_01_nome']           = $this->input->post('fc_40_socio_01_nome');
            $data['fc_41_socio_01_rg']           = $this->input->post('fc_41_socio_01_rg');
            $data['fc_42_socio_01_cpf']           = $this->input->post('fc_42_socio_01_cpf');
            $data['fc_43_socio_01_documento']           = $this->input->post('fc_43_socio_01_documento');
            $data['fc_44_socio_01_rgdigital']           = $this->input->post('fc_44_socio_01_rgdigital');
            $data['fc_45_socio_01_cpfdigital']           = $this->input->post('fc_45_socio_01_cpfdigital');
            $data['fc_46_socio_01_cnhdigital']           = $this->input->post('fc_46_socio_01_cnhdigital');
            $data['fc_47_socio_01_mae']           = $this->input->post('fc_47_socio_01_mae');
            $data['fc_48_socio_01_estadocivil']           = $this->input->post('fc_48_socio_01_estadocivil');
            $data['fc_49_socio_01_regimecasamento']           = $this->input->post('fc_49_socio_01_regimecasamento');
            $data['fc_50_socio_01_profissao']           = $this->input->post('fc_50_socio_01_profissao');
            $data['fc_51_socio_01_declara_irpf']           = $this->input->post('fc_51_socio_01_declara_irpf');
            $data['fc_52_socio_01_irpf']           = $this->input->post('fc_52_socio_01_irpf');
            $data['fc_53_socio_01_eleitor']           = $this->input->post('fc_53_socio_01_eleitor');
            $data['fc_54_socio_01_capital']           = $this->input->post('fc_54_socio_01_capital');
            $data['fc_55_socio_01_pisinss']           = $this->input->post('fc_55_socio_01_pisinss');
            $data['fc_56_socio_01_rua']           = $this->input->post('fc_56_socio_01_rua');
            $data['fc_57_socio_01_numero']           = $this->input->post('fc_57_socio_01_numero');
            $data['fc_58_socio_01_complemento']           = $this->input->post('fc_58_socio_01_complemento');
            $data['fc_59_socio_01_bairro']           = $this->input->post('fc_59_socio_01_bairro');
            $data['fc_60_socio_01_cidade']           = $this->input->post('fc_60_socio_01_cidade');
            $data['fc_61_socio_01_uf']           = $this->input->post('fc_61_socio_01_uf');
            $data['fc_62_socio_01_cep']           = $this->input->post('fc_62_socio_01_cep');
            $data['fc_63_socio_02_nome']           = $this->input->post('fc_63_socio_02_nome');
            $data['fc_64_socio_02_rg']           = $this->input->post('fc_64_socio_02_rg');
            $data['fc_65_socio_02_cpf']           = $this->input->post('fc_65_socio_02_cpf');
            $data['fc_66_socio_02_documento']           = $this->input->post('fc_66_socio_02_documento');
            $data['fc_67_socio_02_rgdigital']           = $this->input->post('fc_67_socio_02_rgdigital');
            $data['fc_68_socio_02_cpfdigital']           = $this->input->post('fc_68_socio_02_cpfdigital');
            $data['fc_69_socio_02_cnhdigital']           = $this->input->post('fc_69_socio_02_cnhdigital');
            $data['fc_70_socio_02_mae']           = $this->input->post('fc_70_socio_02_mae');
            $data['fc_71_socio_02_estadocivil']           = $this->input->post('fc_71_socio_02_estadocivil');
            $data['fc_72_socio_02_regimecasamento']           = $this->input->post('fc_72_socio_02_regimecasamento');
            $data['fc_73_socio_02_profissao']           = $this->input->post('fc_73_socio_02_profissao');
            $data['fc_74_socio_02_declaraimposto']           = $this->input->post('fc_74_socio_02_declaraimposto');
            $data['fc_75_socio_02_irpf']           = $this->input->post('fc_75_socio_02_irpf');
            $data['fc_76_socio_02_eleitor']           = $this->input->post('fc_76_socio_02_eleitor');
            $data['fc_77_socio_02_capital']           = $this->input->post('fc_77_socio_02_capital');
            $data['fc_78_socio_02_pisinss']           = $this->input->post('fc_78_socio_02_pisinss');
            $data['fc_79_socio_02_rua']           = $this->input->post('fc_79_socio_02_rua');
            $data['fc_80_socio_02_numero']           = $this->input->post('fc_80_socio_02_numero');
            $data['fc_81_socio_02_complemento']           = $this->input->post('fc_81_socio_02_complemento');
            $data['fc_82_socio_02_bairro']           = $this->input->post('fc_82_socio_02_bairro');
            $data['fc_83_socio_02_cidade']           = $this->input->post('fc_83_socio_02_cidade');
            $data['fc_84_socio_02_uf']           = $this->input->post('fc_84_socio_02_uf');
            $data['fc_85_socio_02_cep']           = $this->input->post('fc_85_socio_02_cep');
            $data['fc_86_socio_03_nome']           = $this->input->post('fc_86_socio_03_nome');
            $data['fc_87_socio_03_rg']           = $this->input->post('fc_87_socio_03_rg');
            $data['fc_88_socio_03_cpf']           = $this->input->post('fc_88_socio_03_cpf');
            $data['fc_89_socio_03_documento']           = $this->input->post('fc_89_socio_03_documento');
            $data['fc_90_socio_03_rgdigital']           = $this->input->post('fc_90_socio_03_rgdigital');
            $data['fc_91_socio_03_cpfdigital']           = $this->input->post('fc_91_socio_03_cpfdigital');
            $data['fc_92_socio_03_cnhdigital']           = $this->input->post('fc_92_socio_03_cnhdigital');
            $data['fc_93_socio_03_mae']           = $this->input->post('fc_93_socio_03_mae');
            $data['fc_94_socio_03_estadocilvil']           = $this->input->post('fc_94_socio_03_estadocilvil');
            $data['fc_95_socio_03_regimecasamento']           = $this->input->post('fc_95_socio_03_regimecasamento');
            $data['fc_96_socio_03_profissao']           = $this->input->post('fc_96_socio_03_profissao');
            $data['fc_97_socio_03_declaraimposto']           = $this->input->post('fc_97_socio_03_declaraimposto');
            $data['fc_98_socio_03_irpf']           = $this->input->post('fc_98_socio_03_irpf');
            $data['fc_99_socio_03_eleitor']           = $this->input->post('fc_99_socio_03_eleitor');
            $data['fc_100_socio_03_capital']           = $this->input->post('fc_100_socio_03_capital');
            $data['fc_101_socio_03_pisinss']           = $this->input->post('fc_101_socio_03_pisinss');
            $data['fc_102_socio_03_rua']           = $this->input->post('fc_102_socio_03_rua');
            $data['fc_103_socio_03_numero']           = $this->input->post('fc_103_socio_03_numero');
            $data['fc_104_socio_03_complemento']           = $this->input->post('fc_104_socio_03_complemento');
            $data['fc_105_socio_03_bairro']           = $this->input->post('fc_105_socio_03_bairro');
            $data['fc_106_socio_106_socio_03_cidade']           = $this->input->post('fc_106_socio_106_socio_03_cidade');
            $data['fc_107_socio_03_uf']           = $this->input->post('fc_107_socio_03_uf');
            $data['fc_108_socio_03_cep']           = $this->input->post('fc_108_socio_03_cep');
            $data['fc_109_socio_04_nome']           = $this->input->post('fc_109_socio_04_nome');
            $data['fc_110_socio_04_rg']           = $this->input->post('fc_110_socio_04_rg');
            $data['fc_111_socio_04_cpf']           = $this->input->post('fc_111_socio_04_cpf');
            $data['fc_112_socio_04_documento']           = $this->input->post('fc_112_socio_04_documento');
            $data['fc_113_socio_04_rgdigital']           = $this->input->post('fc_113_socio_04_rgdigital');
            $data['fc_114_socio_04_cpfdigital']           = $this->input->post('fc_114_socio_04_cpfdigital');
            $data['fc_115_socio_04_cnhdigital']           = $this->input->post('fc_115_socio_04_cnhdigital');
            $data['fc_116_socio_04_mae']           = $this->input->post('fc_116_socio_04_mae');
            $data['fc_117_socio_04_estadocivil']           = $this->input->post('fc_117_socio_04_estadocivil');
            $data['fc_118_socio_04_regimecasamento']           = $this->input->post('fc_118_socio_04_regimecasamento');
            $data['fc_119_socio_04_profissao']           = $this->input->post('fc_119_socio_04_profissao');
            $data['fc_120_socio_04_declaraimposto']           = $this->input->post('fc_120_socio_04_declaraimposto');
            $data['fc_121_socio_04_irpf']           = $this->input->post('fc_121_socio_04_irpf');
            $data['fc_122_socio_04_eleitor']           = $this->input->post('fc_122_socio_04_eleitor');
            $data['fc_123_socio_04_capital']           = $this->input->post('fc_123_socio_04_capital');
            $data['fc_124_socio_04_pisinss']           = $this->input->post('fc_124_socio_04_pisinss');
            $data['fc_125_socio_04_rua']           = $this->input->post('fc_125_socio_04_rua');
            $data['fc_126_socio_04_numero']           = $this->input->post('fc_126_socio_04_numero');
            $data['fc_127_socio_04_complemento']           = $this->input->post('fc_127_socio_04_complemento');
            $data['fc_128_socio_04_bairro']           = $this->input->post('fc_128_socio_04_bairro');
            $data['fc_129_socio_04_cidade']           = $this->input->post('fc_129_socio_04_cidade');
            $data['fc_107_socio_04_uf']           = $this->input->post('fc_107_socio_04_uf');
            $data['fc_131_socio_04_cep']           = $this->input->post('fc_131_socio_04_cep');

            $this->db->where('clientes_fc_id', $param2);
            $this->db->update('clientes_fc', $data);

            $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso!!!');
            
            
              // Conversão no RD
                //$data['email'] = 'gestao@contsimples.com.br';
                //$data['status'] = '3';
                //$data['obs'] = 'Falta espelho do IPTU';
                
                $fields = http_build_query($data);
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/validacao-documentos.php");
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                $server_output = curl_exec($ch);
                curl_close($ch);
              // Conversão no RD - FIM  

            redirect(base_url() . 'index.php?admin/empresa_abrir3/', 'refresh');

        }


        if ($param1 == 'delete') {

            $data['status']         = 'excluido';
            $this->db->where('clientes_fc_id', $param2);
            $this->db->update('clientes_fc', $data);
            redirect(base_url() . 'index.php?admin/empresa_abrir3/', 'refresh');

        }
        if ($param1 == 'obs') {
        
        
            $data['status']   = $this->input->post('status');
            $data['obs']      = $this->input->post('obs');

            $this->db->where('clientes_fc_id', $param2);
            $this->db->update('clientes_fc', $data);
           
            
            $Xemail    = @$this->db->get_where('w_client_form_id', array('form_id' => $param2,'tipo_form' => 'fc' ))->row('email');

            if (empty($Xemail)){
            
                        $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso, mas email não foi enviado para o Cliente!!!');
            
            } else {
            
                        $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso!!!');
            
                        
            // Conversão no RD
              $data_rd['email']   = $Xemail;
              $data_rd['status']  = $this->input->post('status');
              $data_rd['obs']     = $this->input->post('obs');
              
              $fields = http_build_query($data_rd);
              $ch = curl_init();
              curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/validacao-documentos.php");
              curl_setopt($ch, CURLOPT_POST, 1);
              curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
              curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
              $server_output = curl_exec($ch);
              curl_close($ch);
            // Conversão no RD - FIM  
           
                        }
            $data2['form_client_id']     = $param2;
            $data2['form_tipo']          = 'fc';
            $data2['usuario']            = $this->session->userdata('admin_id');
            $data2['data']               = date("Y-m-d H:i:s", time()); 
            $data2['status']             = $this->input->post('status');
            $data2['obs']                = $this->input->post('obs');
            $this->db->insert('clientes_obs', $data2);
            
        
            // Envio Email            
            if ($this->input->post('status')==9)
            {
            
            $Xnome         = @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('nome');
            $Xdocumento    = @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('fc_03_numero_cpf');
            $Xendereco     = @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('fc_14_nome_rua').', '.
                              @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('fc_15_numero_rua').' '.
                              @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('fc_16_complemento').' - '.
                              @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('fc_17_bairro').' - '.
                              @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('fc_18_cidade').' - '.
                              @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('fc_19_uf').'';
            $Xcep          = @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('fc_20_cep');
            $Xemail        = @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('email');
            $Xnome_socio   = @$this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row('nome');
            
            $this->email_model->envia_notificacao_enviar_boleto_abrir('Abrir Empresa',$Xnome,$Xdocumento,$Xendereco,$Xcep,$Xemail,$Xnome_socio);

            }
            
            
            redirect(base_url() . 'index.php?admin/empresa_abrir3/', 'refresh');

        }
        
        $page_data['empresa_abrir3']     = $this->db->query("SELECT * from clientes_fc where status not in ('6','7')")->result_array(); 
        //$page_data['empresa_abrir3']     =  $this->db->query("SELECT * from clientes_novo_fluxo where tipo_form='abrir empresa' and etapa='3'")->result_array();
        $page_data['page_name']         = 'empresa_abrir3';
        $page_data['page_icon']         = 'globe';
        $page_data['page_title']        = 'Abertura Empresa - Etapa 3';
        $this->load->view('index', $page_data);
    }

/***EMPRESA TRAZER - Etapa 3***/
    function empresa_trazer3 ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'do_update') {
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
//            $data['status']           = $this->input->post('status');
//            $data['obs']           = $this->input->post('obs');
            $data['te_02_numero_rg']           = $this->input->post('te_02_numero_rg');
            $data['te_03_numero_cpf']           = $this->input->post('te_03_numero_cpf');
            $data['te_04_radio_documentos']           = $this->input->post('te_04_radio_documentos');
            $data['te_05_rg_digital']           = $this->input->post('te_05_rg_digital');
            $data['te_06_cpf_digital']           = $this->input->post('te_06_cpf_digital');
            $data['te_07_cnh_digital']           = $this->input->post('te_07_cnh_digital');
            $data['te_08_nome_mae']           = $this->input->post('te_08_nome_mae');
            $data['te_09_estado_civil']           = $this->input->post('te_09_estado_civil');
            $data['te_10_regime_casamento']           = $this->input->post('te_10_regime_casamento');
            $data['te_11_opcao_irpf']           = $this->input->post('te_11_opcao_irpf');
            $data['te_12_irpf']           = $this->input->post('te_12_irpf');
            $data['te_13_titulo_eleitor']           = $this->input->post('te_13_titulo_eleitor');
            $data['te_14_nome_empresarial']           = $this->input->post('te_14_nome_empresarial');
            $data['te_15_cnpj']           = $this->input->post('te_15_cnpj');
            $data['te_16_codigo_acesso']           = $this->input->post('te_16_codigo_acesso');
            $data['te_30_numero_funcionarios']           = $this->input->post('te_30_numero_funcionarios');
            $data['te_17_paginas_contrato']           = $this->input->post('te_17_paginas_contrato');
            $data['te_18_contrato_pagina1']           = $this->input->post('te_18_contrato_pagina1');
            $data['te_19_contrato_pagina2']           = $this->input->post('te_19_contrato_pagina2');
            $data['te_20_contrato_pagina3']           = $this->input->post('te_20_contrato_pagina3');
            $data['te_21_contrato_pagina4']           = $this->input->post('te_21_contrato_pagina4');
            $data['te_40_contrato_pagina5']           = $this->input->post('te_40_contrato_pagina5');
            $data['te_41_contrato_pagina6']           = $this->input->post('te_41_contrato_pagina6');
            $data['te_42_contrato_pagina7']           = $this->input->post('te_42_contrato_pagina7');
            $data['te_43_contrato_pagina8']           = $this->input->post('te_43_contrato_pagina8');
            $data['te_21_alvara']           = $this->input->post('te_21_alvara');
            $data['te_22_tem_certificado']           = $this->input->post('te_22_tem_certificado');
            $data['te_23_certificado_digital']           = $this->input->post('te_23_certificado_digital');
            $data['te_24_certificado_senha']           = $this->input->post('te_24_certificado_senha');
            $data['te_25_numero_socios']           = $this->input->post('te_25_numero_socios');
            $data['te_26_doc_socio01']           = $this->input->post('te_26_doc_socio01');
            $data['te_27_doc_socio02']           = $this->input->post('te_27_doc_socio02');
            $data['te_28_doc_socio03']           = $this->input->post('te_28_doc_socio03');
            $data['te_29_doc_socio04']           = $this->input->post('te_29_doc_socio04');

            $this->db->where('clientes_te_id', $param2);
            $this->db->update('clientes_te', $data);

            $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso!!!');

/*            
            require_once(APPPATH.'libraries/RD_Station.php');
    
                @$rdstation = new RD_Station($_POST);
                @$rdstation->token = 'f8327c603e68c7399b24c5a1ed25768f';
                if ($this->input->post('status')=='3'){
                  @$rdstation->identifier = 'validacao-documentos-pendente';
                }
                else{
                  @$rdstation->identifier = 'validacao-documentos';
                }
                @$rdstation->ignore_fields = array('telefone','data_cadastro','te_02_numero_rg','te_03_numero_cpf','te_04_radio_documentos','te_05_rg_digital','te_06_cpf_digital','te_07_cnh_digital','te_08_nome_mae','te_09_estado_civil','te_10_regime_casamento','te_11_opcao_irpf','te_12_irpf','te_13_titulo_eleitor','te_14_nome_empresarial','te_15_cnpj','te_16_codigo_acesso','te_30_numero_funcionarios','te_17_paginas_contrato','te_18_contrato_pagina1','te_19_contrato_pagina2','te_20_contrato_pagina3','te_21_contrato_pagina4','te_40_contrato_pagina5','te_41_contrato_pagina6','te_42_contrato_pagina7','te_43_contrato_pagina8','te_21_alvara','te_22_tem_certificado','te_23_certificado_digital','te_24_certificado_senha','te_25_numero_socios','te_26_doc_socio01','te_27_doc_socio02','te_28_doc_socio03','te_29_doc_socio04');

                @$rdstation->createLead();
*/
              // Conversão no RD
                //$data['email'] = 'gestao@contsimples.com.br';
                //$data['status'] = '3';
                //$data['obs'] = 'Falta espelho do IPTU';
                
                $fields = http_build_query($data);
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/validacao-documentos.php");
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                $server_output = curl_exec($ch);
                curl_close($ch);
              // Conversão no RD - FIM            

            redirect(base_url() . 'index.php?admin/empresa_trazer3/', 'refresh');

        }


        if ($param1 == 'delete') {

            $data['status']         = 'excluido';
            $this->db->where('clientes_te_id', $param2);
            $this->db->update('clientes_te', $data);
            redirect(base_url() . 'index.php?admin/empresa_trazer3/', 'refresh');

        }
        if ($param1 == 'obs') {
        
        
            $data['status']     = $this->input->post('status');
            $data['obs']        = $this->input->post('obs');

            $this->db->where('clientes_te_id', $param2);
            $this->db->update('clientes_te', $data);

            $Xemail    = @$this->db->get_where('w_client_form_id', array('form_id' => $param2,'tipo_form' => 'te' ))->row('email');

            if (empty($Xemail)){
            
                        $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso, mas email não foi enviado para o Cliente!!!');
            
            } else {
            
                        $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso!!!');
            
                        
            // Conversão no RD
              $data_rd['email']   = $Xemail;
              $data_rd['status']  = $this->input->post('status');
              $data_rd['obs']     = $this->input->post('obs');
              
              $fields = http_build_query($data_rd);
              $ch = curl_init();
              curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/validacao-documentos.php");
              curl_setopt($ch, CURLOPT_POST, 1);
              curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
              curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
              $server_output = curl_exec($ch);
              curl_close($ch);
            // Conversão no RD - FIM  

                        }
            $data2['form_client_id']     = $param2;
            $data2['form_tipo']          = 'te';
            $data2['usuario']            = $this->session->userdata('admin_id');
            $data2['data']               = date("Y-m-d H:i:s", time()); 
            $data2['status']             = $this->input->post('status');
            $data2['obs']                = $this->input->post('obs');
            $this->db->insert('clientes_obs', $data2);
            
            // Envio Email            
            if ($this->input->post('status')==9)
            {
            
            $Xnome         = @$this->db->get_where('clientes_te', array('clientes_te_id' => $param2))->row('te_14_nome_empresarial');
            $Xdocumento    = @$this->db->get_where('clientes_te', array('clientes_te_id' => $param2))->row('te_15_cnpj');
            $Xendereco     = '';
            $Xcep          = '';
            $Xemail        = @$this->db->get_where('clientes_te', array('clientes_te_id' => $param2))->row('email');
            $Xnome_socio   = @$this->db->get_where('clientes_te', array('clientes_te_id' => $param2))->row('nome');
            
            $this->email_model->envia_notificacao_enviar_boleto_trazer('Trazer Empresa',$Xnome,$Xdocumento,$Xendereco,$Xcep,$Xemail,$Xnome_socio);

            }
            
            redirect(base_url() . 'index.php?admin/empresa_trazer3/', 'refresh');

        }
        //$page_data['empresa_trazer']     = $this->db->get('clientes_te')->result_array();
        $page_data['empresa_trazer3']     = $this->db->query("SELECT * from clientes_te where status not in ('6','7')")->result_array();
        $page_data['page_name']         = 'empresa_trazer3';
        $page_data['page_icon']         = 'globe';
        $page_data['page_title']        = 'Trazer Empresa - Etapa 3';
        $this->load->view('index', $page_data);
    }

/***MEI ABERTURA  - Etapa 3***/
    function mei_abrir3 ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'do_update') {
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
//            $data['status']           = $this->input->post('status');
//            $data['obs']           = $this->input->post('obs');
            $data['ma_02_numero_rg']           = $this->input->post('ma_02_numero_rg');
            $data['ma_03_numero_cpf']           = $this->input->post('ma_03_numero_cpf');
            $data['ma_04_radio_documentos']           = $this->input->post('ma_04_radio_documentos');
            $data['ma_05_rg_digital']           = $this->input->post('ma_05_rg_digital');
            $data['ma_06_cpf_digital']           = $this->input->post('ma_06_cpf_digital');
            $data['ma_07_cnh_digital']           = $this->input->post('ma_07_cnh_digital');
            $data['ma_08_nome_mae']           = $this->input->post('ma_08_nome_mae');
            $data['ma_11_opcao_irpf']           = $this->input->post('ma_11_opcao_irpf');
            $data['ma_12_irpf']           = $this->input->post('ma_12_irpf');
            $data['ma_13_titulo_eleitor']           = $this->input->post('ma_13_titulo_eleitor');
            $data['ma_14_nome_rua']           = $this->input->post('ma_14_nome_rua');
            $data['ma_15_numero_rua']           = $this->input->post('ma_15_numero_rua');
            $data['ma_16_complemento']           = $this->input->post('ma_16_complemento');
            $data['ma_17_bairro']           = $this->input->post('ma_17_bairro');
            $data['ma_18_cidade']           = $this->input->post('ma_18_cidade');
            $data['ma_19_uf']           = $this->input->post('ma_19_uf');
            $data['ma_20_cep']           = $this->input->post('ma_20_cep');
            $data['ma_24_nome_fantasia']           = $this->input->post('ma_24_nome_fantasia');
            $data['ma_40_numero_funcionarios']           = $this->input->post('ma_40_numero_funcionarios');
            $data['ma_26_endereco_referencia']           = $this->input->post('ma_26_endereco_referencia');
            $data['ma_27_nome_rua']           = $this->input->post('ma_27_nome_rua');
            $data['ma_28_numero_rua']           = $this->input->post('ma_28_numero_rua');
            $data['ma_29_complemento']           = $this->input->post('ma_29_complemento');
            $data['ma_30_bairro']           = $this->input->post('ma_30_bairro');
            $data['ma_31_cidade']           = $this->input->post('ma_31_cidade');
            $data['ma_32_uf']           = $this->input->post('ma_32_uf');
            $data['ma_33_cep']           = $this->input->post('ma_33_cep');
            $data['ma_34_iptu_empresa']           = $this->input->post('ma_34_iptu_empresa');
            $data['ma_35_atividades']           = $this->input->post('ma_35_atividades');
            $data['ma_36_capital_social']           = $this->input->post('ma_36_capital_social');

            $this->db->where('clientes_ma_id', $param2);
            $this->db->update('clientes_ma', $data);

            $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso!!!');
            
              // Conversão no RD
                //$data['email'] = 'gestao@contsimples.com.br';
                //$data['status'] = '3';
                //$data['obs'] = 'Falta espelho do IPTU';
                
                $fields = http_build_query($data);
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/validacao-documentos.php");
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                $server_output = curl_exec($ch);
                curl_close($ch);
              // Conversão no RD - FIM  

            redirect(base_url() . 'index.php?admin/mei_abrir3/', 'refresh');

        }

        if ($param1 == 'delete') {

            $data['status']         = 'excluido';
            $this->db->where('clientes_ma_id', $param2);
            $this->db->update('clientes_ma', $data);
            redirect(base_url() . 'index.php?admin/mei_abrir3/', 'refresh');

        }
        if ($param1 == 'obs') {
        
        
            $data['status']       = $this->input->post('status');
            $data['obs']          = $this->input->post('obs');

            $this->db->where('clientes_ma_id', $param2);
            $this->db->update('clientes_ma', $data);

            $Xemail    = @$this->db->get_where('w_client_form_id', array('form_id' => $param2,'tipo_form' => 'ma' ))->row('email');

            if (empty($Xemail)){
            
                        $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso, mas email não foi enviado para o Cliente!!!');
            
            } else {
            
                        $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso!!!');
            
                        
            // Conversão no RD
              $data_rd['email']   = $Xemail;
              $data_rd['status']  = $this->input->post('status');
              $data_rd['obs']     = $this->input->post('obs');
              
              $fields = http_build_query($data_rd);
              $ch = curl_init();
              curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/validacao-documentos.php");
              curl_setopt($ch, CURLOPT_POST, 1);
              curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
              curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
              $server_output = curl_exec($ch);
              curl_close($ch);
            // Conversão no RD - FIM  

                        }
            $data2['form_client_id']     = $param2;
            $data2['form_tipo']          = 'ma';
            $data2['usuario']            = $this->session->userdata('admin_id');
            $data2['data']               = date("Y-m-d H:i:s", time()); 
            $data2['status']             = $this->input->post('status');
            $data2['obs']                = $this->input->post('obs');
            $this->db->insert('clientes_obs', $data2);
            
            // Envio Email            
            if ($this->input->post('status')==9)
            {
            
            $Xnome         = @$this->db->get_where('clientes_ma', array('clientes_ma_id' => $param2))->row('nome');
            $Xdocumento    = @$this->db->get_where('clientes_ma', array('clientes_ma_id' => $param2))->row('ma_03_numero_cpf');
            $Xendereco     = @$this->db->get_where('clientes_ma', array('clientes_ma_id' => $param2))->row('ma_14_nome_rua').', '.
                              @$this->db->get_where('clientes_ma', array('clientes_ma_id' => $param2))->row('ma_15_numero_rua').' '.
                              @$this->db->get_where('clientes_ma', array('clientes_ma_id' => $param2))->row('ma_16_complemento').' - '.
                              @$this->db->get_where('clientes_ma', array('clientes_ma_id' => $param2))->row('ma_17_bairro').' - '.
                              @$this->db->get_where('clientes_ma', array('clientes_ma_id' => $param2))->row('ma_18_cidade').' - '.
                              @$this->db->get_where('clientes_ma', array('clientes_ma_id' => $param2))->row('ma_19_uf').'';
            $Xcep          = @$this->db->get_where('clientes_ma', array('clientes_ma_id' => $param2))->row('ma_20_cep');
            $Xemail        = @$this->db->get_where('clientes_ma', array('clientes_ma_id' => $param2))->row('email');
            $Xnome_socio   = @$this->db->get_where('clientes_ma', array('clientes_ma_id' => $param2))->row('nome');
            
            $this->email_model->envia_notificacao_enviar_boleto_abrir('Abrir MEI',$Xnome,$Xdocumento,$Xendereco,$Xcep,$Xemail,$Xnome_socio);

            }
            
            redirect(base_url() . 'index.php?admin/mei_abrir3/', 'refresh');

        }
        //$page_data['mei_abrir']     = $this->db->get('clientes_ma')->result_array();
        $page_data['mei_abrir3']     = $this->db->query("SELECT * from clientes_ma where status not in ('6','7')")->result_array();
        $page_data['page_name']         = 'mei_abrir3';
        $page_data['page_icon']         = 'tag';
        $page_data['page_title']        = 'Abertura MEI - Etapa 3';
        $this->load->view('index', $page_data);
    }

/***MEI TRAZER - Etapa 3***/
    function mei_trazer3 ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'do_update') {
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
//            $data['status']           = $this->input->post('status');
//            $data['obs']           = $this->input->post('obs');
            $data['mt_02_numero_rg']           = $this->input->post('mt_02_numero_rg');
            $data['mt_03_numero_cpf']           = $this->input->post('mt_03_numero_cpf');
            $data['mt_04_radio_documentos']           = $this->input->post('mt_04_radio_documentos');
            $data['mt_05_rg_digital']           = $this->input->post('mt_05_rg_digital');
            $data['mt_06_cpf_digital']           = $this->input->post('mt_06_cpf_digital');
            $data['mt_07_cnh_digital']           = $this->input->post('mt_07_cnh_digital');
            $data['mt_14_nome_empresarial']           = $this->input->post('mt_14_nome_empresarial');
            $data['mt_15_cnpj']           = $this->input->post('mt_15_cnpj');
            $data['mt_16_codigo_acesso']           = $this->input->post('mt_16_codigo_acesso');
            $data['mt_25_numero_funcionarios']           = $this->input->post('mt_25_numero_funcionarios');
            $data['mt_17_paginas_contrato']           = $this->input->post('mt_17_paginas_contrato');
            $data['mt_18_contrato_pagina1']           = $this->input->post('mt_18_contrato_pagina1');
            $data['mt_19_contrato_pagina2']           = $this->input->post('mt_19_contrato_pagina2');
            $data['mt_21_alvara']           = $this->input->post('mt_21_alvara');
            $data['mt_22_tem_certificado']           = $this->input->post('mt_22_tem_certificado');
            $data['mt_23_certificado_digital']           = $this->input->post('mt_23_certificado_digital');
            $data['mt_24_certificado_senha']           = $this->input->post('mt_24_certificado_senha');

            $this->db->where('clientes_mt_id', $param2);
            $this->db->update('clientes_mt', $data);

            $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso!!!');
            
              // Conversão no RD
                //$data['email'] = 'gestao@contsimples.com.br';
                //$data['status'] = '3';
                //$data['obs'] = 'Falta espelho do IPTU';
                
                $fields = http_build_query($data);
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/validacao-documentos.php");
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                $server_output = curl_exec($ch);
                curl_close($ch);
              // Conversão no RD - FIM  

            redirect(base_url() . 'index.php?admin/mei_trazer3/', 'refresh');

        }


        if ($param1 == 'delete') {

            $data['status']         = 'excluido';
            $this->db->where('clientes_mt_id', $param2);
            $this->db->update('clientes_mt', $data);
            redirect(base_url() . 'index.php?admin/mei_trazer3/', 'refresh');

        }
        if ($param1 == 'obs') {
        
        
            $data['status']     = $this->input->post('status');
            $data['obs']        = $this->input->post('obs');

            $this->db->where('clientes_mt_id', $param2);
            $this->db->update('clientes_mt', $data);
            
            $Xemail    = @$this->db->get_where('w_client_form_id', array('form_id' => $param2,'tipo_form' => 'mt' ))->row('email');

            if (empty($Xemail)){
            
                        $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso, mas email não foi enviado para o Cliente!!!');
            
            } else {
            
                        $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso!!!');
            
                        
            // Conversão no RD
              $data_rd['email']   = $Xemail;
              $data_rd['status']  = $this->input->post('status');
              $data_rd['obs']     = $this->input->post('obs');
              
              $fields = http_build_query($data_rd);
              $ch = curl_init();
              curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/validacao-documentos.php");
              curl_setopt($ch, CURLOPT_POST, 1);
              curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
              curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
              $server_output = curl_exec($ch);
              curl_close($ch);
            // Conversão no RD - FIM  

                        }
            $data2['form_client_id']     = $param2;
            $data2['form_tipo']          = 'mt';
            $data2['usuario']            = $this->session->userdata('admin_id');
            $data2['data']               = date("Y-m-d H:i:s", time()); 
            $data2['status']             = $this->input->post('status');
            $data2['obs']                = $this->input->post('obs');
            $this->db->insert('clientes_obs', $data2);
            
            // Envio Email            
            if ($this->input->post('status')==9)
            {
            
            $Xnome         = @$this->db->get_where('clientes_mt', array('clientes_mt_id' => $param2))->row('mt_14_nome_empresarial');
            $Xdocumento    = @$this->db->get_where('clientes_mt', array('clientes_mt_id' => $param2))->row('mt_15_cnpj');
            $Xendereco     = '';
            $Xcep          = '';
            $Xemail        = @$this->db->get_where('clientes_mt', array('clientes_mt_id' => $param2))->row('email');
            $Xnome_socio   = @$this->db->get_where('clientes_mt', array('clientes_mt_id' => $param2))->row('nome');
            
            $this->email_model->envia_notificacao_enviar_boleto_trazer('Trazer MEI',$Xnome,$Xdocumento,$Xendereco,$Xcep,$Xemail,$Xnome_socio);

            }
            
            redirect(base_url() . 'index.php?admin/mei_trazer3/', 'refresh');

        }      
        //$page_data['mei_trazer']     = $this->db->get('clientes_mt')->result_array();
        $page_data['mei_trazer3']     = $this->db->query("SELECT * from clientes_mt where status not in ('6','7')")->result_array();
        $page_data['page_name']         = 'mei_trazer3';
        $page_data['page_icon']         = 'tag';
        $page_data['page_title']        = 'Trazer - Etapa 3';
        $this->load->view('index', $page_data);
    }

/***Prof Liberal ABERTURA***/
    function pl_abrir ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'do_update') {
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
//            $data['status']           = $this->input->post('status');
//            $data['obs']           = $this->input->post('obs');
            $data['pl_03_habilitacao']           = $this->input->post('pl_03_habilitacao');
            $data['pl_04_habilitacao_digital']           = $this->input->post('pl_04_habilitacao_digital');
            $data['pl_05_habilitacao_digital']           = $this->input->post('pl_05_habilitacao_digital');
            $data['pl_13_atividade']           = $this->input->post('pl_13_atividade');
            $data['pl_06_rua']           = $this->input->post('pl_06_rua');
            $data['pl_07_numero']           = $this->input->post('pl_07_numero');
            $data['pl_08_complemento']           = $this->input->post('pl_08_complemento');
            $data['pl_09_bairro']           = $this->input->post('pl_09_bairro');
            $data['pl_10_cidade']           = $this->input->post('pl_10_cidade');
            $data['pl_11_uf']           = $this->input->post('pl_11_uf');
            $data['pl_12_cep']           = $this->input->post('pl_12_cep');
            $data['pl_14_legalizado']           = $this->input->post('pl_14_legalizado');
            $data['pl_15_alvara']           = $this->input->post('pl_15_alvara');
            $data['pl_16_endereco_conferencia']           = $this->input->post('pl_16_endereco_conferencia');
            $data['pl_17_rua']           = $this->input->post('pl_17_rua');
            $data['pl_18_numero']           = $this->input->post('pl_18_numero');
            $data['pl_19_complemento']           = $this->input->post('pl_19_complemento');
            $data['pl_20_bairro']           = $this->input->post('pl_20_bairro');
            $data['pl_21_cidade']           = $this->input->post('pl_21_cidade');
            $data['pl_21_uf']           = $this->input->post('pl_21_uf');
            $data['pl_22_cep']           = $this->input->post('pl_22_cep');
            $data['pl_23_iptu']           = $this->input->post('pl_23_iptu');
            $data['pl_26_iptu']           = $this->input->post('pl_26_iptu');
            $data['pl_24_cadastro_cei']           = $this->input->post('pl_24_cadastro_cei');
            $data['pl_25_numero_cei']           = $this->input->post('pl_25_numero_cei');

            $this->db->where('clientes_pl_id', $param2);
            $this->db->update('clientes_pl', $data);

            $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso!!!');
            
              // Conversão no RD
                //$data['email'] = 'gestao@contsimples.com.br';
                //$data['status'] = '3';
                //$data['obs'] = 'Falta espelho do IPTU';
                
                $fields = http_build_query($data);
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/validacao-documentos.php");
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                $server_output = curl_exec($ch);
                curl_close($ch);
              // Conversão no RD - FIM  

            redirect(base_url() . 'index.php?admin/pl_abrir/', 'refresh');

        }

        if ($param1 == 'delete') {

            $data['status']         = 'excluido';
            $this->db->where('clientes_pl_id', $param2);
            $this->db->update('clientes_pl', $data);
            redirect(base_url() . 'index.php?admin/pl_abrir/', 'refresh');

        }
        if ($param1 == 'obs') {
        
        
            $data['status']     = $this->input->post('status');
            $data['obs']        = $this->input->post('obs');

            $this->db->where('clientes_pl_id', $param2);
            $this->db->update('clientes_pl', $data);

            
            $Xemail    = @$this->db->get_where('w_client_form_id', array('form_id' => $param2,'tipo_form' => 'pl' ))->row('email');

            if (empty($Xemail)){
            
                        $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso, mas email não foi enviado para o Cliente!!!');
            
            } else {
            
                        $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso!!!');
            
                        
            // Conversão no RD
              $data_rd['email']   = $Xemail;
              $data_rd['status']  = $this->input->post('status');
              $data_rd['obs']     = $this->input->post('obs');
              
              $fields = http_build_query($data_rd);
              $ch = curl_init();
              curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/validacao-documentos.php");
              curl_setopt($ch, CURLOPT_POST, 1);
              curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
              curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
              $server_output = curl_exec($ch);
              curl_close($ch);
            // Conversão no RD - FIM  

                        }
            $data2['form_client_id']     = $param2;
            $data2['form_tipo']          = 'pl';
            $data2['usuario']            = $this->session->userdata('admin_id');
            $data2['data']               = date("Y-m-d H:i:s", time()); 
            $data2['status']             = $this->input->post('status');
            $data2['obs']                = $this->input->post('obs');
            $this->db->insert('clientes_obs', $data2);
            
            // Envio Email            
            if ($this->input->post('status')==9)
            {
            
            $Xnome         = @$this->db->get_where('clientes_pl', array('clientes_pl_id' => $param2))->row('nome');
            $Xdocumento    = @$this->db->get_where('clientes_pl', array('clientes_pl_id' => $param2))->row('pl_03_habilitacao');
            $Xendereco     = @$this->db->get_where('clientes_pl', array('clientes_pl_id' => $param2))->row('pl_06_rua').', '.
                              @$this->db->get_where('clientes_pl', array('clientes_pl_id' => $param2))->row('pl_07_numero').' '.
                              @$this->db->get_where('clientes_pl', array('clientes_pl_id' => $param2))->row('pl_08_complemento').' - '.
                              @$this->db->get_where('clientes_pl', array('clientes_pl_id' => $param2))->row('pl_09_bairro').' - '.
                              @$this->db->get_where('clientes_pl', array('clientes_pl_id' => $param2))->row('pl_10_cidade').' - '.
                              @$this->db->get_where('clientes_pl', array('clientes_pl_id' => $param2))->row('pl_11_uf').'';
            $Xcep          = @$this->db->get_where('clientes_pl', array('clientes_pl_id' => $param2))->row('pl_12_cep');
            $Xemail        = @$this->db->get_where('clientes_pl', array('clientes_pl_id' => $param2))->row('email');
            $Xnome_socio   = @$this->db->get_where('clientes_pl', array('clientes_pl_id' => $param2))->row('nome');
            
            $this->email_model->envia_notificacao_enviar_boleto_abrir('Profissional Liberal',$Xnome,$Xdocumento,$Xendereco,$Xcep,$Xemail,$Xnome_socio);

            }
            
            redirect(base_url() . 'index.php?admin/pl_abrir/', 'refresh');

        }        
        //$page_data['pl_abrir']     = $this->db->get('clientes_pl')->result_array();
        $page_data['pl_abrir']     = $this->db->query("SELECT * from clientes_pl where status not in ('6','7')")->result_array();
        $page_data['page_name']         = 'pl_abrir';
        $page_data['page_icon']         = 'headphones';
        $page_data['page_title']        = 'Abertura Prof.Liberal';
        $this->load->view('index', $page_data);
    }

/***Prof Liberal TRAZER***/
    function pl_trazer ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        //$this->session->set_flashdata('flash_message', 'Passou aqui !!!');
        $page_data['pl_trazer3']     = $this->db->get('clientes_pl')->result_array();
        $page_data['page_name']         = 'pl_trazer';
        $page_data['page_icon']         = 'icon-headphones';
        $page_data['page_title']        = 'Trazer Prof.Liberal';
        $this->load->view('index', $page_data);
    }
    
/***COMERCIO ABERTURA  - Etapa 3***/
    function comercio_abrir3 ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url() . 'index.php?admin/comercio_abrir3/', 'refresh');

        if ($param1 == 'do_update') {
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
//            $data['status']           = $this->input->post('status');
//            $data['obs']           = $this->input->post('obs');
            $data['ac_numero_rg']           = $this->input->post('ac_numero_rg');
            $data['ac_numero_cpf']           = $this->input->post('ac_numero_cpf');
            $data['ac_opcao_documentos']           = $this->input->post('ac_opcao_documentos');
            $data['ac_rg_digital']           = $this->input->post('ac_rg_digital');
            $data['ac_cpf_digital']           = $this->input->post('ac_cpf_digital');
            $data['ac_cnh_digital']           = $this->input->post('ac_cnh_digital');
            $data['ac_nome_mae']           = $this->input->post('ac_nome_mae');
            $data['ac_estado_civil']           = $this->input->post('ac_estado_civil');
            $data['ac_regime_casamento']           = $this->input->post('ac_regime_casamento');
            $data['ac_declara_irpf']           = $this->input->post('ac_declara_irpf');
            $data['ac_ultimo_irpf']           = $this->input->post('ac_ultimo_irpf');
            $data['ac_titulo_eleitor']           = $this->input->post('ac_titulo_eleitor');
            $data['ac_residencial_cep']           = $this->input->post('ac_residencial_cep');
            $data['ac_residencial_rua']           = $this->input->post('ac_residencial_rua');
            $data['ac_residencial_numero']           = $this->input->post('ac_residencial_numero');
            $data['ac_residencial_complemento']           = $this->input->post('ac_residencial_complemento');
            $data['ac_residencial_bairro']           = $this->input->post('ac_residencial_bairro');
            $data['ac_residencial_cidade']           = $this->input->post('ac_residencial_cidade');
            $data['ac_residencial_uf']           = $this->input->post('ac_residencial_uf');
            $data['ac_nome_empresa_01']           = $this->input->post('ac_nome_empresa_01');
            $data['ac_nome_empresa_02']           = $this->input->post('ac_nome_empresa_02');
            $data['ac_nome_empresa_03']           = $this->input->post('ac_nome_empresa_03');
            $data['ac_nome_fantasia']           = $this->input->post('ac_nome_fantasia');
            $data['ac_numero_funcionarios']           = $this->input->post('ac_numero_funcionarios');
            $data['ac_cert_bombeiros']           = $this->input->post('ac_cert_bombeiros');
            $data['ac_comercial_cep']           = $this->input->post('ac_comercial_cep');
            $data['ac_comercial_rua']           = $this->input->post('ac_comercial_rua');
            $data['ac_comercial_numero']           = $this->input->post('ac_comercial_numero');
            $data['ac_comercial_complemento']           = $this->input->post('ac_comercial_complemento');
            $data['ac_comercial_bairro']           = $this->input->post('ac_comercial_bairro');
            $data['ac_comercial_cidade']           = $this->input->post('ac_comercial_cidade');
            $data['ac_comercial_uf']           = $this->input->post('ac_comercial_uf');
            $data['ac_numero_iptu']           = $this->input->post('ac_numero_iptu');
            $data['ac_atividades']           = $this->input->post('ac_atividades');
            $data['ac_capital_social']           = $this->input->post('ac_capital_social');
            $data['ac_socio_administrador']           = $this->input->post('ac_socio_administrador');
            $data['ac_retirada_pro_labore']           = $this->input->post('ac_retirada_pro_labore');
            $data['ac_qtd_socios']           = $this->input->post('ac_qtd_socios');
            $data['ac_nome_completo_socio_01']           = $this->input->post('ac_nome_completo_socio_01');
            $data['ac_numero_rg_socio_01']           = $this->input->post('ac_numero_rg_socio_01');
            $data['ac_numero_cpf_socio_01']           = $this->input->post('ac_numero_cpf_socio_01');
            $data['ac_opcao_documentos_socio_01']           = $this->input->post('ac_opcao_documentos_socio_01');
            $data['ac_rg_digital_socio_01']           = $this->input->post('ac_rg_digital_socio_01');
            $data['ac_cpf_digital_socio_01']           = $this->input->post('ac_cpf_digital_socio_01');
            $data['ac_cnh_digital_socio_01']           = $this->input->post('ac_cnh_digital_socio_01');
            $data['ac_nome_mae_socio_01']           = $this->input->post('ac_nome_mae_socio_01');
            $data['ac_estado_civil_socio_01']           = $this->input->post('ac_estado_civil_socio_01');
            $data['ac_regime_casamento_socio_01']           = $this->input->post('ac_regime_casamento_socio_01');
            $data['ac_profissao_socio_01']           = $this->input->post('ac_profissao_socio_01');
            $data['ac_declara_irpf_socio_01']           = $this->input->post('ac_declara_irpf_socio_01');
            $data['ac_ultimo_irpf_socio_01']           = $this->input->post('ac_ultimo_irpf_socio_01');
            $data['ac_titulo_eleitor_socio_01']           = $this->input->post('ac_titulo_eleitor_socio_01');
            $data['ac_capital_social_socio_01']           = $this->input->post('ac_capital_social_socio_01');
            $data['ac_numero_pis_inss_socio_01']           = $this->input->post('ac_numero_pis_inss_socio_01');
            $data['ac_residencial_cep_socio_01']           = $this->input->post('ac_residencial_cep_socio_01');
            $data['ac_residencial_rua_socio_01']           = $this->input->post('ac_residencial_rua_socio_01');
            $data['ac_residencial_numero_socio_01']           = $this->input->post('ac_residencial_numero_socio_01');
            $data['ac_residencial_complemento_socio_01']           = $this->input->post('ac_residencial_complemento_socio_01');
            $data['ac_residencial_bairro_socio_01']           = $this->input->post('ac_residencial_bairro_socio_01');
            $data['ac_residencial_cidade_socio_01']           = $this->input->post('ac_residencial_cidade_socio_01');
            $data['ac_residencial_uf_socio_01']           = $this->input->post('ac_residencial_uf_socio_01');
            $data['ac_nome_completo_socio_02']           = $this->input->post('ac_nome_completo_socio_02');
            $data['ac_numero_rg_socio_02']           = $this->input->post('ac_numero_rg_socio_02');
            $data['ac_numero_cpf_socio_02']           = $this->input->post('ac_numero_cpf_socio_02');
            $data['ac_opcao_documentos_socio_02']           = $this->input->post('ac_opcao_documentos_socio_02');
            $data['ac_rg_digital_socio_02']           = $this->input->post('ac_rg_digital_socio_02');
            $data['ac_cpf_digital_socio_02']           = $this->input->post('ac_cpf_digital_socio_02');
            $data['ac_cnh_digital_socio_02']           = $this->input->post('ac_cnh_digital_socio_02');
            $data['ac_nome_mae_socio_02']           = $this->input->post('ac_nome_mae_socio_02');
            $data['ac_estado_civil_socio_02']           = $this->input->post('ac_estado_civil_socio_02');
            $data['ac_regime_casamento_socio_02']           = $this->input->post('ac_regime_casamento_socio_02');
            $data['ac_profissao_socio_02']           = $this->input->post('ac_profissao_socio_02');
            $data['ac_declara_irpf_socio_02']           = $this->input->post('ac_declara_irpf_socio_02');
            $data['ac_ultimo_irpf_socio_02']           = $this->input->post('ac_ultimo_irpf_socio_02');
            $data['ac_titulo_eleitor_socio_02']           = $this->input->post('ac_titulo_eleitor_socio_02');
            $data['ac_capital_social_socio_02']           = $this->input->post('ac_capital_social_socio_02');
            $data['ac_numero_pis_inss_socio_02']           = $this->input->post('ac_numero_pis_inss_socio_02');
            $data['ac_residencial_cep_socio_02']           = $this->input->post('ac_residencial_cep_socio_02');
            $data['ac_residencial_rua_socio_02']           = $this->input->post('ac_residencial_rua_socio_02');
            $data['ac_residencial_numero_socio_02']           = $this->input->post('ac_residencial_numero_socio_02');
            $data['ac_residencial_complemento_socio_02']           = $this->input->post('ac_residencial_complemento_socio_02');
            $data['ac_residencial_bairro_socio_02']           = $this->input->post('ac_residencial_bairro_socio_02');
            $data['ac_residencial_cidade_socio_02']           = $this->input->post('ac_residencial_cidade_socio_02');
            $data['ac_residencial_uf_socio_02']           = $this->input->post('ac_residencial_uf_socio_02');
            $data['ac_nome_completo_socio_03']           = $this->input->post('ac_nome_completo_socio_03');
            $data['ac_numero_rg_socio_03']           = $this->input->post('ac_numero_rg_socio_03');
            $data['ac_numero_cpf_socio_03']           = $this->input->post('ac_numero_cpf_socio_03');
            $data['ac_opcao_documentos_socio_03']           = $this->input->post('ac_opcao_documentos_socio_03');
            $data['ac_rg_digital_socio_03']           = $this->input->post('ac_rg_digital_socio_03');
            $data['ac_cpf_digital_socio_03']           = $this->input->post('ac_cpf_digital_socio_03');
            $data['ac_cnh_digital_socio_03']           = $this->input->post('ac_cnh_digital_socio_03');
            $data['ac_nome_mae_socio_03']           = $this->input->post('ac_nome_mae_socio_03');
            $data['ac_estado_civil_socio_03']           = $this->input->post('ac_estado_civil_socio_03');
            $data['ac_regime_casamento_socio_03']           = $this->input->post('ac_regime_casamento_socio_03');
            $data['ac_profissao_socio_03']           = $this->input->post('ac_profissao_socio_03');
            $data['ac_declara_irpf_socio_03']           = $this->input->post('ac_declara_irpf_socio_03');
            $data['ac_ultimo_irpf_socio_03']           = $this->input->post('ac_ultimo_irpf_socio_03');
            $data['ac_titulo_eleitor_socio_03']           = $this->input->post('ac_titulo_eleitor_socio_03');
            $data['ac_capital_social_socio_03']           = $this->input->post('ac_capital_social_socio_03');
            $data['ac_numero_pis_inss_socio_03']           = $this->input->post('ac_numero_pis_inss_socio_03');
            $data['ac_residencial_cep_socio_03']           = $this->input->post('ac_residencial_cep_socio_03');
            $data['ac_residencial_rua_socio_03']           = $this->input->post('ac_residencial_rua_socio_03');
            $data['ac_residencial_numero_socio_03']           = $this->input->post('ac_residencial_numero_socio_03');
            $data['ac_residencial_complemento_socio_03']           = $this->input->post('ac_residencial_complemento_socio_03');
            $data['ac_residencial_bairro_socio_03']           = $this->input->post('ac_residencial_bairro_socio_03');
            $data['ac_residencial_cidade_socio_03']           = $this->input->post('ac_residencial_cidade_socio_03');
            $data['ac_residencial_uf_socio_03']           = $this->input->post('ac_residencial_uf_socio_03');
            $data['ac_nome_completo_socio_04']           = $this->input->post('ac_nome_completo_socio_04');
            $data['ac_numero_rg_socio_04']           = $this->input->post('ac_numero_rg_socio_04');
            $data['ac_numero_cpf_socio_04']           = $this->input->post('ac_numero_cpf_socio_04');
            $data['ac_opcao_documentos_socio_04']           = $this->input->post('ac_opcao_documentos_socio_04');
            $data['ac_rg_digital_socio_04']           = $this->input->post('ac_rg_digital_socio_04');
            $data['ac_cpf_digital_socio_04']           = $this->input->post('ac_cpf_digital_socio_04');
            $data['ac_cnh_digital_socio_04']           = $this->input->post('ac_cnh_digital_socio_04');
            $data['ac_nome_mae_socio_04']           = $this->input->post('ac_nome_mae_socio_04');
            $data['ac_estado_civil_socio_04']           = $this->input->post('ac_estado_civil_socio_04');
            $data['ac_regime_casamento_socio_04']           = $this->input->post('ac_regime_casamento_socio_04');
            $data['ac_profissao_socio_04']           = $this->input->post('ac_profissao_socio_04');
            $data['ac_declara_irpf_socio_04']           = $this->input->post('ac_declara_irpf_socio_04');
            $data['ac_ultimo_irpf_socio_04']           = $this->input->post('ac_ultimo_irpf_socio_04');
            $data['ac_titulo_eleitor_socio_04']           = $this->input->post('ac_titulo_eleitor_socio_04');
            $data['ac_capital_social_socio_04']           = $this->input->post('ac_capital_social_socio_04');
            $data['ac_numero_pis_inss_socio_04']           = $this->input->post('ac_numero_pis_inss_socio_04');
            $data['ac_residencial_cep_socio_04']           = $this->input->post('ac_residencial_cep_socio_04');
            $data['ac_residencial_rua_socio_04']           = $this->input->post('ac_residencial_rua_socio_04');
            $data['ac_residencial_numero_socio_04']           = $this->input->post('ac_residencial_numero_socio_04');
            $data['ac_residencial_complemento_socio_04']           = $this->input->post('ac_residencial_complemento_socio_04');
            $data['ac_residencial_bairro_socio_04']           = $this->input->post('ac_residencial_bairro_socio_04');
            $data['ac_residencial_cidade_socio_04']           = $this->input->post('ac_residencial_cidade_socio_04');
            $data['ac_residencial_uf_socio_04']           = $this->input->post('ac_residencial_uf_socio_04');



            $this->db->where('clientes_ac_id', $param2);
            $this->db->update('clientes_ac', $data);

            $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso!!!');
            
/*            
            require_once(APPPATH.'libraries/RD_Station.php');
    
                $rdstation = new RD_Station($_POST);
                $rdstation->token = 'f8327c603e68c7399b24c5a1ed25768f';
                if ($this->input->post('status')=='3'){
                  $rdstation->identifier = 'validacao-documentos-pendente';
                }
                else{
                  $rdstation->identifier = 'validacao-documentos';
                }
                $rdstation->ignore_fields = array('telefone','data_cadastro','ac_numero_rg','ac_numero_cpf','ac_opcao_documentos','ac_rg_digital','ac_cpf_digital','ac_cnh_digital','ac_nome_mae','ac_estado_civil','ac_regime_casamento','ac_declara_irpf','ac_ultimo_irpf','ac_titulo_eleitor','ac_residencial_cep','ac_residencial_rua','ac_residencial_numero','ac_residencial_complemento','ac_residencial_bairro','ac_residencial_cidade','ac_residencial_uf','ac_nome_empresa_01','ac_nome_empresa_02','ac_nome_empresa_03','ac_nome_fantasia','ac_numero_funcionarios','ac_cert_bombeiros','ac_comercial_cep','ac_comercial_rua','ac_comercial_numero','ac_comercial_complemento','ac_comercial_bairro','ac_comercial_cidade','ac_comercial_uf','ac_numero_iptu','ac_atividades','ac_capital_social','ac_socio_administrador','ac_retirada_pro_labore','ac_qtd_socios','ac_nome_completo_socio_01','ac_numero_rg_socio_01','ac_numero_cpf_socio_01','ac_opcao_documentos_socio_01','ac_rg_digital_socio_01','ac_cpf_digital_socio_01','ac_cnh_digital_socio_01','ac_nome_mae_socio_01','ac_estado_civil_socio_01','ac_regime_casamento_socio_01','ac_profissao_socio_01','ac_declara_irpf_socio_01','ac_ultimo_irpf_socio_01','ac_titulo_eleitor_socio_01','ac_capital_social_socio_01','ac_numero_pis_inss_socio_01','ac_residencial_cep_socio_01','ac_residencial_rua_socio_01','ac_residencial_numero_socio_01','ac_residencial_complemento_socio_01','ac_residencial_bairro_socio_01','ac_residencial_cidade_socio_01','ac_residencial_uf_socio_01','ac_nome_completo_socio_02','ac_numero_rg_socio_02','ac_numero_cpf_socio_02','ac_opcao_documentos_socio_02','ac_rg_digital_socio_02','ac_cpf_digital_socio_02','ac_cnh_digital_socio_02','ac_nome_mae_socio_02','ac_estado_civil_socio_02','ac_regime_casamento_socio_02','ac_profissao_socio_02','ac_declara_irpf_socio_02','ac_ultimo_irpf_socio_02','ac_titulo_eleitor_socio_02','ac_capital_social_socio_02','ac_numero_pis_inss_socio_02','ac_residencial_cep_socio_02','ac_residencial_rua_socio_02','ac_residencial_numero_socio_02','ac_residencial_complemento_socio_02','ac_residencial_bairro_socio_02','ac_residencial_cidade_socio_02','ac_residencial_uf_socio_02','ac_nome_completo_socio_03','ac_numero_rg_socio_03','ac_numero_cpf_socio_03','ac_opcao_documentos_socio_03','ac_rg_digital_socio_03','ac_cpf_digital_socio_03','ac_cnh_digital_socio_03','ac_nome_mae_socio_03','ac_estado_civil_socio_03','ac_regime_casamento_socio_03','ac_profissao_socio_03','ac_declara_irpf_socio_03','ac_ultimo_irpf_socio_03','ac_titulo_eleitor_socio_03','ac_capital_social_socio_03','ac_numero_pis_inss_socio_03','ac_residencial_cep_socio_03','ac_residencial_rua_socio_03','ac_residencial_numero_socio_03','ac_residencial_complemento_socio_03','ac_residencial_bairro_socio_03','ac_residencial_cidade_socio_03','ac_residencial_uf_socio_03','ac_nome_completo_socio_04','ac_numero_rg_socio_04','ac_numero_cpf_socio_04','ac_opcao_documentos_socio_04','ac_rg_digital_socio_04','ac_cpf_digital_socio_04','ac_cnh_digital_socio_04','ac_nome_mae_socio_04','ac_estado_civil_socio_04','ac_regime_casamento_socio_04','ac_profissao_socio_04','ac_declara_irpf_socio_04','ac_ultimo_irpf_socio_04','ac_titulo_eleitor_socio_04','ac_capital_social_socio_04','ac_numero_pis_inss_socio_04','ac_residencial_cep_socio_04','ac_residencial_rua_socio_04','ac_residencial_numero_socio_04','ac_residencial_complemento_socio_04','ac_residencial_bairro_socio_04','ac_residencial_cidade_socio_04','ac_residencial_uf_socio_04');
                $rdstation->createLead();
*/
              // Conversão no RD
                //$data['email'] = 'gestao@contsimples.com.br';
                //$data['status'] = '3';
                //$data['obs'] = 'Falta espelho do IPTU';
                
                $fields = http_build_query($data);
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/validacao-documentos.php");
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                $server_output = curl_exec($ch);
                curl_close($ch);
              // Conversão no RD - FIM  
            redirect(base_url() . 'index.php?admin/comercio_abrir3/', 'refresh');

        }


        if ($param1 == 'delete') {

            $data['status']         = 'excluido';
            $this->db->where('clientes_ac_id', $param2);
            $this->db->update('clientes_ac', $data);
            redirect(base_url() . 'index.php?admin/comercio_abrir3/', 'refresh');

        }
        if ($param1 == 'obs') {
        
        
            $data['status']     = $this->input->post('status');
            $data['obs']        = $this->input->post('obs');

            $this->db->where('clientes_ac_id', $param2);
            $this->db->update('clientes_ac', $data);
            
            $Xemail    = @$this->db->get_where('w_client_form_id', array('form_id' => $param2,'tipo_form' => 'ac' ))->row('email');

            if (empty($Xemail)){
            
                        $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso, mas email não foi enviado para o Cliente!!!');
            
            } else {
            
                        $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso!!!');
            
                        
            // Conversão no RD
              $data_rd['email']   = $Xemail;
              $data_rd['status']  = $this->input->post('status');
              $data_rd['obs']     = $this->input->post('obs');
              
              $fields = http_build_query($data_rd);
              $ch = curl_init();
              curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/validacao-documentos.php");
              curl_setopt($ch, CURLOPT_POST, 1);
              curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
              curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
              $server_output = curl_exec($ch);
              curl_close($ch);
            // Conversão no RD - FIM  

                        }
            $data2['form_client_id']     = $param2;
            $data2['form_tipo']          = 'ac';
            $data2['usuario']            = $this->session->userdata('admin_id');
            $data2['data']               = date("Y-m-d H:i:s", time()); 
            $data2['status']             = $this->input->post('status');
            $data2['obs']                = $this->input->post('obs');
            $this->db->insert('clientes_obs', $data2);
            
            $data3['form_client_id']     = $param2;
            $data3['form_tipo']          = 'ac';
            $data3['usuario']            = $this->session->userdata('admin_id');
            $data3['data']               = date("Y-m-d H:i:s", time()); 
            $data3['status']             = $this->input->post('status');
            $data3['obs']                = $this->input->post('obs');
            $this->db->insert('clientes_timeline', $data3);   
            
            // Envio Email            
            if ($this->input->post('status')==9)
            {
            
            $Xnome         = @$this->db->get_where('clientes_ac', array('clientes_ac_id' => $param2))->row('nome');
            $Xdocumento    = @$this->db->get_where('clientes_ac', array('clientes_ac_id' => $param2))->row('ac_numero_cpf');
            $Xendereco     = @$this->db->get_where('clientes_ac', array('clientes_ac_id' => $param2))->row('ac_residencial_rua').', '.
                              @$this->db->get_where('clientes_ac', array('clientes_ac_id' => $param2))->row('ac_residencial_numero').' '.
                              @$this->db->get_where('clientes_ac', array('clientes_ac_id' => $param2))->row('ac_residencial_complemento').' - '.
                              @$this->db->get_where('clientes_ac', array('clientes_ac_id' => $param2))->row('ac_residencial_bairro').' - '.
                              @$this->db->get_where('clientes_ac', array('clientes_ac_id' => $param2))->row('ac_residencial_cidade').' - '.
                              @$this->db->get_where('clientes_ac', array('clientes_ac_id' => $param2))->row('ac_residencial_uf').'';
            $Xcep          = @$this->db->get_where('clientes_ac', array('clientes_ac_id' => $param2))->row('ac_residencial_cep');
            $Xemail        = @$this->db->get_where('clientes_ac', array('clientes_ac_id' => $param2))->row('email');
            $Xnome_socio   = @$this->db->get_where('clientes_ac', array('clientes_ac_id' => $param2))->row('nome');
            
            
            $this->email_model->envia_notificacao_enviar_boleto_abrir('Abrir Comercio',$Xnome,$Xdocumento,$Xendereco,$Xcep,$Xemail,$Xnome_socio);

            }
            
            redirect(base_url() . 'index.php?admin/comercio_abrir3/', 'refresh');

        }         
        //$page_data['comercio_abrir']     = $this->db->get('clientes_ac')->result_array();
        $page_data['comercio_abrir3']     = $this->db->query("SELECT * from clientes_ac where status not in ('6','7')")->result_array();
        $page_data['page_name']         = 'comercio_abrir3';
        $page_data['page_icon']         = 'shopping-cart';
        $page_data['page_title']        = 'Comercio Empresa - Etapa 3';
        $this->load->view('index', $page_data);
    }

/***COMERCIO TRAZER - Etapa 3***/
    function comercio_trazer3 ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url() . 'index.php?admin/comercio_trazer3/', 'refresh');

        if ($param1 == 'do_update') {
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
//            $data['status']           = $this->input->post('status');
//            $data['obs']           = $this->input->post('obs');
            $data['tc_numero_rg']           = $this->input->post('tc_numero_rg');
            $data['tc_numero_cpf']           = $this->input->post('tc_numero_cpf');
            $data['tc_opcao_documentos']           = $this->input->post('tc_opcao_documentos');
            $data['tc_rg_digital']           = $this->input->post('tc_rg_digital');
            $data['tc_cpf_digital']           = $this->input->post('tc_cpf_digital');
            $data['tc_cnh_digital']           = $this->input->post('tc_cnh_digital');
            $data['tc_nome_mae']           = $this->input->post('tc_nome_mae');
            $data['tc_estado_civil']           = $this->input->post('tc_estado_civil');
            $data['tc_regime_casamento']           = $this->input->post('tc_regime_casamento');
            $data['tc_declara_irpf']           = $this->input->post('tc_declara_irpf');
            $data['tc_ultimo_irpf']           = $this->input->post('tc_ultimo_irpf');
            $data['tc_titulo_eleitor']           = $this->input->post('tc_titulo_eleitor');
            $data['tc_nome_empresarial']           = $this->input->post('tc_nome_empresarial');
            $data['tc_cnpj']           = $this->input->post('tc_cnpj');
            $data['tc_inscricao_estadual']           = $this->input->post('tc_inscricao_estadual');
            $data['tc_enquadramento']           = $this->input->post('tc_enquadramento');
            $data['tc_codigo_acesso_simples']           = $this->input->post('tc_codigo_acesso_simples');
            $data['tc_funcionarios']           = $this->input->post('tc_funcionarios');
            $data['tc_qtd_contrato_social']           = $this->input->post('tc_qtd_contrato_social');
            $data['tc_contrato_social_01']           = $this->input->post('tc_contrato_social_01');
            $data['tc_contrato_social_02']           = $this->input->post('tc_contrato_social_02');
            $data['tc_contrato_social_03']           = $this->input->post('tc_contrato_social_03');
            $data['tc_contrato_social_04']           = $this->input->post('tc_contrato_social_04');
            $data['tc_contrato_social_05']           = $this->input->post('tc_contrato_social_05');
            $data['tc_contrato_social_06']           = $this->input->post('tc_contrato_social_06');
            $data['tc_contrato_social_07']           = $this->input->post('tc_contrato_social_07');
            $data['tc_contrato_social_08']           = $this->input->post('tc_contrato_social_08');
            $data['tc_alvara']           = $this->input->post('tc_alvara');
            $data['tc_tipo_nota_fiscal']           = $this->input->post('tc_tipo_nota_fiscal');
            $data['tc_certificado_digital']           = $this->input->post('tc_certificado_digital');
            $data['tc_certificado_digital_a1']           = $this->input->post('tc_certificado_digital_a1');
            $data['tc_certificado_digital_a1_senha']           = $this->input->post('tc_certificado_digital_a1_senha');
            $data['tc_qtd_socios']           = $this->input->post('tc_qtd_socios');
            $data['tc_documentos_socio_01']           = $this->input->post('tc_documentos_socio_01');
            $data['tc_documentos_socio_02']           = $this->input->post('tc_documentos_socio_02');
            $data['tc_documentos_socio_03']           = $this->input->post('tc_documentos_socio_03');
            $data['tc_documentos_socio_04']           = $this->input->post('tc_documentos_socio_04');

           $this->db->where('clientes_tc_id', $param2);
            $this->db->update('clientes_tc', $data);

            $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso!!!');
            
      
              // Conversão no RD
                //$data['email'] = 'gestao@contsimples.com.br';
                //$data['status'] = '3';
                //$data['obs'] = 'Falta espelho do IPTU';
                
                $fields = http_build_query($data);
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/validacao-documentos.php");
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                $server_output = curl_exec($ch);
                curl_close($ch);
              // Conversão no RD - FIM  

            redirect(base_url() . 'index.php?admin/comercio_trazer3/', 'refresh');

        }


        if ($param1 == 'delete') {

            $data['status']         = 'excluido';
            $this->db->where('clientes_tc_id', $param2);
            $this->db->update('clientes_tc', $data);
            redirect(base_url() . 'index.php?admin/comercio_trazer3/', 'refresh');

        }
        if ($param1 == 'obs') {
        
        
            $data['status']           = $this->input->post('status');
            $data['obs']           = $this->input->post('obs');

            $this->db->where('clientes_tc_id', $param2);
            $this->db->update('clientes_tc', $data);

            $Xemail    = @$this->db->get_where('w_client_form_id', array('form_id' => $param2,'tipo_form' => 'tc' ))->row('email');

            if (empty($Xemail)){
            
                        $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso, mas email não foi enviado para o Cliente!!!');
            
            } else {
            
                        $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso!!!');
            
                        
            // Conversão no RD
              $data_rd['email']   = $Xemail;
              $data_rd['status']  = $this->input->post('status');
              $data_rd['obs']     = $this->input->post('obs');
              
              $fields = http_build_query($data_rd);
              $ch = curl_init();
              curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/validacao-documentos.php");
              curl_setopt($ch, CURLOPT_POST, 1);
              curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
              curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
              $server_output = curl_exec($ch);
              curl_close($ch);
            // Conversão no RD - FIM  

                        }
            $data2['form_client_id']     = $param2;
            $data2['form_tipo']          = 'tc';
            $data2['usuario']            = $this->session->userdata('admin_id');
            $data2['data']               = date("Y-m-d H:i:s", time()); 
            $data2['status']             = $this->input->post('status');
            $data2['obs']                = $this->input->post('obs');
            $this->db->insert('clientes_obs', $data2);
            
            $data3['form_client_id']     = $param2;
            $data3['form_tipo']          = 'tc';
            $data3['usuario']            = $this->session->userdata('admin_id');
            $data3['data']               = date("Y-m-d H:i:s", time()); 
            $data3['status']             = $this->input->post('status_timeline');
            $data3['obs']                = '';//$this->input->post('obs');
            $this->db->insert('clientes_timeline', $data3);           
            
            // Envio Email            
            if ($this->input->post('status')==9)
            {
            
            $Xnome         = @$this->db->get_where('clientes_tc', array('clientes_tc_id' => $param2))->row('tc_nome_empresarial');
            $Xdocumento    = @$this->db->get_where('clientes_tc', array('clientes_tc_id' => $param2))->row('tc_cnpj');
            $Xendereco     = '';
            $Xcep          = '';
            $Xemail        = @$this->db->get_where('clientes_tc', array('clientes_tc_id' => $param2))->row('email');
            $Xnome_socio   = @$this->db->get_where('clientes_tc', array('clientes_tc_id' => $param2))->row('nome');
            
            $this->email_model->envia_notificacao_enviar_boleto_trazer('Trazer Comercio',$Xnome,$Xdocumento,$Xendereco,$Xcep,$Xemail,$Xnome_socio);

            }
            
            redirect(base_url() . 'index.php?admin/comercio_trazer3/', 'refresh');

        }         
        //$page_data['comercio_trazer']     = $this->db->get('clientes_tc')->result_array();
        $page_data['comercio_trazer3']     = $this->db->query("SELECT * from clientes_tc where status not in ('6','7')")->result_array();
        $page_data['page_name']         = 'comercio_trazer3';
        $page_data['page_icon']         = 'shopping-cart';
        $page_data['page_title']        = 'Trazer Comercio - Etapa 3';
        $this->load->view('index', $page_data);                      
    }
/**** FIM - FORMULÁRIO ETAPA 3 ********/    
    
/****MANAGE Status Cliente Acompanhamento*****/
    function status_cliente($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['status'] = $this->input->post('status');
            $data['fluxo']    = $this->input->post('fluxo');
            $data['obs']    = $this->input->post('obs');
            $this->db->insert('status_cliente', $data);
            redirect(base_url() . 'index.php?admin/status_cliente/', 'refresh');
        }
        if ($param1 == 'do_update') {

            $data['status']    = $this->input->post('status');
            $data['fluxo']    = $this->input->post('fluxo');
            $data['obs']    = $this->input->post('obs');
            $this->db->where('status_cliente_id', $param2);
            $this->db->update('status_cliente', $data);
            redirect(base_url() . 'index.php?admin/status_cliente/', 'refresh');
        }

        if ($param1 == 'delete') {
            $this->db->where('status_cliente_id', $param2);
            $this->db->delete('status_cliente');
            redirect(base_url() . 'index.php?admin/status_cliente/', 'refresh');
        }
        $page_data['status_cliente']       = $this->db->get('status_cliente')->result_array();
        $page_data['status_cliente_inicial']       = $this->db->get('op_status_inicial')->result_array();        
        $page_data['page_name']  = 'status_cliente';
        $page_data['page_icon']  = 'cog';
        $page_data['page_title'] = 'Status Cliente';
        $this->load->view('index', $page_data);
    }
    
    function status_inicial_cliente($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['opcao'] = $this->input->post('opcao');
            $this->db->insert('op_status_inicial', $data);
            redirect(base_url() . 'index.php?admin/status_cliente/', 'refresh');
        }
        if ($param1 == 'do_update') {

            $data['opcao']    = $this->input->post('opcao');
            $this->db->where('id', $param2);
            $this->db->update('op_status_inicial', $data);
            redirect(base_url() . 'index.php?admin/status_cliente/', 'refresh');
        }

        if ($param1 == 'delete') {
            $this->db->where('id', $param2);
            $this->db->delete('op_status_inicial');
            redirect(base_url() . 'index.php?admin/status_cliente/', 'refresh');
        }
        $page_data['status_cliente']       = $this->db->get('status_cliente')->result_array();
        $page_data['status_cliente_inicial']       = $this->db->get('op_status_inicial')->result_array();
        $page_data['page_name']  = 'status_cliente';
        $page_data['page_icon']  = 'cog';
        $page_data['page_title'] = 'Status Cliente';
        $this->load->view('index', $page_data);
    }    

/**** FINANCEIRO |-> file_boleto ****/
    function file_boleto($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');


        if ($param1 == 'update_finalizar') {

            $data['data_alteracao']    = (date('Y-m-d'));
            $data['status']      = 'pago';
            $this->db->where('financeiro_id', $param2);
            $this->db->update('financeiro', $data);
            
            
            
            $id = $this->db->get_where('financeiro', array('financeiro_id' => $param2))->row('form_client_id');
            $id_form = $this->db->get_where('financeiro', array('financeiro_id' => $param2))->row('form_tipo');
            
            //insere time line
            $data_tl['form_client_id']     = $id;
            $data_tl['form_tipo']          = $id_form;
            $data_tl['usuario']            = $this->session->userdata('admin_id');
            $data_tl['data']               = date("Y-m-d H:i:s", time()); 
            $data_tl['status']             = '11'; //status 11 - boleto pago
            $data_tl['obs']                = 'Boleto Pago';//$this->input->post('obs');
            $this->db->insert('clientes_timeline', $data_tl); 
            
              
              $data_fin['status']           = 11;
               
              switch ($id_form) {
                case 'ac':
                  $this->db->where('clientes_ac_id', $id);
                  $this->db->update('clientes_ac', $data_fin);
                  break;
                case 'fc':
                  $this->db->where('clientes_fc_id', $id);
                  $this->db->update('clientes_fc', $data_fin);
                  break;
                case 'ma':
                  $this->db->where('clientes_ma_id', $id);
                  $this->db->update('clientes_ma', $data_fin);
                  break;
                case 'mt':
                  $this->db->where('clientes_mt_id', $id);
                  $this->db->update('clientes_mt', $data_fin);
                  break;
                case 'pl':
                  $this->db->where('clientes_pl_id', $id);
                  $this->db->update('clientes_pl', $data_fin);
                  break;
                case 'tc':
                  $this->db->where('clientes_tc_id', $id);
                  $this->db->update('clientes_tc', $data_fin);
                  break;
                case 'te':
                  $this->db->where('clientes_te_id', $id);
                  $this->db->update('clientes_te', $data_fin);
                  break;                                                      
                default:
                  $tipo_acao = '';
              }
              
              $Xnome     = @$this->db->get_where('w_client_form_id', array('form_id' => $param2,'tipo_form' => $id_form ))->row('nome');
              $Xemail    = @$this->db->get_where('w_client_form_id', array('form_id' => $param2,'tipo_form' => $id_form ))->row('email');

            if (empty($Xemail)){
            
                        $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso, mas email não foi enviado para o Cliente!!!');
            
            } else {
            
                                    
              // Conversão no RD
                $data_rd['email'] = $Xemail;
                $data_rd['id'] = $param2; // id do boleto no DB
                
                $fields = http_build_query($data_rd);
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/taxa-adesao-paga.php");
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                $server_output = curl_exec($ch);
                curl_close($ch);
              // Conversão no RD - FIM
              
              // Atualiza Status OBS
              $data2['form_client_id']     = $id;
              $data2['form_tipo']          = $id_form;
              $data2['usuario']            = $this->session->userdata('admin_id');
              $data2['data']               = date("Y-m-d H:i:s", time()); 
              $data2['status']             = 11;
              $data2['obs']                = '';
              $this->db->insert('clientes_obs', $data2);             

              // Envia email interno avisando sobre o pagamento do boleto
              $this->email_model->envia_notificacao_boleto_pago($tipo_acao,$Xnome,$Xemail);
              
          
            $this->session->set_flashdata('flash_message', 'Boleto Baixado Com Sucesso!');

            redirect(base_url() . 'index.php?admin/file_boleto/', 'refresh');
            }

        }
        if ($param1 == 'update_cancelar') {
        
                          
              $XTipo_Form       = @$this->db->get_where('financeiro', array('financeiro_id' => $param2))->row()->form_tipo;
              $XClient_Form_Id  = @$this->db->get_where('financeiro', array('financeiro_id' => $param2))->row()->form_client_id;          
              
              $email = @$this->db->get_where('w_client_form_id', array('tipo_form' => $XTipo_Form,'form_id'=>$XClient_Form_Id))->row()->email;
              
          // Integração com o RD

              $data['email'] = $email;
              $data['id'] = $param2 ; // id do boleto no DB
              
              $fields = http_build_query($data);
              $ch = curl_init();
              curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/taxa-adesao-cancelada.php");
              curl_setopt($ch, CURLOPT_POST, 1);
              curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
              curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
              $server_output = curl_exec($ch);
              curl_close($ch);

            // Conversão no RD - FIM

            $data2['status']      = 'cancelado';
            $this->db->where('financeiro_id', $param2);
            $this->db->update('financeiro', $data2);
            redirect(base_url() . 'index.php?admin/file_boleto/', 'refresh');

        }
        if ($param1 == 'delete') {

            $Xdados = $this->db->get_where('files', array('file_id' => $param2))->result_array();
            //print_r($Xdados);

            foreach($Xdados as $row):
              $origem   = $row['path'];
              $cliente  = $row['client'];
              $destino  = $origem;
            endforeach;
            //print_r($origem);

            $destino =  str_replace('/cob/','/_lixo/', $destino);
            $destino =  str_replace('/doc_cad/','/_lixo/', $destino);
            $destino =  str_replace('/doc_extra/','/_lixo/', $destino);
            $destino =  str_replace('/doc_fis/','/_lixo/', $destino);
            $destino =  str_replace('/guias/','/_lixo/', $destino);
            $destino =  str_replace('/mov/','/_lixo/', $destino);
            $destino =  str_replace('/rel/','/_lixo/', $destino);
            $destino =  str_replace('/xml/','/_lixo/', $destino);
            //print_r($destino);

            copy($origem, $destino);
            unlink($origem);

            //rename($destino,$destino.'_'.$this->session->userdata('admin_id'));

            //print_r($destino);


            // Geração do Log   ------------------------------------------------
            $log['admin']        = $this->session->userdata('admin_id');
            $log['client']       = $cliente;
            $log['path']         = $destino;
                $format = 'DATE_W3C';
                $time = time();
            $log['date']         = standard_date($format, $time) ;
            $log['tipo']         = 'deleted';
            $this->db->insert('log', $log);
            // FIM - Geração do Log   ------------------------------------------


            $this->db->where('file_id', $param2);
            $this->db->delete('files');
            $this->session->set_flashdata('flash_message', 'Arquivo Deletado!');
            redirect(base_url() . 'index.php?admin/file_boleto/', 'refresh');
        }
        if ($param1 == 'upload_info') {
        
             //$Xdescription = $this->db->get_where('product', array('product_id' => $this->input->post('product_id')))->row('description');
            //print_r($Xdescription);
            //$Xalterdata = $this->db->get_where('client', array('client_id' => $this->input->post('client')))->row('alterdata');
            //print_r($Xalterdata);
            
            
            $id_form = substr($this->input->post('client'),0,2) ;
            $id = substr($this->input->post('client'),3);
            $nome =  $this->caracter_model->tira_acento($this->db->get_where('w_client_form_id', array('tipo_form' => $id_form,'form_id'=>$id))->row()->name);
            $email = $this->db->get_where('w_client_form_id', array('tipo_form' => $id_form,'form_id'=>$id))->row()->email;
            
            switch ($id_form) {
              case 'ac':
                  $target_dir = "./crm/arquivos/cadastro_06_abrir_comercio/".$id."_".$nome."/";
                  break;
              case 'fc':
                  $target_dir = "./crm/arquivos/cadastro_01_abrir_empresa/".$id."_".$nome."/";
                  break;
              case 'ma':
                  $target_dir = "./crm/arquivos/cadastro_04_abrir_mei/".$id."_".$nome."/";
                  break;
              case 'mt':
                  $target_dir = "./crm/arquivos/cadastro_05_trazer_mei/".$id."_".$nome."/";
                  break;
              case 'pl':
                  $target_dir = "./crm/arquivos/cadastro_03_profissional_liberal/".$id."_".$nome."/";
                  break;
              case 'tc':
                  $target_dir = "./crm/arquivos/cadastro_07_trazer_comercio/".$id."_".$nome."/";
                  break;
              case 'te':
                  $target_dir = "./crm/arquivos/cadastro_02_trazer_empresa/".$id."_".$nome."/";
                  break;                                                      
              default:
                  $target_dir = "./crm/arquivos/";
            } 
            
            $Xrand =  mt_rand();

            $XnovoNome = strtolower($this->caracter_model->t5f_translit($_FILES['file']['name']));
            
            $caminho = $target_dir.$id.'_boleto_'.$Xrand.'_'.strtolower($this->caracter_model->tira_acento($_FILES['file']['name']));
                             
            $data['form_client_id']   = $id;
            $data['form_tipo']        = $id_form;
            $data['usuario']          = $this->session->userdata('admin_id');
            $data['arquivo']          = $XnovoNome;         
            $data['caminho']          = $caminho;
            move_uploaded_file($_FILES['file']['tmp_name'], $target_dir.$id.'_boleto_'.$Xrand.'_'.strtolower($this->caracter_model->tira_acento($_FILES['file']['name'])));            
            //$data['caminho']          = ($this->input->post('path').$Xalterdata.$Xdescription.$Xalterdata.'_'.$Xrand.'_'.$XnovoNome);
            $data['data_postagem']    = date('Y-m-d', strtotime($this->input->post('data_postagem')));
            $data['data_alteracao']   = date('Y-m-d', strtotime($this->input->post('data_alteracao')));
            $data['data_vencimento']  = implode('-',array_reverse(explode('/',$this->input->post('data_vencimento'))));
            if  (strstr($this->input->post('valor'),',')){
                $valor_boleto = str_replace(',','.',str_replace('.','',$this->input->post('valor')));
                $data['valor'] = $valor_boleto;                
            } else {                      
                      $valor_boleto = $this->input->post('valor');
                      $data['valor'] = $valor_boleto;   
                    }; 
            $data['status']           = 'pendente';
            $data['obs']              = $this->input->post('obs');
            $this->db->insert('financeiro', $data);
  
            $query = $this->db->query('SELECT LAST_INSERT_ID()');
            $row = $query->row_array();
            $LastIdInserted = $row['LAST_INSERT_ID()'];
           
            // Envio Email  
            /*
            $Xcontato       = $this->db->get_where('client', array('client_id' => $this->input->post('client')))->row()->contact;
            $Xemail         = $this->db->get_where('client', array('client_id' => $this->input->post('client')))->row()->email;
            $Xtipo_arquivo  = $this->db->get_where('product', array('product_id' => $this->input->post('product_id')))->row()->name;
            $Xarquivo       = ($this->input->post('path').$Xalterdata.$Xdescription.$this->input->post('client').'_'.$Xrand.'_'.$XnovoNome);
            */
            // envio de email diferente para arquivos do tipo boleto
            
            
            $tipo_acao = '';
            
            switch ($id_form) {
              case 'ac':
                  $tipo_acao = 'abrir';
                  break;
              case 'fc':
                  $tipo_acao = 'abrir';
                  break;
              case 'ma':
                  $tipo_acao = 'abrir';
                  break;
              case 'mt':
                  $tipo_acao = 'migrar';
                  break;
              case 'pl':
                  $tipo_acao = 'migrar';
                  break;
              case 'tc':
                  $tipo_acao = 'migrar';
                  break;
              case 'te':
                  $tipo_acao = 'migrar';
                  break;                                                      
              default:
                  $tipo_acao = '';
            }

            //if ($this->input->post('link_pagseguro') == 'sim') {
            
             //envia email
            //$this->email_model->envia_email_link_adesao($nome, $email );
            
            //}else{
              // Conversão no RD
              $data_rd['email'] = $email;
              $data_rd['link_taxa_de_adesao'] = 'https://contsimples.com.br/crm'.substr($caminho,1);
              $data_rd['acao'] = $tipo_acao;
              $data_rd['id'] = $LastIdInserted; // id do boleto no DB
              $data_rd['valor'] = $valor_boleto;
              $data_rd['vencimento'] = implode('-',array_reverse(explode('/',$this->input->post('data_vencimento'))));
              
              $fields = http_build_query($data_rd);
              $ch = curl_init();
              curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/taxa-adesao.php");
              //curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/taxa-adesao-link.php");
              curl_setopt($ch, CURLOPT_POST, 1);
              curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
              curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
              $server_output = curl_exec($ch);
              curl_close($ch);
              // Conversão no RD - FIM
            

              //muda status envio boleto para enviado
              //$server_output = '{"status":"success","b":2}';
              $output_rd = json_decode($server_output,true)['status'];
            
            
              if  ($output_rd=='success'){
                  
                  $data_status['status']      = 'enviado';
                  $this->db->where('financeiro_id', $LastIdInserted);
                  $this->db->update('financeiro', $data_status);
                  
                  $data_fin['status']           = 10;
                   
                  switch ($id_form) {
                    case 'ac':
                      $this->db->where('clientes_ac_id', $id);
                      $this->db->update('clientes_ac', $data_fin);
                      break;
                    case 'fc':
                      $this->db->where('clientes_fc_id', $id);
                      $this->db->update('clientes_fc', $data_fin);
                      break;
                    case 'ma':
                      $this->db->where('clientes_ma_id', $id);
                      $this->db->update('clientes_ma', $data_fin);
                      break;
                    case 'mt':
                      $this->db->where('clientes_mt_id', $id);
                      $this->db->update('clientes_mt', $data_fin);
                      break;
                    case 'pl':
                      $this->db->where('clientes_pl_id', $id);
                      $this->db->update('clientes_pl', $data_fin);
                      break;
                    case 'tc':
                      $this->db->where('clientes_tc_id', $id);
                      $this->db->update('clientes_tc', $data_fin);
                      break;
                    case 'te':
                      $this->db->where('clientes_te_id', $id);
                      $this->db->update('clientes_te', $data_fin);
                      break;                                                      
                    default:
                      $tipo_acao = '';
                  }
                //}
                
                // Atualiza Status OBS
                $data2['form_client_id']     = $id;
                $data2['form_tipo']          = $id_form;
                $data2['usuario']            = $this->session->userdata('admin_id');
                $data2['data']               = date("Y-m-d H:i:s", time()); 
                $data2['status']             = 10;
                $data2['obs']                = $this->input->post('obs');
                $this->db->insert('clientes_obs', $data2);
                   
                $this->session->set_flashdata('flash_message', 'Link Enviado!!');                
                
            } else {  
            
                $data_status['status']      = 'não enviado';
                $this->db->where('financeiro_id', $LastIdInserted);
                $this->db->update('financeiro', $data_status);
                
            $this->session->set_flashdata('flash_message', 'Link Salvo mas não enviado para o RD favor verificar!!');   }; 

            // Geração do Log   ------------------------------------------------
            $log['admin']        = $this->session->userdata('admin_id');
            $log['client']       = $this->input->post('client');
            $log['path']         = $target_dir.$id.'_boleto_'.$Xrand.'_'.strtolower($this->caracter_model->tira_acento($_FILES['file']['name']));
            $format = 'DATE_W3C';
            $time = time();
            $log['date']         = standard_date($format, $time) ;
            $log['tipo']         = 'postagem';
            $this->db->insert('log', $log);
            // FIM - Geração do Log   ------------------------------------------

            redirect(base_url() . 'index.php?admin/file_boleto/', 'refresh');          
            
        }

        //$page_data['files']      = $this->db->get('financeiro')->result_array();
        $page_data['mov']        = $this->db->query("SELECT * from financeiro where status not in ('pago','cancelado')")->result_array();
        $page_data['page_name']  = 'file_boleto';
        $page_data['page_icon']  = 'icon-briefcase';
        $page_data['page_title'] = 'Gestão Financeira - Boletos';
        $this->load->view('index', $page_data);
    }
/**** FINANCEIRO |-> file_adesao ****/
    function file_adesao($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');


        if ($param1 == 'update_finalizar') {

            $data['data_alteracao']    = (date('Y-m-d'));
            $data['status']      = 'pago';
            $this->db->where('financeiro_id', $param2);
            $this->db->update('financeiro', $data);
            
            
            
            $id = $this->db->get_where('financeiro', array('financeiro_id' => $param2))->row('form_client_id');
            $id_form = $this->db->get_where('financeiro', array('financeiro_id' => $param2))->row('form_tipo');
            
            //insere time line
            $data_tl['form_client_id']     = $id;
            $data_tl['form_tipo']          = $id_form;
            $data_tl['usuario']            = $this->session->userdata('admin_id');
            $data_tl['data']               = date("Y-m-d H:i:s", time()); 
            $data_tl['status']             = '11'; //status 11 - boleto pago
            $data_tl['obs']                = 'Boleto Pago';//$this->input->post('obs');
            $this->db->insert('clientes_timeline', $data_tl); 
            
              
              $data_fin['status']           = 11;
               
              switch ($id_form) {
                case 'ac':
                  $this->db->where('clientes_ac_id', $id);
                  $this->db->update('clientes_ac', $data_fin);
                  break;
                case 'fc':
                  $this->db->where('clientes_fc_id', $id);
                  $this->db->update('clientes_fc', $data_fin);
                  break;
                case 'ma':
                  $this->db->where('clientes_ma_id', $id);
                  $this->db->update('clientes_ma', $data_fin);
                  break;
                case 'mt':
                  $this->db->where('clientes_mt_id', $id);
                  $this->db->update('clientes_mt', $data_fin);
                  break;
                case 'pl':
                  $this->db->where('clientes_pl_id', $id);
                  $this->db->update('clientes_pl', $data_fin);
                  break;
                case 'tc':
                  $this->db->where('clientes_tc_id', $id);
                  $this->db->update('clientes_tc', $data_fin);
                  break;
                case 'te':
                  $this->db->where('clientes_te_id', $id);
                  $this->db->update('clientes_te', $data_fin);
                  break;                                                      
                default:
                  $tipo_acao = '';
              }
              
              $Xnome     = @$this->db->get_where('w_client_form_id', array('form_id' => $param2,'tipo_form' => $id_form ))->row('nome');
              $Xemail    = @$this->db->get_where('w_client_form_id', array('form_id' => $param2,'tipo_form' => $id_form ))->row('email');

            if (empty($Xemail)){
            
                        $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso, mas email não foi enviado para o Cliente!!!');
            
            } else {
            
                                    
              // Conversão no RD
                $data_rd['email'] = $Xemail;
                $data_rd['id'] = $param2; // id do boleto no DB
                
                $fields = http_build_query($data_rd);
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/taxa-adesao-paga.php");
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                $server_output = curl_exec($ch);
                curl_close($ch);
              // Conversão no RD - FIM
              
              // Atualiza Status OBS
              $data2['form_client_id']     = $id;
              $data2['form_tipo']          = $id_form;
              $data2['usuario']            = $this->session->userdata('admin_id');
              $data2['data']               = date("Y-m-d H:i:s", time()); 
              $data2['status']             = 11;
              $data2['obs']                = '';
              $this->db->insert('clientes_obs', $data2);             

              // Envia email interno avisando sobre o pagamento do boleto
              $this->email_model->envia_notificacao_boleto_pago($tipo_acao,$Xnome,$Xemail);
              
          
            $this->session->set_flashdata('flash_message', 'Taxa de Adesão Baixada Com Sucesso!');

            redirect(base_url() . 'index.php?admin/file_adesao/', 'refresh');
            }

        }
        if ($param1 == 'update_cancelar') {
        
                          
              $XTipo_Form       = @$this->db->get_where('financeiro', array('financeiro_id' => $param2))->row()->form_tipo;
              $XClient_Form_Id  = @$this->db->get_where('financeiro', array('financeiro_id' => $param2))->row()->form_client_id;          
              
              $email = @$this->db->get_where('w_client_form_id', array('tipo_form' => $XTipo_Form,'form_id'=>$XClient_Form_Id))->row()->email;
              
          // Integração com o RD

              $data['email'] = $email;
              $data['id'] = $param2 ; // id do boleto no DB
              
              $fields = http_build_query($data);
              $ch = curl_init();
              curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/taxa-adesao-cancelada.php");
              curl_setopt($ch, CURLOPT_POST, 1);
              curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
              curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
              $server_output = curl_exec($ch);
              curl_close($ch);

            // Conversão no RD - FIM

            $data2['status']      = 'cancelado';
            $this->db->where('financeiro_id', $param2);
            $this->db->update('financeiro', $data2);
            redirect(base_url() . 'index.php?admin/file_adesao/', 'refresh');

        }
        if ($param1 == 'delete') {

            $Xdados = $this->db->get_where('files', array('file_id' => $param2))->result_array();
            //print_r($Xdados);

            foreach($Xdados as $row):
              $origem   = $row['path'];
              $cliente  = $row['client'];
              $destino  = $origem;
            endforeach;
            //print_r($origem);

            $destino =  str_replace('/cob/','/_lixo/', $destino);
            $destino =  str_replace('/doc_cad/','/_lixo/', $destino);
            $destino =  str_replace('/doc_extra/','/_lixo/', $destino);
            $destino =  str_replace('/doc_fis/','/_lixo/', $destino);
            $destino =  str_replace('/guias/','/_lixo/', $destino);
            $destino =  str_replace('/mov/','/_lixo/', $destino);
            $destino =  str_replace('/rel/','/_lixo/', $destino);
            $destino =  str_replace('/xml/','/_lixo/', $destino);
            //print_r($destino);

            copy($origem, $destino);
            unlink($origem);

            //rename($destino,$destino.'_'.$this->session->userdata('admin_id'));

            //print_r($destino);


            // Geração do Log   ------------------------------------------------
            $log['admin']        = $this->session->userdata('admin_id');
            $log['client']       = $cliente;
            $log['path']         = $destino;
                $format = 'DATE_W3C';
                $time = time();
            $log['date']         = standard_date($format, $time) ;
            $log['tipo']         = 'deleted';
            $this->db->insert('log', $log);
            // FIM - Geração do Log   ------------------------------------------


            $this->db->where('file_id', $param2);
            $this->db->delete('files');
            $this->session->set_flashdata('flash_message', 'Arquivo Deletado!');
            redirect(base_url() . 'index.php?admin/file_adesao/', 'refresh');
        }
        if ($param1 == 'upload_info') {
        
             //$Xdescription = $this->db->get_where('product', array('product_id' => $this->input->post('product_id')))->row('description');
            //print_r($Xdescription);
            //$Xalterdata = $this->db->get_where('client', array('client_id' => $this->input->post('client')))->row('alterdata');
            //print_r($Xalterdata);
            
            
            $id_form = substr($this->input->post('client'),0,2) ;
            $id = substr($this->input->post('client'),3);
            $nome =  $this->caracter_model->tira_acento($this->db->get_where('w_client_form_id', array('tipo_form' => $id_form,'form_id'=>$id))->row()->name);
            $email = $this->db->get_where('w_client_form_id', array('tipo_form' => $id_form,'form_id'=>$id))->row()->email;
            
            switch ($id_form) {
              case 'ac':
                  $target_dir = "./crm/arquivos/cadastro_06_abrir_comercio/".$id."_".$nome."/";
                  break;
              case 'fc':
                  $target_dir = "./crm/arquivos/cadastro_01_abrir_empresa/".$id."_".$nome."/";
                  break;
              case 'ma':
                  $target_dir = "./crm/arquivos/cadastro_04_abrir_mei/".$id."_".$nome."/";
                  break;
              case 'mt':
                  $target_dir = "./crm/arquivos/cadastro_05_trazer_mei/".$id."_".$nome."/";
                  break;
              case 'pl':
                  $target_dir = "./crm/arquivos/cadastro_03_profissional_liberal/".$id."_".$nome."/";
                  break;
              case 'tc':
                  $target_dir = "./crm/arquivos/cadastro_07_trazer_comercio/".$id."_".$nome."/";
                  break;
              case 'te':
                  $target_dir = "./crm/arquivos/cadastro_02_trazer_empresa/".$id."_".$nome."/";
                  break;                                                      
              default:
                  $target_dir = "./crm/arquivos/";
            } 
            
            $Xrand =  mt_rand();

            $XnovoNome = strtolower($this->caracter_model->t5f_translit($_FILES['file']['name']));
            
            $caminho = $target_dir.$id.'_boleto_'.$Xrand.'_'.strtolower($this->caracter_model->tira_acento($_FILES['file']['name']));
                             
            $data['form_client_id']   = $id;
            $data['form_tipo']        = $id_form;
            $data['usuario']          = $this->session->userdata('admin_id');
            $data['arquivo']          = $XnovoNome;         
            $data['caminho']          = $caminho;
            move_uploaded_file($_FILES['file']['tmp_name'], $target_dir.$id.'_boleto_'.$Xrand.'_'.strtolower($this->caracter_model->tira_acento($_FILES['file']['name'])));            
            //$data['caminho']          = ($this->input->post('path').$Xalterdata.$Xdescription.$Xalterdata.'_'.$Xrand.'_'.$XnovoNome);
            $data['data_postagem']    = date('Y-m-d', strtotime($this->input->post('data_postagem')));
            $data['data_alteracao']   = date('Y-m-d', strtotime($this->input->post('data_alteracao')));
            $data['data_vencimento']  = implode('-',array_reverse(explode('/',$this->input->post('data_vencimento'))));
            if  (strstr($this->input->post('valor'),',')){
                $valor_boleto = str_replace(',','.',str_replace('.','',$this->input->post('valor')));
                $data['valor'] = $valor_boleto;                
            } else {                      
                      $valor_boleto = $this->input->post('valor');
                      $data['valor'] = $valor_boleto;   
                    }; 
            $data['status']           = 'pendente';
            $data['obs']              = $this->input->post('obs');
            $this->db->insert('financeiro', $data);
  
            $query = $this->db->query('SELECT LAST_INSERT_ID()');
            $row = $query->row_array();
            $LastIdInserted = $row['LAST_INSERT_ID()'];
           
            // Envio Email  
            /*
            $Xcontato       = $this->db->get_where('client', array('client_id' => $this->input->post('client')))->row()->contact;
            $Xemail         = $this->db->get_where('client', array('client_id' => $this->input->post('client')))->row()->email;
            $Xtipo_arquivo  = $this->db->get_where('product', array('product_id' => $this->input->post('product_id')))->row()->name;
            $Xarquivo       = ($this->input->post('path').$Xalterdata.$Xdescription.$this->input->post('client').'_'.$Xrand.'_'.$XnovoNome);
            */
            // envio de email diferente para arquivos do tipo boleto
            
            
            $tipo_acao = '';
            
            switch ($id_form) {
              case 'ac':
                  $tipo_acao = 'abrir';
                  break;
              case 'fc':
                  $tipo_acao = 'abrir';
                  break;
              case 'ma':
                  $tipo_acao = 'abrir';
                  break;
              case 'mt':
                  $tipo_acao = 'migrar';
                  break;
              case 'pl':
                  $tipo_acao = 'migrar';
                  break;
              case 'tc':
                  $tipo_acao = 'migrar';
                  break;
              case 'te':
                  $tipo_acao = 'migrar';
                  break;                                                      
              default:
                  $tipo_acao = '';
            }

            //if ($this->input->post('link_pagseguro') == 'sim') {
            
             //envia email
            //$this->email_model->envia_email_link_adesao($nome, $email );
            
            //}else{
              // Conversão no RD
              $data_rd['email'] = $email;
              $data_rd['link_taxa_de_adesao'] = 'https://contsimples.com.br/crm'.substr($caminho,1);
              $data_rd['acao'] = $tipo_acao;
              $data_rd['id'] = $LastIdInserted; // id do boleto no DB
              $data_rd['valor'] = $valor_boleto;
              $data_rd['vencimento'] = implode('-',array_reverse(explode('/',$this->input->post('data_vencimento'))));
              
              $fields = http_build_query($data_rd);
              $ch = curl_init();
              curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/taxa-adesao.php");
              //curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/taxa-adesao-link.php");
              curl_setopt($ch, CURLOPT_POST, 1);
              curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
              curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
              $server_output = curl_exec($ch);
              curl_close($ch);
              // Conversão no RD - FIM
            

              //muda status envio boleto para enviado
              //$server_output = '{"status":"success","b":2}';
              $output_rd = json_decode($server_output,true)['status'];
            
            
              if  ($output_rd=='success'){
                  
                  $data_status['status']      = 'enviado';
                  $this->db->where('financeiro_id', $LastIdInserted);
                  $this->db->update('financeiro', $data_status);
                  
                  $data_fin['status']           = 10;
                   
                  switch ($id_form) {
                    case 'ac':
                      $this->db->where('clientes_ac_id', $id);
                      $this->db->update('clientes_ac', $data_fin);
                      break;
                    case 'fc':
                      $this->db->where('clientes_fc_id', $id);
                      $this->db->update('clientes_fc', $data_fin);
                      break;
                    case 'ma':
                      $this->db->where('clientes_ma_id', $id);
                      $this->db->update('clientes_ma', $data_fin);
                      break;
                    case 'mt':
                      $this->db->where('clientes_mt_id', $id);
                      $this->db->update('clientes_mt', $data_fin);
                      break;
                    case 'pl':
                      $this->db->where('clientes_pl_id', $id);
                      $this->db->update('clientes_pl', $data_fin);
                      break;
                    case 'tc':
                      $this->db->where('clientes_tc_id', $id);
                      $this->db->update('clientes_tc', $data_fin);
                      break;
                    case 'te':
                      $this->db->where('clientes_te_id', $id);
                      $this->db->update('clientes_te', $data_fin);
                      break;                                                      
                    default:
                      $tipo_acao = '';
                  }
                //}
                
                // Atualiza Status OBS
                $data2['form_client_id']     = $id;
                $data2['form_tipo']          = $id_form;
                $data2['usuario']            = $this->session->userdata('admin_id');
                $data2['data']               = date("Y-m-d H:i:s", time()); 
                $data2['status']             = 10;
                $data2['obs']                = $this->input->post('obs');
                $this->db->insert('clientes_obs', $data2);
                   
                $this->session->set_flashdata('flash_message', 'Link Enviado!!');                
                
            } else {  
            
                $data_status['status']      = 'não enviado';
                $this->db->where('financeiro_id', $LastIdInserted);
                $this->db->update('financeiro', $data_status);
                
            $this->session->set_flashdata('flash_message', 'Link Salvo mas não enviado para o RD favor verificar!!');   }; 

            // Geração do Log   ------------------------------------------------
            $log['admin']        = $this->session->userdata('admin_id');
            $log['client']       = $this->input->post('client');
            $log['path']         = $target_dir.$id.'_boleto_'.$Xrand.'_'.strtolower($this->caracter_model->tira_acento($_FILES['file']['name']));
            $format = 'DATE_W3C';
            $time = time();
            $log['date']         = standard_date($format, $time) ;
            $log['tipo']         = 'postagem';
            $this->db->insert('log', $log);
            // FIM - Geração do Log   ------------------------------------------

            redirect(base_url() . 'index.php?admin/file_adesao/', 'refresh');          
            
        }

        //$page_data['files']      = $this->db->get('financeiro')->result_array();
        $page_data['mov']        = $this->db->query("SELECT * from financeiro where status not in ('pago','cancelado')")->result_array();
        $page_data['page_name']  = 'file_adesao';
        $page_data['page_icon']  = 'icon-briefcase';
        $page_data['page_title'] = 'Gestão Financeira - Taxa de Adesão';
        $this->load->view('index', $page_data);
    }
/**** FINANCEIRO |-> file_1mesalidade ****/
    function file_1mensalidade($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');


        if ($param1 == 'update_finalizar') {

            $data['data_alteracao']    = (date('Y-m-d'));
            $data['status']      = 'pago';
            $this->db->where('financeiro_id', $param2);
            $this->db->update('financeiro', $data);
            
            
            
            $id = $this->db->get_where('financeiro', array('financeiro_id' => $param2))->row('form_client_id');
            $id_form = $this->db->get_where('financeiro', array('financeiro_id' => $param2))->row('form_tipo');
            
            //insere time line
            $data_tl['form_client_id']     = $id;
            $data_tl['form_tipo']          = $id_form;
            $data_tl['usuario']            = $this->session->userdata('admin_id');
            $data_tl['data']               = date("Y-m-d H:i:s", time()); 
            $data_tl['status']             = '11'; //status 11 - boleto pago
            $data_tl['obs']                = 'Boleto Pago';//$this->input->post('obs');
            $this->db->insert('clientes_timeline', $data_tl); 
            
              
              $data_fin['status']           = 11;
               
              switch ($id_form) {
                case 'ac':
                  $this->db->where('clientes_ac_id', $id);
                  $this->db->update('clientes_ac', $data_fin);
                  break;
                case 'fc':
                  $this->db->where('clientes_fc_id', $id);
                  $this->db->update('clientes_fc', $data_fin);
                  break;
                case 'ma':
                  $this->db->where('clientes_ma_id', $id);
                  $this->db->update('clientes_ma', $data_fin);
                  break;
                case 'mt':
                  $this->db->where('clientes_mt_id', $id);
                  $this->db->update('clientes_mt', $data_fin);
                  break;
                case 'pl':
                  $this->db->where('clientes_pl_id', $id);
                  $this->db->update('clientes_pl', $data_fin);
                  break;
                case 'tc':
                  $this->db->where('clientes_tc_id', $id);
                  $this->db->update('clientes_tc', $data_fin);
                  break;
                case 'te':
                  $this->db->where('clientes_te_id', $id);
                  $this->db->update('clientes_te', $data_fin);
                  break;                                                      
                default:
                  $tipo_acao = '';
              }
              
              $Xnome     = @$this->db->get_where('w_client_form_id', array('form_id' => $param2,'tipo_form' => $id_form ))->row('nome');
              $Xemail    = @$this->db->get_where('w_client_form_id', array('form_id' => $param2,'tipo_form' => $id_form ))->row('email');

            if (empty($Xemail)){
            
                        $this->session->set_flashdata('flash_message', 'Ajuste Realizado com Sucesso, mas email não foi enviado para o Cliente!!!');
            
            } else {
            
                                    
              // Conversão no RD
                $data_rd['email'] = $Xemail;
                $data_rd['id'] = $param2; // id do boleto no DB
                
                $fields = http_build_query($data_rd);
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/taxa-adesao-paga.php");
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                $server_output = curl_exec($ch);
                curl_close($ch);
              // Conversão no RD - FIM
              
              // Atualiza Status OBS
              $data2['form_client_id']     = $id;
              $data2['form_tipo']          = $id_form;
              $data2['usuario']            = $this->session->userdata('admin_id');
              $data2['data']               = date("Y-m-d H:i:s", time()); 
              $data2['status']             = 11;
              $data2['obs']                = '';
              $this->db->insert('clientes_obs', $data2);             

              // Envia email interno avisando sobre o pagamento do boleto
              $this->email_model->envia_notificacao_boleto_pago($tipo_acao,$Xnome,$Xemail);
              
          
            $this->session->set_flashdata('flash_message', '1ª Mensalidade Baixada Com Sucesso!');

            redirect(base_url() . 'index.php?admin/file_adesao/', 'refresh');
            }

        }
        if ($param1 == 'update_cancelar') {
        
                          
              $XTipo_Form       = @$this->db->get_where('financeiro', array('financeiro_id' => $param2))->row()->form_tipo;
              $XClient_Form_Id  = @$this->db->get_where('financeiro', array('financeiro_id' => $param2))->row()->form_client_id;          
              
              $email = @$this->db->get_where('w_client_form_id', array('tipo_form' => $XTipo_Form,'form_id'=>$XClient_Form_Id))->row()->email;
              
          // Integração com o RD

              $data['email'] = $email;
              $data['id'] = $param2 ; // id do boleto no DB
              
              $fields = http_build_query($data);
              $ch = curl_init();
              curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/taxa-adesao-cancelada.php");
              curl_setopt($ch, CURLOPT_POST, 1);
              curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
              curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
              $server_output = curl_exec($ch);
              curl_close($ch);

            // Conversão no RD - FIM

            $data2['status']      = 'cancelado';
            $this->db->where('financeiro_id', $param2);
            $this->db->update('financeiro', $data2);
            redirect(base_url() . 'index.php?admin/file_1mensalidade/', 'refresh');

        }
        if ($param1 == 'delete') {

            $Xdados = $this->db->get_where('files', array('file_id' => $param2))->result_array();
            //print_r($Xdados);

            foreach($Xdados as $row):
              $origem   = $row['path'];
              $cliente  = $row['client'];
              $destino  = $origem;
            endforeach;
            //print_r($origem);

            $destino =  str_replace('/cob/','/_lixo/', $destino);
            $destino =  str_replace('/doc_cad/','/_lixo/', $destino);
            $destino =  str_replace('/doc_extra/','/_lixo/', $destino);
            $destino =  str_replace('/doc_fis/','/_lixo/', $destino);
            $destino =  str_replace('/guias/','/_lixo/', $destino);
            $destino =  str_replace('/mov/','/_lixo/', $destino);
            $destino =  str_replace('/rel/','/_lixo/', $destino);
            $destino =  str_replace('/xml/','/_lixo/', $destino);
            //print_r($destino);

            copy($origem, $destino);
            unlink($origem);

            //rename($destino,$destino.'_'.$this->session->userdata('admin_id'));

            //print_r($destino);


            // Geração do Log   ------------------------------------------------
            $log['admin']        = $this->session->userdata('admin_id');
            $log['client']       = $cliente;
            $log['path']         = $destino;
                $format = 'DATE_W3C';
                $time = time();
            $log['date']         = standard_date($format, $time) ;
            $log['tipo']         = 'deleted';
            $this->db->insert('log', $log);
            // FIM - Geração do Log   ------------------------------------------


            $this->db->where('file_id', $param2);
            $this->db->delete('files');
            $this->session->set_flashdata('flash_message', 'Arquivo Deletado!');
            redirect(base_url() . 'index.php?admin/file_1mensalidade/', 'refresh');
        }
        if ($param1 == 'upload_info') {
        
             //$Xdescription = $this->db->get_where('product', array('product_id' => $this->input->post('product_id')))->row('description');
            //print_r($Xdescription);
            //$Xalterdata = $this->db->get_where('client', array('client_id' => $this->input->post('client')))->row('alterdata');
            //print_r($Xalterdata);
            
            
            $id_form = substr($this->input->post('client'),0,2) ;
            $id = substr($this->input->post('client'),3);
            $nome =  $this->caracter_model->tira_acento($this->db->get_where('w_client_form_id', array('tipo_form' => $id_form,'form_id'=>$id))->row()->name);
            $email = $this->db->get_where('w_client_form_id', array('tipo_form' => $id_form,'form_id'=>$id))->row()->email;
            
            switch ($id_form) {
              case 'ac':
                  $target_dir = "./crm/arquivos/cadastro_06_abrir_comercio/".$id."_".$nome."/";
                  break;
              case 'fc':
                  $target_dir = "./crm/arquivos/cadastro_01_abrir_empresa/".$id."_".$nome."/";
                  break;
              case 'ma':
                  $target_dir = "./crm/arquivos/cadastro_04_abrir_mei/".$id."_".$nome."/";
                  break;
              case 'mt':
                  $target_dir = "./crm/arquivos/cadastro_05_trazer_mei/".$id."_".$nome."/";
                  break;
              case 'pl':
                  $target_dir = "./crm/arquivos/cadastro_03_profissional_liberal/".$id."_".$nome."/";
                  break;
              case 'tc':
                  $target_dir = "./crm/arquivos/cadastro_07_trazer_comercio/".$id."_".$nome."/";
                  break;
              case 'te':
                  $target_dir = "./crm/arquivos/cadastro_02_trazer_empresa/".$id."_".$nome."/";
                  break;                                                      
              default:
                  $target_dir = "./crm/arquivos/";
            } 
            
            $Xrand =  mt_rand();

            $XnovoNome = strtolower($this->caracter_model->t5f_translit($_FILES['file']['name']));
            
            $caminho = $target_dir.$id.'_file_1mensalidade_'.$Xrand.'_'.strtolower($this->caracter_model->tira_acento($_FILES['file']['name']));
                             
            $data['form_client_id']   = $id;
            $data['form_tipo']        = $id_form;
            $data['usuario']          = $this->session->userdata('admin_id');
            $data['arquivo']          = $XnovoNome;         
            $data['caminho']          = $caminho;
            move_uploaded_file($_FILES['file']['tmp_name'], $target_dir.$id.'_file_1mensalidade_'.$Xrand.'_'.strtolower($this->caracter_model->tira_acento($_FILES['file']['name'])));            
            //$data['caminho']          = ($this->input->post('path').$Xalterdata.$Xdescription.$Xalterdata.'_'.$Xrand.'_'.$XnovoNome);
            $data['data_postagem']    = date('Y-m-d', strtotime($this->input->post('data_postagem')));
            $data['data_alteracao']   = date('Y-m-d', strtotime($this->input->post('data_alteracao')));
            $data['data_vencimento']  = implode('-',array_reverse(explode('/',$this->input->post('data_vencimento'))));
            if  (strstr($this->input->post('valor'),',')){
                $valor_boleto = str_replace(',','.',str_replace('.','',$this->input->post('valor')));
                $data['valor'] = $valor_boleto;                
            } else {                      
                      $valor_boleto = $this->input->post('valor');
                      $data['valor'] = $valor_boleto;   
                    }; 
            $data['status']           = 'pendente';
            $data['obs']              = $this->input->post('obs');
            $this->db->insert('financeiro', $data);
  
            $query = $this->db->query('SELECT LAST_INSERT_ID()');
            $row = $query->row_array();
            $LastIdInserted = $row['LAST_INSERT_ID()'];
           
            // Envio Email  
            /*
            $Xcontato       = $this->db->get_where('client', array('client_id' => $this->input->post('client')))->row()->contact;
            $Xemail         = $this->db->get_where('client', array('client_id' => $this->input->post('client')))->row()->email;
            $Xtipo_arquivo  = $this->db->get_where('product', array('product_id' => $this->input->post('product_id')))->row()->name;
            $Xarquivo       = ($this->input->post('path').$Xalterdata.$Xdescription.$this->input->post('client').'_'.$Xrand.'_'.$XnovoNome);
            */
            // envio de email diferente para arquivos do tipo boleto
            
            
            $tipo_acao = '';
            
            switch ($id_form) {
              case 'ac':
                  $tipo_acao = 'abrir';
                  break;
              case 'fc':
                  $tipo_acao = 'abrir';
                  break;
              case 'ma':
                  $tipo_acao = 'abrir';
                  break;
              case 'mt':
                  $tipo_acao = 'migrar';
                  break;
              case 'pl':
                  $tipo_acao = 'migrar';
                  break;
              case 'tc':
                  $tipo_acao = 'migrar';
                  break;
              case 'te':
                  $tipo_acao = 'migrar';
                  break;                                                      
              default:
                  $tipo_acao = '';
            }

            //if ($this->input->post('link_pagseguro') == 'sim') {
            
             //envia email
            //$this->email_model->envia_email_link_adesao($nome, $email );
            
            //}else{
              // Conversão no RD
              $data_rd['email'] = $email;
              $data_rd['link_taxa_de_adesao'] = 'https://contsimples.com.br/crm'.substr($caminho,1);
              $data_rd['acao'] = $tipo_acao;
              $data_rd['id'] = $LastIdInserted; // id do boleto no DB
              $data_rd['valor'] = $valor_boleto;
              $data_rd['vencimento'] = implode('-',array_reverse(explode('/',$this->input->post('data_vencimento'))));
              
              $fields = http_build_query($data_rd);
              $ch = curl_init();
              curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/taxa-adesao.php");
              //curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/taxa-adesao-link.php");
              curl_setopt($ch, CURLOPT_POST, 1);
              curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
              curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
              $server_output = curl_exec($ch);
              curl_close($ch);
              // Conversão no RD - FIM
            

              //muda status envio boleto para enviado
              //$server_output = '{"status":"success","b":2}';
              $output_rd = json_decode($server_output,true)['status'];
            
            
              if  ($output_rd=='success'){
                  
                  $data_status['status']      = 'enviado';
                  $this->db->where('financeiro_id', $LastIdInserted);
                  $this->db->update('financeiro', $data_status);
                  
                  $data_fin['status']           = 10;
                   
                  switch ($id_form) {
                    case 'ac':
                      $this->db->where('clientes_ac_id', $id);
                      $this->db->update('clientes_ac', $data_fin);
                      break;
                    case 'fc':
                      $this->db->where('clientes_fc_id', $id);
                      $this->db->update('clientes_fc', $data_fin);
                      break;
                    case 'ma':
                      $this->db->where('clientes_ma_id', $id);
                      $this->db->update('clientes_ma', $data_fin);
                      break;
                    case 'mt':
                      $this->db->where('clientes_mt_id', $id);
                      $this->db->update('clientes_mt', $data_fin);
                      break;
                    case 'pl':
                      $this->db->where('clientes_pl_id', $id);
                      $this->db->update('clientes_pl', $data_fin);
                      break;
                    case 'tc':
                      $this->db->where('clientes_tc_id', $id);
                      $this->db->update('clientes_tc', $data_fin);
                      break;
                    case 'te':
                      $this->db->where('clientes_te_id', $id);
                      $this->db->update('clientes_te', $data_fin);
                      break;                                                      
                    default:
                      $tipo_acao = '';
                  }
                //}
                
                // Atualiza Status OBS
                $data2['form_client_id']     = $id;
                $data2['form_tipo']          = $id_form;
                $data2['usuario']            = $this->session->userdata('admin_id');
                $data2['data']               = date("Y-m-d H:i:s", time()); 
                $data2['status']             = 10;
                $data2['obs']                = $this->input->post('obs');
                $this->db->insert('clientes_obs', $data2);
                   
                $this->session->set_flashdata('flash_message', 'Link Enviado!!');                
                
            } else {  
            
                $data_status['status']      = 'não enviado';
                $this->db->where('financeiro_id', $LastIdInserted);
                $this->db->update('financeiro', $data_status);
                
            $this->session->set_flashdata('flash_message', 'Link Salvo mas não enviado para o RD favor verificar!!');   }; 

            // Geração do Log   ------------------------------------------------
            $log['admin']        = $this->session->userdata('admin_id');
            $log['client']       = $this->input->post('client');
            $log['path']         = $target_dir.$id.'_file_1mensalidade_'.$Xrand.'_'.strtolower($this->caracter_model->tira_acento($_FILES['file']['name']));
            $format = 'DATE_W3C';
            $time = time();
            $log['date']         = standard_date($format, $time) ;
            $log['tipo']         = 'postagem';
            $this->db->insert('log', $log);
            // FIM - Geração do Log   ------------------------------------------

            redirect(base_url() . 'index.php?admin/file_1mensalidade/', 'refresh');          
            
        }

        //$page_data['files']      = $this->db->get('financeiro')->result_array();
        $page_data['mov']        = $this->db->query("SELECT * from financeiro where status not in ('pago','cancelado')")->result_array();
        $page_data['page_name']  = 'file_1mensalidade';
        $page_data['page_icon']  = 'icon-briefcase';
        $page_data['page_title'] = 'Gestão Financeira - 1ª Mensalidade';
        $this->load->view('index', $page_data);
    }      
    
        
/**** FINANCEIRO |-> Boletos Pagos ****/
    function rel_fin_pagos($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['mov']      = $this->db->get_where('financeiro', array('status'=>'pago'))->result_array();
        $page_data['page_name']  = 'rel_fin_pagos';
        $page_data['page_icon']  = 'icon-briefcase';
        $page_data['page_title'] = 'Gestão Financeira - Boletos Pagos';
        $this->load->view('index', $page_data);
    }
/**** FINANCEIRO |-> Boletos Cancelados ****/
    function rel_fin_cancelados($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['mov']      = $this->db->get_where('financeiro', array('status'=>'cancelado'))->result_array();
        $page_data['page_name']  = 'rel_fin_cancelados';
        $page_data['page_icon']  = 'icon-briefcase';
        $page_data['page_title'] = 'Gestão Financeira - Boletos Cancelados';
        $this->load->view('index', $page_data);
    }         
/****MANAGE Relatórios *****/
    function rel_resumo_pendentes($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['dados']       = $this->db->get_where('w_client', array('status' => 'Pendente Cliente'))->result_array();
        $page_data['page_name']  = 'rel_resumo_pendentes';
        $page_data['page_icon']  = 'cog';
        $page_data['page_title'] = 'Clientes Pendentes';
        $this->load->view('index', $page_data);
    }
    function rel_resumo_pendentes_cs($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        
        //$page_data['dados']       = $this->db->get_where('w_client', array('status' => 'Novo'))->result_array();
        //$sql = 'SELECT * from w_client where status <> ?';
        //$page_data['dados']       = $this->db->query($sql, array('Pendente Cliente'))->row_array();
        $page_data['dados']      = $this->db->query("SELECT * from w_client where status not in ('Pendente Cliente','Finalizado','Desistência Cliente','Cadastro Incompleto')")->result_array();
        $page_data['page_name']  = 'rel_resumo_pendentes_cs';
        $page_data['page_icon']  = 'cog';
        $page_data['page_title'] = 'Pendentes - ContSimples';
        $this->load->view('index', $page_data);
    }
    function rel_resumo_finalizados_cs($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        
        //$page_data['dados']       = $this->db->get_where('w_client', array('status' => 'Novo'))->result_array();
        //$sql = 'SELECT * from w_client where status <> ?';
        //$page_data['dados']       = $this->db->query($sql, array('Pendente Cliente'))->row_array();
        $page_data['dados']      = $this->db->query("SELECT * from w_client where status in ('Finalizado','Desistência Cliente')")->result_array();  
        $page_data['page_name']  = 'rel_resumo_finalizados_cs';
        $page_data['page_icon']  = 'cog';
        $page_data['page_title'] = 'Finalizados - ContSimples';
        $this->load->view('index', $page_data);
    }
    function rel_resumo_incompleto($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['dados']       = $this->db->get_where('w_client', array('status' => 'Cadastro Incompleto'))->result_array();
        $page_data['page_name']  = 'rel_resumo_incompleto';
        $page_data['page_icon']  = 'cog';
        $page_data['page_title'] = 'Cadastro Incompletos';
        $this->load->view('index', $page_data);
    }
    function rel_log_clientes_excluidos($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        
        //$page_data['dados']       = $this->db->get_where('w_log', array('tipo' => 'Proc.Del'))->result_array();
        //$sql = 'SELECT * from w_client where status <> ?';
        //$page_data['dados']       = $this->db->query($sql, array('Pendente Cliente'))->row_array();
        $page_data['dados']       = $this->db->get_where('w_log', array('tipo' => 'Proc.Del'))->result_array();
        $page_data['page_name']  = 'rel_log_clientes_excluidos';
        $page_data['page_icon']  = 'cog';
        $page_data['page_title'] = 'Log Clientes Excluidos';
        $this->load->view('index', $page_data);
    }
    function apaga_processo($param1 = '', $param2 = '', $param3 = '' )
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'delete') {

            //$Xdados = $this->db->query("SELECT * from w_client where status in ('Excluir Processo')")->result_array();
            //print_r($Xdados);
            
            $variavel = explode("_",$param2);
            
            $id_form = $variavel[0];
            $id = $variavel[1];
            $client_id =  $variavel[2];
            $nome =  $this->db->get_where('w_client_form_id', array('tipo_form' => $id_form,'form_id'=>$id))->row()->name;
            $pasta_nome =  $this->caracter_model->tira_acento($this->db->get_where('w_client_form_id', array('tipo_form' => $id_form,'form_id'=>$id))->row()->name);
            $email = $this->db->get_where('w_client_form_id', array('tipo_form' => $id_form,'form_id'=>$id))->row()->email;

            /*
            echo  $id_form.'<br>';
            echo  $id.'<br>';
            echo  $client_id.'<br>';
            echo  $nome.'<br>';
            echo  $pasta_nome.'<br>';
            echo  $email.'<br>';
            */

            
            switch ($id_form) {
              case 'ac':
                  $target_dir = "./crm/arquivos/cadastro_06_abrir_comercio/".$id."_".$pasta_nome;
                  $formulario = 'clientes_ac';
                  break;
              case 'fc':
                  $target_dir = "./crm/arquivos/cadastro_01_abrir_empresa/".$id."_".$pasta_nome;
                  $formulario = 'clientes_fc';
                  break;
              case 'ma':
                  $target_dir = "./crm/arquivos/cadastro_04_abrir_mei/".$id."_".$pasta_nome;
                  $formulario = 'clientes_ma';
                  break;
              case 'mt':
                  $target_dir = "./crm/arquivos/cadastro_05_trazer_mei/".$id."_".$pasta_nome;
                  $formulario = 'clientes_mt';
                  break;
              case 'pl':
                  $target_dir = "./crm/arquivos/cadastro_03_profissional_liberal/".$id."_".$pasta_nome;
                  $formulario = 'clientes_pl';
                  break;
              case 'tc':
                  $target_dir = "./crm/arquivos/cadastro_07_trazer_comercio/".$id."_".$pasta_nome;
                  $formulario = 'clientes_tc';
                  break;
              case 'te':
                  $target_dir = "./crm/arquivos/cadastro_02_trazer_empresa/".$id."_".$pasta_nome;
                  $formulario = 'clientes_te';
                  break;                                                      
              default:
                  $target_dir = "";
            } 
            
            rmdir($target_dir);

            //print_r($target_dir);
            
           
            //envia email
            $this->email_model->envia_email_exclusao_processo($nome, $email, $target_dir, $id_form, $id );


            // Geração do Log   ------------------------------------------------
            $log['admin']        = $this->session->userdata('admin_id');
            $log['client']       = 0;
            $log['path']         = $nome.' - '.$email.' pasta: '.$target_dir;
                $format = 'DATE_W3C';
                $time = time();
            $log['date']         = standard_date($format, $time) ;
            $log['tipo']         = 'Proc.Del';
            $this->db->insert('log', $log);
            // FIM - Geração do Log   ------------------------------------------


            //remove registros do banco de dados
            $this->db->where('client_id', $client_id);
            $this->db->delete('client');
            
            $this->db->where('clientes_'.$id_form.'_id', $id);
            $this->db->delete($formulario);
            
            $this->db->query("delete from clientes_obs where form_client_id='".$id_form."' and form_tipo='".$id."'");
            
            
            //$this->session->set_flashdata('flash_message', "client_id: ".$client_id." e ".'clientes_'.$id_form.'_id :'.$id."" );
            $this->session->set_flashdata('flash_message', 'Cliente e Seus cadastros deletados com Sucesso');
            
            redirect(base_url() . 'index.php?admin/apaga_processo/', 'refresh');
        }


        $page_data['dados']      = $this->db->query("SELECT * from w_client where status in ('Excluir Processo')")->result_array();
        $page_data['page_name']  = 'apaga_processo';
        $page_data['page_icon']  = 'cog';
        $page_data['page_title'] = 'Exclusão - ContSimples';
        $this->load->view('index', $page_data);
    }

/****MANAGE transaction*****/
    function transaction($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['amount'] = $this->input->post('amount');
            $data['type']   = $this->input->post('type');
            $data['order']  = $this->input->post('order');
            $data['about']  = $this->input->post('about');
            $data['date']   = $this->input->post('date');
            $this->db->insert('transaction', $data);
            redirect(base_url() . 'index.php?admin/transaction/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['amount'] = $this->input->post('amount');
            $data['type']   = $this->input->post('type');
            $data['order']  = $this->input->post('order');
            $data['about']  = $this->input->post('about');
            $data['date']   = $this->input->post('date');
            $this->db->where('transaction_id', $param2);
            $this->db->update('transaction', $data);
            redirect(base_url() . 'index.php?admin/transaction/', 'refresh');
        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile']       = true;
            $page_data['current_transaction_id'] = $param2;
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('transaction', array(
                'transaction_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $this->db->where('transaction_id', $param2);
            $this->db->delete('transaction');
            redirect(base_url() . 'index.php?admin/transaction/', 'refresh');
        }
        $page_data['transaction'] = $this->db->get('transaction')->result_array();
        $page_data['page_name']   = 'transaction';
        $page_data['page_icon']   = 'random';
        $page_data['page_title']  = 'manage_transaction';
        $this->load->view('index', $page_data);
    }
/**** Relatórios |-> Auxiliares ****/
    function rel_aux($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        
        //$page_data['rel_aux']      =  $this->db->get('w_client_status')->result_array();
        $page_data['page_name']  = 'rel_aux';
        $page_data['page_icon']  = 'print';
        $page_data['page_title'] = 'Relatórios - Auxiliares';
        $this->load->view('index', $page_data);
    }
/**** Relatórios |-> Auxiliares ****/
    function rel_acompanhamento($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url(), 'refresh');
        
        //$page_data['rel_aux']      =  $this->db->get('w_client_status')->result_array();
        $page_data['page_name']  = 'rel_acompanhamento';
        $page_data['page_icon']  = 'signal';
        $page_data['page_title'] = 'Relatórios - Acompanhamento';
        $this->load->view('index', $page_data);
    }    
    
/*****SITE/SYSTEM SETTINGS*********/
    function system_settings($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');

        if ($param2 == 'do_update') {
            $this->db->where('type', $param1);
            $this->db->update('settings', array(
                'description' => $this->input->post('description')
            ));
            $this->session->set_flashdata('flash_message', 'settings_updated');
            redirect(base_url() . 'index.php?admin/system_settings/', 'refresh');
        }
        if ($param1 == 'upload_logo') {
            move_uploaded_file($_FILES['userfile']['tmp_name'], 'uploads/logo.png');
            $this->session->set_flashdata('flash_message', 'settings_updated');
            redirect(base_url() . 'index.php?admin/system_settings/', 'refresh');
        }
        $page_data['page_name']  = 'system_settings';
        $page_data['page_icon'] = 'cog';
        $page_data['page_title'] = 'Configurações do sistema';
        $page_data['settings']   = $this->db->get('settings')->result_array();
        $this->load->view('index', $page_data);
    }

/*****LANGUAGE SETTINGS*********/
    function manage_language($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');

        if ($param1 == 'edit_phrase') {
            $page_data['edit_profile'] = $param2;
        }
        if ($param1 == 'update_phrase') {
            $language     = $param2;
            $total_phrase = $this->input->post('total_phrase');
            for ($i = 1; $i < $total_phrase; $i++) {
                //$data[$language]	=	$this->input->post('phrase').$i;
                $this->db->where('phrase_id', $i);
                $this->db->update('language', array(
                    $language => $this->input->post('phrase' . $i)
                ));
            }
            redirect(base_url() . 'index.php?admin/manage_language/edit_phrase/' . $language, 'refresh');
        }
        if ($param1 == 'do_update') {
            $language        = $this->input->post('language');
            $data[$language] = $this->input->post('phrase');
            $this->db->where('phrase_id', $param2);
            $this->db->update('language', $data);
            $this->session->set_flashdata('flash_message', 'settings_updated');
            redirect(base_url() . 'index.php?admin/manage_language/', 'refresh');
        }
        if ($param1 == 'add_phrase') {
            $data['phrase'] = $this->input->post('phrase');
            $this->db->insert('language', $data);
            $this->session->set_flashdata('flash_message', 'settings_updated');
            redirect(base_url() . 'index.php?admin/manage_language/', 'refresh');
        }
        if ($param1 == 'add_language') {
            $language = $this->input->post('language');
            $this->load->dbforge();
            $fields = array(
                $language => array(
                    'type' => 'LONGTEXT'
                )
            );
            $this->dbforge->add_column('language', $fields);

            $this->session->set_flashdata('flash_message', 'settings_updated');
            redirect(base_url() . 'index.php?admin/manage_language/', 'refresh');
        }
        if ($param1 == 'delete_language') {
            $language = $param2;
            $this->load->dbforge();
            $this->dbforge->drop_column('language', $language);
            $this->session->set_flashdata('flash_message', 'settings_updated');

            redirect(base_url() . 'index.php?admin/manage_language/', 'refresh');
        }
        $page_data['page_name']  = 'manage_language';
        $page_data['page_icon'] = 'comment';
        $page_data['page_title'] = 'manage_language';
        //$page_data['language_phrases'] = $this->db->get('language')->result_array();
        $this->load->view('index', $page_data);
    }

/******MANAGE OWN PROFILE AND CHANGE PASSWORD***/
    function manage_profile($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('admin_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');
        if ($param1 == 'update_profile_info') {
            $data['email'] = $this->input->post('email');

            $this->db->where('admin_id', $this->session->userdata('admin_id'));
            $this->db->update('admin', $data);
            $this->session->set_flashdata('flash_message', 'account_updated');
            redirect(base_url() . 'index.php?admin/manage_profile/', 'refresh');
        }
        if ($param1 == 'change_password') {
            $data['password']             = $this->input->post('password');
            $data['new_password']         = $this->input->post('new_password');
            $data['confirm_new_password'] = $this->input->post('confirm_new_password');

            $current_password = $this->db->get_where('admin', array(
                'admin_id' => $this->session->userdata('admin_id')
            ))->row()->password;
            if ($current_password == $data['password'] && $data['new_password'] == $data['confirm_new_password']) {
                $this->db->where('admin_id', $this->session->userdata('admin_id'));
                $this->db->update('admin', array(
                    'password' => $data['new_password']
                ));
                $this->session->set_flashdata('flash_message', 'password_updated');
            } else {
                $this->session->set_flashdata('flash_message', 'password_mismatch');
            }
            redirect(base_url() . 'index.php?admin/manage_profile/', 'refresh');
        }
        $page_data['page_name']  = 'manage_profile';
        $page_data['page_icon'] = 'key';
        $page_data['page_title'] = 'Minha Conta';
        $page_data['edit_data']  = $this->db->get_where('admin', array(
            'admin_id' => $this->session->userdata('admin_id')
        ))->result_array();
        $this->load->view('index', $page_data);
    }

}
