<?php
if (!defined('BASEPATH'))
    exit('No direct script access allowed');

/*
 *  @author : Wallace Pacheco
 *  date    : 01 junho, 2015
 *  ContSimples Tecnologia
 *  http://contsimples.com.br
 */

/*
|---------------------------------------------------------------
| TimeZone
|---------------------------------------------------------------
*/
date_default_timezone_set('America/Sao_Paulo');

class Client extends CI_Controller
{


    function __construct()
    {
        parent::__construct();
        $this->load->database();
        $this->load->library('calendar');
        //$this->load->library('pdf');
        $this->load->helper('date');
        //$this->load->dbutil();
        //$this->load->library('phplot.php');
        /*cache control*/
        $this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
        $this->output->set_header('Pragma: no-cache');
    }

/***default functin, redirects to login page if no client logged in yet***/
    public function index()
    {

        if ($this->session->userdata('client_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');
        if ($this->session->userdata('client_login') == 1)
            redirect(base_url() . 'index.php?client/dashboard', 'refresh');
    }

/***CLIENTE DASHBOARD***/
    function dashboard()
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        $page_data['page_name']  = 'dashboard';
        $page_data['page_icon'] = 'dashboard';
        $page_data['page_title'] = 'Painel';
        $this->load->view('index', $page_data);
    }


/****MANAGE Avisos*****/
    function avisos($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        //$this->session->set_flashdata('flash_message', 'Passou en!!');

        if ($param1 == 'create') {
            $data['sender']        = $this->input->post('sender');
            $data['sender_type']   = $this->input->post('sender_type');
            $data['receiver']      = $this->input->post('receiver');
            $data['receiver_type'] = $this->input->post('receiver_type');
            $data['subject']       = $this->input->post('subject');
            $data['body']          = $this->input->post('body');
            $data['time']          = $this->input->post('time');
            $data['date']          = $this->input->post('date');
            $data['status']        = $this->input->post('status');
            $this->db->insert('files', $data);

            // Envio Email
            //$Xsender        = $this->db->get_where('client', array('client_id' => $this->input->post('sender')))->row()->name;
            //$Xsend_email    = $this->db->get_where('client', array('client_id' => $this->input->post('sender')))->row()->email;


            //$this->email_model->envia_email_mensagem_cliente($Xsender,$Xsend_email,$this->input->post('subject'),$this->input->post('body'));


            redirect(base_url() . 'index.php?client/avisos/', 'refresh');
        }
        if ($param1 == 'update_status') {

            $data['status']         = 'baixado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect(base_url() . 'index.php?client/avisos/', 'refresh');

        }
        if ($param1 == 'delete') {
            $this->db->where('file_id', $param2);
            $this->db->delete('files');
            redirect(base_url() . 'index.php?client/avisos/', 'refresh');
        }

        $page_data['avisos']    = $this->db->get_where('files', array('client' => $this->session->userdata('client_id')))->result_array();
        //$page_data['message']    =  $this->db->get_where('message', array('sender' => $this->session->userdata('client_id')))->result_array();
        $page_data['page_name']  = 'avisos';
        $page_data['page_icon']  = 'envelope';
        $page_data['page_title'] = 'Avisos Importantes!';
        $this->load->view('index', $page_data);
    }

    /***EMPRESA ABERTURA***/
    function empresa_abrir ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url() . 'index.php?client/empresa_abrir/', 'refresh');

        if ($param1 == 'do_update') {
        
            $id = $this->input->post('id') ;
            $target_dir = "./crm/arquivos/cadastro_01_abrir_empresa/".$id."_".$this->caracter_model->tira_acento($this->input->post('nome'))."/";        
        
            $XStatus = '8';
        
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['status']           = $XStatus;
            $data['obs']           = $this->input->post('obs');
            $data['fc_02_numero_rg']           = $this->input->post('fc_02_numero_rg');
            $data['fc_04_radio_documentos']           = $this->input->post('fc_04_radio_documentos');
            //$data['fc_05_rg_digital']           = $this->input->post('fc_05_rg_digital');            
            if ( empty($_FILES['file_fc_05_rg_digital']['name'])){
                $data['fc_05_rg_digital']   = $this->input->post('fc_05_rg_digital');
              }  else {
                $data['fc_05_rg_digital']   = $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_05_rg_digital']['name']));
                move_uploaded_file($_FILES['file_fc_05_rg_digital']['tmp_name'], $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_05_rg_digital']['name'])));
              }              
            //$data['fc_06_cpf_digital']           = $this->input->post('fc_06_cpf_digital');
            if ( empty($_FILES['file_fc_06_cpf_digital']['name'])){
                $data['fc_06_cpf_digital']   = $this->input->post('fc_06_cpf_digital');
              }  else {
                $data['fc_06_cpf_digital']   = $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_06_cpf_digital']['name']));
                move_uploaded_file($_FILES['file_fc_06_cpf_digital']['tmp_name'], $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_06_cpf_digital']['name'])));
              }                 
            //$data['fc_07_cnh_digital']           = $this->input->post('fc_07_cnh_digital');
            if ( empty($_FILES['file_fc_07_cnh_digital']['name'])){
                $data['fc_07_cnh_digital']   = $this->input->post('fc_07_cnh_digital');
              }  else {
                $data['fc_07_cnh_digital']   = $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_07_cnh_digital']['name']));
                move_uploaded_file($_FILES['file_fc_07_cnh_digital']['tmp_name'], $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_07_cnh_digital']['name'])));
              } 
            $data['fc_08_nome_mae']           = $this->input->post('fc_08_nome_mae');
            $data['fc_09_estado_civil']           = $this->input->post('fc_09_estado_civil');
            $data['fc_10_regime_casamento']           = $this->input->post('fc_10_regime_casamento');
            $data['fc_11_opcao_irpf']           = $this->input->post('fc_11_opcao_irpf');
            $data['fc_12_irpf']           = $this->input->post('fc_12_irpf');
            $data['fc_13_titulo_eleitor']           = $this->input->post('fc_13_titulo_eleitor');
            $data['fc_14_nome_rua']           = $this->input->post('fc_14_nome_rua');
            $data['fc_15_numero_rua']           = $this->input->post('fc_15_numero_rua');
            $data['fc_16_complemento']           = $this->input->post('fc_16_complemento');
            $data['fc_17_bairro']           = $this->input->post('fc_17_bairro');
            $data['fc_18_cidade']           = $this->input->post('fc_18_cidade');
            $data['fc_19_uf']           = $this->input->post('fc_19_uf');
            $data['fc_20_cep']           = $this->input->post('fc_20_cep');
            $data['fc_21_nome_empresa01']           = $this->input->post('fc_21_nome_empresa01');
            $data['fc_22_nome_empresa02']           = $this->input->post('fc_22_nome_empresa02');
            $data['fc_23_nome_empresa03']           = $this->input->post('fc_23_nome_empresa03');
            $data['fc_24_nome_fantasia']           = $this->input->post('fc_24_nome_fantasia');
            $data['fc_25_data_inicio']           = $this->input->post('fc_25_data_inicio');
            $data['fc_134_numero_funcionarios']           = $this->input->post('fc_134_numero_funcionarios');
            $data['fc_26_endereco_referencia']           = $this->input->post('fc_26_endereco_referencia');
            $data['fc_27_nome_rua']           = $this->input->post('fc_27_nome_rua');
            $data['fc_28_numero_rua']           = $this->input->post('fc_28_numero_rua');
            $data['fc_30_bairro']           = $this->input->post('fc_30_bairro');
            $data['fc_31_cidade']           = $this->input->post('fc_31_cidade');
            $data['fc_32_uf']           = $this->input->post('fc_32_uf');
            $data['fc_33_cep']           = $this->input->post('fc_33_cep');
            $data['fc_34_iptu_empresa']           = $this->input->post('fc_34_iptu_empresa');
            $data['fc_35_atividades']           = $this->input->post('fc_35_atividades');
            $data['fc_36_capital_social']           = $this->input->post('fc_36_capital_social');
            $data['fc_37_socio_administrador']           = $this->input->post('fc_37_socio_administrador');
            $data['fc_38_pro_labore']           = $this->input->post('fc_38_pro_labore');
            $data['fc_39_qtd_socios']           = $this->input->post('fc_39_qtd_socios');
            $data['fc_40_socio_01_nome']           = $this->input->post('fc_40_socio_01_nome');
            $data['fc_41_socio_01_rg']           = $this->input->post('fc_41_socio_01_rg');
            $data['fc_42_socio_01_cpf']           = $this->input->post('fc_42_socio_01_cpf');
            $data['fc_43_socio_01_documento']           = $this->input->post('fc_43_socio_01_documento');
            //$data['fc_44_socio_01_rgdigital']           = $this->input->post('fc_44_socio_01_rgdigital');
            if ( empty($_FILES['file_fc_44_socio_01_rgdigital']['name'])){
                $data['fc_44_socio_01_rgdigital']   = $this->input->post('fc_44_socio_01_rgdigital');
              }  else {
                $data['fc_44_socio_01_rgdigital']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_44_socio_01_rgdigital']['name']));
                move_uploaded_file($_FILES['file_fc_44_socio_01_rgdigital']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_44_socio_01_rgdigital']['name'])));
              } 
            //$data['fc_45_socio_01_cpfdigital']           = $this->input->post('fc_45_socio_01_cpfdigital');
            if ( empty($_FILES['file_fc_45_socio_01_cpfdigital']['name'])){
                $data['fc_45_socio_01_cpfdigital']   = $this->input->post('fc_45_socio_01_cpfdigital');
              }  else {
                $data['fc_45_socio_01_cpfdigital']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_45_socio_01_cpfdigital']['name']));
                move_uploaded_file($_FILES['file_fc_45_socio_01_cpfdigital']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_45_socio_01_cpfdigital']['name'])));
              } 
            //$data['fc_46_socio_01_cnhdigital']           = $this->input->post('fc_46_socio_01_cnhdigital');
            if ( empty($_FILES['file_fc_46_socio_01_cnhdigital']['name'])){
                $data['fc_46_socio_01_cnhdigital']   = $this->input->post('fc_46_socio_01_cnhdigital');
              }  else {
                $data['fc_46_socio_01_cnhdigital']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_46_socio_01_cnhdigital']['name']));
                move_uploaded_file($_FILES['file_fc_46_socio_01_cnhdigital']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_46_socio_01_cnhdigital']['name'])));
              } 
            $data['fc_47_socio_01_mae']           = $this->input->post('fc_47_socio_01_mae');
            $data['fc_48_socio_01_estadocivil']           = $this->input->post('fc_48_socio_01_estadocivil');
            $data['fc_49_socio_01_regimecasamento']           = $this->input->post('fc_49_socio_01_regimecasamento');
            $data['fc_50_socio_01_profissao']           = $this->input->post('fc_50_socio_01_profissao');
            $data['fc_51_socio_01_declara_irpf']           = $this->input->post('fc_51_socio_01_declara_irpf');
            $data['fc_52_socio_01_irpf']           = $this->input->post('fc_52_socio_01_irpf');
            $data['fc_53_socio_01_eleitor']           = $this->input->post('fc_53_socio_01_eleitor');
            $data['fc_54_socio_01_capital']           = $this->input->post('fc_54_socio_01_capital');
            $data['fc_55_socio_01_pisinss']           = $this->input->post('fc_55_socio_01_pisinss');
            $data['fc_56_socio_01_rua']           = $this->input->post('fc_56_socio_01_rua');
            $data['fc_57_socio_01_numero']           = $this->input->post('fc_57_socio_01_numero');
            $data['fc_58_socio_01_complemento']           = $this->input->post('fc_58_socio_01_complemento');
            $data['fc_59_socio_01_bairro']           = $this->input->post('fc_59_socio_01_bairro');
            $data['fc_60_socio_01_cidade']           = $this->input->post('fc_60_socio_01_cidade');
            $data['fc_61_socio_01_uf']           = $this->input->post('fc_61_socio_01_uf');
            $data['fc_62_socio_01_cep']           = $this->input->post('fc_62_socio_01_cep');
            $data['fc_63_socio_02_nome']           = $this->input->post('fc_63_socio_02_nome');
            $data['fc_64_socio_02_rg']           = $this->input->post('fc_64_socio_02_rg');
            $data['fc_65_socio_02_cpf']           = $this->input->post('fc_65_socio_02_cpf');
            $data['fc_66_socio_02_documento']           = $this->input->post('fc_66_socio_02_documento');
            $data['fc_67_socio_02_rgdigital']           = $this->input->post('fc_67_socio_02_rgdigital');
            $data['fc_68_socio_02_cpfdigital']           = $this->input->post('fc_68_socio_02_cpfdigital');
            $data['fc_69_socio_02_cnhdigital']           = $this->input->post('fc_69_socio_02_cnhdigital');
            //$data['fc_44_socio_01_rgdigital']           = $this->input->post('fc_44_socio_01_rgdigital');
            if ( empty($_FILES['file_fc_44_socio_01_rgdigital']['name'])){
                $data['fc_44_socio_01_rgdigital']   = $this->input->post('fc_44_socio_01_rgdigital');
              }  else {
                $data['fc_44_socio_01_rgdigital']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_44_socio_01_rgdigital']['name']));
                move_uploaded_file($_FILES['file_fc_44_socio_01_rgdigital']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_44_socio_01_rgdigital']['name'])));
              } 
            //$data['fc_45_socio_01_cpfdigital']           = $this->input->post('fc_45_socio_01_cpfdigital');
            if ( empty($_FILES['file_fc_45_socio_01_cpfdigital']['name'])){
                $data['fc_45_socio_01_cpfdigital']   = $this->input->post('fc_45_socio_01_cpfdigital');
              }  else {
                $data['fc_45_socio_01_cpfdigital']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_45_socio_01_cpfdigital']['name']));
                move_uploaded_file($_FILES['file_fc_45_socio_01_cpfdigital']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_45_socio_01_cpfdigital']['name'])));
              } 
            //$data['fc_46_socio_01_cnhdigital']           = $this->input->post('fc_46_socio_01_cnhdigital');
            if ( empty($_FILES['file_fc_46_socio_01_cnhdigital']['name'])){
                $data['fc_46_socio_01_cnhdigital']   = $this->input->post('fc_46_socio_01_cnhdigital');
              }  else {
                $data['fc_46_socio_01_cnhdigital']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_46_socio_01_cnhdigital']['name']));
                move_uploaded_file($_FILES['file_fc_46_socio_01_cnhdigital']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_46_socio_01_cnhdigital']['name'])));
              } 
            $data['fc_70_socio_02_mae']           = $this->input->post('fc_70_socio_02_mae');
            $data['fc_71_socio_02_estadocivil']           = $this->input->post('fc_71_socio_02_estadocivil');
            $data['fc_72_socio_02_regimecasamento']           = $this->input->post('fc_72_socio_02_regimecasamento');
            $data['fc_73_socio_02_profissao']           = $this->input->post('fc_73_socio_02_profissao');
            $data['fc_74_socio_02_declaraimposto']           = $this->input->post('fc_74_socio_02_declaraimposto');
            $data['fc_75_socio_02_irpf']           = $this->input->post('fc_75_socio_02_irpf');
            $data['fc_76_socio_02_eleitor']           = $this->input->post('fc_76_socio_02_eleitor');
            $data['fc_77_socio_02_capital']           = $this->input->post('fc_77_socio_02_capital');
            $data['fc_78_socio_02_pisinss']           = $this->input->post('fc_78_socio_02_pisinss');
            $data['fc_79_socio_02_rua']           = $this->input->post('fc_79_socio_02_rua');
            $data['fc_80_socio_02_numero']           = $this->input->post('fc_80_socio_02_numero');
            $data['fc_81_socio_02_complemento']           = $this->input->post('fc_81_socio_02_complemento');
            $data['fc_82_socio_02_bairro']           = $this->input->post('fc_82_socio_02_bairro');
            $data['fc_83_socio_02_cidade']           = $this->input->post('fc_83_socio_02_cidade');
            $data['fc_84_socio_02_uf']           = $this->input->post('fc_84_socio_02_uf');
            $data['fc_85_socio_02_cep']           = $this->input->post('fc_85_socio_02_cep');
            $data['fc_86_socio_03_nome']           = $this->input->post('fc_86_socio_03_nome');
            $data['fc_87_socio_03_rg']           = $this->input->post('fc_87_socio_03_rg');
            $data['fc_88_socio_03_cpf']           = $this->input->post('fc_88_socio_03_cpf');
            $data['fc_89_socio_03_documento']           = $this->input->post('fc_89_socio_03_documento');
            //$data['fc_90_socio_03_rgdigital']           = $this->input->post('fc_90_socio_03_rgdigital');
            if ( empty($_FILES['file_fc_90_socio_03_rgdigital']['name'])){
                $data['fc_90_socio_03_rgdigital']   = $this->input->post('fc_90_socio_03_rgdigital');
              }  else {
                $data['fc_90_socio_03_rgdigital']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_90_socio_03_rgdigital']['name']));
                move_uploaded_file($_FILES['file_fc_90_socio_03_rgdigital']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_90_socio_03_rgdigital']['name'])));
              } 
            //$data['fc_91_socio_03_cpfdigital']           = $this->input->post('fc_91_socio_03_cpfdigital');
            if ( empty($_FILES['file_fc_91_socio_03_cpfdigital']['name'])){
                $data['fc_91_socio_03_cpfdigital']   = $this->input->post('fc_91_socio_03_cpfdigital');
              }  else {
                $data['fc_91_socio_03_cpfdigital']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_91_socio_03_cpfdigital']['name']));
                move_uploaded_file($_FILES['file_fc_91_socio_03_cpfdigital']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_91_socio_03_cpfdigital']['name'])));
              } 
            //$data['fc_92_socio_03_cnhdigital']           = $this->input->post('fc_92_socio_03_cnhdigital');
            if ( empty($_FILES['file_fc_92_socio_03_cnhdigital']['name'])){
                $data['fc_92_socio_03_cnhdigital']   = $this->input->post('fc_92_socio_03_cnhdigital');
              }  else {
                $data['fc_92_socio_03_cnhdigital']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_92_socio_03_cnhdigital']['name']));
                move_uploaded_file($_FILES['file_fc_92_socio_03_cnhdigital']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_92_socio_03_cnhdigital']['name'])));
              } 
            $data['fc_93_socio_03_mae']           = $this->input->post('fc_93_socio_03_mae');
            $data['fc_94_socio_03_estadocilvil']           = $this->input->post('fc_94_socio_03_estadocilvil');
            $data['fc_95_socio_03_regimecasamento']           = $this->input->post('fc_95_socio_03_regimecasamento');
            $data['fc_96_socio_03_profissao']           = $this->input->post('fc_96_socio_03_profissao');
            $data['fc_97_socio_03_declaraimposto']           = $this->input->post('fc_97_socio_03_declaraimposto');
            $data['fc_98_socio_03_irpf']           = $this->input->post('fc_98_socio_03_irpf');
            $data['fc_99_socio_03_eleitor']           = $this->input->post('fc_99_socio_03_eleitor');
            $data['fc_100_socio_03_capital']           = $this->input->post('fc_100_socio_03_capital');
            $data['fc_101_socio_03_pisinss']           = $this->input->post('fc_101_socio_03_pisinss');
            $data['fc_102_socio_03_rua']           = $this->input->post('fc_102_socio_03_rua');
            $data['fc_103_socio_03_numero']           = $this->input->post('fc_103_socio_03_numero');
            $data['fc_104_socio_03_complemento']           = $this->input->post('fc_104_socio_03_complemento');
            $data['fc_105_socio_03_bairro']           = $this->input->post('fc_105_socio_03_bairro');
            $data['fc_106_socio_106_socio_03_cidade']           = $this->input->post('fc_106_socio_106_socio_03_cidade');
            $data['fc_107_socio_03_uf']           = $this->input->post('fc_107_socio_03_uf');
            $data['fc_108_socio_03_cep']           = $this->input->post('fc_108_socio_03_cep');
            $data['fc_109_socio_04_nome']           = $this->input->post('fc_109_socio_04_nome');
            $data['fc_110_socio_04_rg']           = $this->input->post('fc_110_socio_04_rg');
            $data['fc_111_socio_04_cpf']           = $this->input->post('fc_111_socio_04_cpf');
            $data['fc_112_socio_04_documento']           = $this->input->post('fc_112_socio_04_documento');
            //$data['fc_113_socio_04_rgdigital']           = $this->input->post('fc_113_socio_04_rgdigital');
            if ( empty($_FILES['file_fc_113_socio_04_rgdigital']['name'])){
                $data['fc_113_socio_04_rgdigital']   = $this->input->post('fc_113_socio_04_rgdigital');
              }  else {
                $data['fc_113_socio_04_rgdigital']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_113_socio_04_rgdigital']['name']));
                move_uploaded_file($_FILES['file_fc_113_socio_04_rgdigital']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_113_socio_04_rgdigital']['name'])));
              } 
            //$data['fc_114_socio_04_cpfdigital']           = $this->input->post('fc_114_socio_04_cpfdigital');
            if ( empty($_FILES['file_fc_114_socio_04_cpfdigital']['name'])){
                $data['fc_114_socio_04_cpfdigital']   = $this->input->post('fc_114_socio_04_cpfdigital');
              }  else {
                $data['fc_114_socio_04_cpfdigital']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_114_socio_04_cpfdigital']['name']));
                move_uploaded_file($_FILES['file_fc_114_socio_04_cpfdigital']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_114_socio_04_cpfdigital']['name'])));
              } 
            //$data['fc_115_socio_04_cnhdigital']           = $this->input->post('fc_115_socio_04_cnhdigital');
            if ( empty($_FILES['file_fc_115_socio_04_cnhdigital']['name'])){
                $data['fc_115_socio_04_cnhdigital']   = $this->input->post('fc_115_socio_04_cnhdigital');
              }  else {
                $data['fc_115_socio_04_cnhdigital']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_115_socio_04_cnhdigital']['name']));
                move_uploaded_file($_FILES['file_fc_46_socio_01_cnhdigital']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_fc_115_socio_04_cnhdigital']['name'])));
              } 
            $data['fc_116_socio_04_mae']           = $this->input->post('fc_116_socio_04_mae');
            $data['fc_117_socio_04_estadocivil']           = $this->input->post('fc_117_socio_04_estadocivil');
            $data['fc_118_socio_04_regimecasamento']           = $this->input->post('fc_118_socio_04_regimecasamento');
            $data['fc_119_socio_04_profissao']           = $this->input->post('fc_119_socio_04_profissao');
            $data['fc_120_socio_04_declaraimposto']           = $this->input->post('fc_120_socio_04_declaraimposto');
            $data['fc_121_socio_04_irpf']           = $this->input->post('fc_121_socio_04_irpf');
            $data['fc_122_socio_04_eleitor']           = $this->input->post('fc_122_socio_04_eleitor');
            $data['fc_123_socio_04_capital']           = $this->input->post('fc_123_socio_04_capital');
            $data['fc_124_socio_04_pisinss']           = $this->input->post('fc_124_socio_04_pisinss');
            $data['fc_125_socio_04_rua']           = $this->input->post('fc_125_socio_04_rua');
            $data['fc_126_socio_04_numero']           = $this->input->post('fc_126_socio_04_numero');
            $data['fc_127_socio_04_complemento']           = $this->input->post('fc_127_socio_04_complemento');
            $data['fc_128_socio_04_bairro']           = $this->input->post('fc_128_socio_04_bairro');
            $data['fc_129_socio_04_cidade']           = $this->input->post('fc_129_socio_04_cidade');
            $data['fc_107_socio_04_uf']           = $this->input->post('fc_107_socio_04_uf');
            $data['fc_131_socio_04_cep']           = $this->input->post('fc_131_socio_04_cep');

            $this->db->where('clientes_fc_id', $param2);
            $this->db->update('clientes_fc', $data);
            
            //var_dump($Xdados);
            // verifica se o cadastro esta completo
            
            $XTeste = 0;
            $XNomeCampoErro = 'Campos AINDA NÃO preenchidos ';
            
            $Xdados = $this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->result_array();
            $Xemail = $this->db->get_where('clientes_fc', array('clientes_fc_id' => $param2))->row()->email;
           
            foreach($Xdados as $Xok) {
            
            if (empty($Xok['nome']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'nome'; }
            if (empty($Xok['email']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'email'; }
            if (empty($Xok['telefone']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'telefone'; }
            //if (empty($Xok['data_cadastro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'data_cadastro'; }
            //if (empty($Xok['status']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'status'; }
            //if (empty($Xok['obs']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'obs'; }
            if (empty($Xok['fc_02_numero_rg']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_02_numero_rg'; }
            if (empty($Xok['fc_03_numero_cpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_03_numero_cpf'; }

            if ($Xok['fc_04_radio_documentos']=='RG e CPF')
            {
                if (empty($Xok['fc_05_rg_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_05_rg_digital'; }
                if (empty($Xok['fc_06_cpf_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_06_cpf_digital'; }
            } else if ($Xok['fc_04_radio_documentos']=='CNH (Carteira de motorista)')
              {
                if (empty($Xok['fc_07_cnh_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_07_cnh_digital'; }
              }
            if (empty($Xok['fc_08_nome_mae']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_08_nome_mae'; }
//            if (empty($Xok['fc_09_estado_civil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_09_estado_civil'; }
//            if (empty($Xok['fc_10_regime_casamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_10_regime_casamento'; }
            if ($Xok['fc_09_estado_civil']=='Casado')
            {
                  if (empty($Xok['fc_10_regime_casamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_10_regime_casamento'; }
            } else 
              {
                  if (empty($Xok['fc_09_estado_civil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_09_estado_civil'; }
              }            
            if (empty($Xok['fc_14_nome_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_14_nome_rua'; }
            if (empty($Xok['fc_15_numero_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_15_numero_rua'; }
            //if (empty($Xok['fc_16_complemento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_16_complemento'; }
            if (empty($Xok['fc_17_bairro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_17_bairro'; }
            if (empty($Xok['fc_18_cidade']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_18_cidade'; }
            if (empty($Xok['fc_19_uf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_19_uf'; }
            if (empty($Xok['fc_20_cep']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_20_cep'; }
            if (empty($Xok['fc_21_nome_empresa01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_21_nome_empresa01'; }
            if (empty($Xok['fc_22_nome_empresa02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_22_nome_empresa02'; }
            if (empty($Xok['fc_23_nome_empresa03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_23_nome_empresa03'; }
            if (empty($Xok['fc_24_nome_fantasia']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_24_nome_fantasia'; }
            if (empty($Xok['fc_25_data_inicio']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_25_data_inicio'; }
            //if (empty($Xok['fc_134_numero_funcionarios'])) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_134_numero_funcionarios'; } 
            //if (empty($Xok['fc_26_endereco_referencia']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_26_endereco_referencia'; }
            if ($Xok['fc_26_endereco_referencia']=='Endereço Residencial')
            {
                if (empty($Xok['fc_34_iptu_empresa']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_34_iptu_empresa'; }
            } else 
              {
                if (empty($Xok['fc_34_iptu_empresa']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_34_iptu_empresa'; }
                if (empty($Xok['fc_27_nome_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_27_nome_rua'; }
                if (empty($Xok['fc_28_numero_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_28_numero_rua'; }
                //if (empty($Xok['fc_29_complemento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_29_complemento'; }
                if (empty($Xok['fc_30_bairro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_30_bairro'; }
                if (empty($Xok['fc_31_cidade']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_31_cidade'; }
                if (empty($Xok['fc_32_uf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_32_uf'; }
                if (empty($Xok['fc_33_cep']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_33_cep'; }
              }
            
            //if (empty($Xok['fc_11_opcao_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_11_opcao_irpf'; }
            if ($Xok['fc_11_opcao_irpf']=='Não')
            {
                  if (empty($Xok['fc_13_titulo_eleitor']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_13_titulo_eleitor'; }
            } else 
              {
                  if (empty($Xok['fc_12_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_12_irpf'; }
              }

            if (empty($Xok['fc_35_atividades']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_35_atividades'; }
            if (empty($Xok['fc_36_capital_social']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_36_capital_social'; }
            if (empty($Xok['fc_37_socio_administrador']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_37_socio_administrador'; }
            if (empty($Xok['fc_38_pro_labore']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_38_pro_labore'; }
            //if (empty($Xok['fc_39_qtd_socios']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_39_qtd_socios'; }            
            switch ($Xok['fc_39_qtd_socios']) {
                case '0':
                
                  break;
                case '1':
                    if (empty($Xok['fc_40_socio_01_nome']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_40_socio_01_nome'; }
                    if (empty($Xok['fc_41_socio_01_rg']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_41_socio_01_rg'; }
                    if (empty($Xok['fc_42_socio_01_cpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_42_socio_01_cpf'; }
                    //if (empty($Xok['fc_43_socio_01_documento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_43_socio_01_documento'; }
                    if ($Xok['fc_43_socio_01_documento']=='RG e CPF')
                    {
                        if (empty($Xok['fc_44_socio_01_rgdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_44_socio_01_rgdigital'; }
                        if (empty($Xok['fc_45_socio_01_cpfdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_45_socio_01_cpfdigital'; }
                    } else if ($Xok['fc_43_socio_01_documento']=='CNH (Carteira de motorista)')
                      {
                        if (empty($Xok['fc_46_socio_01_cnhdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_46_socio_01_cnhdigital'; }
                      }
                    if (empty($Xok['fc_47_socio_01_mae']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_47_socio_01_mae'; }
//                    if (empty($Xok['fc_48_socio_01_estadocivil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_48_socio_01_estadocivil'; }
//                    if (empty($Xok['fc_49_socio_01_regimecasamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_49_socio_01_regimecasamento'; }                  
                    if ($Xok['fc_48_socio_01_estadocivil']=='Casado')
                    {
                          if (empty($Xok['fc_49_socio_01_regimecasamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_49_socio_01_regimecasamento'; }
                    } else 
                      {
                          if (empty($Xok['fc_48_socio_01_estadocivil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_48_socio_01_estadocivil'; }
                      }                    
                    if (empty($Xok['fc_50_socio_01_profissao']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_50_socio_01_profissao'; }
                    //if (empty($Xok['fc_51_socio_01_declara_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_51_socio_01_declara_irpf'; }                    
                    if ($Xok['fc_51_socio_01_declara_irpf']=='Não')
                    {
                          if (empty($Xok['fc_53_socio_01_eleitor']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_53_socio_01_eleitor'; }
                    } else 
                      {
                          if (empty($Xok['fc_52_socio_01_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_52_socio_01_irpf'; }
                      }                    
                    if (empty($Xok['fc_54_socio_01_capital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_54_socio_01_capital'; }
                    if (empty($Xok['fc_55_socio_01_pisinss']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_55_socio_01_pisinss'; }
                    if (empty($Xok['fc_56_socio_01_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_56_socio_01_rua'; }
                    if (empty($Xok['fc_57_socio_01_numero']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_57_socio_01_numero'; }
                    //if (empty($Xok['fc_58_socio_01_complemento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_58_socio_01_complemento'; }
                    if (empty($Xok['fc_59_socio_01_bairro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_59_socio_01_bairro'; }
                    if (empty($Xok['fc_60_socio_01_cidade']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_60_socio_01_cidade'; }
                    if (empty($Xok['fc_61_socio_01_uf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_61_socio_01_uf'; }
                    if (empty($Xok['fc_62_socio_01_cep']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_62_socio_01_cep'; }
                  break;
                case '2':
                    if (empty($Xok['fc_40_socio_01_nome']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_40_socio_01_nome'; }
                    if (empty($Xok['fc_41_socio_01_rg']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_41_socio_01_rg'; }
                    if (empty($Xok['fc_42_socio_01_cpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_42_socio_01_cpf'; }
                    //if (empty($Xok['fc_43_socio_01_documento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_43_socio_01_documento'; }
                    if ($Xok['fc_43_socio_01_documento']=='RG e CPF')
                    {
                        if (empty($Xok['fc_44_socio_01_rgdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_44_socio_01_rgdigital'; }
                        if (empty($Xok['fc_45_socio_01_cpfdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_45_socio_01_cpfdigital'; }
                    } else if ($Xok['fc_43_socio_01_documento']=='CNH (Carteira de motorista)')
                      {
                        if (empty($Xok['fc_46_socio_01_cnhdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_46_socio_01_cnhdigital'; }
                      }
                    if (empty($Xok['fc_47_socio_01_mae']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_47_socio_01_mae'; }
//                    if (empty($Xok['fc_48_socio_01_estadocivil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_48_socio_01_estadocivil'; }
//                    if (empty($Xok['fc_49_socio_01_regimecasamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_49_socio_01_regimecasamento'; }                  
                    if ($Xok['fc_48_socio_01_estadocivil']=='Casado')
                    {
                          if (empty($Xok['fc_49_socio_01_regimecasamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_49_socio_01_regimecasamento'; }
                    } else 
                      {
                          if (empty($Xok['fc_48_socio_01_estadocivil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_48_socio_01_estadocivil'; }
                      }                    if (empty($Xok['fc_50_socio_01_profissao']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_50_socio_01_profissao'; }
                    //if (empty($Xok['fc_51_socio_01_declara_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_51_socio_01_declara_irpf'; }                    
                    if ($Xok['fc_51_socio_01_declara_irpf']=='Não')
                    {
                          if (empty($Xok['fc_53_socio_01_eleitor']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_53_socio_01_eleitor'; }
                    } else 
                      {
                          if (empty($Xok['fc_52_socio_01_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_52_socio_01_irpf'; }
                      }                    
                    if (empty($Xok['fc_54_socio_01_capital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_54_socio_01_capital'; }
                    if (empty($Xok['fc_55_socio_01_pisinss']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_55_socio_01_pisinss'; }
                    if (empty($Xok['fc_56_socio_01_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_56_socio_01_rua'; }
                    if (empty($Xok['fc_57_socio_01_numero']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_57_socio_01_numero'; }
                    //if (empty($Xok['fc_58_socio_01_complemento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_58_socio_01_complemento'; }
                    if (empty($Xok['fc_59_socio_01_bairro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_59_socio_01_bairro'; }
                    if (empty($Xok['fc_60_socio_01_cidade']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_60_socio_01_cidade'; }
                    if (empty($Xok['fc_61_socio_01_uf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_61_socio_01_uf'; }
                    if (empty($Xok['fc_62_socio_01_cep']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_62_socio_01_cep'; }
                    //if (empty($Xok['fc_66_socio_02_documento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'Campo'; }
                    if ($Xok['fc_66_socio_02_documento'] == 'RG e CPF')
                    {
                        if (empty($Xok['fc_67_socio_02_rgdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_67_socio_02_rgdigital'; }
                        if (empty($Xok['fc_68_socio_02_cpfdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_68_socio_02_cpfdigital'; }
                    } else if ($Xok['fc_66_socio_02_documento'] == 'CNH (Carteira de motorista)')
                      {
                        if (empty($Xok['fc_69_socio_02_cnhdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_69_socio_02_cnhdigital'; }
                      }                                        
                    if (empty($Xok['fc_70_socio_02_mae']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_70_socio_02_mae'; }
                    //if (empty($Xok['fc_71_socio_02_estadocivil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_71_socio_02_estadocivil'; }
                    //if (empty($Xok['fc_72_socio_02_regimecasamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_72_socio_02_regimecasamento'; }
                    if ($Xok['fc_71_socio_02_estadocivil']=='Casado')
                    {
                          if (empty($Xok['fc_72_socio_02_regimecasamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_72_socio_02_regimecasamento'; }
                    } else 
                      {
                          if (empty($Xok['fc_71_socio_02_estadocivil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_71_socio_02_estadocivil'; }
                      }                                                          
                    if (empty($Xok['fc_73_socio_02_profissao']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_73_socio_02_profissao'; }      
                    //if (empty($Xok['fc_74_socio_02_declaraimposto']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_74_socio_02_declaraimposto'; }
                    if ($Xok['fc_74_socio_02_declaraimposto'] == 'Não')
                    {
                          if (empty($Xok['fc_76_socio_02_eleitor']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_76_socio_02_eleitor'; }
                    } else 
                      {
                          if (empty($Xok['fc_75_socio_02_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_75_socio_02_irpf'; }
                      }                                        
                    if (empty($Xok['fc_77_socio_02_capital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_77_socio_02_capital'; }
                    if (empty($Xok['fc_78_socio_02_pisinss']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_78_socio_02_pisinss'; }
                    if (empty($Xok['fc_79_socio_02_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_79_socio_02_rua'; }
                    if (empty($Xok['fc_80_socio_02_numero']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_80_socio_02_numero'; }
                    //if (empty($Xok['fc_81_socio_02_complemento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_81_socio_02_complemento'; }
                    if (empty($Xok['fc_82_socio_02_bairro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_82_socio_02_bairro'; }
                    if (empty($Xok['fc_83_socio_02_cidade']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_83_socio_02_cidade'; }
                    if (empty($Xok['fc_84_socio_02_uf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_84_socio_02_uf'; }
                    if (empty($Xok['fc_85_socio_02_cep']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_85_socio_02_cep'; }
                  break;
                case '3':
                    if (empty($Xok['fc_40_socio_01_nome']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_40_socio_01_nome'; }
                    if (empty($Xok['fc_41_socio_01_rg']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_41_socio_01_rg'; }
                    if (empty($Xok['fc_42_socio_01_cpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_42_socio_01_cpf'; }
                    //if (empty($Xok['fc_43_socio_01_documento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_43_socio_01_documento'; }
                    if ($Xok['fc_43_socio_01_documento']=='RG e CPF')
                    {
                        if (empty($Xok['fc_44_socio_01_rgdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_44_socio_01_rgdigital'; }
                        if (empty($Xok['fc_45_socio_01_cpfdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_45_socio_01_cpfdigital'; }
                    } else if ($Xok['fc_43_socio_01_documento']=='CNH (Carteira de motorista)')
                      {
                        if (empty($Xok['fc_46_socio_01_cnhdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_46_socio_01_cnhdigital'; }
                      }
                    if (empty($Xok['fc_47_socio_01_mae']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_47_socio_01_mae'; }
//                    if (empty($Xok['fc_48_socio_01_estadocivil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_48_socio_01_estadocivil'; }
//                    if (empty($Xok['fc_49_socio_01_regimecasamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_49_socio_01_regimecasamento'; }                  
                    if ($Xok['fc_48_socio_01_estadocivil']=='Casado')
                    {
                          if (empty($Xok['fc_49_socio_01_regimecasamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_49_socio_01_regimecasamento'; }
                    } else 
                      {
                          if (empty($Xok['fc_48_socio_01_estadocivil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_48_socio_01_estadocivil'; }
                      }                    
                    if (empty($Xok['fc_50_socio_01_profissao']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_50_socio_01_profissao'; }
                    //if (empty($Xok['fc_51_socio_01_declara_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_51_socio_01_declara_irpf'; }                    
                    if ($Xok['fc_51_socio_01_declara_irpf']=='Não')
                    {
                          if (empty($Xok['fc_53_socio_01_eleitor']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_53_socio_01_eleitor'; }
                    } else 
                      {
                          if (empty($Xok['fc_52_socio_01_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_52_socio_01_irpf'; }
                      }                    
                    if (empty($Xok['fc_54_socio_01_capital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_54_socio_01_capital'; }
                    if (empty($Xok['fc_55_socio_01_pisinss']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_55_socio_01_pisinss'; }
                    if (empty($Xok['fc_56_socio_01_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_56_socio_01_rua'; }
                    if (empty($Xok['fc_57_socio_01_numero']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_57_socio_01_numero'; }
                    //if (empty($Xok['fc_58_socio_01_complemento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_58_socio_01_complemento'; }
                    if (empty($Xok['fc_59_socio_01_bairro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_59_socio_01_bairro'; }
                    if (empty($Xok['fc_60_socio_01_cidade']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_60_socio_01_cidade'; }
                    if (empty($Xok['fc_61_socio_01_uf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_61_socio_01_uf'; }
                    if (empty($Xok['fc_62_socio_01_cep']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_62_socio_01_cep'; }
                    //if (empty($Xok['fc_66_socio_02_documento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'Campo'; }
                    if ($Xok['fc_66_socio_02_documento'] == 'RG e CPF')
                    {
                        if (empty($Xok['fc_67_socio_02_rgdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_67_socio_02_rgdigital'; }
                        if (empty($Xok['fc_68_socio_02_cpfdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_68_socio_02_cpfdigital'; }
                    } else if ($Xok['fc_66_socio_02_documento'] == 'CNH (Carteira de motorista)')
                      {
                        if (empty($Xok['fc_69_socio_02_cnhdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_69_socio_02_cnhdigital'; }
                      }                                        
                    if (empty($Xok['fc_70_socio_02_mae']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_70_socio_02_mae'; }
                    if (empty($Xok['fc_71_socio_02_estadocivil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_71_socio_02_estadocivil'; }
                    //if (empty($Xok['fc_71_socio_02_estadocivil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_71_socio_02_estadocivil'; }
                    //if (empty($Xok['fc_72_socio_02_regimecasamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_72_socio_02_regimecasamento'; }
                    if ($Xok['fc_71_socio_02_estadocivil']=='Casado')
                    {
                          if (empty($Xok['fc_72_socio_02_regimecasamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_72_socio_02_regimecasamento'; }
                    } else 
                      {
                          if (empty($Xok['fc_71_socio_02_estadocivil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_71_socio_02_estadocivil'; }
                      }
                    if (empty($Xok['fc_73_socio_02_profissao']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_73_socio_02_profissao'; }                          
                    //if (empty($Xok['fc_74_socio_02_declaraimposto']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_74_socio_02_declaraimposto'; }
                    if ($Xok['fc_74_socio_02_declaraimposto'] == 'Não')
                    {
                          if (empty($Xok['fc_76_socio_02_eleitor']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_76_socio_02_eleitor'; }
                    } else 
                      {
                          if (empty($Xok['fc_75_socio_02_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_75_socio_02_irpf'; }
                      }                                        
                    if (empty($Xok['fc_77_socio_02_capital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_77_socio_02_capital'; }
                    if (empty($Xok['fc_78_socio_02_pisinss']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_78_socio_02_pisinss'; }
                    if (empty($Xok['fc_79_socio_02_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_79_socio_02_rua'; }
                    if (empty($Xok['fc_80_socio_02_numero']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_80_socio_02_numero'; }
                    //if (empty($Xok['fc_81_socio_02_complemento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_81_socio_02_complemento'; }
                    if (empty($Xok['fc_82_socio_02_bairro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_82_socio_02_bairro'; }
                    if (empty($Xok['fc_83_socio_02_cidade']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_83_socio_02_cidade'; }
                    if (empty($Xok['fc_84_socio_02_uf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_84_socio_02_uf'; }
                    if (empty($Xok['fc_85_socio_02_cep']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_85_socio_02_cep'; }                    
                    
                    //socio 3                
                    if (empty($Xok['fc_86_socio_03_nome']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_86_socio_03_nome'; }
                    if (empty($Xok['fc_87_socio_03_rg']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_87_socio_03_rg'; }
                    if (empty($Xok['fc_88_socio_03_cpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_88_socio_03_cpf'; }
                    //if (empty($Xok['fc_89_socio_03_documento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_89_socio_03_documento'; }
                    if ($Xok['fc_89_socio_03_documento']=='RG e CPF')
                    {
                        if (empty($Xok['fc_90_socio_03_rgdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_90_socio_03_rgdigital'; }
                        if (empty($Xok['fc_91_socio_03_cpfdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_91_socio_03_cpfdigital'; }
                    } else if ($Xok['fc_89_socio_03_documento']=='CNH (Carteira de motorista)')
                      {
                        if (empty($Xok['fc_92_socio_03_cnhdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_92_socio_03_cnhdigital'; }
                      }                    
                    if (empty($Xok['fc_93_socio_03_mae']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_93_socio_03_mae'; }
                    //if (empty($Xok['fc_94_socio_03_estadocilvil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_94_socio_03_estadocilvil'; }
                    //if (empty($Xok['fc_95_socio_03_regimecasamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_95_socio_03_regimecasamento'; }
                    if ($Xok['fc_94_socio_03_estadocilvil']=='Casado')
                    {
                          if (empty($Xok['fc_95_socio_03_regimecasamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_95_socio_03_regimecasamento'; }
                    } else 
                      {
                          if (empty($Xok['fc_94_socio_03_estadocilvil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_94_socio_03_estadocilvil'; }
                      }
                    if (empty($Xok['fc_96_socio_03_profissao']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_96_socio_03_profissao'; }                       
                    //if (empty($Xok['fc_97_socio_03_declaraimposto']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_97_socio_03_declaraimposto'; }
                    if ($Xok['fc_97_socio_03_declaraimposto']=='Não')
                    {
                          if (empty($Xok['fc_99_socio_03_eleitor']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_99_socio_03_eleitor'; }
                    } else 
                      {
                          if (empty($Xok['fc_98_socio_03_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_98_socio_03_irpf'; }
                      }                     
                    if (empty($Xok['fc_100_socio_03_capital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_100_socio_03_capital'; }
                    if (empty($Xok['fc_101_socio_03_pisinss']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_101_socio_03_pisinss'; }
                    if (empty($Xok['fc_102_socio_03_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_102_socio_03_rua'; }
                    if (empty($Xok['fc_103_socio_03_numero']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_103_socio_03_numero'; }
                    //if (empty($Xok['fc_104_socio_03_complemento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_104_socio_03_complemento'; }
                    if (empty($Xok['fc_105_socio_03_bairro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_105_socio_03_bairro'; }
                    if (empty($Xok['fc_106_socio_106_socio_03_cidade']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_106_socio_106_socio_03_cidade'; }
                    if (empty($Xok['fc_107_socio_03_uf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_107_socio_03_uf'; }
                    if (empty($Xok['fc_108_socio_03_cep']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_108_socio_03_cep'; }
                  break;
                case '4':
                    if (empty($Xok['fc_40_socio_01_nome']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_40_socio_01_nome'; }
                    if (empty($Xok['fc_41_socio_01_rg']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_41_socio_01_rg'; }
                    if (empty($Xok['fc_42_socio_01_cpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_42_socio_01_cpf'; }
                    //if (empty($Xok['fc_43_socio_01_documento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_43_socio_01_documento'; }
                    if ($Xok['fc_43_socio_01_documento']=='RG e CPF')
                    {
                        if (empty($Xok['fc_44_socio_01_rgdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_44_socio_01_rgdigital'; }
                        if (empty($Xok['fc_45_socio_01_cpfdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_45_socio_01_cpfdigital'; }
                    } else if ($Xok['fc_43_socio_01_documento']=='CNH (Carteira de motorista)')
                      {
                        if (empty($Xok['fc_46_socio_01_cnhdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_46_socio_01_cnhdigital'; }
                      }
                    if (empty($Xok['fc_47_socio_01_mae']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_47_socio_01_mae'; }
//                    if (empty($Xok['fc_48_socio_01_estadocivil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_48_socio_01_estadocivil'; }
//                    if (empty($Xok['fc_49_socio_01_regimecasamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_49_socio_01_regimecasamento'; }                  
                    if ($Xok['fc_48_socio_01_estadocivil']=='Casado')
                    {
                          if (empty($Xok['fc_49_socio_01_regimecasamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_49_socio_01_regimecasamento'; }
                    } else 
                      {
                          if (empty($Xok['fc_48_socio_01_estadocivil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_48_socio_01_estadocivil'; }
                      }
                    if (empty($Xok['fc_50_socio_01_profissao']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_50_socio_01_profissao'; }
                    //if (empty($Xok['fc_51_socio_01_declara_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_51_socio_01_declara_irpf'; }                    
                    if ($Xok['fc_51_socio_01_declara_irpf']=='Não')
                    {
                          if (empty($Xok['fc_53_socio_01_eleitor']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_53_socio_01_eleitor'; }
                    } else 
                      {
                          if (empty($Xok['fc_52_socio_01_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_52_socio_01_irpf'; }
                      }                    
                    if (empty($Xok['fc_54_socio_01_capital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_54_socio_01_capital'; }
                    if (empty($Xok['fc_55_socio_01_pisinss']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_55_socio_01_pisinss'; }
                    if (empty($Xok['fc_56_socio_01_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_56_socio_01_rua'; }
                    if (empty($Xok['fc_57_socio_01_numero']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_57_socio_01_numero'; }
                    //if (empty($Xok['fc_58_socio_01_complemento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_58_socio_01_complemento'; }
                    if (empty($Xok['fc_59_socio_01_bairro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_59_socio_01_bairro'; }
                    if (empty($Xok['fc_60_socio_01_cidade']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_60_socio_01_cidade'; }
                    if (empty($Xok['fc_61_socio_01_uf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_61_socio_01_uf'; }
                    if (empty($Xok['fc_62_socio_01_cep']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_62_socio_01_cep'; }
                    //if (empty($Xok['fc_66_socio_02_documento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'Campo'; }
                    if ($Xok['fc_66_socio_02_documento'] == 'RG e CPF')
                    {
                        if (empty($Xok['fc_67_socio_02_rgdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_67_socio_02_rgdigital'; }
                        if (empty($Xok['fc_68_socio_02_cpfdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_68_socio_02_cpfdigital'; }
                    } else if ($Xok['fc_66_socio_02_documento'] == 'CNH (Carteira de motorista)')
                      {
                        if (empty($Xok['fc_69_socio_02_cnhdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_69_socio_02_cnhdigital'; }
                      }                                        
                    if (empty($Xok['fc_70_socio_02_mae']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_70_socio_02_mae'; }
                    //if (empty($Xok['fc_71_socio_02_estadocivil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_71_socio_02_estadocivil'; }
                    //if (empty($Xok['fc_72_socio_02_regimecasamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_72_socio_02_regimecasamento'; }
                    if ($Xok['fc_71_socio_02_estadocivil']=='Casado')
                    {
                          if (empty($Xok['fc_72_socio_02_regimecasamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_72_socio_02_regimecasamento'; }
                    } else 
                      {
                          if (empty($Xok['fc_71_socio_02_estadocivil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_71_socio_02_estadocivil'; }
                      }                    
                    if (empty($Xok['fc_73_socio_02_profissao']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_73_socio_02_profissao'; }      
                    //if (empty($Xok['fc_74_socio_02_declaraimposto']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_74_socio_02_declaraimposto'; }
                    if ($Xok['fc_74_socio_02_declaraimposto'] == 'Não')
                    {
                          if (empty($Xok['fc_76_socio_02_eleitor']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_76_socio_02_eleitor'; }
                    } else 
                      {
                          if (empty($Xok['fc_75_socio_02_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_75_socio_02_irpf'; }
                      }                                        
                    if (empty($Xok['fc_77_socio_02_capital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_77_socio_02_capital'; }
                    if (empty($Xok['fc_78_socio_02_pisinss']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_78_socio_02_pisinss'; }
                    if (empty($Xok['fc_79_socio_02_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_79_socio_02_rua'; }
                    if (empty($Xok['fc_80_socio_02_numero']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_80_socio_02_numero'; }
                    //if (empty($Xok['fc_81_socio_02_complemento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_81_socio_02_complemento'; }
                    if (empty($Xok['fc_82_socio_02_bairro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_82_socio_02_bairro'; }
                    if (empty($Xok['fc_83_socio_02_cidade']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_83_socio_02_cidade'; }
                    if (empty($Xok['fc_84_socio_02_uf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_84_socio_02_uf'; }
                    if (empty($Xok['fc_85_socio_02_cep']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_85_socio_02_cep'; }                    
                    
                    //socio 3                
                    if (empty($Xok['fc_86_socio_03_nome']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_86_socio_03_nome'; }
                    if (empty($Xok['fc_87_socio_03_rg']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_87_socio_03_rg'; }
                    if (empty($Xok['fc_88_socio_03_cpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_88_socio_03_cpf'; }
                    //if (empty($Xok['fc_89_socio_03_documento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_89_socio_03_documento'; }
                    if ($Xok['fc_89_socio_03_documento']=='RG e CPF')
                    {
                        if (empty($Xok['fc_90_socio_03_rgdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_90_socio_03_rgdigital'; }
                        if (empty($Xok['fc_91_socio_03_cpfdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_91_socio_03_cpfdigital'; }
                    } else if ($Xok['fc_89_socio_03_documento']=='CNH (Carteira de motorista)')
                      {
                        if (empty($Xok['fc_92_socio_03_cnhdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_92_socio_03_cnhdigital'; }
                      }                    
                    if (empty($Xok['fc_93_socio_03_mae']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_93_socio_03_mae'; }
                    //if (empty($Xok['fc_94_socio_03_estadocilvil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_94_socio_03_estadocilvil'; }
                    //if (empty($Xok['fc_95_socio_03_regimecasamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_95_socio_03_regimecasamento'; }
                    if ($Xok['fc_94_socio_03_estadocilvil']=='Casado')
                    {
                          if (empty($Xok['fc_95_socio_03_regimecasamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_95_socio_03_regimecasamento'; }
                    } else 
                      {
                          if (empty($Xok['fc_94_socio_03_estadocilvil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_94_socio_03_estadocilvil'; }
                      }
                    if (empty($Xok['fc_96_socio_03_profissao']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_96_socio_03_profissao'; }
                    if (empty($Xok['fc_96_socio_03_profissao']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_96_socio_03_profissao'; }
                    //if (empty($Xok['fc_97_socio_03_declaraimposto']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_97_socio_03_declaraimposto'; }
                    if ($Xok['fc_97_socio_03_declaraimposto']=='Não')
                    {
                          if (empty($Xok['fc_99_socio_03_eleitor']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_99_socio_03_eleitor'; }
                    } else 
                      {
                          if (empty($Xok['fc_98_socio_03_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_98_socio_03_irpf'; }
                      }                     
                    if (empty($Xok['fc_100_socio_03_capital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_100_socio_03_capital'; }
                    if (empty($Xok['fc_101_socio_03_pisinss']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_101_socio_03_pisinss'; }
                    if (empty($Xok['fc_102_socio_03_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_102_socio_03_rua'; }
                    if (empty($Xok['fc_103_socio_03_numero']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_103_socio_03_numero'; }
                    //if (empty($Xok['fc_104_socio_03_complemento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_104_socio_03_complemento'; }
                    if (empty($Xok['fc_105_socio_03_bairro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_105_socio_03_bairro'; }
                    if (empty($Xok['fc_106_socio_106_socio_03_cidade']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_106_socio_106_socio_03_cidade'; }
                    if (empty($Xok['fc_107_socio_03_uf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_107_socio_03_uf'; }
                    if (empty($Xok['fc_108_socio_03_cep']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_108_socio_03_cep'; }                    
                    
                    // socio 4                
                    if (empty($Xok['fc_109_socio_04_nome']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_109_socio_04_nome'; }
                    if (empty($Xok['fc_110_socio_04_rg']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_110_socio_04_rg'; }
                    if (empty($Xok['fc_111_socio_04_cpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_111_socio_04_cpf'; }
                    //if (empty($Xok['fc_112_socio_04_documento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_112_socio_04_documento'; }
                    if ($Xok['fc_112_socio_04_documento']=='RG e CPF')
                    {
                        if (empty($Xok['fc_113_socio_04_rgdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_113_socio_04_rgdigital'; }
                        if (empty($Xok['fc_114_socio_04_cpfdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_114_socio_04_cpfdigital'; }
                    } else if ($Xok['fc_112_socio_04_documento']=='CNH (Carteira de motorista)')
                      {
                        if (empty($Xok['fc_115_socio_04_cnhdigital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'Campo'; }
                      }                        
                    if (empty($Xok['fc_116_socio_04_mae']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_116_socio_04_mae'; }
                    if (empty($Xok['fc_117_socio_04_estadocivil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_117_socio_04_estadocivil'; }
                    if (empty($Xok['fc_118_socio_04_regimecasamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_118_socio_04_regimecasamento'; }
                    if (empty($Xok['fc_119_socio_04_profissao']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_119_socio_04_profissao'; }
                    //if (empty($Xok['fc_120_socio_04_declaraimposto']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_120_socio_04_declaraimposto'; }
                    if ($Xok['fc_120_socio_04_declaraimposto']=='Não')
                    {
                          if (empty($Xok['fc_122_socio_04_eleitor']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_122_socio_04_eleitor'; }
                    } else 
                      {
                          if (empty($Xok['fc_121_socio_04_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_121_socio_04_irpf'; }
                      }                      
                    if (empty($Xok['fc_123_socio_04_capital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_123_socio_04_capital'; }
                    if (empty($Xok['fc_124_socio_04_pisinss']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_124_socio_04_pisinss'; }
                    if (empty($Xok['fc_125_socio_04_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_125_socio_04_rua'; }
                    if (empty($Xok['fc_126_socio_04_numero']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_126_socio_04_numero'; }
                    //if (empty($Xok['fc_127_socio_04_complemento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'Campo'; }
                    if (empty($Xok['fc_128_socio_04_bairro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_128_socio_04_bairro'; }
                    if (empty($Xok['fc_129_socio_04_cidade']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_129_socio_04_cidade'; }
                    if (empty($Xok['fc_107_socio_04_uf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_107_socio_04_uf'; }
                    if (empty($Xok['fc_131_socio_04_cep']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'fc_131_socio_04_cep'; }
                  break;                                                     
                default:
                  //$XTeste = '';
              }
            
            }
            
            //echo 'final - passou: '; echo  $XTeste ; echo '<br>';
            //print_r($XNomeCampoErro);
            //print_r($XTeste);          
            
            if ($XTeste == 0) {
            
              // Conversão no RD
              $data_rd['email'] = $Xemail;
              $fields = http_build_query($data_rd);
              $ch = curl_init();
              curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/cadastro-completo-finalizado.php");
              curl_setopt($ch, CURLOPT_POST, 1);
              curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
              curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
              $server_output = curl_exec($ch);
              curl_close($ch);
              // Conversão no RD - FIM
            
            $data2['status']           = '1';
            $this->db->where('clientes_fc_id', $param2);
            $this->db->update('clientes_fc', $data2);
            
            $this->session->set_flashdata('flash_message', 'Cadastro Completado com Sucesso!!!');
            redirect(base_url() . 'index.php?client/cadastro_completo/', 'refresh');
            
            } 

            $this->session->set_flashdata('flash_message', $XNomeCampoErro.'<br>Demais Atualizações Realizadas com Sucesso!!!');

            redirect(base_url() . 'index.php?client/empresa_abrir/', 'refresh');

        }


        if ($param1 == 'delete') {

            $data['status']         = 'excluido';
            $this->db->where('clientes_fc_id', $param2);
            $this->db->update('clientes_fc', $data);
            redirect(base_url() . 'index.php?client/empresa_abrir/', 'refresh');

        }
        $page_data['empresa_abrir']     = $this->db->get('clientes_fc')->result_array();
        $page_data['page_name']         = 'empresa_abrir';
        $page_data['page_icon']         = 'user';
        $page_data['page_title']        = 'Abertura Empresa';
        $this->load->view('index', $page_data);
    }

    /***EMPRESA TRAZER***/
    function empresa_trazer ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'do_update') {
        
            $id = $this->input->post('id') ;
            $target_dir = "./crm/arquivos/cadastro_02_trazer_empresa/".$id."_".$this->caracter_model->tira_acento($this->input->post('nome'))."/";        
        
            $XStatus = '8';
        
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['status']           = $XStatus;
            $data['obs']           = $this->input->post('obs');
            $data['te_02_numero_rg']           = $this->input->post('te_02_numero_rg');
            $data['te_03_numero_cpf']           = $this->input->post('te_03_numero_cpf');
            $data['te_04_radio_documentos']           = $this->input->post('te_04_radio_documentos');
            //$data['te_05_rg_digital']           = $this->input->post('te_05_rg_digital');            
            if ( empty($_FILES['file_te_05_rg_digital']['name'])){
                $data['te_05_rg_digital']   = $this->input->post('te_05_rg_digital');
              }  else {
                $data['te_05_rg_digital']   = $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_05_rg_digital']['name']));
                move_uploaded_file($_FILES['file_te_05_rg_digital']['tmp_name'], $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_05_rg_digital']['name'])));
              }              
            //$data['te_06_cpf_digital']           = $this->input->post('te_06_cpf_digital');
            if ( empty($_FILES['file_te_06_cpf_digital']['name'])){
                $data['te_06_cpf_digital']   = $this->input->post('te_06_cpf_digital');
              }  else {
                $data['te_06_cpf_digital']   = $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_06_cpf_digital']['name']));
                move_uploaded_file($_FILES['file_te_06_cpf_digital']['tmp_name'], $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_06_cpf_digital']['name'])));
              }                 
            //$data['te_07_cnh_digital']           = $this->input->post('te_07_cnh_digital');
            if ( empty($_FILES['file_te_07_cnh_digital']['name'])){
                $data['te_07_cnh_digital']   = $this->input->post('te_07_cnh_digital');
              }  else {
                $data['te_07_cnh_digital']   = $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_07_cnh_digital']['name']));
                move_uploaded_file($_FILES['file_te_07_cnh_digital']['tmp_name'], $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_07_cnh_digital']['name'])));
              }             
            $data['te_08_nome_mae']           = $this->input->post('te_08_nome_mae');
            $data['te_09_estado_civil']           = $this->input->post('te_09_estado_civil');
            $data['te_10_regime_casamento']           = $this->input->post('te_10_regime_casamento');
            $data['te_11_opcao_irpf']           = $this->input->post('te_11_opcao_irpf');
            $data['te_12_irpf']           = $this->input->post('te_12_irpf');
            $data['te_13_titulo_eleitor']           = $this->input->post('te_13_titulo_eleitor');
            $data['te_14_nome_empresarial']           = $this->input->post('te_14_nome_empresarial');
            $data['te_15_cnpj']           = $this->input->post('te_15_cnpj');
            $data['te_16_codigo_acesso']           = $this->input->post('te_16_codigo_acesso');
            $data['te_30_numero_funcionarios']           = $this->input->post('te_30_numero_funcionarios');
            //$data['te_17_paginas_contrato']           = $this->input->post('te_17_paginas_contrato');
            if ( empty($_FILES['file_te_17_paginas_contrato']['name'])){
                $data['te_17_paginas_contrato']   = $this->input->post('te_17_paginas_contrato');
              }  else {
                $data['te_17_paginas_contrato']   = $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_17_paginas_contrato']['name']));
                move_uploaded_file($_FILES['file_te_17_paginas_contrato']['tmp_name'], $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_17_paginas_contrato']['name'])));
              }            
            //$data['te_18_contrato_pagina1']           = $this->input->post('te_18_contrato_pagina1');
            if ( empty($_FILES['file_te_18_contrato_pagina1']['name'])){
                $data['te_18_contrato_pagina1']   = $this->input->post('te_18_contrato_pagina1');
              }  else {
                $data['te_18_contrato_pagina1']   = $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_18_contrato_pagina1']['name']));
                move_uploaded_file($_FILES['file_te_18_contrato_pagina1']['tmp_name'], $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_18_contrato_pagina1']['name'])));
              }             
            //$data['te_19_contrato_pagina2']           = $this->input->post('te_19_contrato_pagina2');
            if ( empty($_FILES['file_te_19_contrato_pagina2']['name'])){
                $data['te_19_contrato_pagina2']   = $this->input->post('te_19_contrato_pagina2');
              }  else {
                $data['te_19_contrato_pagina2']   = $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_19_contrato_pagina2']['name']));
                move_uploaded_file($_FILES['file_te_19_contrato_pagina2']['tmp_name'], $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_19_contrato_pagina2']['name'])));
              }           
            //$data['te_20_contrato_pagina3']           = $this->input->post('te_20_contrato_pagina3');
            if ( empty($_FILES['file_te_20_contrato_pagina3']['name'])){
                $data['te_20_contrato_pagina3']   = $this->input->post('te_20_contrato_pagina3');
              }  else {
                $data['te_20_contrato_pagina3']   = $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_20_contrato_pagina3']['name']));
                move_uploaded_file($_FILES['file_te_20_contrato_pagina3']['tmp_name'], $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_20_contrato_pagina3']['name'])));
              }            
            //$data['te_21_contrato_pagina4']           = $this->input->post('te_21_contrato_pagina4');
            if ( empty($_FILES['file_te_21_contrato_pagina4']['name'])){
                $data['te_21_contrato_pagina4']   = $this->input->post('te_21_contrato_pagina4');
              }  else {
                $data['te_21_contrato_pagina4']   = $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_21_contrato_pagina4']['name']));
                move_uploaded_file($_FILES['file_te_21_contrato_pagina4']['tmp_name'], $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_21_contrato_pagina4']['name'])));
              }             
            //$data['te_40_contrato_pagina5']           = $this->input->post('te_40_contrato_pagina5');
            if ( empty($_FILES['file_te_40_contrato_pagina5']['name'])){
                $data['te_40_contrato_pagina5']   = $this->input->post('te_40_contrato_pagina5');
              }  else {
                $data['te_40_contrato_pagina5']   = $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_40_contrato_pagina5']['name']));
                move_uploaded_file($_FILES['file_te_40_contrato_pagina5']['tmp_name'], $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_40_contrato_pagina5']['name'])));
              }              
            //$data['te_41_contrato_pagina6']           = $this->input->post('te_41_contrato_pagina6');
            if ( empty($_FILES['file_te_41_contrato_pagina6']['name'])){
                $data['te_41_contrato_pagina6']   = $this->input->post('te_41_contrato_pagina6');
              }  else {
                $data['te_41_contrato_pagina6']   = $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_41_contrato_pagina6']['name']));
                move_uploaded_file($_FILES['file_te_41_contrato_pagina6']['tmp_name'], $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_41_contrato_pagina6']['name'])));
              }             
            //$data['te_42_contrato_pagina7']           = $this->input->post('te_42_contrato_pagina7');
            if ( empty($_FILES['file_te_42_contrato_pagina7']['name'])){
                $data['te_42_contrato_pagina7']   = $this->input->post('te_42_contrato_pagina7');
              }  else {
                $data['te_42_contrato_pagina7']   = $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_42_contrato_pagina7']['name']));
                move_uploaded_file($_FILES['file_te_42_contrato_pagina7']['tmp_name'], $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_42_contrato_pagina7']['name'])));
              }              
            //$data['te_43_contrato_pagina8']           = $this->input->post('te_43_contrato_pagina8');
            if ( empty($_FILES['file_te_43_contrato_pagina8']['name'])){
                $data['te_43_contrato_pagina8']   = $this->input->post('te_43_contrato_pagina8');
              }  else {
                $data['te_43_contrato_pagina8']   = $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_43_contrato_pagina8']['name']));
                move_uploaded_file($_FILES['file_te_43_contrato_pagina8']['tmp_name'], $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_43_contrato_pagina8']['name'])));
              }              
            //$data['te_21_alvara']           = $this->input->post('te_21_alvara');
            if ( empty($_FILES['file_te_21_alvara']['name'])){                $data['te_21_alvara']   = $this->input->post('te_21_alvara');
              }  else {
                $data['te_21_alvara']   = $target_dir.$id."_alvara_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_21_alvara']['name']));
                move_uploaded_file($_FILES['file_te_21_alvara']['tmp_name'], $target_dir.$id."_alvara_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_21_alvara']['name'])));
              }               
            $data['te_22_tem_certificado']           = $this->input->post('te_22_tem_certificado');
            //$data['te_23_certificado_digital']           = $this->input->post('te_23_certificado_digital');
            if ( empty($_FILES['file_te_23_certificado_digital']['name'])){
                $data['te_23_certificado_digital']   = $this->input->post('te_23_certificado_digital');
              }  else {
                $data['te_23_certificado_digital']   = $target_dir.$id."_cert_digi_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_23_certificado_digital']['name']));
                move_uploaded_file($_FILES['file_te_23_certificado_digital']['tmp_name'], $target_dir.$id."_vert_digi_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_23_certificado_digital']['name'])));
              }             
            $data['te_24_certificado_senha']           = $this->input->post('te_24_certificado_senha');
            $data['te_25_numero_socios']           = $this->input->post('te_25_numero_socios');
            //$data['te_26_doc_socio01']           = $this->input->post('te_26_doc_socio01');
            if ( empty($_FILES['file_te_26_doc_socio01']['name'])){
                $data['te_26_doc_socio01']   = $this->input->post('te_26_doc_socio01');
              }  else {
                $data['te_26_doc_socio01']   = $target_dir.$id."_doc_soc_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_26_doc_socio01']['name']));
                move_uploaded_file($_FILES['file_te_26_doc_socio01']['tmp_name'], $target_dir.$id."_doc_soc_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_26_doc_socio01']['name'])));
              } 
            //$data['te_27_doc_socio02']           = $this->input->post('te_27_doc_socio02');
            if ( empty($_FILES['file_te_27_doc_socio02']['name'])){
                $data['te_27_doc_socio02']   = $this->input->post('te_27_doc_socio02');
              }  else {
                $data['te_27_doc_socio02']   = $target_dir.$id."_doc_soc_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_27_doc_socio02']['name']));
                move_uploaded_file($_FILES['file_te_27_doc_socio02']['tmp_name'], $target_dir.$id."_doc_soc_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_27_doc_socio02']['name'])));
              }             
            //$data['te_28_doc_socio03']           = $this->input->post('te_28_doc_socio03');
            if ( empty($_FILES['file_te_28_doc_socio03']['name'])){
                $data['te_28_doc_socio03']   = $this->input->post('te_28_doc_socio03');
              }  else {
                $data['te_28_doc_socio03']   = $target_dir.$id."_doc_soc_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_28_doc_socio03']['name']));
                move_uploaded_file($_FILES['file_te_28_doc_socio03']['tmp_name'], $target_dir.$id."_doc_soc_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_28_doc_socio03']['name'])));
              }             
            //$data['te_29_doc_socio04']           = $this->input->post('te_29_doc_socio04');
            if ( empty($_FILES['file_te_29_doc_socio04']['name'])){
                $data['te_29_doc_socio04']   = $this->input->post('te_29_doc_socio04');
              }  else {
                $data['te_29_doc_socio04']   = $target_dir.$id."_doc_soc_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_29_doc_socio04']['name']));
                move_uploaded_file($_FILES['file_te_29_doc_socio04']['tmp_name'], $target_dir.$id."_doc_soc_".strtolower($this->caracter_model->tira_acento($_FILES['file_te_29_doc_socio04']['name'])));
              }             

            $this->db->where('clientes_te_id', $param2);
            $this->db->update('clientes_te', $data);

            //var_dump($Xdados);
            // verifica se o cadastro esta completo
            
            $XTeste = 0;
            $XNomeCampoErro = 'Campos AINDA NÃO preenchidos ';
            
            $Xdados = $this->db->get_where('clientes_te', array('clientes_te_id' => $param2))->result_array();
            $Xemail = $this->db->get_where('clientes_te', array('clientes_te_id' => $param2))->row()->email;
           
            //var_dump($Xdados);
           
            foreach($Xdados as $Xok) {
            
                if (empty($Xok['nome']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'nome'; }
                if (empty($Xok['email']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'email'; }
                if (empty($Xok['telefone']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'telefone'; }
                //if (empty($Xok['data_cadastro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'data_cadastro'; }
                //if (empty($Xok['status']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'status'; }
                //if (empty($Xok['obs']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'obs'; }
                if (empty($Xok['te_02_numero_rg']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_02_numero_rg'; }
                if (empty($Xok['te_03_numero_cpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_03_numero_cpf'; }
    
                if ($Xok['te_04_radio_documentos']=='RG e CPF')
                {
                    if (empty($Xok['te_05_rg_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_05_rg_digital'; }
                    if (empty($Xok['te_06_cpf_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_06_cpf_digital'; }
                } else if ($Xok['te_04_radio_documentos']=='CNH (Carteira de motorista)')
                  {
                    if (empty($Xok['te_07_cnh_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_07_cnh_digital'; }
                  }
                if (empty($Xok['te_08_nome_mae']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_08_nome_mae'; }
    //            if (empty($Xok['te_09_estado_civil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_09_estado_civil'; }
    //            if (empty($Xok['te_10_regime_casamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_10_regime_casamento'; }
                if ($Xok['te_09_estado_civil']=='Casado')
                {
                      if (empty($Xok['te_10_regime_casamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_10_regime_casamento'; }
                } else 
                  {
                      if (empty($Xok['te_09_estado_civil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_09_estado_civil'; }
                  } 
                //if (empty($Xok['te_11_opcao_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_11_opcao_irpf'; }
                if ($Xok['te_11_opcao_irpf']=='Não')
                {
                      if (empty($Xok['te_13_titulo_eleitor']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_13_titulo_eleitor'; }
                } else 
                  {
                      if (empty($Xok['te_12_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_12_irpf'; }
                  }
    	  
                if (empty($Xok['te_14_nome_empresarial']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_14_nome_empresarial'; }
                if (empty($Xok['te_15_cnpj']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_15_cnpj'; }
                if (empty($Xok['te_16_codigo_acesso']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_16_codigo_acesso'; }
    			      //if (empty($Xok['te_30_numero_funcionarios']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_30_numero_funcionarios'; }
    						            
                if ($Xok['te_22_tem_certificado']=='SIM')
                {
                    if (empty($Xok['te_23_certificado_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_23_certificado_digital'; }
    				        if (empty($Xok['te_24_certificado_senha']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_24_certificado_senha'; }
    				
                }          
			
		        switch ($Xok['te_17_paginas_contrato']) {
                case '1':
                    if (empty($Xok['te_18_contrato_pagina1']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_18_contrato_pagina1'; }
                  break;
                case '2':
					          if (empty($Xok['te_18_contrato_pagina1']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_18_contrato_pagina1'; }
                    if (empty($Xok['te_19_contrato_pagina2']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_19_contrato_pagina2'; }
                  break;
                case '3':
					          if (empty($Xok['te_18_contrato_pagina1']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_18_contrato_pagina1'; }
                    if (empty($Xok['te_19_contrato_pagina2']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_19_contrato_pagina2'; }				
                    if (empty($Xok['te_20_contrato_pagina3']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_20_contrato_pagina3'; }
                  break;
                case '4':
					          if (empty($Xok['te_18_contrato_pagina1']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_18_contrato_pagina1'; }
                    if (empty($Xok['te_19_contrato_pagina2']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_19_contrato_pagina2'; }				
                    if (empty($Xok['te_20_contrato_pagina3']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_20_contrato_pagina3'; }				
                    if (empty($Xok['te_21_contrato_pagina4']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_21_contrato_pagina4'; }
                  break;
                case '5':
					          if (empty($Xok['te_18_contrato_pagina1']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_18_contrato_pagina1'; }
                    if (empty($Xok['te_19_contrato_pagina2']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_19_contrato_pagina2'; }				
                    if (empty($Xok['te_20_contrato_pagina3']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_20_contrato_pagina3'; }				
                    if (empty($Xok['te_21_contrato_pagina4']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_21_contrato_pagina4'; }				
                    if (empty($Xok['te_40_contrato_pagina5']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_40_contrato_pagina5'; }
                  break;
                case '6':
					          if (empty($Xok['te_18_contrato_pagina1']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_18_contrato_pagina1'; }
                    if (empty($Xok['te_19_contrato_pagina2']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_19_contrato_pagina2'; }				
                    if (empty($Xok['te_20_contrato_pagina3']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_20_contrato_pagina3'; }				
                    if (empty($Xok['te_21_contrato_pagina4']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_21_contrato_pagina4'; }				
                    if (empty($Xok['te_40_contrato_pagina5']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_40_contrato_pagina5'; }				
                    if (empty($Xok['te_41_contrato_pagina6']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_41_contrato_pagina6'; }
                  break;
                case '7':
					          if (empty($Xok['te_18_contrato_pagina1']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_18_contrato_pagina1'; }
                    if (empty($Xok['te_19_contrato_pagina2']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_19_contrato_pagina2'; }				
                    if (empty($Xok['te_20_contrato_pagina3']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_20_contrato_pagina3'; }				
                    if (empty($Xok['te_21_contrato_pagina4']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_21_contrato_pagina4'; }				
                    if (empty($Xok['te_40_contrato_pagina5']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_40_contrato_pagina5'; }				
                    if (empty($Xok['te_41_contrato_pagina6']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_41_contrato_pagina6'; }				
                    if (empty($Xok['te_42_contrato_pagina7']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_42_contrato_pagina7'; }
                  break;
                case '8':
					          if (empty($Xok['te_18_contrato_pagina1']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_18_contrato_pagina1'; }
                    if (empty($Xok['te_19_contrato_pagina2']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_19_contrato_pagina2'; }				
                    if (empty($Xok['te_20_contrato_pagina3']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_20_contrato_pagina3'; }				
                    if (empty($Xok['te_21_contrato_pagina4']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_21_contrato_pagina4'; }				
                    if (empty($Xok['te_40_contrato_pagina5']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_40_contrato_pagina5'; }				
                    if (empty($Xok['te_41_contrato_pagina6']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_41_contrato_pagina6'; }				
                    if (empty($Xok['te_42_contrato_pagina7']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_42_contrato_pagina7'; }				
                    if (empty($Xok['te_43_contrato_pagina8']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_43_contrato_pagina8'; }
                  break;				  
                default:
                  //$XTeste = '';
              }
			  
			        switch ($Xok['te_25_numero_socios']) {
                case '1':
                    if (empty($Xok['te_26_doc_socio01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_26_doc_socio01'; }
                  break;
                case '2':
					          if (empty($Xok['te_26_doc_socio01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_26_doc_socio01'; }
                    if (empty($Xok['te_27_doc_socio02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_27_doc_socio02'; }
                  break;
                case '3':
                    if (empty($Xok['te_26_doc_socio01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_26_doc_socio01'; }
                    if (empty($Xok['te_27_doc_socio02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_27_doc_socio02'; }				
                    if (empty($Xok['te_28_doc_socio03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_28_doc_socio03'; }
                  break;
                case '4':
                    if (empty($Xok['te_26_doc_socio01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_26_doc_socio01'; }
                    if (empty($Xok['te_27_doc_socio02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_27_doc_socio02'; }				
                    if (empty($Xok['te_28_doc_socio03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_28_doc_socio03'; }				
                    if (empty($Xok['te_29_doc_socio04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'te_29_doc_socio04'; }
                  break;				  
                default:
                  //$XTeste = '';
              }
            
            }
            
            //echo 'final - passou: '; echo  $XTeste ; echo '<br>';
            //print_r($XNomeCampoErro);       
            
            if ($XTeste == 0) {
            
              // Conversão no RD
              $data_rd['email'] = $Xemail;
              $fields = http_build_query($data_rd);
              $ch = curl_init();
              curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/cadastro-completo-finalizado.php");
              curl_setopt($ch, CURLOPT_POST, 1);
              curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
              curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
              $server_output = curl_exec($ch);
              curl_close($ch);
              // Conversão no RD - FIM
            
            $data2['status']           = '1';
            $this->db->where('clientes_te_id', $param2);
            $this->db->update('clientes_te', $data2);
            
            $this->session->set_flashdata('flash_message', 'Cadastro Completado com Sucesso!!!');
            redirect(base_url() . 'index.php?client/cadastro_completo/', 'refresh');
            
            } 

            $this->session->set_flashdata('flash_message', $XNomeCampoErro.'<br>Demais Atualizações Realizadas com Sucesso!!!');

            redirect(base_url() . 'index.php?client/empresa_trazer/', 'refresh');

        }


        if ($param1 == 'delete') {

            $data['status']         = 'excluido';
            $this->db->where('clientes_te_id', $param2);
            $this->db->update('clientes_te', $data);
            redirect(base_url() . 'index.php?client/empresa_trazer/', 'refresh');

        }
        $page_data['empresa_trazer']     = $this->db->get('clientes_te')->result_array();
        $page_data['page_name']         = 'empresa_trazer';
        $page_data['page_icon']         = 'user';
        $page_data['page_title']        = 'Trazer Empresa';
        $this->load->view('index', $page_data);
    }

    /***MEI ABERTURA***/
    function mei_abrir ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'do_update') {
        
            $id = $this->input->post('id') ;
            $target_dir = "./crm/arquivos/cadastro_04_abrir_mei/".$id."_".$this->caracter_model->tira_acento($this->input->post('nome'))."/";        
            
            $XStatus = '8';
                
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['status']           = $XStatus;
            $data['obs']           = $this->input->post('obs');
            $data['ma_02_numero_rg']           = $this->input->post('ma_02_numero_rg');
            $data['ma_03_numero_cpf']           = $this->input->post('ma_03_numero_cpf');
            $data['ma_04_radio_documentos']           = $this->input->post('ma_04_radio_documentos');
            //$data['ma_05_rg_digital']           = $this->input->post('ma_05_rg_digital');            
            if ( empty($_FILES['file_ma_05_rg_digital']['name'])){
                $data['ma_05_rg_digital']   = $this->input->post('ma_05_rg_digital');
              }  else {
                $data['ma_05_rg_digital']   = $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ma_05_rg_digital']['name']));
                move_uploaded_file($_FILES['file_ma_05_rg_digital']['tmp_name'], $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ma_05_rg_digital']['name'])));
              }              
            //$data['ma_06_cpf_digital']           = $this->input->post('ma_06_cpf_digital');
            if ( empty($_FILES['file_ma_06_cpf_digital']['name'])){
                $data['ma_06_cpf_digital']   = $this->input->post('ma_06_cpf_digital');
              }  else {
                $data['ma_06_cpf_digital']   = $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ma_06_cpf_digital']['name']));
                move_uploaded_file($_FILES['file_ma_06_cpf_digital']['tmp_name'], $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ma_06_cpf_digital']['name'])));
              }                 
            //$data['ma_07_cnh_digital']           = $this->input->post('ma_07_cnh_digital');
            if ( empty($_FILES['file_ma_07_cnh_digital']['name'])){
                $data['ma_07_cnh_digital']   = $this->input->post('ma_07_cnh_digital');
              }  else {
                $data['ma_07_cnh_digital']   = $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ma_07_cnh_digital']['name']));
                move_uploaded_file($_FILES['file_ma_07_cnh_digital']['tmp_name'], $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ma_07_cnh_digital']['name'])));
              } 
            $data['ma_08_nome_mae']           = $this->input->post('ma_08_nome_mae');
            $data['ma_11_opcao_irpf']           = $this->input->post('ma_11_opcao_irpf');
            $data['ma_12_irpf']           = $this->input->post('ma_12_irpf');
            $data['ma_13_titulo_eleitor']           = $this->input->post('ma_13_titulo_eleitor');
            $data['ma_14_nome_rua']           = $this->input->post('ma_14_nome_rua');
            $data['ma_15_numero_rua']           = $this->input->post('ma_15_numero_rua');
            $data['ma_16_complemento']           = $this->input->post('ma_16_complemento');
            $data['ma_17_bairro']           = $this->input->post('ma_17_bairro');
            $data['ma_18_cidade']           = $this->input->post('ma_18_cidade');
            $data['ma_19_uf']           = $this->input->post('ma_19_uf');
            $data['ma_20_cep']           = $this->input->post('ma_20_cep');
            $data['ma_24_nome_fantasia']           = $this->input->post('ma_24_nome_fantasia');
            $data['ma_40_numero_funcionarios']           = $this->input->post('ma_40_numero_funcionarios');
            $data['ma_26_endereco_referencia']           = $this->input->post('ma_26_endereco_referencia');
            $data['ma_27_nome_rua']           = $this->input->post('ma_27_nome_rua');
            $data['ma_28_numero_rua']           = $this->input->post('ma_28_numero_rua');
            $data['ma_29_complemento']           = $this->input->post('ma_29_complemento');
            $data['ma_30_bairro']           = $this->input->post('ma_30_bairro');
            $data['ma_31_cidade']           = $this->input->post('ma_31_cidade');
            $data['ma_32_uf']           = $this->input->post('ma_32_uf');
            $data['ma_33_cep']           = $this->input->post('ma_33_cep');
            $data['ma_34_iptu_empresa']           = $this->input->post('ma_34_iptu_empresa');
            $data['ma_35_atividades']           = $this->input->post('ma_35_atividades');
            $data['ma_36_capital_social']           = $this->input->post('ma_36_capital_social');

            $this->db->where('clientes_ma_id', $param2);
            $this->db->update('clientes_ma', $data);

                        //var_dump($Xdados);
            // verifica se o cadastro esta completo
            
            $XTeste = 0;
            $XNomeCampoErro = 'Campos AINDA NÃO preenchidos ';
            
            $Xdados = $this->db->get_where('clientes_ma', array('clientes_ma_id' => $param2))->result_array();
            $Xemail = $this->db->get_where('clientes_ma', array('clientes_ma_id' => $param2))->row()->email;
           
            //var_dump($Xdados);
           
            foreach($Xdados as $Xok) {

      			      if (empty($Xok['nome']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'nome'; }
                  if (empty($Xok['email']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'email'; }
                  if (empty($Xok['telefone']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'telefone'; }
                  //if (empty($Xok['data_cadastro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'data_cadastro'; }
                  //if (empty($Xok['status']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'status'; }
                  //if (empty($Xok['obs']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'obs'; }
                  if (empty($Xok['ma_02_numero_rg']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_02_numero_rg'; }
                  if (empty($Xok['ma_03_numero_cpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_03_numero_cpf'; }
      
                  if ($Xok['ma_04_radio_documentos']=='RG e CPF')
                  {
                      if (empty($Xok['ma_05_rg_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_05_rg_digital'; }
                      if (empty($Xok['ma_06_cpf_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_06_cpf_digital'; }
                  } else if ($Xok['ma_04_radio_documentos']=='CNH (Carteira de motorista)')
                    {
                      if (empty($Xok['ma_07_cnh_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_07_cnh_digital'; }
                    }
                  if (empty($Xok['ma_08_nome_mae']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_08_nome_mae'; }
      //            if (empty($Xok['ma_09_estado_civil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_09_estado_civil'; }
      //            if (empty($Xok['ma_10_regime_casamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_10_regime_casamento'; }
      //            if ($Xok['ma_09_estado_civil']=='Casado')
      //            {
      //                  if (empty($Xok['ma_10_regime_casamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_10_regime_casamento'; }
      //            } else 
      //              {
      //                  if (empty($Xok['ma_09_estado_civil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_09_estado_civil'; }
      //              }
                  //if (empty($Xok['ma_11_opcao_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_11_opcao_irpf'; }
                  if ($Xok['ma_11_opcao_irpf']=='Não')
                  {
                        if (empty($Xok['ma_13_titulo_eleitor']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_13_titulo_eleitor'; }
                  } else 
                    {
                        if (empty($Xok['ma_12_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_12_irpf'; }
                    }            
                  if (empty($Xok['ma_14_nome_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_14_nome_rua'; }
                  if (empty($Xok['ma_15_numero_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_15_numero_rua'; }
                  //if (empty($Xok['ma_16_complemento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_16_complemento'; }
                  if (empty($Xok['ma_17_bairro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_17_bairro'; }
                  if (empty($Xok['ma_18_cidade']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_18_cidade'; }
                  if (empty($Xok['ma_19_uf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_19_uf'; }
                  if (empty($Xok['ma_20_cep']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_20_cep'; }
                  //if (empty($Xok['ma_21_nome_empresa01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_21_nome_empresa01'; }
                  //if (empty($Xok['ma_22_nome_empresa02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_22_nome_empresa02'; }
                  //if (empty($Xok['ma_23_nome_empresa03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_23_nome_empresa03'; }
                  if (empty($Xok['ma_24_nome_fantasia']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_24_nome_fantasia'; }
                  //if (empty($Xok['ma_25_data_inicio']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_25_data_inicio'; }
                  //if (empty($Xok['ma_40_numero_funcionarios'])) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_40_numero_funcionarios'; } 
                  //if (empty($Xok['ma_26_endereco_referencia']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_26_endereco_referencia'; }
                  if ($Xok['ma_26_endereco_referencia']=='Endereço Residencial')
                  {
                      if (empty($Xok['ma_34_iptu_empresa']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_34_iptu_empresa'; }
                  } else 
                    {
                      if (empty($Xok['ma_34_iptu_empresa']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_34_iptu_empresa'; }
                      //wrp - 20/04/2018if (empty($Xok['ma_27_nome_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_27_nome_rua'; }
                      //wrp - 20/04/2018if (empty($Xok['ma_28_numero_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_28_numero_rua'; }
                      //if (empty($Xok['ma_29_complemento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_29_complemento'; }
                      //wrp - 20/04/2018 - if (empty($Xok['ma_30_bairro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_30_bairro'; }
                      //wrp - 20/04/2018if (empty($Xok['ma_31_cidade']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_31_cidade'; }
                      //wrp - 20/04/2018if (empty($Xok['ma_32_uf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_32_uf'; }
                      //wrp - 20/04/2018if (empty($Xok['ma_33_cep']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_33_cep'; }
                    }
                  
      
                  if (empty($Xok['ma_35_atividades']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_35_atividades'; }
                  if (empty($Xok['ma_36_capital_social']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ma_36_capital_social'; }

            
            }
            
            //echo 'final - passou: '; echo  $XTeste ; echo '<br>';
            //print_r($XNomeCampoErro);
            //print_r($XTeste);          
            
            if ($XTeste == 0) {
            
              // Conversão no RD
              $data_rd['email'] = $Xemail;
              $fields = http_build_query($data_rd);
              $ch = curl_init();
              curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/cadastro-completo-finalizado.php");
              curl_setopt($ch, CURLOPT_POST, 1);
              curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
              curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
              $server_output = curl_exec($ch);
              curl_close($ch);
              // Conversão no RD - FIM
            
            $data2['status']           = '1';
            $this->db->where('clientes_ma_id', $param2);
            $this->db->update('clientes_ma', $data2);
            
            $this->session->set_flashdata('flash_message', 'Cadastro Completado com Sucesso!!!');
            redirect(base_url() . 'index.php?client/cadastro_completo/', 'refresh');
            
            }

            $this->session->set_flashdata('flash_message', $XNomeCampoErro.'<br>Demais Atualizações Realizadas com Sucesso!!!');

            redirect(base_url() . 'index.php?client/mei_abrir/', 'refresh');

        }

        if ($param1 == 'delete') {

            $data['status']         = 'excluido';
            $this->db->where('clientes_ma_id', $param2);
            $this->db->update('clientes_ma', $data);
            redirect(base_url() . 'index.php?client/mei_abrir/', 'refresh');

        }
        $page_data['mei_abrir']     = $this->db->get('clientes_ma')->result_array();
        $page_data['page_name']         = 'mei_abrir';
        $page_data['page_icon']         = 'user';
        $page_data['page_title']        = 'Abertura MEI';
        $this->load->view('index', $page_data);
    }

    /***MEI TRAZER***/
    function mei_trazer ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'do_update') {
        
            $id = $this->input->post('id') ;
            $target_dir = "./crm/arquivos/cadastro_05_trazer_mei/".$id."_".$this->caracter_model->tira_acento($this->input->post('nome'))."/";        
            
            $XStatus = '8';
                
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['status']           = $XStatus;
            $data['obs']           = $this->input->post('obs');
            $data['mt_02_numero_rg']           = $this->input->post('mt_02_numero_rg');
            $data['mt_03_numero_cpf']           = $this->input->post('mt_03_numero_cpf');
            $data['mt_04_radio_documentos']           = $this->input->post('mt_04_radio_documentos');
            //$data['mt_05_rg_digital']           = $this->input->post('mt_05_rg_digital');           
            if ( empty($_FILES['file_mt_05_rg_digital']['name'])){
                $data['mt_05_rg_digital']   = $this->input->post('mt_05_rg_digital');
              }  else {
                $data['mt_05_rg_digital']   = $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_mt_05_rg_digital']['name']));
                move_uploaded_file($_FILES['file_mt_05_rg_digital']['tmp_name'], $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_mt_05_rg_digital']['name'])));
              }              
            //$data['mt_06_cpf_digital']           = $this->input->post('mt_06_cpf_digital');
            if ( empty($_FILES['file_mt_06_cpf_digital']['name'])){
                $data['mt_06_cpf_digital']   = $this->input->post('mt_06_cpf_digital');
              }  else {
                $data['mt_06_cpf_digital']   = $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_mt_06_cpf_digital']['name']));
                move_uploaded_file($_FILES['file_mt_06_cpf_digital']['tmp_name'], $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_mt_06_cpf_digital']['name'])));
              }                 
            //$data['mt_07_cnh_digital']           = $this->input->post('mt_07_cnh_digital');
            if ( empty($_FILES['file_mt_07_cnh_digital']['name'])){
                $data['mt_07_cnh_digital']   = $this->input->post('mt_07_cnh_digital');
              }  else {
                $data['mt_07_cnh_digital']   = $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_mt_07_cnh_digital']['name']));
                move_uploaded_file($_FILES['file_mt_07_cnh_digital']['tmp_name'], $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_mt_07_cnh_digital']['name'])));
              } 
            $data['mt_14_nome_empresarial']           = $this->input->post('mt_14_nome_empresarial');
            $data['mt_15_cnpj']           = $this->input->post('mt_15_cnpj');
            $data['mt_16_codigo_acesso']           = $this->input->post('mt_16_codigo_acesso');
            $data['mt_25_numero_funcionarios']           = $this->input->post('mt_25_numero_funcionarios');
            $data['mt_17_paginas_contrato']           = $this->input->post('mt_17_paginas_contrato');
            //$data['mt_18_contrato_pagina1']           = $this->input->post('mt_18_contrato_pagina1');
            if ( empty($_FILES['file_mt_18_contrato_pagina1']['name'])){
                $data['mt_18_contrato_pagina1']   = $this->input->post('mt_18_contrato_pagina1');
              }  else {
                $data['mt_18_contrato_pagina1']   = $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_mt_18_contrato_pagina1']['name']));
                move_uploaded_file($_FILES['file_mt_18_contrato_pagina1']['tmp_name'], $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_mt_18_contrato_pagina1']['name'])));
              } 
            //$data['mt_19_contrato_pagina2']           = $this->input->post('mt_19_contrato_pagina2');
            if ( empty($_FILES['file_mt_19_contrato_pagina2']['name'])){
                $data['mt_19_contrato_pagina2']   = $this->input->post('mt_19_contrato_pagina2');
              }  else {
                $data['mt_19_contrato_pagina2']   = $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_mt_19_contrato_pagina2']['name']));
                move_uploaded_file($_FILES['file_mt_19_contrato_pagina2']['tmp_name'], $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_mt_19_contrato_pagina2']['name'])));
              } 
            //$data['mt_21_alvara']           = $this->input->post('mt_21_alvara');
            if ( empty($_FILES['file_mt_21_alvara']['name'])){
                $data['mt_21_alvara']   = $this->input->post('mt_21_alvara');
              }  else {
                $data['mt_21_alvara']   = $target_dir.$id."_alvara_".strtolower($this->caracter_model->tira_acento($_FILES['file_mt_21_alvara']['name']));
                move_uploaded_file($_FILES['file_mt_21_alvara']['tmp_name'], $target_dir.$id."_alvara_".strtolower($this->caracter_model->tira_acento($_FILES['file_mt_21_alvara']['name'])));
              } 
            $data['mt_22_tem_certificado']           = $this->input->post('mt_22_tem_certificado');
            //$data['mt_23_certificado_digital']           = $this->input->post('mt_23_certificado_digital');
            if ( empty($_FILES['file_mt_23_certificado_digital']['name'])){
                $data['mt_23_certificado_digital']   = $this->input->post('mt_23_certificado_digital');
              }  else {
                $data['mt_23_certificado_digital']   = $target_dir.$id."_cert_digi_".strtolower($this->caracter_model->tira_acento($_FILES['file_mt_23_certificado_digital']['name']));
                move_uploaded_file($_FILES['file_mt_23_certificado_digital']['tmp_name'], $target_dir.$id."_cert_digi_".strtolower($this->caracter_model->tira_acento($_FILES['file_mt_23_certificado_digital']['name'])));
              } 
            $data['mt_24_certificado_senha']           = $this->input->post('mt_24_certificado_senha');

            $this->db->where('clientes_mt_id', $param2);
            $this->db->update('clientes_mt', $data);

            //var_dump($Xdados);
            // verifica se o cadastro esta completo
            
            $XTeste = 0;
            $XNomeCampoErro = 'Campos AINDA NÃO preenchidos ';
            
            $Xdados = $this->db->get_where('clientes_mt', array('clientes_mt_id' => $param2))->result_array();
            $Xemail = $this->db->get_where('clientes_mt', array('clientes_mt_id' => $param2))->row()->email;
           
            foreach($Xdados as $Xok) {
            
                  if (empty($Xok['nome']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'nome'; }
                  if (empty($Xok['email']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'email'; }
                  if (empty($Xok['telefone']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'telefone'; }
                  //if (empty($Xok['data_cadastro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'data_cadastro'; }
                  //if (empty($Xok['status']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'status'; }
                  //if (empty($Xok['obs']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'obs'; }
                  if (empty($Xok['mt_02_numero_rg']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'mt_02_numero_rg'; }
                  if (empty($Xok['mt_03_numero_cpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'mt_03_numero_cpf'; }
      
                  if ($Xok['mt_04_radio_documentos']=='RG e CPF')
                  {
                      if (empty($Xok['mt_05_rg_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'mt_05_rg_digital'; }
                      if (empty($Xok['mt_06_cpf_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'mt_06_cpf_digital'; }
                  } else if ($Xok['mt_04_radio_documentos']=='CNH (Carteira de motorista)')
                    {
                      if (empty($Xok['mt_07_cnh_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'mt_07_cnh_digital'; }
                    }
        
                  if (empty($Xok['mt_14_nome_empresarial']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'mt_14_nome_empresarial'; }
                  if (empty($Xok['mt_15_cnpj']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'mt_15_cnpj'; }
                  if (empty($Xok['mt_16_codigo_acesso']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'mt_16_codigo_acesso'; }
      			//if (empty($Xok['mt_25_numero_funcionarios']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'mt_25_numero_funcionarios'; }
      			//if (empty($Xok['mt_21_alvara']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'mt_21_alvara'; }
      			            
                  if ($Xok['mt_22_tem_certificado']=='SIM')
                  {
                      if (empty($Xok['mt_23_certificado_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'mt_23_certificado_digital'; }
                      if (empty($Xok['mt_24_certificado_senha']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'mt_24_certificado_senha'; }
      				
                  }          
      			
                  switch ($Xok['mt_17_paginas_contrato']) {
                      case '1':
                          if (empty($Xok['mt_18_contrato_pagina1']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'mt_18_contrato_pagina1'; }
                        break;
                      case '2':
                          if (empty($Xok['mt_18_contrato_pagina1']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'mt_18_contrato_pagina1'; }
                          if (empty($Xok['mt_19_contrato_pagina2']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'mt_19_contrato_pagina2'; }
                        break;				  
                      default:
                        //$XTeste = '';
                    }
            
            }
            
            //echo 'final - passou: '; echo  $XTeste ; echo '<br>';
            //print_r($XNomeCampoErro);
            //print_r($XTeste);          
            
            if ($XTeste == 0) {
            
              // Conversão no RD
              $data_rd['email'] = $Xemail;
              $fields = http_build_query($data_rd);
              $ch = curl_init();
              curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/cadastro-completo-finalizado.php");
              curl_setopt($ch, CURLOPT_POST, 1);
              curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
              curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
              $server_output = curl_exec($ch);
              curl_close($ch);
              // Conversão no RD - FIM
            
            $data2['status']           = '1';
            $this->db->where('clientes_mt_id', $param2);
            $this->db->update('clientes_mt', $data2);
            
            $this->session->set_flashdata('flash_message', 'Cadastro Completado com Sucesso!!!');
            redirect(base_url() . 'index.php?client/cadastro_completo/', 'refresh');
            
            } 
            $this->session->set_flashdata('flash_message', $XNomeCampoErro.'<br>Demais Atualizações Realizadas com Sucesso!!!');

            redirect(base_url() . 'index.php?client/mei_trazer/', 'refresh');

        }


        if ($param1 == 'delete') {

            $data['status']         = 'excluido';
            $this->db->where('clientes_mt_id', $param2);
            $this->db->update('clientes_mt', $data);
            redirect(base_url() . 'index.php?client/mei_trazer/', 'refresh');

        }
        $page_data['mei_trazer']     = $this->db->get('clientes_mt')->result_array();
        $page_data['page_name']         = 'mei_trazer';
        $page_data['page_icon']         = 'user';
        $page_data['page_title']        = 'Trazer MEI';
        $this->load->view('index', $page_data);
    }
    
    /***COMERCIO ABRIR***/
    function comercio_abrir ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'do_update') {
        
            $id = $this->input->post('id') ;
            $target_dir = "./crm/arquivos/cadastro_06_abrir_comercio/".$id."_".$this->caracter_model->tira_acento($this->input->post('nome'))."/";        
            
            $XStatus = '8';
                      
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['status']           = $XStatus;
            $data['ac_numero_rg']           = $this->input->post('ac_numero_rg');
            $data['ac_numero_cpf']           = $this->input->post('ac_numero_cpf');
            $data['ac_opcao_documentos']           = $this->input->post('ac_opcao_documentos');
            //$data['ac_rg_digital']           = $this->input->post('ac_rg_digital');           
            if ( empty($_FILES['file_ac_rg_digital']['name'])){
                $data['ac_rg_digital']   = $this->input->post('ac_rg_digital');
              }  else {
                $data['ac_rg_digital']   = $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_rg_digital']['name']));
                move_uploaded_file($_FILES['file_ac_rg_digital']['tmp_name'], $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_rg_digital']['name'])));
              }              
            //$data['ac_cpf_digital']           = $this->input->post('ac_cpf_digital');
            if ( empty($_FILES['file_ac_cpf_digital']['name'])){
                $data['ac_cpf_digital']   = $this->input->post('ac_cpf_digital');
              }  else {
                $data['ac_cpf_digital']   = $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cpf_digital']['name']));
                move_uploaded_file($_FILES['file_ac_cpf_digital']['tmp_name'], $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cpf_digital']['name'])));
              }                 
            //$data['ac_cnh_digital']           = $this->input->post('ac_cnh_digital');
            if ( empty($_FILES['file_ac_cnh_digital']['name'])){
                $data['ac_cnh_digital']   = $this->input->post('ac_cnh_digital');
              }  else {
                $data['ac_cnh_digital']   = $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cnh_digital']['name']));
                move_uploaded_file($_FILES['file_ac_cnh_digital']['tmp_name'], $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cnh_digital']['name'])));
              } 
            $data['ac_nome_mae']           = $this->input->post('ac_nome_mae');
            $data['ac_estado_civil']           = $this->input->post('ac_estado_civil');
            $data['ac_regime_casamento']           = $this->input->post('ac_regime_casamento');
            $data['ac_declara_irpf']           = $this->input->post('ac_declara_irpf');
            $data['ac_ultimo_irpf']           = $this->input->post('ac_ultimo_irpf');
            $data['ac_titulo_eleitor']           = $this->input->post('ac_titulo_eleitor');
            $data['ac_residencial_cep']           = $this->input->post('ac_residencial_cep');
            $data['ac_residencial_rua']           = $this->input->post('ac_residencial_rua');
            $data['ac_residencial_numero']           = $this->input->post('ac_residencial_numero');
            $data['ac_residencial_complemento']           = $this->input->post('ac_residencial_complemento');
            $data['ac_residencial_bairro']           = $this->input->post('ac_residencial_bairro');
            $data['ac_residencial_cidade']           = $this->input->post('ac_residencial_cidade');
            $data['ac_residencial_uf']           = $this->input->post('ac_residencial_uf');
            $data['ac_nome_empresa_01']           = $this->input->post('ac_nome_empresa_01');
            $data['ac_nome_empresa_02']           = $this->input->post('ac_nome_empresa_02');
            $data['ac_nome_empresa_03']           = $this->input->post('ac_nome_empresa_03');
            $data['ac_nome_fantasia']           = $this->input->post('ac_nome_fantasia');
            $data['ac_numero_funcionarios']           = $this->input->post('ac_numero_funcionarios');
            //$data['ac_cert_bombeiros']           = $this->input->post('ac_cert_bombeiros');
            if ( empty($_FILES['file_ac_cert_bombeiros']['name'])){
                $data['ac_cert_bombeiros']   = $this->input->post('ac_cert_bombeiros');
              }  else {
                $data['ac_cert_bombeiros']   = $target_dir.$id."_certbomb_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cert_bombeiros']['name']));
                move_uploaded_file($_FILES['file_ac_cert_bombeiros']['tmp_name'], $target_dir.$id."_certbomb_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cert_bombeiros']['name'])));
              } 
            $data['ac_comercial_cep']           = $this->input->post('ac_comercial_cep');
            $data['ac_comercial_rua']           = $this->input->post('ac_comercial_rua');
            $data['ac_comercial_numero']           = $this->input->post('ac_comercial_numero');
            $data['ac_comercial_complemento']           = $this->input->post('ac_comercial_complemento');
            $data['ac_comercial_bairro']           = $this->input->post('ac_comercial_bairro');
            $data['ac_comercial_cidade']           = $this->input->post('ac_comercial_cidade');
            $data['ac_comercial_uf']           = $this->input->post('ac_comercial_uf');
            $data['ac_numero_iptu']           = $this->input->post('ac_numero_iptu');
            $data['ac_atividades']           = $this->input->post('ac_atividades');
            $data['ac_capital_social']           = $this->input->post('ac_capital_social');
            $data['ac_socio_administrador']           = $this->input->post('ac_socio_administrador');
            $data['ac_retirada_pro_labore']           = $this->input->post('ac_retirada_pro_labore');
            $data['ac_qtd_socios']           = $this->input->post('ac_qtd_socios');
            $data['ac_nome_completo_socio_01']           = $this->input->post('ac_nome_completo_socio_01');
            $data['ac_numero_rg_socio_01']           = $this->input->post('ac_numero_rg_socio_01');
            $data['ac_numero_cpf_socio_01']           = $this->input->post('ac_numero_cpf_socio_01');
            $data['ac_opcao_documentos_socio_01']           = $this->input->post('ac_opcao_documentos_socio_01');
            //$data['ac_rg_digital_socio_01']           = $this->input->post('ac_rg_digital_socio_01');
            if ( empty($_FILES['file_ac_rg_digital_socio_01']['name'])){
                $data['ac_rg_digital_socio_01']   = $this->input->post('ac_rg_digital_socio_01');
              }  else {
                $data['ac_rg_digital_socio_01']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_rg_digital_socio_01']['name']));
                move_uploaded_file($_FILES['file_ac_rg_digital_socio_01']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_rg_digital_socio_01']['name'])));
              } 
            //$data['ac_cpf_digital_socio_01']           = $this->input->post('ac_cpf_digital_socio_01');
            if ( empty($_FILES['file_ac_cpf_digital_socio_01']['name'])){
                $data['ac_cpf_digital_socio_01']   = $this->input->post('ac_cpf_digital_socio_01');
              }  else {
                $data['ac_cpf_digital_socio_01']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cpf_digital_socio_01']['name']));
                move_uploaded_file($_FILES['file_ac_cpf_digital_socio_01']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cpf_digital_socio_01']['name'])));
              } 
            //$data['ac_cnh_digital_socio_01']           = $this->input->post('ac_cnh_digital_socio_01');
            if ( empty($_FILES['file_ac_cnh_digital_socio_01']['name'])){
                $data['ac_cnh_digital_socio_01']   = $this->input->post('ac_cnh_digital_socio_01');
              }  else {
                $data['ac_cnh_digital_socio_01']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cnh_digital_socio_01']['name']));
                move_uploaded_file($_FILES['file_ac_cnh_digital_socio_01']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cnh_digital_socio_01']['name'])));
              } 
            $data['ac_nome_mae_socio_01']           = $this->input->post('ac_nome_mae_socio_01');
            $data['ac_estado_civil_socio_01']           = $this->input->post('ac_estado_civil_socio_01');
            $data['ac_regime_casamento_socio_01']           = $this->input->post('ac_regime_casamento_socio_01');
            $data['ac_profissao_socio_01']           = $this->input->post('ac_profissao_socio_01');
            $data['ac_declara_irpf_socio_01']           = $this->input->post('ac_declara_irpf_socio_01');
            $data['ac_ultimo_irpf_socio_01']           = $this->input->post('ac_ultimo_irpf_socio_01');
            $data['ac_titulo_eleitor_socio_01']           = $this->input->post('ac_titulo_eleitor_socio_01');
            $data['ac_capital_social_socio_01']           = $this->input->post('ac_capital_social_socio_01');
            $data['ac_numero_pis_inss_socio_01']           = $this->input->post('ac_numero_pis_inss_socio_01');
            $data['ac_residencial_cep_socio_01']           = $this->input->post('ac_residencial_cep_socio_01');
            $data['ac_residencial_rua_socio_01']           = $this->input->post('ac_residencial_rua_socio_01');
            $data['ac_residencial_numero_socio_01']           = $this->input->post('ac_residencial_numero_socio_01');
            $data['ac_residencial_complemento_socio_01']           = $this->input->post('ac_residencial_complemento_socio_01');
            $data['ac_residencial_bairro_socio_01']           = $this->input->post('ac_residencial_bairro_socio_01');
            $data['ac_residencial_cidade_socio_01']           = $this->input->post('ac_residencial_cidade_socio_01');
            $data['ac_residencial_uf_socio_01']           = $this->input->post('ac_residencial_uf_socio_01');
            $data['ac_nome_completo_socio_02']           = $this->input->post('ac_nome_completo_socio_02');
            $data['ac_numero_rg_socio_02']           = $this->input->post('ac_numero_rg_socio_02');
            $data['ac_numero_cpf_socio_02']           = $this->input->post('ac_numero_cpf_socio_02');
            $data['ac_opcao_documentos_socio_02']           = $this->input->post('ac_opcao_documentos_socio_02');
            //$data['ac_rg_digital_socio_02']           = $this->input->post('ac_rg_digital_socio_02');
            if ( empty($_FILES['file_ac_rg_digital_socio_02']['name'])){
                $data['ac_rg_digital_socio_02']   = $this->input->post('ac_rg_digital_socio_02');
              }  else {
                $data['ac_rg_digital_socio_02']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_rg_digital_socio_02']['name']));
                move_uploaded_file($_FILES['file_ac_rg_digital_socio_02']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_rg_digital_socio_02']['name'])));
              } 
            //$data['ac_cpf_digital_socio_02']           = $this->input->post('ac_cpf_digital_socio_02');
            if ( empty($_FILES['file_ac_cpf_digital_socio_02']['name'])){
                $data['ac_cpf_digital_socio_02']   = $this->input->post('ac_cpf_digital_socio_02');
              }  else {
                $data['ac_cpf_digital_socio_02']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cpf_digital_socio_02']['name']));
                move_uploaded_file($_FILES['file_ac_cpf_digital_socio_02']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cpf_digital_socio_02']['name'])));
              } 
            //$data['ac_cnh_digital_socio_02']           = $this->input->post('ac_cnh_digital_socio_02');
            if ( empty($_FILES['file_ac_cnh_digital_socio_02']['name'])){
                $data['ac_cnh_digital_socio_02']   = $this->input->post('ac_cnh_digital_socio_02');
              }  else {
                $data['ac_cnh_digital_socio_02']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cnh_digital_socio_02']['name']));
                move_uploaded_file($_FILES['file_ac_cnh_digital_socio_02']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cnh_digital_socio_02']['name'])));
              } 
            $data['ac_nome_mae_socio_02']           = $this->input->post('ac_nome_mae_socio_02');
            $data['ac_estado_civil_socio_02']           = $this->input->post('ac_estado_civil_socio_02');
            $data['ac_regime_casamento_socio_02']           = $this->input->post('ac_regime_casamento_socio_02');
            $data['ac_profissao_socio_02']           = $this->input->post('ac_profissao_socio_02');
            $data['ac_declara_irpf_socio_02']           = $this->input->post('ac_declara_irpf_socio_02');
            $data['ac_ultimo_irpf_socio_02']           = $this->input->post('ac_ultimo_irpf_socio_02');
            $data['ac_titulo_eleitor_socio_02']           = $this->input->post('ac_titulo_eleitor_socio_02');
            $data['ac_capital_social_socio_02']           = $this->input->post('ac_capital_social_socio_02');
            $data['ac_numero_pis_inss_socio_02']           = $this->input->post('ac_numero_pis_inss_socio_02');
            $data['ac_residencial_cep_socio_02']           = $this->input->post('ac_residencial_cep_socio_02');
            $data['ac_residencial_rua_socio_02']           = $this->input->post('ac_residencial_rua_socio_02');
            $data['ac_residencial_numero_socio_02']           = $this->input->post('ac_residencial_numero_socio_02');
            $data['ac_residencial_complemento_socio_02']           = $this->input->post('ac_residencial_complemento_socio_02');
            $data['ac_residencial_bairro_socio_02']           = $this->input->post('ac_residencial_bairro_socio_02');
            $data['ac_residencial_cidade_socio_02']           = $this->input->post('ac_residencial_cidade_socio_02');
            $data['ac_residencial_uf_socio_02']           = $this->input->post('ac_residencial_uf_socio_02');
            $data['ac_nome_completo_socio_03']           = $this->input->post('ac_nome_completo_socio_03');
            $data['ac_numero_rg_socio_03']           = $this->input->post('ac_numero_rg_socio_03');
            $data['ac_numero_cpf_socio_03']           = $this->input->post('ac_numero_cpf_socio_03');
            $data['ac_opcao_documentos_socio_03']           = $this->input->post('ac_opcao_documentos_socio_03');
            //$data['ac_rg_digital_socio_03']           = $this->input->post('ac_rg_digital_socio_03');
            if ( empty($_FILES['file_ac_rg_digital_socio_03']['name'])){
                $data['ac_rg_digital_socio_03']   = $this->input->post('ac_rg_digital_socio_03');
              }  else {
                $data['ac_rg_digital_socio_03']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_rg_digital_socio_03']['name']));
                move_uploaded_file($_FILES['file_ac_rg_digital_socio_03']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_rg_digital_socio_03']['name'])));
              } 
            //$data['ac_cpf_digital_socio_03']           = $this->input->post('ac_cpf_digital_socio_03');
            if ( empty($_FILES['file_ac_cpf_digital_socio_03']['name'])){
                $data['ac_cpf_digital_socio_03']   = $this->input->post('ac_cpf_digital_socio_03');
              }  else {
                $data['ac_cpf_digital_socio_03']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cpf_digital_socio_03']['name']));
                move_uploaded_file($_FILES['file_ac_cpf_digital_socio_03']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cpf_digital_socio_03']['name'])));
              } 
            //$data['ac_cnh_digital_socio_03']           = $this->input->post('ac_cnh_digital_socio_03');
            if ( empty($_FILES['file_ac_cnh_digital_socio_03']['name'])){
                $data['ac_cnh_digital_socio_03']   = $this->input->post('ac_cnh_digital_socio_03');
              }  else {
                $data['ac_cnh_digital_socio_03']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cnh_digital_socio_03']['name']));
                move_uploaded_file($_FILES['file_ac_cnh_digital_socio_03']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cnh_digital_socio_03']['name'])));
              } 
            $data['ac_nome_mae_socio_03']           = $this->input->post('ac_nome_mae_socio_03');
            $data['ac_estado_civil_socio_03']           = $this->input->post('ac_estado_civil_socio_03');
            $data['ac_regime_casamento_socio_03']           = $this->input->post('ac_regime_casamento_socio_03');
            $data['ac_profissao_socio_03']           = $this->input->post('ac_profissao_socio_03');
            $data['ac_declara_irpf_socio_03']           = $this->input->post('ac_declara_irpf_socio_03');
            $data['ac_ultimo_irpf_socio_03']           = $this->input->post('ac_ultimo_irpf_socio_03');
            $data['ac_titulo_eleitor_socio_03']           = $this->input->post('ac_titulo_eleitor_socio_03');
            $data['ac_capital_social_socio_03']           = $this->input->post('ac_capital_social_socio_03');
            $data['ac_numero_pis_inss_socio_03']           = $this->input->post('ac_numero_pis_inss_socio_03');
            $data['ac_residencial_cep_socio_03']           = $this->input->post('ac_residencial_cep_socio_03');
            $data['ac_residencial_rua_socio_03']           = $this->input->post('ac_residencial_rua_socio_03');
            $data['ac_residencial_numero_socio_03']           = $this->input->post('ac_residencial_numero_socio_03');
            $data['ac_residencial_complemento_socio_03']           = $this->input->post('ac_residencial_complemento_socio_03');
            $data['ac_residencial_bairro_socio_03']           = $this->input->post('ac_residencial_bairro_socio_03');
            $data['ac_residencial_cidade_socio_03']           = $this->input->post('ac_residencial_cidade_socio_03');
            $data['ac_residencial_uf_socio_03']           = $this->input->post('ac_residencial_uf_socio_03');
            $data['ac_nome_completo_socio_04']           = $this->input->post('ac_nome_completo_socio_04');
            $data['ac_numero_rg_socio_04']           = $this->input->post('ac_numero_rg_socio_04');
            $data['ac_numero_cpf_socio_04']           = $this->input->post('ac_numero_cpf_socio_04');
            $data['ac_opcao_documentos_socio_04']           = $this->input->post('ac_opcao_documentos_socio_04');
            //$data['ac_rg_digital_socio_04']           = $this->input->post('ac_rg_digital_socio_04');
            if ( empty($_FILES['file_ac_rg_digital_socio_04']['name'])){
                $data['ac_rg_digital_socio_04']   = $this->input->post('ac_rg_digital_socio_04');
              }  else {
                $data['ac_rg_digital_socio_04']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_rg_digital_socio_04']['name']));
                move_uploaded_file($_FILES['file_ac_rg_digital_socio_04']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_rg_digital_socio_04']['name'])));
              } 
            //$data['ac_cpf_digital_socio_04']           = $this->input->post('ac_cpf_digital_socio_04');
            if ( empty($_FILES['file_ac_cpf_digital_socio_04']['name'])){
                $data['ac_cpf_digital_socio_04']   = $this->input->post('ac_cpf_digital_socio_04');
              }  else {
                $data['ac_cpf_digital_socio_04']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cpf_digital_socio_04']['name']));
                move_uploaded_file($_FILES['file_ac_cpf_digital_socio_04']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cpf_digital_socio_04']['name'])));
              } 
            //$data['ac_cnh_digital_socio_04']           = $this->input->post('ac_cnh_digital_socio_04');
            if ( empty($_FILES['file_ac_cnh_digital_socio_04']['name'])){
                $data['ac_cnh_digital_socio_04']   = $this->input->post('ac_cnh_digital_socio_04');
              }  else {
                $data['ac_cnh_digital_socio_04']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cnh_digital_socio_04']['name']));
                move_uploaded_file($_FILES['file_ac_cnh_digital_socio_04']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_ac_cnh_digital_socio_04']['name'])));
              } 
            $data['ac_nome_mae_socio_04']           = $this->input->post('ac_nome_mae_socio_04');
            $data['ac_estado_civil_socio_04']           = $this->input->post('ac_estado_civil_socio_04');
            $data['ac_regime_casamento_socio_04']           = $this->input->post('ac_regime_casamento_socio_04');
            $data['ac_profissao_socio_04']           = $this->input->post('ac_profissao_socio_04');
            $data['ac_declara_irpf_socio_04']           = $this->input->post('ac_declara_irpf_socio_04');
            $data['ac_ultimo_irpf_socio_04']           = $this->input->post('ac_ultimo_irpf_socio_04');
            $data['ac_titulo_eleitor_socio_04']           = $this->input->post('ac_titulo_eleitor_socio_04');
            $data['ac_capital_social_socio_04']           = $this->input->post('ac_capital_social_socio_04');
            $data['ac_numero_pis_inss_socio_04']           = $this->input->post('ac_numero_pis_inss_socio_04');
            $data['ac_residencial_cep_socio_04']           = $this->input->post('ac_residencial_cep_socio_04');
            $data['ac_residencial_rua_socio_04']           = $this->input->post('ac_residencial_rua_socio_04');
            $data['ac_residencial_numero_socio_04']           = $this->input->post('ac_residencial_numero_socio_04');
            $data['ac_residencial_complemento_socio_04']           = $this->input->post('ac_residencial_complemento_socio_04');
            $data['ac_residencial_bairro_socio_04']           = $this->input->post('ac_residencial_bairro_socio_04');
            $data['ac_residencial_cidade_socio_04']           = $this->input->post('ac_residencial_cidade_socio_04');
            $data['ac_residencial_uf_socio_04']           = $this->input->post('ac_residencial_uf_socio_04');


            $this->db->where('clientes_ac_id', $param2);
            $this->db->update('clientes_ac', $data);

            //var_dump($Xdados);
            // verifica se o cadastro esta completo
            
            $XTeste = 0;
            $XNomeCampoErro = 'Campos AINDA NÃO preenchidos ';
            
            $Xdados = $this->db->get_where('clientes_ac', array('clientes_ac_id' => $param2))->result_array();
            $Xemail = $this->db->get_where('clientes_ac', array('clientes_ac_id' => $param2))->row()->email;
           
            foreach($Xdados as $Xok) {
            
                  if (empty($Xok['nome']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'nome'; }
                  if (empty($Xok['email']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'email'; }
                  if (empty($Xok['telefone']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'telefone'; }
                  //if (empty($Xok['data_cadastro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'data_cadastro'; }
                  //if (empty($Xok['status']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'status'; }
                  //if (empty($Xok['obs']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'obs'; }
                  if (empty($Xok['ac_numero_rg']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_rg'; }
                  if (empty($Xok['ac_numero_cpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_cpf'; }
      
                  if ($Xok['ac_opcao_documentos']=='RG e CPF')
                  {
                      if (empty($Xok['ac_rg_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_rg_digital'; }
                      if (empty($Xok['ac_cpf_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cpf_digital'; }
                  } else if ($Xok['ac_opcao_documentos']=='CNH (Carteira de motorista)')
                    {
                      if (empty($Xok['ac_cnh_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cnh_digital'; }
                    }
                  if (empty($Xok['ac_nome_mae']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_mae'; }
                  //if (empty($Xok['ac_estado_civil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil'; }
                  //if (empty($Xok['ac_regime_casamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento'; }
                  if ($Xok['ac_estado_civil']=='Casado')
                  {
                        if (empty($Xok['ac_regime_casamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento'; }
                  } else 
                    {
                        if (empty($Xok['ac_estado_civil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil'; }
                    }            
                  if (empty($Xok['ac_residencial_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_rua'; }
                  if (empty($Xok['ac_residencial_numero']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_numero'; }
                  //if (empty($Xok['ac_residencial_complemento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_complemento'; }
                  if (empty($Xok['ac_residencial_bairro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_bairro'; }
                  if (empty($Xok['ac_residencial_cidade']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cidade'; }
                  if (empty($Xok['ac_residencial_uf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_uf'; }
                  if (empty($Xok['ac_residencial_cep']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cep'; }
                  if (empty($Xok['ac_nome_empresa_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_empresa_01'; }
                  if (empty($Xok['ac_nome_empresa_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_empresa_02'; }
                  if (empty($Xok['ac_nome_empresa_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_empresa_03'; }
                  if (empty($Xok['ac_nome_fantasia']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_fantasia'; }
                  //if (empty($Xok['ac_numero_funcionarios'])) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_funcionarios'; } 
                  //if (empty($Xok['ac_cert_bombeiros']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cert_bombeiros'; }
      
            			if (empty($Xok['ac_comercial_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_comercial_rua'; }
            			if (empty($Xok['ac_comercial_numero']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_comercial_numero'; }
            			//if (empty($Xok['ac_comercial_complemento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_comercial_complemento'; }
            			if (empty($Xok['ac_comercial_bairro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_comercial_bairro'; }
            			if (empty($Xok['ac_comercial_cidade']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_comercial_cidade'; }
            			if (empty($Xok['ac_comercial_uf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_comercial_uf'; }
            			if (empty($Xok['ac_comercial_cep']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_comercial_cep'; }
            			if (empty($Xok['ac_numero_iptu']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_iptu'; }
            			if (empty($Xok['ac_atividades']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_atividades'; }
            			if (empty($Xok['ac_capital_social']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_capital_social'; }
            			if (empty($Xok['ac_socio_administrador']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_socio_administrador'; }
            			if (empty($Xok['ac_retirada_pro_labore']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_retirada_pro_labore'; }


            
            //if (empty($Xok['ac_declara_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_declara_irpf'; }
            if ($Xok['ac_declara_irpf']=='Não')
            {
                  if (empty($Xok['ac_titulo_eleitor']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_titulo_eleitor'; }
            } else 
              {
                  if (empty($Xok['ac_ultimo_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_ultimo_irpf'; }
              }


            //if (empty($Xok['ac_qtd_socios']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_qtd_socios'; }            
            switch ($Xok['ac_qtd_socios']) {
                case '0':
                
                  break;
                case '1':
                    if (empty($Xok['ac_nome_completo_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_completo_socio_01'; }
                    if (empty($Xok['ac_numero_rg_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_rg_socio_01'; }
                    if (empty($Xok['ac_numero_cpf_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_cpf_socio_01'; }
                    //if (empty($Xok['ac_opcao_documentos_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_opcao_documentos_socio_01'; }
                    if ($Xok['ac_opcao_documentos_socio_01']=='RG e CPF')
                    {
                        if (empty($Xok['ac_rg_digital_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_rg_digital_socio_01'; }
                        if (empty($Xok['ac_cpf_digital_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cpf_digital_socio_01'; }
                    } else if ($Xok['ac_opcao_documentos_socio_01']=='CNH (Carteira de motorista)')
                      {
                        if (empty($Xok['ac_cnh_digital_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cnh_digital_socio_01'; }
                      }
                    if (empty($Xok['ac_nome_mae_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_mae_socio_01'; }
          					//if (empty($Xok['ac_estado_civil_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil_socio_01'; }
          					//if (empty($Xok['ac_regime_casamento_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento_socio_01'; }                  
                    if ($Xok['ac_estado_civil_socio_01']=='Casado')
                    {
                          if (empty($Xok['ac_regime_casamento_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento_socio_01'; }
                    } else 
                      {
                          if (empty($Xok['ac_estado_civil_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil_socio_01'; }
                      }                    
                    if (empty($Xok['ac_profissao_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_profissao_socio_01'; }
                    //if (empty($Xok['ac_declara_irpf_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_declara_irpf_socio_01'; }                    
                    if ($Xok['ac_declara_irpf_socio_01']=='Não')
                    {
                          if (empty($Xok['ac_titulo_eleitor_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_titulo_eleitor_socio_01'; }
                    } else 
                      {
                          if (empty($Xok['ac_ultimo_irpf_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_ultimo_irpf_socio_01'; }
                      }                    
                    if (empty($Xok['ac_capital_social_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_capital_social_socio_01'; }
                    if (empty($Xok['ac_numero_pis_inss_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_pis_inss_socio_01'; }
                    if (empty($Xok['ac_residencial_rua_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_rua_socio_01'; }
                    if (empty($Xok['ac_residencial_numero_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_numero_socio_01'; }
                    //if (empty($Xok['ac_residencial_complemento_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_complemento_socio_01'; }
                    if (empty($Xok['ac_residencial_bairro_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_bairro_socio_01'; }
                    if (empty($Xok['ac_residencial_cidade_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cidade_socio_01'; }
                    if (empty($Xok['ac_residencial_uf_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_uf_socio_01'; }
                    if (empty($Xok['ac_residencial_cep_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cep_socio_01'; }
                  break;
                case '2':
                    if (empty($Xok['ac_nome_completo_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_completo_socio_01'; }
                    if (empty($Xok['ac_numero_rg_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_rg_socio_01'; }
                    if (empty($Xok['ac_numero_cpf_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_cpf_socio_01'; }
                    //if (empty($Xok['ac_opcao_documentos_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_opcao_documentos_socio_01'; }
                    if ($Xok['ac_opcao_documentos_socio_01']=='RG e CPF')
                    {
                        if (empty($Xok['ac_rg_digital_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_rg_digital_socio_01'; }
                        if (empty($Xok['ac_cpf_digital_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cpf_digital_socio_01'; }
                    } else if ($Xok['ac_opcao_documentos_socio_01']=='CNH (Carteira de motorista)')
                      {
                        if (empty($Xok['ac_cnh_digital_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cnh_digital_socio_01'; }
                      }
                    if (empty($Xok['ac_nome_mae_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_mae_socio_01'; }
          					//if (empty($Xok['ac_estado_civil_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil_socio_01'; }
          					//if (empty($Xok['ac_regime_casamento_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento_socio_01'; }                  
                    if ($Xok['ac_estado_civil_socio_01']=='Casado')
                    {
                          if (empty($Xok['ac_regime_casamento_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento_socio_01'; }
                    } else 
                      {
                          if (empty($Xok['ac_estado_civil_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil_socio_01'; }
                      }                    
                    if (empty($Xok['ac_profissao_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_profissao_socio_01'; }
                    //if (empty($Xok['ac_declara_irpf_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_declara_irpf_socio_01'; }                    
                    if ($Xok['ac_declara_irpf_socio_01']=='Não')
                    {
                          if (empty($Xok['ac_titulo_eleitor_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_titulo_eleitor_socio_01'; }
                    } else 
                      {
                          if (empty($Xok['ac_ultimo_irpf_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_ultimo_irpf_socio_01'; }
                      }                    
                    if (empty($Xok['ac_capital_social_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_capital_social_socio_01'; }
                    if (empty($Xok['ac_numero_pis_inss_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_pis_inss_socio_01'; }
                    if (empty($Xok['ac_residencial_rua_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_rua_socio_01'; }
                    if (empty($Xok['ac_residencial_numero_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_numero_socio_01'; }
                    //if (empty($Xok['ac_residencial_complemento_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_complemento_socio_01'; }
                    if (empty($Xok['ac_residencial_bairro_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_bairro_socio_01'; }
                    if (empty($Xok['ac_residencial_cidade_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cidade_socio_01'; }
                    if (empty($Xok['ac_residencial_uf_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_uf_socio_01'; }
                    if (empty($Xok['ac_residencial_cep_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cep_socio_01'; }
					
					//socio 2		
                    if (empty($Xok['ac_nome_completo_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_completo_socio_02'; }
                    if (empty($Xok['ac_numero_rg_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_rg_socio_02'; }
                    if (empty($Xok['ac_numero_cpf_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_cpf_socio_02'; }
                    //if (empty($Xok['ac_opcao_documentos_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_opcao_documentos_socio_02'; }
                    if ($Xok['ac_opcao_documentos_socio_02']=='RG e CPF')
                    {
                        if (empty($Xok['ac_rg_digital_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_rg_digital_socio_02'; }
                        if (empty($Xok['ac_cpf_digital_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cpf_digital_socio_02'; }
                    } else if ($Xok['ac_opcao_documentos_socio_02']=='CNH (Carteira de motorista)')
                      {
                        if (empty($Xok['ac_cnh_digital_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cnh_digital_socio_02'; }
                      }
                    if (empty($Xok['ac_nome_mae_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_mae_socio_02'; }
          					//if (empty($Xok['ac_estado_civil_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil_socio_02'; }
          					//if (empty($Xok['ac_regime_casamento_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento_socio_02'; }                  
                    if ($Xok['ac_estado_civil_socio_02']=='Casado')
                    {
                          if (empty($Xok['ac_regime_casamento_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento_socio_02'; }
                    } else 
                      {
                          if (empty($Xok['ac_estado_civil_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil_socio_02'; }
                      }                    
                    if (empty($Xok['ac_profissao_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_profissao_socio_02'; }
                    //if (empty($Xok['ac_declara_irpf_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_declara_irpf_socio_02'; }                    
                    if ($Xok['ac_declara_irpf_socio_02']=='Não')
                    {
                          if (empty($Xok['ac_titulo_eleitor_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_titulo_eleitor_socio_02'; }
                    } else 
                      {
                          if (empty($Xok['ac_ultimo_irpf_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_ultimo_irpf_socio_02'; }
                      }                    
                    if (empty($Xok['ac_capital_social_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_capital_social_socio_02'; }
                    if (empty($Xok['ac_numero_pis_inss_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_pis_inss_socio_02'; }
                    if (empty($Xok['ac_residencial_rua_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_rua_socio_02'; }
                    if (empty($Xok['ac_residencial_numero_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_numero_socio_02'; }
                    //if (empty($Xok['ac_residencial_complemento_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_complemento_socio_02'; }
                    if (empty($Xok['ac_residencial_bairro_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_bairro_socio_02'; }
                    if (empty($Xok['ac_residencial_cidade_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cidade_socio_02'; }
                    if (empty($Xok['ac_residencial_uf_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_uf_socio_02'; }
                    if (empty($Xok['ac_residencial_cep_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cep_socio_02'; }                  
				          break;
                case '3':
                    if (empty($Xok['ac_nome_completo_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_completo_socio_01'; }
                    if (empty($Xok['ac_numero_rg_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_rg_socio_01'; }
                    if (empty($Xok['ac_numero_cpf_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_cpf_socio_01'; }
                    //if (empty($Xok['ac_opcao_documentos_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_opcao_documentos_socio_01'; }
                    if ($Xok['ac_opcao_documentos_socio_01']=='RG e CPF')
                    {
                        if (empty($Xok['ac_rg_digital_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_rg_digital_socio_01'; }
                        if (empty($Xok['ac_cpf_digital_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cpf_digital_socio_01'; }
                    } else if ($Xok['ac_opcao_documentos_socio_01']=='CNH (Carteira de motorista)')
                      {
                        if (empty($Xok['ac_cnh_digital_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cnh_digital_socio_01'; }
                      }
                    if (empty($Xok['ac_nome_mae_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_mae_socio_01'; }
          					//if (empty($Xok['ac_estado_civil_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil_socio_01'; }
          					//if (empty($Xok['ac_regime_casamento_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento_socio_01'; }                  
                    if ($Xok['ac_estado_civil_socio_01']=='Casado')
                    {
                          if (empty($Xok['ac_regime_casamento_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento_socio_01'; }
                    } else 
                      {
                          if (empty($Xok['ac_estado_civil_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil_socio_01'; }
                      }                    
                    if (empty($Xok['ac_profissao_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_profissao_socio_01'; }
                    //if (empty($Xok['ac_declara_irpf_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_declara_irpf_socio_01'; }                    
                    if ($Xok['ac_declara_irpf_socio_01']=='Não')
                    {
                          if (empty($Xok['ac_titulo_eleitor_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_titulo_eleitor_socio_01'; }
                    } else 
                      {
                          if (empty($Xok['ac_ultimo_irpf_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_ultimo_irpf_socio_01'; }
                      }                    
                    if (empty($Xok['ac_capital_social_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_capital_social_socio_01'; }
                    if (empty($Xok['ac_numero_pis_inss_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_pis_inss_socio_01'; }
                    if (empty($Xok['ac_residencial_rua_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_rua_socio_01'; }
                    if (empty($Xok['ac_residencial_numero_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_numero_socio_01'; }
                    //if (empty($Xok['ac_residencial_complemento_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_complemento_socio_01'; }
                    if (empty($Xok['ac_residencial_bairro_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_bairro_socio_01'; }
                    if (empty($Xok['ac_residencial_cidade_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cidade_socio_01'; }
                    if (empty($Xok['ac_residencial_uf_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_uf_socio_01'; }
                    if (empty($Xok['ac_residencial_cep_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cep_socio_01'; }
					
					//socio 2		
                    if (empty($Xok['ac_nome_completo_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_completo_socio_02'; }
                    if (empty($Xok['ac_numero_rg_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_rg_socio_02'; }
                    if (empty($Xok['ac_numero_cpf_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_cpf_socio_02'; }
                    //if (empty($Xok['ac_opcao_documentos_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_opcao_documentos_socio_02'; }
                    if ($Xok['ac_opcao_documentos_socio_02']=='RG e CPF')
                    {
                        if (empty($Xok['ac_rg_digital_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_rg_digital_socio_02'; }
                        if (empty($Xok['ac_cpf_digital_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cpf_digital_socio_02'; }
                    } else if ($Xok['ac_opcao_documentos_socio_02']=='CNH (Carteira de motorista)')
                      {
                        if (empty($Xok['ac_cnh_digital_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cnh_digital_socio_02'; }
                      }
                    if (empty($Xok['ac_nome_mae_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_mae_socio_02'; }
          					//if (empty($Xok['ac_estado_civil_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil_socio_02'; }
          					//if (empty($Xok['ac_regime_casamento_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento_socio_02'; }                  
                              if ($Xok['ac_estado_civil_socio_02']=='Casado')
                    {
                          if (empty($Xok['ac_regime_casamento_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento_socio_02'; }
                    } else 
                      {
                          if (empty($Xok['ac_estado_civil_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil_socio_02'; }
                      }                    
                    if (empty($Xok['ac_profissao_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_profissao_socio_02'; }
                    //if (empty($Xok['ac_declara_irpf_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_declara_irpf_socio_02'; }                    
                    if ($Xok['ac_declara_irpf_socio_02']=='Não')
                    {
                          if (empty($Xok['ac_titulo_eleitor_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_titulo_eleitor_socio_02'; }
                    } else 
                      {
                          if (empty($Xok['ac_ultimo_irpf_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_ultimo_irpf_socio_02'; }
                      }                    
                    if (empty($Xok['ac_capital_social_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_capital_social_socio_02'; }
                    if (empty($Xok['ac_numero_pis_inss_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_pis_inss_socio_02'; }
                    if (empty($Xok['ac_residencial_rua_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_rua_socio_02'; }
                    if (empty($Xok['ac_residencial_numero_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_numero_socio_02'; }
                    //if (empty($Xok['ac_residencial_complemento_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_complemento_socio_02'; }
                    if (empty($Xok['ac_residencial_bairro_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_bairro_socio_02'; }
                    if (empty($Xok['ac_residencial_cidade_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cidade_socio_02'; }
                    if (empty($Xok['ac_residencial_uf_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_uf_socio_02'; }
                    if (empty($Xok['ac_residencial_cep_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cep_socio_02'; }                  
					
					//socio3
                    if (empty($Xok['ac_nome_completo_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_completo_socio_03'; }
                    if (empty($Xok['ac_numero_rg_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_rg_socio_03'; }
                    if (empty($Xok['ac_numero_cpf_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_cpf_socio_03'; }
                    //if (empty($Xok['ac_opcao_documentos_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_opcao_documentos_socio_03'; }
                    if ($Xok['ac_opcao_documentos_socio_03']=='RG e CPF')
                    {
                        if (empty($Xok['ac_rg_digital_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_rg_digital_socio_03'; }
                        if (empty($Xok['ac_cpf_digital_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cpf_digital_socio_03'; }
                    } else if ($Xok['ac_opcao_documentos_socio_03']=='CNH (Carteira de motorista)')
                      {
                        if (empty($Xok['ac_cnh_digital_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cnh_digital_socio_03'; }
                      }
                    if (empty($Xok['ac_nome_mae_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_mae_socio_03'; }
          					//if (empty($Xok['ac_estado_civil_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil_socio_03'; }
          					//if (empty($Xok['ac_regime_casamento_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento_socio_03'; }                  
                    if ($Xok['ac_estado_civil_socio_03']=='Casado')
                    {
                          if (empty($Xok['ac_regime_casamento_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento_socio_03'; }
                    } else 
                      {
                          if (empty($Xok['ac_estado_civil_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil_socio_03'; }
                      }                    
                    if (empty($Xok['ac_profissao_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_profissao_socio_03'; }
                    //if (empty($Xok['ac_declara_irpf_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_declara_irpf_socio_03'; }                    
                    if ($Xok['ac_declara_irpf_socio_03']=='Não')
                    {
                          if (empty($Xok['ac_titulo_eleitor_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_titulo_eleitor_socio_03'; }
                    } else 
                      {
                          if (empty($Xok['ac_ultimo_irpf_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_ultimo_irpf_socio_03'; }
                      }                    
                    if (empty($Xok['ac_capital_social_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_capital_social_socio_03'; }
                    if (empty($Xok['ac_numero_pis_inss_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_pis_inss_socio_03'; }
                    if (empty($Xok['ac_residencial_rua_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_rua_socio_03'; }
                    if (empty($Xok['ac_residencial_numero_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_numero_socio_03'; }
                    //if (empty($Xok['ac_residencial_complemento_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_complemento_socio_03'; }
                    if (empty($Xok['ac_residencial_bairro_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_bairro_socio_03'; }
                    if (empty($Xok['ac_residencial_cidade_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cidade_socio_03'; }
                    if (empty($Xok['ac_residencial_uf_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_uf_socio_03'; }
                    if (empty($Xok['ac_residencial_cep_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cep_socio_03'; }
                  break;
                case '4':
				    if (empty($Xok['ac_nome_completo_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_completo_socio_01'; }
                    if (empty($Xok['ac_numero_rg_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_rg_socio_01'; }
                    if (empty($Xok['ac_numero_cpf_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_cpf_socio_01'; }
                    //if (empty($Xok['ac_opcao_documentos_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_opcao_documentos_socio_01'; }
                    if ($Xok['ac_opcao_documentos_socio_01']=='RG e CPF')
                    {
                        if (empty($Xok['ac_rg_digital_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_rg_digital_socio_01'; }
                        if (empty($Xok['ac_cpf_digital_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cpf_digital_socio_01'; }
                    } else if ($Xok['ac_opcao_documentos_socio_01']=='CNH (Carteira de motorista)')
                      {
                        if (empty($Xok['ac_cnh_digital_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cnh_digital_socio_01'; }
                      }
                    if (empty($Xok['ac_nome_mae_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_mae_socio_01'; }
          					//if (empty($Xok['ac_estado_civil_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil_socio_01'; }
          					//if (empty($Xok['ac_regime_casamento_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento_socio_01'; }                  
                    if ($Xok['ac_estado_civil_socio_01']=='Casado')
                    {
                          if (empty($Xok['ac_regime_casamento_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento_socio_01'; }
                    } else 
                      {
                          if (empty($Xok['ac_estado_civil_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil_socio_01'; }
                      }                    
                    if (empty($Xok['ac_profissao_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_profissao_socio_01'; }
                    //if (empty($Xok['ac_declara_irpf_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_declara_irpf_socio_01'; }                    
                    if ($Xok['ac_declara_irpf_socio_01']=='Não')
                    {
                          if (empty($Xok['ac_titulo_eleitor_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_titulo_eleitor_socio_01'; }
                    } else 
                      {
                          if (empty($Xok['ac_ultimo_irpf_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_ultimo_irpf_socio_01'; }
                      }                    
                    if (empty($Xok['ac_capital_social_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_capital_social_socio_01'; }
                    if (empty($Xok['ac_numero_pis_inss_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_pis_inss_socio_01'; }
                    if (empty($Xok['ac_residencial_rua_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_rua_socio_01'; }
                    if (empty($Xok['ac_residencial_numero_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_numero_socio_01'; }
                    //if (empty($Xok['ac_residencial_complemento_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_complemento_socio_01'; }
                    if (empty($Xok['ac_residencial_bairro_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_bairro_socio_01'; }
                    if (empty($Xok['ac_residencial_cidade_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cidade_socio_01'; }
                    if (empty($Xok['ac_residencial_uf_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_uf_socio_01'; }
                    if (empty($Xok['ac_residencial_cep_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cep_socio_01'; }
					
					//socio 2		
                    if (empty($Xok['ac_nome_completo_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_completo_socio_02'; }
                    if (empty($Xok['ac_numero_rg_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_rg_socio_02'; }
                    if (empty($Xok['ac_numero_cpf_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_cpf_socio_02'; }
                    //if (empty($Xok['ac_opcao_documentos_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_opcao_documentos_socio_02'; }
                    if ($Xok['ac_opcao_documentos_socio_02']=='RG e CPF')
                    {
                        if (empty($Xok['ac_rg_digital_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_rg_digital_socio_02'; }
                        if (empty($Xok['ac_cpf_digital_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cpf_digital_socio_02'; }
                    } else if ($Xok['ac_opcao_documentos_socio_02']=='CNH (Carteira de motorista)')
                      {
                        if (empty($Xok['ac_cnh_digital_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cnh_digital_socio_02'; }
                      }
                    if (empty($Xok['ac_nome_mae_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_mae_socio_02'; }
          					//if (empty($Xok['ac_estado_civil_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil_socio_02'; }
          					//if (empty($Xok['ac_regime_casamento_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento_socio_02'; }                  
                    if ($Xok['ac_estado_civil_socio_02']=='Casado')
                    {
                          if (empty($Xok['ac_regime_casamento_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento_socio_02'; }
                    } else 
                      {
                          if (empty($Xok['ac_estado_civil_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil_socio_02'; }
                      }                    
                    if (empty($Xok['ac_profissao_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_profissao_socio_02'; }
                    //if (empty($Xok['ac_declara_irpf_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_declara_irpf_socio_02'; }                    
                    if ($Xok['ac_declara_irpf_socio_02']=='Não')
                    {
                          if (empty($Xok['ac_titulo_eleitor_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_titulo_eleitor_socio_02'; }
                    } else 
                      {
                          if (empty($Xok['ac_ultimo_irpf_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_ultimo_irpf_socio_02'; }
                      }                    
                    if (empty($Xok['ac_capital_social_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_capital_social_socio_02'; }
                    if (empty($Xok['ac_numero_pis_inss_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_pis_inss_socio_02'; }
                    if (empty($Xok['ac_residencial_rua_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_rua_socio_02'; }
                    if (empty($Xok['ac_residencial_numero_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_numero_socio_02'; }
                    //if (empty($Xok['ac_residencial_complemento_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_complemento_socio_02'; }
                    if (empty($Xok['ac_residencial_bairro_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_bairro_socio_02'; }
                    if (empty($Xok['ac_residencial_cidade_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cidade_socio_02'; }
                    if (empty($Xok['ac_residencial_uf_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_uf_socio_02'; }
                    if (empty($Xok['ac_residencial_cep_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cep_socio_02'; }                  
					
					//socio3
                    if (empty($Xok['ac_nome_completo_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_completo_socio_03'; }
                    if (empty($Xok['ac_numero_rg_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_rg_socio_03'; }
                    if (empty($Xok['ac_numero_cpf_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_cpf_socio_03'; }
                    //if (empty($Xok['ac_opcao_documentos_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_opcao_documentos_socio_03'; }
                    if ($Xok['ac_opcao_documentos_socio_03']=='RG e CPF')
                    {
                        if (empty($Xok['ac_rg_digital_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_rg_digital_socio_03'; }
                        if (empty($Xok['ac_cpf_digital_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cpf_digital_socio_03'; }
                    } else if ($Xok['ac_opcao_documentos_socio_03']=='CNH (Carteira de motorista)')
                      {
                        if (empty($Xok['ac_cnh_digital_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cnh_digital_socio_03'; }
                      }
                    if (empty($Xok['ac_nome_mae_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_mae_socio_03'; }
          					//if (empty($Xok['ac_estado_civil_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil_socio_03'; }
          					//if (empty($Xok['ac_regime_casamento_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento_socio_03'; }                  
                    if ($Xok['ac_estado_civil_socio_03']=='Casado')
                    {
                          if (empty($Xok['ac_regime_casamento_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento_socio_03'; }
                    } else 
                      {
                          if (empty($Xok['ac_estado_civil_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil_socio_03'; }
                      }                    
                    if (empty($Xok['ac_profissao_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_profissao_socio_03'; }
                    //if (empty($Xok['ac_declara_irpf_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_declara_irpf_socio_03'; }                    
                    if ($Xok['ac_declara_irpf_socio_03']=='Não')
                    {
                          if (empty($Xok['ac_titulo_eleitor_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_titulo_eleitor_socio_03'; }
                    } else 
                      {
                          if (empty($Xok['ac_ultimo_irpf_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_ultimo_irpf_socio_03'; }
                      }                    
                    if (empty($Xok['ac_capital_social_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_capital_social_socio_03'; }
                    if (empty($Xok['ac_numero_pis_inss_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_pis_inss_socio_03'; }
                    if (empty($Xok['ac_residencial_rua_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_rua_socio_03'; }
                    if (empty($Xok['ac_residencial_numero_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_numero_socio_03'; }
                    //if (empty($Xok['ac_residencial_complemento_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_complemento_socio_03'; }
                    if (empty($Xok['ac_residencial_bairro_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_bairro_socio_03'; }
                    if (empty($Xok['ac_residencial_cidade_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cidade_socio_03'; }
                    if (empty($Xok['ac_residencial_uf_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_uf_socio_03'; }
                    if (empty($Xok['ac_residencial_cep_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cep_socio_03'; }
				
					//socio 4
                    if (empty($Xok['ac_nome_completo_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_completo_socio_04'; }
                    if (empty($Xok['ac_numero_rg_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_rg_socio_04'; }
                    if (empty($Xok['ac_numero_cpf_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_cpf_socio_04'; }
                    //if (empty($Xok['ac_opcao_documentos_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_opcao_documentos_socio_04'; }
                    if ($Xok['ac_opcao_documentos_socio_04']=='RG e CPF')
                    {
                        if (empty($Xok['ac_rg_digital_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_rg_digital_socio_04'; }
                        if (empty($Xok['ac_cpf_digital_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cpf_digital_socio_04'; }
                    } else if ($Xok['ac_opcao_documentos_socio_04']=='CNH (Carteira de motorista)')
                      {
                        if (empty($Xok['ac_cnh_digital_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_cnh_digital_socio_04'; }
                      }
                    if (empty($Xok['ac_nome_mae_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_nome_mae_socio_04'; }
          					//if (empty($Xok['ac_estado_civil_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil_socio_04'; }
          					//if (empty($Xok['ac_regime_casamento_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento_socio_04'; }                  
                    if ($Xok['ac_estado_civil_socio_04']=='Casado')
                    {
                          if (empty($Xok['ac_regime_casamento_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_regime_casamento_socio_04'; }
                    } else 
                      {
                          if (empty($Xok['ac_estado_civil_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_estado_civil_socio_04'; }
                      }                    
                    if (empty($Xok['ac_profissao_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_profissao_socio_04'; }
                    //if (empty($Xok['ac_declara_irpf_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_declara_irpf_socio_04'; }                    
                    if ($Xok['ac_declara_irpf_socio_04']=='Não')
                    {
                          if (empty($Xok['ac_titulo_eleitor_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_titulo_eleitor_socio_04'; }
                    } else 
                      {
                          if (empty($Xok['ac_ultimo_irpf_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_ultimo_irpf_socio_04'; }
                      }                    
                    if (empty($Xok['ac_capital_social_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_capital_social_socio_04'; }
                    if (empty($Xok['ac_numero_pis_inss_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_numero_pis_inss_socio_04'; }
                    if (empty($Xok['ac_residencial_rua_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_rua_socio_04'; }
                    if (empty($Xok['ac_residencial_numero_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_numero_socio_04'; }
                    //if (empty($Xok['ac_residencial_complemento_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_complemento_socio_04'; }
                    if (empty($Xok['ac_residencial_bairro_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_bairro_socio_04'; }
                    if (empty($Xok['ac_residencial_cidade_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cidade_socio_04'; }
                    if (empty($Xok['ac_residencial_uf_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_uf_socio_04'; }
                    if (empty($Xok['ac_residencial_cep_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'ac_residencial_cep_socio_04'; }
                  break;                                                     
                default:
                  //$XTeste = '';
              }
            
            }
            
            //echo 'final - passou: '; echo  $XTeste ; echo '<br>';
            //print_r($XNomeCampoErro);
            //print_r($XTeste);          
            
            if ($XTeste == 0) {
            
              // Conversão no RD
              $data_rd['email'] = $Xemail;
              $fields = http_build_query($data_rd);
              $ch = curl_init();
              curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/cadastro-completo-finalizado.php");
              curl_setopt($ch, CURLOPT_POST, 1);
              curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
              curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
              $server_output = curl_exec($ch);
              curl_close($ch);
              // Conversão no RD - FIM
            
            $data2['status']           = '1';
            $this->db->where('clientes_ac_id', $param2);
            $this->db->update('clientes_ac', $data2);
            
            $this->session->set_flashdata('flash_message', 'Cadastro Completado com Sucesso!!!');
            redirect(base_url() . 'index.php?client/cadastro_completo/', 'refresh');
            
            }

            $this->session->set_flashdata('flash_message', $XNomeCampoErro.'<br>Demais Atualizações Realizadas com Sucesso!!!');

            redirect(base_url() . 'index.php?client/comercio_abrir/', 'refresh');

        }


        if ($param1 == 'delete') {

            $data['status']         = 'excluido';
            $this->db->where('clientes_ac_id', $param2);
            $this->db->update('clientes_ac', $data);
            redirect(base_url() . 'index.php?client/comercio_abrir/', 'refresh');

        }
        $page_data['comercio_abrir']    = $this->db->get('clientes_ac')->result_array();
        $page_data['page_name']         = 'comercio_abrir';
        $page_data['page_icon']         = 'user';
        $page_data['page_title']        = 'Abrir Comércio';
        $this->load->view('index', $page_data);
    }

    /***COMERCIO TRAZER***/
    function comercio_trazer ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'do_update') { 
        
            $id = $this->input->post('id') ;
            $target_dir = "./crm/arquivos/cadastro_07_trazer_comercio/".$id."_".$this->caracter_model->tira_acento($this->input->post('nome'))."/";
            
            $XStatus = '8';
            
            if (empty($this->input->post('tc_tipo_nota_fiscal')) ){
                     $tipo_nota_fiscal = '';
            } else {
                     $tipo_nota_fiscal = substr(implode(',', $this->input->post('tc_tipo_nota_fiscal')), 0);
            }
            
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['status']           = $XStatus;
            $data['obs']           = $this->input->post('obs');
            $data['tc_numero_rg']           = $this->input->post('tc_numero_rg');
            $data['tc_numero_cpf']           = $this->input->post('tc_numero_cpf');
            $data['tc_opcao_documentos']           = $this->input->post('tc_opcao_documentos');
            //$data['tc_rg_digital']           = $this->input->post('tc_rg_digital');
            if ( empty($_FILES['file_tc_rg_digital']['name'])){
                $data['tc_rg_digital']   = $this->input->post('tc_rg_digital');
              }  else {
                $data['tc_rg_digital']   = $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_rg_digital']['name']));
                move_uploaded_file($_FILES['file_tc_rg_digital']['tmp_name'], $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_rg_digital']['name'])));
              }              
            //$data['tc_cpf_digital']           = $this->input->post('tc_cpf_digital');
            if ( empty($_FILES['file_tc_cpf_digital']['name'])){
                $data['tc_cpf_digital']   = $this->input->post('tc_cpf_digital');
              }  else {
                $data['tc_cpf_digital']   = $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_cpf_digital']['name']));
                move_uploaded_file($_FILES['file_tc_cpf_digital']['tmp_name'], $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_cpf_digital']['name'])));
              }                 
            //$data['tc_cnh_digital']           = $this->input->post('tc_cnh_digital');
            if ( empty($_FILES['file_tc_cnh_digital']['name'])){
                $data['tc_cnh_digital']   = $this->input->post('tc_cnh_digital');
              }  else {
                $data['tc_cnh_digital']   = $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_cnh_digital']['name']));
                move_uploaded_file($_FILES['file_tc_cnh_digital']['tmp_name'], $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_cnh_digital']['name'])));
              } 
            $data['tc_nome_mae']           = $this->input->post('tc_nome_mae');
            $data['tc_estado_civil']           = $this->input->post('tc_estado_civil');
            $data['tc_regime_casamento']           = $this->input->post('tc_regime_casamento');
            $data['tc_declara_irpf']           = $this->input->post('tc_declara_irpf');
            $data['tc_ultimo_irpf']           = $this->input->post('tc_ultimo_irpf');
            $data['tc_titulo_eleitor']           = $this->input->post('tc_titulo_eleitor');
            $data['tc_nome_empresarial']           = $this->input->post('tc_nome_empresarial');
            $data['tc_cnpj']           = $this->input->post('tc_cnpj');
            $data['tc_inscricao_estadual']           = $this->input->post('tc_inscricao_estadual');
            $data['tc_enquadramento']           = $this->input->post('tc_enquadramento');
            $data['tc_codigo_acesso_simples']           = $this->input->post('tc_codigo_acesso_simples');
            $data['tc_funcionarios']           = $this->input->post('tc_funcionarios');
            $data['tc_qtd_contrato_social']           = $this->input->post('tc_qtd_contrato_social');
            //$data['tc_contrato_social_01']           = $this->input->post('tc_contrato_social_01');
            if ( empty($_FILES['file_tc_contrato_social_01']['name'])){
                $data['tc_contrato_social_01']   = $this->input->post('tc_contrato_social_01');
              }  else {
                $data['tc_contrato_social_01']   = $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_contrato_social_01']['name']));
                move_uploaded_file($_FILES['file_tc_contrato_social_01']['tmp_name'], $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_contrato_social_01']['name'])));
              }  
            //$data['tc_contrato_social_02']           = $this->input->post('tc_contrato_social_02');
            if ( empty($_FILES['file_te_17_paginas_contrato']['name'])){
                $data['tc_contrato_social_02']   = $this->input->post('tc_contrato_social_02');
              }  else {
                $data['tc_contrato_social_02']   = $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['te_17_paginas_contrato']['name']));
                move_uploaded_file($_FILES['te_17_paginas_contrato']['tmp_name'], $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['te_17_paginas_contrato']['name'])));
              }  
            //$data['tc_contrato_social_03']           = $this->input->post('tc_contrato_social_03');
            if ( empty($_FILES['file_tc_contrato_social_03']['name'])){
                $data['tc_contrato_social_03']   = $this->input->post('tc_contrato_social_03');
              }  else {
                $data['tc_contrato_social_03']   = $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_contrato_social_03']['name']));
                move_uploaded_file($_FILES['file_tc_contrato_social_03']['tmp_name'], $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_contrato_social_03']['name'])));
              }  
            //$data['tc_contrato_social_04']           = $this->input->post('tc_contrato_social_04');
            if ( empty($_FILES['file_tc_contrato_social_04']['name'])){
                $data['tc_contrato_social_04']   = $this->input->post('tc_contrato_social_04');
              }  else {
                $data['tc_contrato_social_04']   = $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_contrato_social_04']['name']));
                move_uploaded_file($_FILES['file_tc_contrato_social_04']['tmp_name'], $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_contrato_social_04']['name'])));
              }  
            //$data['tc_contrato_social_05']           = $this->input->post('tc_contrato_social_05');
            if ( empty($_FILES['file_tc_contrato_social_05']['name'])){
                $data['tc_contrato_social_05']   = $this->input->post('tc_contrato_social_05');
              }  else {
                $data['tc_contrato_social_05']   = $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_contrato_social_05']['name']));
                move_uploaded_file($_FILES['file_tc_contrato_social_05']['tmp_name'], $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_contrato_social_05']['name'])));
              }  
            //$data['tc_contrato_social_06']           = $this->input->post('tc_contrato_social_06');
            if ( empty($_FILES['file_tc_contrato_social_06']['name'])){
                $data['tc_contrato_social_06']   = $this->input->post('tc_contrato_social_06');
              }  else {
                $data['tc_contrato_social_06']   = $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_contrato_social_06']['name']));
                move_uploaded_file($_FILES['file_tc_contrato_social_06']['tmp_name'], $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_contrato_social_06']['name'])));
              }  
            //$data['tc_contrato_social_07']           = $this->input->post('tc_contrato_social_07');
            if ( empty($_FILES['file_tc_contrato_social_07']['name'])){
                $data['tc_contrato_social_07']   = $this->input->post('tc_contrato_social_07');
              }  else {
                $data['tc_contrato_social_07']   = $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_contrato_social_07']['name']));
                move_uploaded_file($_FILES['file_tc_contrato_social_07']['tmp_name'], $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_contrato_social_07']['name'])));
              }  
            //$data['tc_contrato_social_08']           = $this->input->post('tc_contrato_social_08');
            if ( empty($_FILES['file_tc_contrato_social_08']['name'])){
                $data['tc_contrato_social_08']   = $this->input->post('tc_contrato_social_08');
              }  else {
                $data['tc_contrato_social_08']   = $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_contrato_social_08']['name']));
                move_uploaded_file($_FILES['file_tc_contrato_social_08']['tmp_name'], $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_contrato_social_08']['name'])));
              }  
            //$data['tc_alvara']           = $this->input->post('tc_alvara');
            if ( empty($_FILES['file_tc_alvara']['name'])){
                $data['tc_alvara']   = $this->input->post('tc_alvara');
              }  else {
                $data['tc_alvara']   = $target_dir.$id."_cs_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_alvara']['name']));
                move_uploaded_file($_FILES['file_tc_alvara']['tmp_name'], $target_dir.$id."_alvara_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_alvara']['name'])));
              }
            $data['tc_tipo_nota_fiscal']           = $tipo_nota_fiscal;
            $data['tc_certificado_digital']           = $this->input->post('tc_certificado_digital');
            //$data['tc_certificado_digital_a1']           = $this->input->post('tc_certificado_digital_a1');
            if ( empty($_FILES['file_tc_certificado_digital_a1']['name'])){
                $data['tc_certificado_digital_a1']   = $this->input->post('tc_certificado_digital_a1');
              }  else {
                $data['tc_certificado_digital_a1']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_certificado_digital_a1']['name']));
                move_uploaded_file($_FILES['file_tc_certificado_digital_a1']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_certificado_digital_a1']['name'])));
              } 
            $data['tc_certificado_digital_a1_senha']           = $this->input->post('tc_certificado_digital_a1_senha');
            $data['tc_qtd_socios']           = $this->input->post('tc_qtd_socios');
            //$data['tc_documentos_socio_01']           = $this->input->post('tc_documentos_socio_01');
            if ( empty($_FILES['file_tc_documentos_socio_01']['name'])){
                $data['tc_documentos_socio_01']   = $this->input->post('tc_documentos_socio_01');
              }  else {
                $data['tc_documentos_socio_01']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_documentos_socio_01']['name']));
                move_uploaded_file($_FILES['file_tc_documentos_socio_01']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_documentos_socio_01']['name'])));
              } 
            //$data['tc_documentos_socio_02']           = $this->input->post('tc_documentos_socio_02');
            if ( empty($_FILES['file_tc_documentos_socio_02']['name'])){
                $data['tc_documentos_socio_02']   = $this->input->post('tc_documentos_socio_02');
              }  else {
                $data['tc_documentos_socio_02']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_documentos_socio_02']['name']));
                move_uploaded_file($_FILES['file_tc_documentos_socio_02']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_documentos_socio_02']['name'])));
              } 
            //$data['tc_documentos_socio_03']           = $this->input->post('tc_documentos_socio_03');
            if ( empty($_FILES['file_tc_documentos_socio_03']['name'])){
                $data['tc_documentos_socio_03']   = $this->input->post('tc_documentos_socio_03');
              }  else {
                $data['tc_documentos_socio_03']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_documentos_socio_03']['name']));
                move_uploaded_file($_FILES['file_tc_documentos_socio_03']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_documentos_socio_03']['name'])));
              } 
            //$data['tc_documentos_socio_04']           = $this->input->post('tc_documentos_socio_04');
            if ( empty($_FILES['file_tc_documentos_socio_04']['name'])){
                $data['tc_documentos_socio_04']   = $this->input->post('tc_documentos_socio_04');
              }  else {
                $data['tc_documentos_socio_04']   = $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_documentos_socio_04']['name']));
                move_uploaded_file($_FILES['file_tc_documentos_socio_04']['tmp_name'], $target_dir.$id."_docsoc_".strtolower($this->caracter_model->tira_acento($_FILES['file_tc_documentos_socio_04']['name'])));
              } 


            $this->db->where('clientes_tc_id', $param2);
            $this->db->update('clientes_tc', $data);
            //var_dump($Xdados);
            // verifica se o cadastro esta completo
            
            $XTeste = 0;
            $XNomeCampoErro = 'Campos AINDA NÃO preenchidos ';
            
            $Xdados = $this->db->get_where('clientes_tc', array('clientes_tc_id' => $param2))->result_array();
            $Xemail = $this->db->get_where('clientes_tc', array('clientes_tc_id' => $param2))->row()->email;
           
            foreach($Xdados as $Xok) {
            
                if (empty($Xok['nome']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'nome'; }
                if (empty($Xok['email']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'email'; }
                if (empty($Xok['telefone']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'telefone'; }
                //if (empty($Xok['data_cadastro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'data_cadastro'; }
                //if (empty($Xok['status']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'status'; }
                //if (empty($Xok['obs']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'obs'; }
                if (empty($Xok['tc_numero_rg']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_numero_rg'; }
                if (empty($Xok['tc_numero_cpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_numero_cpf'; }
    
                if ($Xok['tc_opcao_documentos']=='RG e CPF')
                {
                    if (empty($Xok['tc_rg_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_rg_digital'; }
                    if (empty($Xok['tc_cpf_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_cpf_digital'; }
                } else if ($Xok['tc_opcao_documentos']=='CNH (Carteira de motorista)')
                  {
                    if (empty($Xok['tc_cnh_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_cnh_digital'; }
                  }
                if (empty($Xok['tc_nome_mae']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_nome_mae'; }
    //            if (empty($Xok['tc_estado_civil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_estado_civil'; }
    //            if (empty($Xok['tc_regime_casamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_regime_casamento'; }
                if ($Xok['tc_estado_civil']=='Casado')
                {
                      if (empty($Xok['tc_regime_casamento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_regime_casamento'; }
                } else 
                  {
                      if (empty($Xok['tc_estado_civil']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_estado_civil'; }
                  } 
                //if (empty($Xok['tc_declara_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_declara_irpf'; }
                if ($Xok['tc_declara_irpf']=='Não')
                {
                      if (empty($Xok['tc_titulo_eleitor']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_titulo_eleitor'; }
                } else 
                  {
                      if (empty($Xok['tc_ultimo_irpf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_ultimo_irpf'; }
                  }
    	  
                if (empty($Xok['tc_nome_empresarial']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_nome_empresarial'; }
                if (empty($Xok['tc_cnpj']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_cnpj'; }
                if (empty($Xok['tc_inscricao_estadual']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_inscricao_estadual'; }
          			//if (empty($Xok['tc_enquadramento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_enquadramento'; }
          			if (empty($Xok['tc_codigo_acesso_simples']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_codigo_acesso_simples'; }
                if (empty($Xok['tc_tipo_nota_fiscal']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_tipo_nota_fiscal'; }
          			//if (empty($Xok['tc_funcionarios']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_funcionarios'; }
                //if (empty($Xok['tc_alvara']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_alvara'; }
    			
    			            
                if ($Xok['tc_certificado_digital']=='SIM')
                {
                    if (empty($Xok['tc_certificado_digital_a1']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_certificado_digital_a1'; }
                    if (empty($Xok['tc_certificado_digital_a1_senha']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_certificado_digital_a1_senha'; }
    				
                }          
			
              switch ($Xok['tc_qtd_contrato_social']) {
                case '1':
                    if (empty($Xok['tc_contrato_social_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_01'; }
                  break;
                case '2':
                    if (empty($Xok['tc_contrato_social_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_01'; }
                    if (empty($Xok['tc_contrato_social_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_02'; }
                  break;
                case '3':
                    if (empty($Xok['tc_contrato_social_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_01'; }
                    if (empty($Xok['tc_contrato_social_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_02'; }				
                    if (empty($Xok['tc_contrato_social_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_03'; }
                  break;
                case '4':
                    if (empty($Xok['tc_contrato_social_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_01'; }
                    if (empty($Xok['tc_contrato_social_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_02'; }				
                    if (empty($Xok['tc_contrato_social_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_03'; }				
                    if (empty($Xok['tc_contrato_social_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_04'; }
                  break;
                case '5':
                    if (empty($Xok['tc_contrato_social_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_01'; }
                    if (empty($Xok['tc_contrato_social_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_02'; }				
                    if (empty($Xok['tc_contrato_social_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_03'; }				
                    if (empty($Xok['tc_contrato_social_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_04'; }				
                    if (empty($Xok['tc_contrato_social_05']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_05'; }
                  break;
                case '6':
                    if (empty($Xok['tc_contrato_social_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_01'; }
                    if (empty($Xok['tc_contrato_social_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_02'; }				
                    if (empty($Xok['tc_contrato_social_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_03'; }				
                    if (empty($Xok['tc_contrato_social_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_04'; }				
                    if (empty($Xok['tc_contrato_social_05']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_05'; }				
                    if (empty($Xok['tc_contrato_social_06']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_06'; }
                  break;
                case '7':
                    if (empty($Xok['tc_contrato_social_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_01'; }
                    if (empty($Xok['tc_contrato_social_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_02'; }				
                    if (empty($Xok['tc_contrato_social_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_03'; }				
                    if (empty($Xok['tc_contrato_social_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_04'; }				
                    if (empty($Xok['tc_contrato_social_05']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_05'; }				
                    if (empty($Xok['tc_contrato_social_06']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_06'; }				
                    if (empty($Xok['tc_contrato_social_07']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_07'; }
                  break;
                case '8':
                    if (empty($Xok['tc_contrato_social_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_01'; }
                    if (empty($Xok['tc_contrato_social_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_02'; }				
                    if (empty($Xok['tc_contrato_social_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_03'; }				
                    if (empty($Xok['tc_contrato_social_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_04'; }				
                    if (empty($Xok['tc_contrato_social_05']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_05'; }				
                    if (empty($Xok['tc_contrato_social_06']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_06'; }				
                    if (empty($Xok['tc_contrato_social_07']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_07'; }				
                    if (empty($Xok['tc_contrato_social_08']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_contrato_social_08'; }
                  break;				  
                default:
                  //$XTeste = '';
              }
			  
              switch ($Xok['tc_qtd_socios']) {
                case '1':
                    if (empty($Xok['tc_documentos_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_documentos_socio_01'; }
                  break;
                case '2':
                    if (empty($Xok['tc_documentos_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_documentos_socio_01'; }
                    if (empty($Xok['tc_documentos_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_documentos_socio_02'; }
                  break;
                case '3':
                    if (empty($Xok['tc_documentos_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_documentos_socio_01'; }
                    if (empty($Xok['tc_documentos_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_documentos_socio_02'; }				
                    if (empty($Xok['tc_documentos_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_documentos_socio_03'; }
                  break;
                case '4':
                    if (empty($Xok['tc_documentos_socio_01']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_documentos_socio_01'; }
                    if (empty($Xok['tc_documentos_socio_02']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_documentos_socio_02'; }				
                    if (empty($Xok['tc_documentos_socio_03']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_documentos_socio_03'; }				
                    if (empty($Xok['tc_documentos_socio_04']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'tc_documentos_socio_04'; }
                  break;				  
                default:
                  //$XTeste = '';
              }
            
            }
            
            //echo 'final - passou: '; echo  $XTeste ; echo '<br>';
            //print_r($XNomeCampoErro);
            //print_r($XTeste);          
            
            if ($XTeste == 0) {
            
              // Conversão no RD
              $data_rd['email'] = $Xemail;
              $fields = http_build_query($data_rd);
              $ch = curl_init();
              curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/cadastro-completo-finalizado.php");
              curl_setopt($ch, CURLOPT_POST, 1);
              curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
              curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
              $server_output = curl_exec($ch);
              curl_close($ch);
              // Conversão no RD - FIM
            
            $data2['status']           = '1';
            $this->db->where('clientes_tc_id', $param2);
            $this->db->update('clientes_tc', $data2);
            
            $this->session->set_flashdata('flash_message', 'Cadastro Completado com Sucesso!!!');
            redirect(base_url() . 'index.php?client/cadastro_completo/', 'refresh');
            
            }
            $this->session->set_flashdata('flash_message', $XNomeCampoErro.'<br>Demais Atualizações Realizadas com Sucesso!!!');

            redirect(base_url() . 'index.php?client/comercio_trazer/', 'refresh');

        }


        if ($param1 == 'delete') {

            $data['status']         = 'excluido';
            $this->db->where('clientes_tc_id', $param2);
            $this->db->update('clientes_tc', $data);
            redirect(base_url() . 'index.php?client/comercio_trazer/', 'refresh');

        }
        $page_data['comercio_trazer']   = $this->db->get('clientes_tc')->result_array();
        $page_data['page_name']         = 'comercio_trazer';
        $page_data['page_icon']         = 'user';
        $page_data['page_title']        = 'Trazer Comércio';
        $this->load->view('index', $page_data);
    }        

    /***Prof Liberal ABERTURA***/
    function pl_abrir ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'do_update') {

            $id = $this->input->post('id') ;
            $target_dir = "./crm/arquivos/cadastro_03_profissional_liberal/".$id."_".$this->caracter_model->tira_acento($this->input->post('nome'))."/";                
        
            $XStatus = '8';
        
            $data['nome']           = $this->input->post('nome');
            $data['email']           = $this->input->post('email');
            $data['telefone']           = $this->input->post('telefone');
            $data['data_cadastro']           = $this->input->post('data_cadastro');
            $data['status']           = $XStatus;
            $data['obs']           = $this->input->post('obs');
            $data['pl_03_habilitacao']           = $this->input->post('pl_03_habilitacao');
            //$data['pl_04_habilitacao_digital']           = $this->input->post('pl_04_habilitacao_digital');
            if ( empty($_FILES['file_pl_04_habilitacao_digital']['name'])){
                $data['pl_04_habilitacao_digital']   = $this->input->post('pl_04_habilitacao_digital');
              }  else {
                $data['pl_04_habilitacao_digital']   = $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_pl_04_habilitacao_digital']['name']));
                move_uploaded_file($_FILES['file_pl_04_habilitacao_digital']['tmp_name'], $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_pl_04_habilitacao_digital']['name'])));
              } 
            //$data['pl_05_habilitacao_digital']           = $this->input->post('pl_05_habilitacao_digital');
            if ( empty($_FILES['file_pl_05_habilitacao_digital']['name'])){
                $data['pl_05_habilitacao_digital']   = $this->input->post('pl_05_habilitacao_digital');
              }  else {
                $data['pl_05_habilitacao_digital']   = $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_pl_05_habilitacao_digital']['name']));
                move_uploaded_file($_FILES['file_pl_05_habilitacao_digital']['tmp_name'], $target_dir.$id."_doc_".strtolower($this->caracter_model->tira_acento($_FILES['file_pl_05_habilitacao_digital']['name'])));
              } 
            $data['pl_13_atividade']           = $this->input->post('pl_13_atividade');
            $data['pl_06_rua']           = $this->input->post('pl_06_rua');
            $data['pl_07_numero']           = $this->input->post('pl_07_numero');
            $data['pl_08_complemento']           = $this->input->post('pl_08_complemento');
            $data['pl_09_bairro']           = $this->input->post('pl_09_bairro');
            $data['pl_10_cidade']           = $this->input->post('pl_10_cidade');
            $data['pl_11_uf']           = $this->input->post('pl_11_uf');
            $data['pl_12_cep']           = $this->input->post('pl_12_cep');
            $data['pl_14_legalizado']           = $this->input->post('pl_14_legalizado');
            //$data['pl_15_alvara']           = $this->input->post('pl_15_alvara');            
            if ( empty($_FILES['file_pl_15_alvara']['name'])){
                $data['pl_15_alvara']   = $this->input->post('pl_15_alvara');
              }  else {
                $data['pl_15_alvara']   = $target_dir.$id."_alvara_".strtolower($this->caracter_model->tira_acento($_FILES['file_pl_15_alvara']['name']));
                move_uploaded_file($_FILES['file_pl_15_alvara']['tmp_name'], $target_dir.$id."_alvara_".strtolower($this->caracter_model->tira_acento($_FILES['file_pl_15_alvara']['name'])));
              } 
            $data['pl_16_endereco_conferencia']           = $this->input->post('pl_16_endereco_conferencia');
            $data['pl_17_rua']           = $this->input->post('pl_17_rua');
            $data['pl_18_numero']           = $this->input->post('pl_18_numero');
            $data['pl_19_complemento']           = $this->input->post('pl_19_complemento');
            $data['pl_20_bairro']           = $this->input->post('pl_20_bairro');
            $data['pl_21_cidade']           = $this->input->post('pl_21_cidade');
            $data['pl_21_uf']           = $this->input->post('pl_21_uf');
            $data['pl_22_cep']           = $this->input->post('pl_22_cep');
            $data['pl_23_iptu']           = $this->input->post('pl_23_iptu');
            $data['pl_26_iptu']           = $this->input->post('pl_26_iptu');
            $data['pl_24_cadastro_cei']           = $this->input->post('pl_24_cadastro_cei');
            $data['pl_25_numero_cei']           = $this->input->post('pl_25_numero_cei');

            $this->db->where('clientes_pl_id', $param2);
            $this->db->update('clientes_pl', $data);

                        //var_dump($Xdados);
            // verifica se o cadastro esta completo
            
            $XTeste = 0;
            $XNomeCampoErro = 'Campos AINDA NÃO preenchidos ';
            
            $Xdados = $this->db->get_where('clientes_pl', array('clientes_pl_id' => $param2))->result_array();
            $Xemail = $this->db->get_where('clientes_pl', array('clientes_pl_id' => $param2))->row()->email;
           
            foreach($Xdados as $Xok) {
            
                if (empty($Xok['nome']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'nome'; }
                if (empty($Xok['email']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'email'; }
                if (empty($Xok['telefone']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'telefone'; }
                //if (empty($Xok['data_cadastro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'data_cadastro'; }
                //if (empty($Xok['status']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'status'; }
                //if (empty($Xok['obs']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'obs'; }
    
    
                if ($Xok['pl_03_habilitacao']=='RG e CPF')
                {
                    if (empty($Xok['pl_04_habilitacao_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_04_habilitacao_digital'; }
    
                } else if ($Xok['pl_03_habilitacao']=='CNH (Carteira de motorista)')
                  {
                    if (empty($Xok['pl_05_habilitacao_digital']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_05_habilitacao_digital'; }
                  }
      
                if (empty($Xok['pl_13_atividade']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_13_atividade'; }
                if (empty($Xok['pl_06_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_06_rua'; }
                if (empty($Xok['pl_07_numero']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_07_numero'; }
          			//if (empty($Xok['pl_08_complemento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_08_complemento'; }
          			if (empty($Xok['pl_09_bairro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_09_bairro'; }
          			if (empty($Xok['pl_10_cidade']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_10_cidade'; }
          			if (empty($Xok['pl_11_uf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_11_uf'; }
          			if (empty($Xok['pl_12_cep']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_12_cep'; }
          			if (empty($Xok['pl_14_legalizado']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_14_legalizado'; }
          			//if (empty($Xok['pl_15_alvara']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_15_alvara'; }
          
                if (empty($Xok['pl_16_endereco_conferencia']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_16_endereco_conferencia'; }
                if (empty($Xok['pl_17_rua']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_17_rua'; }
                if (empty($Xok['pl_18_numero']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_18_numero'; }
          			//if (empty($Xok['pl_19_complemento']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_19_complemento'; }
          			if (empty($Xok['pl_20_bairro']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_20_bairro'; }
          			if (empty($Xok['pl_21_cidade']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_21_cidade'; }
          			if (empty($Xok['pl_21_uf']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_21_uf'; }
          			if (empty($Xok['pl_22_cep']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_22_cep'; }
                                
                if ($Xok['fc_26_endereco_referencia']=='Endereço Residencial')
                {
                    if (empty($Xok['pl_26_iptu']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_26_iptu'; }
                } else 
                  {
                    if (empty($Xok['pl_23_iptu']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_23_iptu'; }	
                  }
		
          			if (empty($Xok['pl_24_cadastro_cei']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_24_cadastro_cei'; }			
          			//if (empty($Xok['pl_25_numero_cei']) ) { $XTeste = 1;  $XNomeCampoErro= $XNomeCampoErro . ' | ' . 'pl_25_numero_cei'; }			
          			            
            }
            
            //echo 'final - passou: '; echo  $XTeste ; echo '<br>';
            //print_r($XNomeCampoErro);
            //print_r($XTeste);          
            
            if ($XTeste == 0) {
            
              // Conversão no RD
              $data_rd['email'] = $Xemail;
              $fields = http_build_query($data_rd);
              $ch = curl_init();
              curl_setopt($ch, CURLOPT_URL,"https://csdw.herokuapp.com/services/cadastro-completo-finalizado.php");
              curl_setopt($ch, CURLOPT_POST, 1);
              curl_setopt($ch, CURLOPT_POSTFIELDS,$fields);
              curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
              $server_output = curl_exec($ch);
              curl_close($ch);
              // Conversão no RD - FIM
            
            $data2['status']           = '1';
            $this->db->where('clientes_pl_id', $param2);
            $this->db->update('clientes_pl', $data2);
            
            $this->session->set_flashdata('flash_message', 'Cadastro Completado com Sucesso!!!');
            redirect(base_url() . 'index.php?client/cadastro_completo/', 'refresh');
            
            } 
            
            $this->session->set_flashdata('flash_message', $XNomeCampoErro.'<br>Demais Atualizações Realizadas com Sucesso!!!');

            redirect(base_url() . 'index.php?client/pl_abrir/', 'refresh');

        }

        if ($param1 == 'delete') {

            $data['status']         = 'excluido';
            $this->db->where('clientes_pl_id', $param2);
            $this->db->update('clientes_pl', $data);
            redirect(base_url() . 'index.php?client/pl_abrir/', 'refresh');

        }
        $page_data['pl_abrir']     = $this->db->get('clientes_pl')->result_array();
        $page_data['page_name']         = 'pl_abrir';
        $page_data['page_icon']         = 'user';
        $page_data['page_title']        = 'Abertura Prof.Liberal';
        $this->load->view('index', $page_data);
    }

    /***Prof Liberal TRAZER***/
    function pl_trazer ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        //$this->session->set_flashdata('flash_message', 'Passou aqui !!!');
        $page_data['pl_trazer']     = $this->db->get('clientes_pl')->result_array();
        $page_data['page_name']         = 'pl_trazer';
        $page_data['page_icon']         = 'user';
        $page_data['page_title']        = 'Trazer Prof.Liberal';
        $this->load->view('index', $page_data);
    }

/***Cadastro Completo***/
    function cadastro_completo ($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        //$this->session->set_flashdata('flash_message', 'Passou aqui !!!');
        //$page_data['pl_trazer']     = $this->db->get('clientes_pl')->result_array();
        $page_data['page_name']         = 'cadastro_completo';
        $page_data['page_icon']         = 'user';
        $page_data['page_title']        = 'Aviso de Finalização de Cadastro!!!';
        $this->load->view('index', $page_data);
    }
/****MANAGE Status Cliente Acompanhamento*****/
    function status_cliente($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['status'] = $this->input->post('status');
            $this->db->insert('status_cliente', $data);
            redirect(base_url() . 'index.php?client/status_cliente/', 'refresh');
        }
        if ($param1 == 'do_update') {

            $data['status']    = $this->input->post('status');
            $this->db->where('status_cliente_id', $param2);
            $this->db->update('status_cliente', $data);
            redirect(base_url() . 'index.php?client/status_cliente/', 'refresh');
        }

        if ($param1 == 'delete') {
            $this->db->where('status_cliente_id', $param2);
            $this->db->delete('status_cliente');
            redirect(base_url() . 'index.php?client/status_cliente/', 'refresh');
        }
        $page_data['status_cliente']       = $this->db->get('status_cliente')->result_array();
        $page_data['page_name']  = 'status_cliente';
        $page_data['page_icon']  = 'cog';
        $page_data['page_title'] = 'Status Cliente';
        $this->load->view('index', $page_data);
    }



/**** Página Serviços Avulsos*****/
    function serv_avulso($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        else if ($param1 == 'personal_profile') {
            $page_data['personal_profile']   = true;
            $page_data['current_product_id'] = $param2;
        }
        $page_data['page_name']  = 'serv_avulso';
        $page_data['page_icon']  = 'tasks';
        $page_data['page_title'] = 'Serviços Avulsos';
        $this->load->view('index', $page_data);
    }

/*****SITE/SYSTEM SETTINGS********
    function system_settings($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');

        if ($param2 == 'do_update') {
            $this->db->where('type', $param1);
            $this->db->update('settings', array(
                'description' => $this->input->post('description')
            ));
            $this->session->set_flashdata('flash_message', 'settings_updated');
            redirect(base_url() . 'index.php?client/system_settings/', 'refresh');
        }
        if ($param1 == 'upload_logo') {
            move_uploaded_file($_FILES['userfile']['tmp_name'], 'uploads/logo.png');
            $this->session->set_flashdata('flash_message', 'settings_updated');
            redirect(base_url() . 'index.php?client/system_settings/', 'refresh');
   }
        $page_data['page_name']  = 'system_settings';
        $page_data['page_title'] = 'ConfiguraÃ§Ãµes do Sistema';
        $page_data['settings']   = $this->db->get('settings')->result_array();
        $this->load->view('index', $page_data);
    }
  */
/****** GESTÃO DO USUÁRIO E TROCA DE SENHA ***/
    function manage_profile($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url() . 'index.php?login', 'refresh');
        if ($param1 == 'update_profile_info') {
            $data['name']    = $this->input->post('name');
            $data['address'] = $this->input->post('address');
            $data['phone']   = $this->input->post('phone');
            $data['email']   = $this->input->post('email');

            $this->db->where('client_id', $this->session->userdata('client_id'));
            $this->db->update('client', $data);
            $this->session->set_flashdata('flash_message', 'account_updated');
            redirect(base_url() . 'index.php?client/manage_profile/', 'refresh');
        }
        if ($param1 == 'change_password') {
            $data['password']             = $this->input->post('password');
            $data['new_password']         = $this->input->post('new_password');
            $data['confirm_new_password'] = $this->input->post('confirm_new_password');

            $current_password = $this->db->get_where('client', array(
                'client_id' => $this->session->userdata('client_id')
            ))->row()->password;
            if ($current_password == $data['password'] && $data['new_password'] == $data['confirm_new_password']) {
                $this->db->where('client_id', $this->session->userdata('client_id'));
                $this->db->update('client', array(
                    'password' => $data['new_password']
                ));
                $this->session->set_flashdata('flash_message', 'password_updated');
            } else {
                $this->session->set_flashdata('flash_message', 'password_mismatch');
            }
            redirect(base_url() . 'index.php?client/manage_profile/', 'refresh');
        }
        $page_data['page_name']  = 'manage_profile';
        $page_data['page_title'] = 'Gestão Usuário';
        $page_data['page_icon'] = 'user';
        $page_data['edit_data']  = $this->db->get_where('client', array(
            'client_id' => $this->session->userdata('client_id')
        ))->result_array();
        $this->load->view('index', $page_data);
    }

}
/****** GESTÃO DO USUÁRIO E TROCA DE SENHA ***/